/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Definitions                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

/// Returns the operands within this call that are used as arguments to the
/// callee as a mutable range.
::mlir::MutableOperandRange circt::arc::CallOpMutableInterface::getArgOperandsMutable() {
      return getImpl()->getArgOperandsMutable(getImpl(), getOperation());
  }
/// Returns the callee of this call-like operation. A `callee` is either a
/// reference to a symbol, via SymbolRefAttr, or a reference to a defined
/// SSA value. If the reference is an SSA value, the SSA value corresponds
/// to a region of a lambda-like operation.
::mlir::CallInterfaceCallable circt::arc::CallOpMutableInterface::getCallableForCallee() {
      return getImpl()->implCallOpInterface->getCallableForCallee(getImpl()->implCallOpInterface, getOperation());
  }
/// Sets the callee of this call-like operation. A `callee` is either a
/// reference to a symbol, via SymbolRefAttr, or a reference to a defined
/// SSA value. The type of the `callee` is expected to be the same as the
/// return type of `getCallableForCallee`, e.g., `callee` should be
/// SymbolRefAttr for `func.call`.
void circt::arc::CallOpMutableInterface::setCalleeFromCallable(::mlir::CallInterfaceCallable callee) {
      return getImpl()->implCallOpInterface->setCalleeFromCallable(getImpl()->implCallOpInterface, getOperation(), callee);
  }
/// Returns the operands within this call that are used as arguments to the
/// callee.
::mlir::Operation::operand_range circt::arc::CallOpMutableInterface::getArgOperands() {
      return getImpl()->implCallOpInterface->getArgOperands(getImpl()->implCallOpInterface, getOperation());
  }
/// For operations that are only clocked under dynamic conditions. Ideally,
/// this should not exist as a conditionally clocked operation can ussually
/// be split into two operations (one clocked, one non-clocked) as it makes
/// using this interface more complicated.
bool circt::arc::ClockedOpInterface::isClocked() {
      return getImpl()->isClocked(getImpl(), getOperation());
  }
/// Returns the SSA value representing the clock signal. It is valid to
/// return a null value if the operation is inside a clocked region and thus
/// the clock is defined by the operation with the clocked region.
::mlir::Value circt::arc::ClockedOpInterface::getClock() {
      return getImpl()->getClock(getImpl(), getOperation());
  }
/// Removes the clock value, e.g., used when moving a clocked operation into
/// a clocked region.
void circt::arc::ClockedOpInterface::eraseClock() {
      return getImpl()->eraseClock(getImpl(), getOperation());
  }
