/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace circt {
namespace arc {
class CallOpMutableInterface;
namespace detail {
struct CallOpMutableInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    ::mlir::MutableOperandRange (*getArgOperandsMutable)(const Concept *impl, ::mlir::Operation *);
    /// The base classes of this interface.
    const ::mlir::CallOpInterface::Concept *implCallOpInterface = nullptr;

    void initializeInterfaceConcept(::mlir::detail::InterfaceMap &interfaceMap) {
      implCallOpInterface = interfaceMap.lookup<::mlir::CallOpInterface>();
      assert(implCallOpInterface && "`::circt::arc::CallOpMutableInterface` expected its base interface `::mlir::CallOpInterface` to be registered");
    }
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::circt::arc::CallOpMutableInterface;
    Model() : Concept{getArgOperandsMutable} {}

    static inline ::mlir::MutableOperandRange getArgOperandsMutable(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::circt::arc::CallOpMutableInterface;
    FallbackModel() : Concept{getArgOperandsMutable} {}

    static inline ::mlir::MutableOperandRange getArgOperandsMutable(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
  };
};template <typename ConcreteOp>
struct CallOpMutableInterfaceTrait;

} // namespace detail
class CallOpMutableInterface : public ::mlir::OpInterface<CallOpMutableInterface, detail::CallOpMutableInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<CallOpMutableInterface, detail::CallOpMutableInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::CallOpMutableInterfaceTrait<ConcreteOp> {};
  /// Returns the operands within this call that are used as arguments to the
  /// callee as a mutable range.
  ::mlir::MutableOperandRange getArgOperandsMutable();
  //===----------------------------------------------------------------===//
  // Inherited from ::mlir::CallOpInterface
  //===----------------------------------------------------------------===//

  operator ::mlir::CallOpInterface () const {
    return ::mlir::CallOpInterface(*this, getImpl()->implCallOpInterface);
  }

  /// Returns the callee of this call-like operation. A `callee` is either a
  /// reference to a symbol, via SymbolRefAttr, or a reference to a defined
  /// SSA value. If the reference is an SSA value, the SSA value corresponds
  /// to a region of a lambda-like operation.
  ::mlir::CallInterfaceCallable getCallableForCallee();
  /// Sets the callee of this call-like operation. A `callee` is either a
  /// reference to a symbol, via SymbolRefAttr, or a reference to a defined
  /// SSA value. The type of the `callee` is expected to be the same as the
  /// return type of `getCallableForCallee`, e.g., `callee` should be
  /// SymbolRefAttr for `func.call`.
  void setCalleeFromCallable(::mlir::CallInterfaceCallable callee);
  /// Returns the operands within this call that are used as arguments to the
  /// callee.
  ::mlir::Operation::operand_range getArgOperands();

    /// Resolve the callable operation for given callee to a
    /// CallableOpInterface, or nullptr if a valid callable was not resolved.
    /// `symbolTable` is an optional parameter that will allow for using a
    /// cached symbol table for symbol lookups instead of performing an O(N)
    /// scan.
    Operation *resolveCallable(SymbolTableCollection *symbolTable = nullptr);
};
namespace detail {
  template <typename ConcreteOp>
  struct CallOpMutableInterfaceTrait : public ::mlir::OpInterface<CallOpMutableInterface, detail::CallOpMutableInterfaceInterfaceTraits>::Trait<ConcreteOp> {
  };
}// namespace detail
} // namespace arc
} // namespace circt
namespace circt {
namespace arc {
class ClockedOpInterface;
namespace detail {
struct ClockedOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    bool (*isClocked)(const Concept *impl, ::mlir::Operation *);
    ::mlir::Value (*getClock)(const Concept *impl, ::mlir::Operation *);
    void (*eraseClock)(const Concept *impl, ::mlir::Operation *);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::circt::arc::ClockedOpInterface;
    Model() : Concept{isClocked, getClock, eraseClock} {}

    static inline bool isClocked(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::Value getClock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void eraseClock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::circt::arc::ClockedOpInterface;
    FallbackModel() : Concept{isClocked, getClock, eraseClock} {}

    static inline bool isClocked(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::Value getClock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void eraseClock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    bool isClocked(::mlir::Operation *tablegen_opaque_val) const;
    ::mlir::Value getClock(::mlir::Operation *tablegen_opaque_val) const;
    void eraseClock(::mlir::Operation *tablegen_opaque_val) const;
  };
};template <typename ConcreteOp>
struct ClockedOpInterfaceTrait;

} // namespace detail
class ClockedOpInterface : public ::mlir::OpInterface<ClockedOpInterface, detail::ClockedOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<ClockedOpInterface, detail::ClockedOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::ClockedOpInterfaceTrait<ConcreteOp> {};
  /// For operations that are only clocked under dynamic conditions. Ideally,
  /// this should not exist as a conditionally clocked operation can ussually
  /// be split into two operations (one clocked, one non-clocked) as it makes
  /// using this interface more complicated.
  bool isClocked();
  /// Returns the SSA value representing the clock signal. It is valid to
  /// return a null value if the operation is inside a clocked region and thus
  /// the clock is defined by the operation with the clocked region.
  ::mlir::Value getClock();
  /// Removes the clock value, e.g., used when moving a clocked operation into
  /// a clocked region.
  void eraseClock();
};
namespace detail {
  template <typename ConcreteOp>
  struct ClockedOpInterfaceTrait : public ::mlir::OpInterface<ClockedOpInterface, detail::ClockedOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
    /// For operations that are only clocked under dynamic conditions. Ideally,
    /// this should not exist as a conditionally clocked operation can ussually
    /// be split into two operations (one clocked, one non-clocked) as it makes
    /// using this interface more complicated.
    bool isClocked() {
      return true;
    }
    /// Returns the SSA value representing the clock signal. It is valid to
    /// return a null value if the operation is inside a clocked region and thus
    /// the clock is defined by the operation with the clocked region.
    ::mlir::Value getClock() {
      return (*static_cast<ConcreteOp *>(this)).getClock();
    }
    /// Removes the clock value, e.g., used when moving a clocked operation into
    /// a clocked region.
    void eraseClock() {
      return (*static_cast<ConcreteOp *>(this)).getClockMutable().clear();
    }
  };
}// namespace detail
} // namespace arc
} // namespace circt
namespace circt {
namespace arc {
template<typename ConcreteOp>
::mlir::MutableOperandRange detail::CallOpMutableInterfaceInterfaceTraits::Model<ConcreteOp>::getArgOperandsMutable(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getArgOperandsMutable();
}
template<typename ConcreteOp>
::mlir::MutableOperandRange detail::CallOpMutableInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getArgOperandsMutable(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getArgOperandsMutable(tablegen_opaque_val);
}
} // namespace arc
} // namespace circt
namespace circt {
namespace arc {
template<typename ConcreteOp>
bool detail::ClockedOpInterfaceInterfaceTraits::Model<ConcreteOp>::isClocked(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).isClocked();
}
template<typename ConcreteOp>
::mlir::Value detail::ClockedOpInterfaceInterfaceTraits::Model<ConcreteOp>::getClock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getClock();
}
template<typename ConcreteOp>
void detail::ClockedOpInterfaceInterfaceTraits::Model<ConcreteOp>::eraseClock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).eraseClock();
}
template<typename ConcreteOp>
bool detail::ClockedOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::isClocked(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->isClocked(tablegen_opaque_val);
}
template<typename ConcreteOp>
::mlir::Value detail::ClockedOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getClock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getClock(tablegen_opaque_val);
}
template<typename ConcreteOp>
void detail::ClockedOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::eraseClock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->eraseClock(tablegen_opaque_val);
}
template<typename ConcreteModel, typename ConcreteOp>
bool detail::ClockedOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::isClocked(::mlir::Operation *tablegen_opaque_val) const {
return true;
}
template<typename ConcreteModel, typename ConcreteOp>
::mlir::Value detail::ClockedOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getClock(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getClock();
}
template<typename ConcreteModel, typename ConcreteOp>
void detail::ClockedOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::eraseClock(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getClockMutable().clear();
}
} // namespace arc
} // namespace circt
