/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_ADDTAPS
#define GEN_PASS_DECL_ALLOCATESTATE
#define GEN_PASS_DECL_ARCCANONICALIZER
#define GEN_PASS_DECL_DEDUP
#define GEN_PASS_DECL_GROUPRESETSANDENABLES
#define GEN_PASS_DECL_INFERMEMORIES
#define GEN_PASS_DECL_INFERSTATEPROPERTIES
#define GEN_PASS_DECL_INLINEARCS
#define GEN_PASS_DECL_INLINEMODULES
#define GEN_PASS_DECL_ISOLATECLOCKS
#define GEN_PASS_DECL_LATENCYRETIMING
#define GEN_PASS_DECL_LEGALIZESTATEUPDATE
#define GEN_PASS_DECL_LOWERCLOCKSTOFUNCS
#define GEN_PASS_DECL_LOWERLUT
#define GEN_PASS_DECL_LOWERSTATE
#define GEN_PASS_DECL_MAKETABLES
#define GEN_PASS_DECL_MUXTOCONTROLFLOW
#define GEN_PASS_DECL_PRINTSTATEINFO
#define GEN_PASS_DECL_SIMPLIFYVARIADICOPS
#define GEN_PASS_DECL_SPLITLOOPS
#define GEN_PASS_DECL_STRIPSV
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// AddTaps
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ADDTAPS
struct AddTapsOptions {
  bool tapPorts = true;
  bool tapWires = true;
  bool tapNamedValues = false;
};
#undef GEN_PASS_DECL_ADDTAPS
#endif // GEN_PASS_DECL_ADDTAPS
#ifdef GEN_PASS_DEF_ADDTAPS
namespace impl {

template <typename DerivedT>
class AddTapsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = AddTapsBase;

  AddTapsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  AddTapsBase(const AddTapsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-add-taps");
  }
  ::llvm::StringRef getArgument() const override { return "arc-add-taps"; }

  ::llvm::StringRef getDescription() const override { return "Add taps to ports and wires such that they remain observable"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AddTaps");
  }
  ::llvm::StringRef getName() const override { return "AddTaps"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AddTapsBase<DerivedT>)

  AddTapsBase(const AddTapsOptions &options) : AddTapsBase() {
    tapPorts = options.tapPorts;
    tapWires = options.tapWires;
    tapNamedValues = options.tapNamedValues;
  }
protected:
  ::mlir::Pass::Option<bool> tapPorts{*this, "ports", ::llvm::cl::desc("Make module ports observable"), ::llvm::cl::init(true)};
  ::mlir::Pass::Option<bool> tapWires{*this, "wires", ::llvm::cl::desc("Make wires observable"), ::llvm::cl::init(true)};
  ::mlir::Pass::Option<bool> tapNamedValues{*this, "named-values", ::llvm::cl::desc("Make values with `sv.namehint` observable"), ::llvm::cl::init(false)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ADDTAPS
#endif // GEN_PASS_DEF_ADDTAPS

//===----------------------------------------------------------------------===//
// AllocateState
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ALLOCATESTATE
#undef GEN_PASS_DECL_ALLOCATESTATE
#endif // GEN_PASS_DECL_ALLOCATESTATE
#ifdef GEN_PASS_DEF_ALLOCATESTATE
namespace impl {

template <typename DerivedT>
class AllocateStateBase : public ::mlir::OperationPass<arc::ModelOp> {
public:
  using Base = AllocateStateBase;

  AllocateStateBase() : ::mlir::OperationPass<arc::ModelOp>(::mlir::TypeID::get<DerivedT>()) {}
  AllocateStateBase(const AllocateStateBase &other) : ::mlir::OperationPass<arc::ModelOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-allocate-state");
  }
  ::llvm::StringRef getArgument() const override { return "arc-allocate-state"; }

  ::llvm::StringRef getDescription() const override { return "Allocate and layout the global simulation state"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AllocateState");
  }
  ::llvm::StringRef getName() const override { return "AllocateState"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AllocateStateBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ALLOCATESTATE
#endif // GEN_PASS_DEF_ALLOCATESTATE

//===----------------------------------------------------------------------===//
// ArcCanonicalizer
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ARCCANONICALIZER
#undef GEN_PASS_DECL_ARCCANONICALIZER
#endif // GEN_PASS_DECL_ARCCANONICALIZER
#ifdef GEN_PASS_DEF_ARCCANONICALIZER
namespace impl {

template <typename DerivedT>
class ArcCanonicalizerBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ArcCanonicalizerBase;

  ArcCanonicalizerBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ArcCanonicalizerBase(const ArcCanonicalizerBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-canonicalizer");
  }
  ::llvm::StringRef getArgument() const override { return "arc-canonicalizer"; }

  ::llvm::StringRef getDescription() const override { return "Simulation centric canonicalizations"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ArcCanonicalizer");
  }
  ::llvm::StringRef getName() const override { return "ArcCanonicalizer"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<hw::HWDialect>();

  registry.insert<comb::CombDialect>();

  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ArcCanonicalizerBase<DerivedT>)

protected:
  ::mlir::Pass::Statistic numArcArgsRemoved{this, "num-arc-args-removed", "Number of arguments removed from DefineOps"};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ARCCANONICALIZER
#endif // GEN_PASS_DEF_ARCCANONICALIZER

//===----------------------------------------------------------------------===//
// Dedup
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_DEDUP
#undef GEN_PASS_DECL_DEDUP
#endif // GEN_PASS_DECL_DEDUP
#ifdef GEN_PASS_DEF_DEDUP
namespace impl {

template <typename DerivedT>
class DedupBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = DedupBase;

  DedupBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  DedupBase(const DedupBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-dedup");
  }
  ::llvm::StringRef getArgument() const override { return "arc-dedup"; }

  ::llvm::StringRef getDescription() const override { return "Deduplicate identical arc definitions"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Dedup");
  }
  ::llvm::StringRef getName() const override { return "Dedup"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(DedupBase<DerivedT>)

protected:
  ::mlir::Pass::Statistic dedupPassNumArcsDeduped{this, "dedupPassNumArcsDeduped", "Number of arcs deduped"};
  ::mlir::Pass::Statistic dedupPassTotalOps{this, "dedupPassTotalOps", "Total number of ops deduped"};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_DEDUP
#endif // GEN_PASS_DEF_DEDUP

//===----------------------------------------------------------------------===//
// GroupResetsAndEnables
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_GROUPRESETSANDENABLES
#undef GEN_PASS_DECL_GROUPRESETSANDENABLES
#endif // GEN_PASS_DECL_GROUPRESETSANDENABLES
#ifdef GEN_PASS_DEF_GROUPRESETSANDENABLES
namespace impl {

template <typename DerivedT>
class GroupResetsAndEnablesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = GroupResetsAndEnablesBase;

  GroupResetsAndEnablesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  GroupResetsAndEnablesBase(const GroupResetsAndEnablesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-group-resets-and-enables");
  }
  ::llvm::StringRef getArgument() const override { return "arc-group-resets-and-enables"; }

  ::llvm::StringRef getDescription() const override { return "Group reset and enable conditions of lowered states"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("GroupResetsAndEnables");
  }
  ::llvm::StringRef getName() const override { return "GroupResetsAndEnables"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  registry.insert<mlir::scf::SCFDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(GroupResetsAndEnablesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_GROUPRESETSANDENABLES
#endif // GEN_PASS_DEF_GROUPRESETSANDENABLES

//===----------------------------------------------------------------------===//
// InferMemories
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_INFERMEMORIES
struct InferMemoriesOptions {
  bool tapPorts = true;
};
#undef GEN_PASS_DECL_INFERMEMORIES
#endif // GEN_PASS_DECL_INFERMEMORIES
#ifdef GEN_PASS_DEF_INFERMEMORIES
namespace impl {

template <typename DerivedT>
class InferMemoriesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = InferMemoriesBase;

  InferMemoriesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  InferMemoriesBase(const InferMemoriesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-infer-memories");
  }
  ::llvm::StringRef getArgument() const override { return "arc-infer-memories"; }

  ::llvm::StringRef getDescription() const override { return "Convert `FIRRTL_Memory` instances to dedicated memory ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("InferMemories");
  }
  ::llvm::StringRef getName() const override { return "InferMemories"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  registry.insert<comb::CombDialect>();

  registry.insert<seq::SeqDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(InferMemoriesBase<DerivedT>)

  InferMemoriesBase(const InferMemoriesOptions &options) : InferMemoriesBase() {
    tapPorts = options.tapPorts;
  }
protected:
  ::mlir::Pass::Option<bool> tapPorts{*this, "tap-ports", ::llvm::cl::desc("Make memory ports observable"), ::llvm::cl::init(true)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_INFERMEMORIES
#endif // GEN_PASS_DEF_INFERMEMORIES

//===----------------------------------------------------------------------===//
// InferStateProperties
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_INFERSTATEPROPERTIES
#undef GEN_PASS_DECL_INFERSTATEPROPERTIES
#endif // GEN_PASS_DECL_INFERSTATEPROPERTIES
#ifdef GEN_PASS_DEF_INFERSTATEPROPERTIES
namespace impl {

template <typename DerivedT>
class InferStatePropertiesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = InferStatePropertiesBase;

  InferStatePropertiesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  InferStatePropertiesBase(const InferStatePropertiesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-infer-state-properties");
  }
  ::llvm::StringRef getArgument() const override { return "arc-infer-state-properties"; }

  ::llvm::StringRef getDescription() const override { return "Add resets and enables explicitly to the state operations"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("InferStateProperties");
  }
  ::llvm::StringRef getName() const override { return "InferStateProperties"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  registry.insert<circt::comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(InferStatePropertiesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_INFERSTATEPROPERTIES
#endif // GEN_PASS_DEF_INFERSTATEPROPERTIES

//===----------------------------------------------------------------------===//
// InlineArcs
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_INLINEARCS
struct InlineArcsOptions {
  bool intoArcsOnly = false;
  unsigned maxNonTrivialOpsInBody = 3;
};
#undef GEN_PASS_DECL_INLINEARCS
#endif // GEN_PASS_DECL_INLINEARCS
#ifdef GEN_PASS_DEF_INLINEARCS
namespace impl {

template <typename DerivedT>
class InlineArcsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = InlineArcsBase;

  InlineArcsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  InlineArcsBase(const InlineArcsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-inline");
  }
  ::llvm::StringRef getArgument() const override { return "arc-inline"; }

  ::llvm::StringRef getDescription() const override { return "Inline very small arcs"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("InlineArcs");
  }
  ::llvm::StringRef getName() const override { return "InlineArcs"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(InlineArcsBase<DerivedT>)

  InlineArcsBase(const InlineArcsOptions &options) : InlineArcsBase() {
    intoArcsOnly = options.intoArcsOnly;
    maxNonTrivialOpsInBody = options.maxNonTrivialOpsInBody;
  }
protected:
  ::mlir::Pass::Option<bool> intoArcsOnly{*this, "into-arcs-only", ::llvm::cl::desc("Call operations to inline"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<unsigned> maxNonTrivialOpsInBody{*this, "max-body-ops", ::llvm::cl::desc("Max number of non-trivial ops in the region to be inlined"), ::llvm::cl::init(3)};
  ::mlir::Pass::Statistic numInlinedArcs{this, "inlined-arcs", "Arcs inlined at a use site"};
  ::mlir::Pass::Statistic numRemovedArcs{this, "removed-arcs", "Arcs removed after full inlining"};
  ::mlir::Pass::Statistic numTrivialArcs{this, "trivial-arcs", "Arcs with very few ops"};
  ::mlir::Pass::Statistic numSingleUseArcs{this, "single-use-arcs", "Arcs with a single use"};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_INLINEARCS
#endif // GEN_PASS_DEF_INLINEARCS

//===----------------------------------------------------------------------===//
// InlineModules
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_INLINEMODULES
#undef GEN_PASS_DECL_INLINEMODULES
#endif // GEN_PASS_DECL_INLINEMODULES
#ifdef GEN_PASS_DEF_INLINEMODULES
namespace impl {

template <typename DerivedT>
class InlineModulesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = InlineModulesBase;

  InlineModulesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  InlineModulesBase(const InlineModulesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-inline-modules");
  }
  ::llvm::StringRef getArgument() const override { return "arc-inline-modules"; }

  ::llvm::StringRef getDescription() const override { return "Eagerly inline private modules"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("InlineModules");
  }
  ::llvm::StringRef getName() const override { return "InlineModules"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(InlineModulesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_INLINEMODULES
#endif // GEN_PASS_DEF_INLINEMODULES

//===----------------------------------------------------------------------===//
// IsolateClocks
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ISOLATECLOCKS
#undef GEN_PASS_DECL_ISOLATECLOCKS
#endif // GEN_PASS_DECL_ISOLATECLOCKS
#ifdef GEN_PASS_DEF_ISOLATECLOCKS
namespace impl {

template <typename DerivedT>
class IsolateClocksBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = IsolateClocksBase;

  IsolateClocksBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  IsolateClocksBase(const IsolateClocksBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-isolate-clocks");
  }
  ::llvm::StringRef getArgument() const override { return "arc-isolate-clocks"; }

  ::llvm::StringRef getDescription() const override { return "Group clocked operations into clock domains"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("IsolateClocks");
  }
  ::llvm::StringRef getName() const override { return "IsolateClocks"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(IsolateClocksBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ISOLATECLOCKS
#endif // GEN_PASS_DEF_ISOLATECLOCKS

//===----------------------------------------------------------------------===//
// LatencyRetiming
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LATENCYRETIMING
#undef GEN_PASS_DECL_LATENCYRETIMING
#endif // GEN_PASS_DECL_LATENCYRETIMING
#ifdef GEN_PASS_DEF_LATENCYRETIMING
namespace impl {

template <typename DerivedT>
class LatencyRetimingBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LatencyRetimingBase;

  LatencyRetimingBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LatencyRetimingBase(const LatencyRetimingBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-latency-retiming");
  }
  ::llvm::StringRef getArgument() const override { return "arc-latency-retiming"; }

  ::llvm::StringRef getDescription() const override { return "Push latencies through the design"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LatencyRetiming");
  }
  ::llvm::StringRef getName() const override { return "LatencyRetiming"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LatencyRetimingBase<DerivedT>)

protected:
  ::mlir::Pass::Statistic numOpsRemoved{this, "num-ops-removed", "Number of zero-latency passthrough states removed"};
  ::mlir::Pass::Statistic latencyUnitsSaved{this, "latency-units-saved", "Number of latency units saved by merging them in a successor state"};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LATENCYRETIMING
#endif // GEN_PASS_DEF_LATENCYRETIMING

//===----------------------------------------------------------------------===//
// LegalizeStateUpdate
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LEGALIZESTATEUPDATE
#undef GEN_PASS_DECL_LEGALIZESTATEUPDATE
#endif // GEN_PASS_DECL_LEGALIZESTATEUPDATE
#ifdef GEN_PASS_DEF_LEGALIZESTATEUPDATE
namespace impl {

template <typename DerivedT>
class LegalizeStateUpdateBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LegalizeStateUpdateBase;

  LegalizeStateUpdateBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LegalizeStateUpdateBase(const LegalizeStateUpdateBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-legalize-state-update");
  }
  ::llvm::StringRef getArgument() const override { return "arc-legalize-state-update"; }

  ::llvm::StringRef getDescription() const override { return "Insert temporaries such that state reads don't see writes"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LegalizeStateUpdate");
  }
  ::llvm::StringRef getName() const override { return "LegalizeStateUpdate"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LegalizeStateUpdateBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LEGALIZESTATEUPDATE
#endif // GEN_PASS_DEF_LEGALIZESTATEUPDATE

//===----------------------------------------------------------------------===//
// LowerClocksToFuncs
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERCLOCKSTOFUNCS
#undef GEN_PASS_DECL_LOWERCLOCKSTOFUNCS
#endif // GEN_PASS_DECL_LOWERCLOCKSTOFUNCS
#ifdef GEN_PASS_DEF_LOWERCLOCKSTOFUNCS
namespace impl {

template <typename DerivedT>
class LowerClocksToFuncsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerClocksToFuncsBase;

  LowerClocksToFuncsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerClocksToFuncsBase(const LowerClocksToFuncsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-lower-clocks-to-funcs");
  }
  ::llvm::StringRef getArgument() const override { return "arc-lower-clocks-to-funcs"; }

  ::llvm::StringRef getDescription() const override { return "Lower clock trees into functions"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerClocksToFuncs");
  }
  ::llvm::StringRef getName() const override { return "LowerClocksToFuncs"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<mlir::func::FuncDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerClocksToFuncsBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERCLOCKSTOFUNCS
#endif // GEN_PASS_DEF_LOWERCLOCKSTOFUNCS

//===----------------------------------------------------------------------===//
// LowerLUT
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERLUT
#undef GEN_PASS_DECL_LOWERLUT
#endif // GEN_PASS_DECL_LOWERLUT
#ifdef GEN_PASS_DEF_LOWERLUT
namespace impl {

template <typename DerivedT>
class LowerLUTBase : public ::mlir::OperationPass<arc::DefineOp> {
public:
  using Base = LowerLUTBase;

  LowerLUTBase() : ::mlir::OperationPass<arc::DefineOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerLUTBase(const LowerLUTBase &other) : ::mlir::OperationPass<arc::DefineOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-lower-lut");
  }
  ::llvm::StringRef getArgument() const override { return "arc-lower-lut"; }

  ::llvm::StringRef getDescription() const override { return "Lowers arc.lut into a comb and hw only representation."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerLUT");
  }
  ::llvm::StringRef getName() const override { return "LowerLUT"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<hw::HWDialect>();

  registry.insert<comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerLUTBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERLUT
#endif // GEN_PASS_DEF_LOWERLUT

//===----------------------------------------------------------------------===//
// LowerState
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERSTATE
#undef GEN_PASS_DECL_LOWERSTATE
#endif // GEN_PASS_DECL_LOWERSTATE
#ifdef GEN_PASS_DEF_LOWERSTATE
namespace impl {

template <typename DerivedT>
class LowerStateBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerStateBase;

  LowerStateBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerStateBase(const LowerStateBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-lower-state");
  }
  ::llvm::StringRef getArgument() const override { return "arc-lower-state"; }

  ::llvm::StringRef getDescription() const override { return "Split state into read and write ops grouped by clock tree"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerState");
  }
  ::llvm::StringRef getName() const override { return "LowerState"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  registry.insert<mlir::scf::SCFDialect>();

  registry.insert<mlir::func::FuncDialect>();

  registry.insert<mlir::LLVM::LLVMDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerStateBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERSTATE
#endif // GEN_PASS_DEF_LOWERSTATE

//===----------------------------------------------------------------------===//
// MakeTables
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_MAKETABLES
#undef GEN_PASS_DECL_MAKETABLES
#endif // GEN_PASS_DECL_MAKETABLES
#ifdef GEN_PASS_DEF_MAKETABLES
namespace impl {

template <typename DerivedT>
class MakeTablesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = MakeTablesBase;

  MakeTablesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  MakeTablesBase(const MakeTablesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-make-tables");
  }
  ::llvm::StringRef getArgument() const override { return "arc-make-tables"; }

  ::llvm::StringRef getDescription() const override { return "Transform appropriate arc logic into lookup tables"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("MakeTables");
  }
  ::llvm::StringRef getName() const override { return "MakeTables"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(MakeTablesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_MAKETABLES
#endif // GEN_PASS_DEF_MAKETABLES

//===----------------------------------------------------------------------===//
// MuxToControlFlow
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_MUXTOCONTROLFLOW
#undef GEN_PASS_DECL_MUXTOCONTROLFLOW
#endif // GEN_PASS_DECL_MUXTOCONTROLFLOW
#ifdef GEN_PASS_DEF_MUXTOCONTROLFLOW
namespace impl {

template <typename DerivedT>
class MuxToControlFlowBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = MuxToControlFlowBase;

  MuxToControlFlowBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  MuxToControlFlowBase(const MuxToControlFlowBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-mux-to-control-flow");
  }
  ::llvm::StringRef getArgument() const override { return "arc-mux-to-control-flow"; }

  ::llvm::StringRef getDescription() const override { return "Convert muxes with large independent fan-ins to if-statements"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("MuxToControlFlow");
  }
  ::llvm::StringRef getName() const override { return "MuxToControlFlow"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<mlir::scf::SCFDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(MuxToControlFlowBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_MUXTOCONTROLFLOW
#endif // GEN_PASS_DEF_MUXTOCONTROLFLOW

//===----------------------------------------------------------------------===//
// PrintStateInfo
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_PRINTSTATEINFO
struct PrintStateInfoOptions {
  std::string stateFile;
};
#undef GEN_PASS_DECL_PRINTSTATEINFO
#endif // GEN_PASS_DECL_PRINTSTATEINFO
#ifdef GEN_PASS_DEF_PRINTSTATEINFO
namespace impl {

template <typename DerivedT>
class PrintStateInfoBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintStateInfoBase;

  PrintStateInfoBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintStateInfoBase(const PrintStateInfoBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-print-state-info");
  }
  ::llvm::StringRef getArgument() const override { return "arc-print-state-info"; }

  ::llvm::StringRef getDescription() const override { return "Print the state storage layout in JSON format"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrintStateInfo");
  }
  ::llvm::StringRef getName() const override { return "PrintStateInfo"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintStateInfoBase<DerivedT>)

  PrintStateInfoBase(const PrintStateInfoOptions &options) : PrintStateInfoBase() {
    stateFile = options.stateFile;
  }
protected:
  ::mlir::Pass::Option<std::string> stateFile{*this, "state-file", ::llvm::cl::desc("Emit file with state description")};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_PRINTSTATEINFO
#endif // GEN_PASS_DEF_PRINTSTATEINFO

//===----------------------------------------------------------------------===//
// SimplifyVariadicOps
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_SIMPLIFYVARIADICOPS
#undef GEN_PASS_DECL_SIMPLIFYVARIADICOPS
#endif // GEN_PASS_DECL_SIMPLIFYVARIADICOPS
#ifdef GEN_PASS_DEF_SIMPLIFYVARIADICOPS
namespace impl {

template <typename DerivedT>
class SimplifyVariadicOpsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = SimplifyVariadicOpsBase;

  SimplifyVariadicOpsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  SimplifyVariadicOpsBase(const SimplifyVariadicOpsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-simplify-variadic-ops");
  }
  ::llvm::StringRef getArgument() const override { return "arc-simplify-variadic-ops"; }

  ::llvm::StringRef getDescription() const override { return "Convert variadic ops into distributed binary ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("SimplifyVariadicOps");
  }
  ::llvm::StringRef getName() const override { return "SimplifyVariadicOps"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(SimplifyVariadicOpsBase<DerivedT>)

protected:
  ::mlir::Pass::Statistic numOpsSkippedMultipleBlocks{this, "skipped-multiple-blocks", "Ops skipped due to operands in different blocks"};
  ::mlir::Pass::Statistic numOpsSimplified{this, "simplified", "Ops simplified into binary ops"};
  ::mlir::Pass::Statistic numOpsCreated{this, "created", "Ops created as part of simplification"};
  ::mlir::Pass::Statistic numOpsReordered{this, "reordered", "Ops where simplification reordered operands"};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_SIMPLIFYVARIADICOPS
#endif // GEN_PASS_DEF_SIMPLIFYVARIADICOPS

//===----------------------------------------------------------------------===//
// SplitLoops
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_SPLITLOOPS
#undef GEN_PASS_DECL_SPLITLOOPS
#endif // GEN_PASS_DECL_SPLITLOOPS
#ifdef GEN_PASS_DEF_SPLITLOOPS
namespace impl {

template <typename DerivedT>
class SplitLoopsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = SplitLoopsBase;

  SplitLoopsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  SplitLoopsBase(const SplitLoopsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-split-loops");
  }
  ::llvm::StringRef getArgument() const override { return "arc-split-loops"; }

  ::llvm::StringRef getDescription() const override { return "Split arcs to break zero latency loops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("SplitLoops");
  }
  ::llvm::StringRef getName() const override { return "SplitLoops"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(SplitLoopsBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_SPLITLOOPS
#endif // GEN_PASS_DEF_SPLITLOOPS

//===----------------------------------------------------------------------===//
// StripSV
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_STRIPSV
#undef GEN_PASS_DECL_STRIPSV
#endif // GEN_PASS_DECL_STRIPSV
#ifdef GEN_PASS_DEF_STRIPSV
namespace impl {

template <typename DerivedT>
class StripSVBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = StripSVBase;

  StripSVBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  StripSVBase(const StripSVBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-strip-sv");
  }
  ::llvm::StringRef getArgument() const override { return "arc-strip-sv"; }

  ::llvm::StringRef getDescription() const override { return "Remove SV wire, reg, and assigns"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("StripSV");
  }
  ::llvm::StringRef getName() const override { return "StripSV"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  registry.insert<comb::CombDialect>();

  registry.insert<hw::HWDialect>();

  registry.insert<seq::SeqDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(StripSVBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_STRIPSV
#endif // GEN_PASS_DEF_STRIPSV
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// AddTaps Registration
//===----------------------------------------------------------------------===//

inline void registerAddTaps() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createAddTapsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerAddTapsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createAddTapsPass();
  });
}

//===----------------------------------------------------------------------===//
// AllocateState Registration
//===----------------------------------------------------------------------===//

inline void registerAllocateState() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createAllocateStatePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerAllocateStatePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createAllocateStatePass();
  });
}

//===----------------------------------------------------------------------===//
// ArcCanonicalizer Registration
//===----------------------------------------------------------------------===//

inline void registerArcCanonicalizer() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createArcCanonicalizerPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerArcCanonicalizerPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createArcCanonicalizerPass();
  });
}

//===----------------------------------------------------------------------===//
// Dedup Registration
//===----------------------------------------------------------------------===//

inline void registerDedup() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createDedupPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerDedupPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createDedupPass();
  });
}

//===----------------------------------------------------------------------===//
// GroupResetsAndEnables Registration
//===----------------------------------------------------------------------===//

inline void registerGroupResetsAndEnables() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createGroupResetsAndEnablesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerGroupResetsAndEnablesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createGroupResetsAndEnablesPass();
  });
}

//===----------------------------------------------------------------------===//
// InferMemories Registration
//===----------------------------------------------------------------------===//

inline void registerInferMemories() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createInferMemoriesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerInferMemoriesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createInferMemoriesPass();
  });
}

//===----------------------------------------------------------------------===//
// InferStateProperties Registration
//===----------------------------------------------------------------------===//

inline void registerInferStateProperties() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createInferStatePropertiesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerInferStatePropertiesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createInferStatePropertiesPass();
  });
}

//===----------------------------------------------------------------------===//
// InlineArcs Registration
//===----------------------------------------------------------------------===//

inline void registerInlineArcs() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createInlineArcsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerInlineArcsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createInlineArcsPass();
  });
}

//===----------------------------------------------------------------------===//
// InlineModules Registration
//===----------------------------------------------------------------------===//

inline void registerInlineModules() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createInlineModulesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerInlineModulesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createInlineModulesPass();
  });
}

//===----------------------------------------------------------------------===//
// IsolateClocks Registration
//===----------------------------------------------------------------------===//

inline void registerIsolateClocks() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createIsolateClocksPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerIsolateClocksPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createIsolateClocksPass();
  });
}

//===----------------------------------------------------------------------===//
// LatencyRetiming Registration
//===----------------------------------------------------------------------===//

inline void registerLatencyRetiming() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createLatencyRetimingPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLatencyRetimingPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createLatencyRetimingPass();
  });
}

//===----------------------------------------------------------------------===//
// LegalizeStateUpdate Registration
//===----------------------------------------------------------------------===//

inline void registerLegalizeStateUpdate() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createLegalizeStateUpdatePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLegalizeStateUpdatePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createLegalizeStateUpdatePass();
  });
}

//===----------------------------------------------------------------------===//
// LowerClocksToFuncs Registration
//===----------------------------------------------------------------------===//

inline void registerLowerClocksToFuncs() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createLowerClocksToFuncsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerClocksToFuncsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createLowerClocksToFuncsPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerLUT Registration
//===----------------------------------------------------------------------===//

inline void registerLowerLUT() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createLowerLUTPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerLUTPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createLowerLUTPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerState Registration
//===----------------------------------------------------------------------===//

inline void registerLowerState() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createLowerStatePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerStatePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createLowerStatePass();
  });
}

//===----------------------------------------------------------------------===//
// MakeTables Registration
//===----------------------------------------------------------------------===//

inline void registerMakeTables() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createMakeTablesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerMakeTablesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createMakeTablesPass();
  });
}

//===----------------------------------------------------------------------===//
// MuxToControlFlow Registration
//===----------------------------------------------------------------------===//

inline void registerMuxToControlFlow() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createMuxToControlFlowPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerMuxToControlFlowPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createMuxToControlFlowPass();
  });
}

//===----------------------------------------------------------------------===//
// PrintStateInfo Registration
//===----------------------------------------------------------------------===//

inline void registerPrintStateInfo() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createPrintStateInfoPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerPrintStateInfoPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createPrintStateInfoPass();
  });
}

//===----------------------------------------------------------------------===//
// SimplifyVariadicOps Registration
//===----------------------------------------------------------------------===//

inline void registerSimplifyVariadicOps() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createSimplifyVariadicOpsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerSimplifyVariadicOpsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createSimplifyVariadicOpsPass();
  });
}

//===----------------------------------------------------------------------===//
// SplitLoops Registration
//===----------------------------------------------------------------------===//

inline void registerSplitLoops() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createSplitLoopsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerSplitLoopsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createSplitLoopsPass();
  });
}

//===----------------------------------------------------------------------===//
// StripSV Registration
//===----------------------------------------------------------------------===//

inline void registerStripSV() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createStripSVPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerStripSVPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::arc::createStripSVPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerAddTaps();
  registerAllocateState();
  registerArcCanonicalizer();
  registerDedup();
  registerGroupResetsAndEnables();
  registerInferMemories();
  registerInferStateProperties();
  registerInlineArcs();
  registerInlineModules();
  registerIsolateClocks();
  registerLatencyRetiming();
  registerLegalizeStateUpdate();
  registerLowerClocksToFuncs();
  registerLowerLUT();
  registerLowerState();
  registerMakeTables();
  registerMuxToControlFlow();
  registerPrintStateInfo();
  registerSimplifyVariadicOps();
  registerSplitLoops();
  registerStripSV();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class AddTapsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = AddTapsBase;

  AddTapsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  AddTapsBase(const AddTapsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-add-taps");
  }
  ::llvm::StringRef getArgument() const override { return "arc-add-taps"; }

  ::llvm::StringRef getDescription() const override { return "Add taps to ports and wires such that they remain observable"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AddTaps");
  }
  ::llvm::StringRef getName() const override { return "AddTaps"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AddTapsBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> tapPorts{*this, "ports", ::llvm::cl::desc("Make module ports observable"), ::llvm::cl::init(true)};
  ::mlir::Pass::Option<bool> tapWires{*this, "wires", ::llvm::cl::desc("Make wires observable"), ::llvm::cl::init(true)};
  ::mlir::Pass::Option<bool> tapNamedValues{*this, "named-values", ::llvm::cl::desc("Make values with `sv.namehint` observable"), ::llvm::cl::init(false)};
};

template <typename DerivedT>
class AllocateStateBase : public ::mlir::OperationPass<arc::ModelOp> {
public:
  using Base = AllocateStateBase;

  AllocateStateBase() : ::mlir::OperationPass<arc::ModelOp>(::mlir::TypeID::get<DerivedT>()) {}
  AllocateStateBase(const AllocateStateBase &other) : ::mlir::OperationPass<arc::ModelOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-allocate-state");
  }
  ::llvm::StringRef getArgument() const override { return "arc-allocate-state"; }

  ::llvm::StringRef getDescription() const override { return "Allocate and layout the global simulation state"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AllocateState");
  }
  ::llvm::StringRef getName() const override { return "AllocateState"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AllocateStateBase<DerivedT>)

protected:
};

template <typename DerivedT>
class ArcCanonicalizerBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ArcCanonicalizerBase;

  ArcCanonicalizerBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ArcCanonicalizerBase(const ArcCanonicalizerBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-canonicalizer");
  }
  ::llvm::StringRef getArgument() const override { return "arc-canonicalizer"; }

  ::llvm::StringRef getDescription() const override { return "Simulation centric canonicalizations"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ArcCanonicalizer");
  }
  ::llvm::StringRef getName() const override { return "ArcCanonicalizer"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<hw::HWDialect>();

  registry.insert<comb::CombDialect>();

  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ArcCanonicalizerBase<DerivedT>)

protected:
  ::mlir::Pass::Statistic numArcArgsRemoved{this, "num-arc-args-removed", "Number of arguments removed from DefineOps"};
};

template <typename DerivedT>
class DedupBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = DedupBase;

  DedupBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  DedupBase(const DedupBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-dedup");
  }
  ::llvm::StringRef getArgument() const override { return "arc-dedup"; }

  ::llvm::StringRef getDescription() const override { return "Deduplicate identical arc definitions"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Dedup");
  }
  ::llvm::StringRef getName() const override { return "Dedup"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(DedupBase<DerivedT>)

protected:
  ::mlir::Pass::Statistic dedupPassNumArcsDeduped{this, "dedupPassNumArcsDeduped", "Number of arcs deduped"};
  ::mlir::Pass::Statistic dedupPassTotalOps{this, "dedupPassTotalOps", "Total number of ops deduped"};
};

template <typename DerivedT>
class GroupResetsAndEnablesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = GroupResetsAndEnablesBase;

  GroupResetsAndEnablesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  GroupResetsAndEnablesBase(const GroupResetsAndEnablesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-group-resets-and-enables");
  }
  ::llvm::StringRef getArgument() const override { return "arc-group-resets-and-enables"; }

  ::llvm::StringRef getDescription() const override { return "Group reset and enable conditions of lowered states"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("GroupResetsAndEnables");
  }
  ::llvm::StringRef getName() const override { return "GroupResetsAndEnables"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  registry.insert<mlir::scf::SCFDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(GroupResetsAndEnablesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class InferMemoriesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = InferMemoriesBase;

  InferMemoriesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  InferMemoriesBase(const InferMemoriesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-infer-memories");
  }
  ::llvm::StringRef getArgument() const override { return "arc-infer-memories"; }

  ::llvm::StringRef getDescription() const override { return "Convert `FIRRTL_Memory` instances to dedicated memory ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("InferMemories");
  }
  ::llvm::StringRef getName() const override { return "InferMemories"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  registry.insert<comb::CombDialect>();

  registry.insert<seq::SeqDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(InferMemoriesBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> tapPorts{*this, "tap-ports", ::llvm::cl::desc("Make memory ports observable"), ::llvm::cl::init(true)};
};

template <typename DerivedT>
class InferStatePropertiesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = InferStatePropertiesBase;

  InferStatePropertiesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  InferStatePropertiesBase(const InferStatePropertiesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-infer-state-properties");
  }
  ::llvm::StringRef getArgument() const override { return "arc-infer-state-properties"; }

  ::llvm::StringRef getDescription() const override { return "Add resets and enables explicitly to the state operations"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("InferStateProperties");
  }
  ::llvm::StringRef getName() const override { return "InferStateProperties"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  registry.insert<circt::comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(InferStatePropertiesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class InlineArcsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = InlineArcsBase;

  InlineArcsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  InlineArcsBase(const InlineArcsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-inline");
  }
  ::llvm::StringRef getArgument() const override { return "arc-inline"; }

  ::llvm::StringRef getDescription() const override { return "Inline very small arcs"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("InlineArcs");
  }
  ::llvm::StringRef getName() const override { return "InlineArcs"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(InlineArcsBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> intoArcsOnly{*this, "into-arcs-only", ::llvm::cl::desc("Call operations to inline"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<unsigned> maxNonTrivialOpsInBody{*this, "max-body-ops", ::llvm::cl::desc("Max number of non-trivial ops in the region to be inlined"), ::llvm::cl::init(3)};
  ::mlir::Pass::Statistic numInlinedArcs{this, "inlined-arcs", "Arcs inlined at a use site"};
  ::mlir::Pass::Statistic numRemovedArcs{this, "removed-arcs", "Arcs removed after full inlining"};
  ::mlir::Pass::Statistic numTrivialArcs{this, "trivial-arcs", "Arcs with very few ops"};
  ::mlir::Pass::Statistic numSingleUseArcs{this, "single-use-arcs", "Arcs with a single use"};
};

template <typename DerivedT>
class InlineModulesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = InlineModulesBase;

  InlineModulesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  InlineModulesBase(const InlineModulesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-inline-modules");
  }
  ::llvm::StringRef getArgument() const override { return "arc-inline-modules"; }

  ::llvm::StringRef getDescription() const override { return "Eagerly inline private modules"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("InlineModules");
  }
  ::llvm::StringRef getName() const override { return "InlineModules"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(InlineModulesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class IsolateClocksBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = IsolateClocksBase;

  IsolateClocksBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  IsolateClocksBase(const IsolateClocksBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-isolate-clocks");
  }
  ::llvm::StringRef getArgument() const override { return "arc-isolate-clocks"; }

  ::llvm::StringRef getDescription() const override { return "Group clocked operations into clock domains"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("IsolateClocks");
  }
  ::llvm::StringRef getName() const override { return "IsolateClocks"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(IsolateClocksBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LatencyRetimingBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LatencyRetimingBase;

  LatencyRetimingBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LatencyRetimingBase(const LatencyRetimingBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-latency-retiming");
  }
  ::llvm::StringRef getArgument() const override { return "arc-latency-retiming"; }

  ::llvm::StringRef getDescription() const override { return "Push latencies through the design"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LatencyRetiming");
  }
  ::llvm::StringRef getName() const override { return "LatencyRetiming"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LatencyRetimingBase<DerivedT>)

protected:
  ::mlir::Pass::Statistic numOpsRemoved{this, "num-ops-removed", "Number of zero-latency passthrough states removed"};
  ::mlir::Pass::Statistic latencyUnitsSaved{this, "latency-units-saved", "Number of latency units saved by merging them in a successor state"};
};

template <typename DerivedT>
class LegalizeStateUpdateBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LegalizeStateUpdateBase;

  LegalizeStateUpdateBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LegalizeStateUpdateBase(const LegalizeStateUpdateBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-legalize-state-update");
  }
  ::llvm::StringRef getArgument() const override { return "arc-legalize-state-update"; }

  ::llvm::StringRef getDescription() const override { return "Insert temporaries such that state reads don't see writes"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LegalizeStateUpdate");
  }
  ::llvm::StringRef getName() const override { return "LegalizeStateUpdate"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LegalizeStateUpdateBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerClocksToFuncsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerClocksToFuncsBase;

  LowerClocksToFuncsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerClocksToFuncsBase(const LowerClocksToFuncsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-lower-clocks-to-funcs");
  }
  ::llvm::StringRef getArgument() const override { return "arc-lower-clocks-to-funcs"; }

  ::llvm::StringRef getDescription() const override { return "Lower clock trees into functions"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerClocksToFuncs");
  }
  ::llvm::StringRef getName() const override { return "LowerClocksToFuncs"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<mlir::func::FuncDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerClocksToFuncsBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerLUTBase : public ::mlir::OperationPass<arc::DefineOp> {
public:
  using Base = LowerLUTBase;

  LowerLUTBase() : ::mlir::OperationPass<arc::DefineOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerLUTBase(const LowerLUTBase &other) : ::mlir::OperationPass<arc::DefineOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-lower-lut");
  }
  ::llvm::StringRef getArgument() const override { return "arc-lower-lut"; }

  ::llvm::StringRef getDescription() const override { return "Lowers arc.lut into a comb and hw only representation."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerLUT");
  }
  ::llvm::StringRef getName() const override { return "LowerLUT"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<hw::HWDialect>();

  registry.insert<comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerLUTBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerStateBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerStateBase;

  LowerStateBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerStateBase(const LowerStateBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-lower-state");
  }
  ::llvm::StringRef getArgument() const override { return "arc-lower-state"; }

  ::llvm::StringRef getDescription() const override { return "Split state into read and write ops grouped by clock tree"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerState");
  }
  ::llvm::StringRef getName() const override { return "LowerState"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  registry.insert<mlir::scf::SCFDialect>();

  registry.insert<mlir::func::FuncDialect>();

  registry.insert<mlir::LLVM::LLVMDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerStateBase<DerivedT>)

protected:
};

template <typename DerivedT>
class MakeTablesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = MakeTablesBase;

  MakeTablesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  MakeTablesBase(const MakeTablesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-make-tables");
  }
  ::llvm::StringRef getArgument() const override { return "arc-make-tables"; }

  ::llvm::StringRef getDescription() const override { return "Transform appropriate arc logic into lookup tables"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("MakeTables");
  }
  ::llvm::StringRef getName() const override { return "MakeTables"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(MakeTablesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class MuxToControlFlowBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = MuxToControlFlowBase;

  MuxToControlFlowBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  MuxToControlFlowBase(const MuxToControlFlowBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-mux-to-control-flow");
  }
  ::llvm::StringRef getArgument() const override { return "arc-mux-to-control-flow"; }

  ::llvm::StringRef getDescription() const override { return "Convert muxes with large independent fan-ins to if-statements"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("MuxToControlFlow");
  }
  ::llvm::StringRef getName() const override { return "MuxToControlFlow"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<mlir::scf::SCFDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(MuxToControlFlowBase<DerivedT>)

protected:
};

template <typename DerivedT>
class PrintStateInfoBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintStateInfoBase;

  PrintStateInfoBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintStateInfoBase(const PrintStateInfoBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-print-state-info");
  }
  ::llvm::StringRef getArgument() const override { return "arc-print-state-info"; }

  ::llvm::StringRef getDescription() const override { return "Print the state storage layout in JSON format"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrintStateInfo");
  }
  ::llvm::StringRef getName() const override { return "PrintStateInfo"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintStateInfoBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> stateFile{*this, "state-file", ::llvm::cl::desc("Emit file with state description")};
};

template <typename DerivedT>
class SimplifyVariadicOpsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = SimplifyVariadicOpsBase;

  SimplifyVariadicOpsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  SimplifyVariadicOpsBase(const SimplifyVariadicOpsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-simplify-variadic-ops");
  }
  ::llvm::StringRef getArgument() const override { return "arc-simplify-variadic-ops"; }

  ::llvm::StringRef getDescription() const override { return "Convert variadic ops into distributed binary ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("SimplifyVariadicOps");
  }
  ::llvm::StringRef getName() const override { return "SimplifyVariadicOps"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(SimplifyVariadicOpsBase<DerivedT>)

protected:
  ::mlir::Pass::Statistic numOpsSkippedMultipleBlocks{this, "skipped-multiple-blocks", "Ops skipped due to operands in different blocks"};
  ::mlir::Pass::Statistic numOpsSimplified{this, "simplified", "Ops simplified into binary ops"};
  ::mlir::Pass::Statistic numOpsCreated{this, "created", "Ops created as part of simplification"};
  ::mlir::Pass::Statistic numOpsReordered{this, "reordered", "Ops where simplification reordered operands"};
};

template <typename DerivedT>
class SplitLoopsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = SplitLoopsBase;

  SplitLoopsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  SplitLoopsBase(const SplitLoopsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-split-loops");
  }
  ::llvm::StringRef getArgument() const override { return "arc-split-loops"; }

  ::llvm::StringRef getDescription() const override { return "Split arcs to break zero latency loops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("SplitLoops");
  }
  ::llvm::StringRef getName() const override { return "SplitLoops"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(SplitLoopsBase<DerivedT>)

protected:
};

template <typename DerivedT>
class StripSVBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = StripSVBase;

  StripSVBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  StripSVBase(const StripSVBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arc-strip-sv");
  }
  ::llvm::StringRef getArgument() const override { return "arc-strip-sv"; }

  ::llvm::StringRef getDescription() const override { return "Remove SV wire, reg, and assigns"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("StripSV");
  }
  ::llvm::StringRef getName() const override { return "StripSV"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arc::ArcDialect>();

  registry.insert<comb::CombDialect>();

  registry.insert<hw::HWDialect>();

  registry.insert<seq::SeqDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(StripSVBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
