/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_CLKINSERTION
#define GEN_PASS_DECL_COMPILECONTROL
#define GEN_PASS_DECL_GOINSERTION
#define GEN_PASS_DECL_GROUPINVARIANTCODEMOTION
#define GEN_PASS_DECL_REMOVECOMBGROUPS
#define GEN_PASS_DECL_REMOVEGROUPS
#define GEN_PASS_DECL_RESETINSERTION
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// ClkInsertion
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_CLKINSERTION
#undef GEN_PASS_DECL_CLKINSERTION
#endif // GEN_PASS_DECL_CLKINSERTION
#ifdef GEN_PASS_DEF_CLKINSERTION
namespace impl {

template <typename DerivedT>
class ClkInsertionBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = ClkInsertionBase;

  ClkInsertionBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  ClkInsertionBase(const ClkInsertionBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-clk-insertion");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-clk-insertion"; }

  ::llvm::StringRef getDescription() const override { return "Inserts assignments from component clock to sub-component clock."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ClkInsertion");
  }
  ::llvm::StringRef getName() const override { return "ClkInsertion"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ClkInsertionBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_CLKINSERTION
#endif // GEN_PASS_DEF_CLKINSERTION

//===----------------------------------------------------------------------===//
// CompileControl
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_COMPILECONTROL
#undef GEN_PASS_DECL_COMPILECONTROL
#endif // GEN_PASS_DECL_COMPILECONTROL
#ifdef GEN_PASS_DEF_COMPILECONTROL
namespace impl {

template <typename DerivedT>
class CompileControlBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = CompileControlBase;

  CompileControlBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  CompileControlBase(const CompileControlBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-compile-control");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-compile-control"; }

  ::llvm::StringRef getDescription() const override { return "Generates latency-insensitive finite state machines to realize control."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("CompileControl");
  }
  ::llvm::StringRef getName() const override { return "CompileControl"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<comb::CombDialect>();

  registry.insert<hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(CompileControlBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_COMPILECONTROL
#endif // GEN_PASS_DEF_COMPILECONTROL

//===----------------------------------------------------------------------===//
// GoInsertion
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_GOINSERTION
#undef GEN_PASS_DECL_GOINSERTION
#endif // GEN_PASS_DECL_GOINSERTION
#ifdef GEN_PASS_DEF_GOINSERTION
namespace impl {

template <typename DerivedT>
class GoInsertionBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = GoInsertionBase;

  GoInsertionBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  GoInsertionBase(const GoInsertionBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-go-insertion");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-go-insertion"; }

  ::llvm::StringRef getDescription() const override { return "Insert go signals into the guards of a group's non-hole assignments"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("GoInsertion");
  }
  ::llvm::StringRef getName() const override { return "GoInsertion"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(GoInsertionBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_GOINSERTION
#endif // GEN_PASS_DEF_GOINSERTION

//===----------------------------------------------------------------------===//
// GroupInvariantCodeMotion
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_GROUPINVARIANTCODEMOTION
#undef GEN_PASS_DECL_GROUPINVARIANTCODEMOTION
#endif // GEN_PASS_DECL_GROUPINVARIANTCODEMOTION
#ifdef GEN_PASS_DEF_GROUPINVARIANTCODEMOTION
namespace impl {

template <typename DerivedT>
class GroupInvariantCodeMotionBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = GroupInvariantCodeMotionBase;

  GroupInvariantCodeMotionBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  GroupInvariantCodeMotionBase(const GroupInvariantCodeMotionBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-gicm");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-gicm"; }

  ::llvm::StringRef getDescription() const override { return "Lift group-invariant operations to wire-scope."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("GroupInvariantCodeMotion");
  }
  ::llvm::StringRef getName() const override { return "GroupInvariantCodeMotion"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(GroupInvariantCodeMotionBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_GROUPINVARIANTCODEMOTION
#endif // GEN_PASS_DEF_GROUPINVARIANTCODEMOTION

//===----------------------------------------------------------------------===//
// RemoveCombGroups
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_REMOVECOMBGROUPS
#undef GEN_PASS_DECL_REMOVECOMBGROUPS
#endif // GEN_PASS_DECL_REMOVECOMBGROUPS
#ifdef GEN_PASS_DEF_REMOVECOMBGROUPS
namespace impl {

template <typename DerivedT>
class RemoveCombGroupsBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = RemoveCombGroupsBase;

  RemoveCombGroupsBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  RemoveCombGroupsBase(const RemoveCombGroupsBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-remove-comb-groups");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-remove-comb-groups"; }

  ::llvm::StringRef getDescription() const override { return "Removes combinational groups from a Calyx component."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RemoveCombGroups");
  }
  ::llvm::StringRef getName() const override { return "RemoveCombGroups"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RemoveCombGroupsBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_REMOVECOMBGROUPS
#endif // GEN_PASS_DEF_REMOVECOMBGROUPS

//===----------------------------------------------------------------------===//
// RemoveGroups
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_REMOVEGROUPS
#undef GEN_PASS_DECL_REMOVEGROUPS
#endif // GEN_PASS_DECL_REMOVEGROUPS
#ifdef GEN_PASS_DEF_REMOVEGROUPS
namespace impl {

template <typename DerivedT>
class RemoveGroupsBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = RemoveGroupsBase;

  RemoveGroupsBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  RemoveGroupsBase(const RemoveGroupsBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-remove-groups");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-remove-groups"; }

  ::llvm::StringRef getDescription() const override { return "Inlines the groups in a Calyx component."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RemoveGroups");
  }
  ::llvm::StringRef getName() const override { return "RemoveGroups"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RemoveGroupsBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_REMOVEGROUPS
#endif // GEN_PASS_DEF_REMOVEGROUPS

//===----------------------------------------------------------------------===//
// ResetInsertion
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_RESETINSERTION
#undef GEN_PASS_DECL_RESETINSERTION
#endif // GEN_PASS_DECL_RESETINSERTION
#ifdef GEN_PASS_DEF_RESETINSERTION
namespace impl {

template <typename DerivedT>
class ResetInsertionBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = ResetInsertionBase;

  ResetInsertionBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  ResetInsertionBase(const ResetInsertionBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-reset-insertion");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-reset-insertion"; }

  ::llvm::StringRef getDescription() const override { return "Connect component reset to sub-component reset for applicable components."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ResetInsertion");
  }
  ::llvm::StringRef getName() const override { return "ResetInsertion"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ResetInsertionBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_RESETINSERTION
#endif // GEN_PASS_DEF_RESETINSERTION
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ClkInsertion Registration
//===----------------------------------------------------------------------===//

inline void registerClkInsertion() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createClkInsertionPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerClkInsertionPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createClkInsertionPass();
  });
}

//===----------------------------------------------------------------------===//
// CompileControl Registration
//===----------------------------------------------------------------------===//

inline void registerCompileControl() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createCompileControlPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerCompileControlPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createCompileControlPass();
  });
}

//===----------------------------------------------------------------------===//
// GoInsertion Registration
//===----------------------------------------------------------------------===//

inline void registerGoInsertion() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createGoInsertionPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerGoInsertionPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createGoInsertionPass();
  });
}

//===----------------------------------------------------------------------===//
// GroupInvariantCodeMotion Registration
//===----------------------------------------------------------------------===//

inline void registerGroupInvariantCodeMotion() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createGroupInvariantCodeMotionPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerGroupInvariantCodeMotionPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createGroupInvariantCodeMotionPass();
  });
}

//===----------------------------------------------------------------------===//
// RemoveCombGroups Registration
//===----------------------------------------------------------------------===//

inline void registerRemoveCombGroups() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createRemoveCombGroupsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRemoveCombGroupsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createRemoveCombGroupsPass();
  });
}

//===----------------------------------------------------------------------===//
// RemoveGroups Registration
//===----------------------------------------------------------------------===//

inline void registerRemoveGroups() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createRemoveGroupsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRemoveGroupsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createRemoveGroupsPass();
  });
}

//===----------------------------------------------------------------------===//
// ResetInsertion Registration
//===----------------------------------------------------------------------===//

inline void registerResetInsertion() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createResetInsertionPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerResetInsertionPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::calyx::createResetInsertionPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerClkInsertion();
  registerCompileControl();
  registerGoInsertion();
  registerGroupInvariantCodeMotion();
  registerRemoveCombGroups();
  registerRemoveGroups();
  registerResetInsertion();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class ClkInsertionBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = ClkInsertionBase;

  ClkInsertionBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  ClkInsertionBase(const ClkInsertionBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-clk-insertion");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-clk-insertion"; }

  ::llvm::StringRef getDescription() const override { return "Inserts assignments from component clock to sub-component clock."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ClkInsertion");
  }
  ::llvm::StringRef getName() const override { return "ClkInsertion"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ClkInsertionBase<DerivedT>)

protected:
};

template <typename DerivedT>
class CompileControlBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = CompileControlBase;

  CompileControlBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  CompileControlBase(const CompileControlBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-compile-control");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-compile-control"; }

  ::llvm::StringRef getDescription() const override { return "Generates latency-insensitive finite state machines to realize control."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("CompileControl");
  }
  ::llvm::StringRef getName() const override { return "CompileControl"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<comb::CombDialect>();

  registry.insert<hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(CompileControlBase<DerivedT>)

protected:
};

template <typename DerivedT>
class GoInsertionBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = GoInsertionBase;

  GoInsertionBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  GoInsertionBase(const GoInsertionBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-go-insertion");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-go-insertion"; }

  ::llvm::StringRef getDescription() const override { return "Insert go signals into the guards of a group's non-hole assignments"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("GoInsertion");
  }
  ::llvm::StringRef getName() const override { return "GoInsertion"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(GoInsertionBase<DerivedT>)

protected:
};

template <typename DerivedT>
class GroupInvariantCodeMotionBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = GroupInvariantCodeMotionBase;

  GroupInvariantCodeMotionBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  GroupInvariantCodeMotionBase(const GroupInvariantCodeMotionBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-gicm");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-gicm"; }

  ::llvm::StringRef getDescription() const override { return "Lift group-invariant operations to wire-scope."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("GroupInvariantCodeMotion");
  }
  ::llvm::StringRef getName() const override { return "GroupInvariantCodeMotion"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(GroupInvariantCodeMotionBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RemoveCombGroupsBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = RemoveCombGroupsBase;

  RemoveCombGroupsBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  RemoveCombGroupsBase(const RemoveCombGroupsBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-remove-comb-groups");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-remove-comb-groups"; }

  ::llvm::StringRef getDescription() const override { return "Removes combinational groups from a Calyx component."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RemoveCombGroups");
  }
  ::llvm::StringRef getName() const override { return "RemoveCombGroups"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RemoveCombGroupsBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RemoveGroupsBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = RemoveGroupsBase;

  RemoveGroupsBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  RemoveGroupsBase(const RemoveGroupsBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-remove-groups");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-remove-groups"; }

  ::llvm::StringRef getDescription() const override { return "Inlines the groups in a Calyx component."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RemoveGroups");
  }
  ::llvm::StringRef getName() const override { return "RemoveGroups"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RemoveGroupsBase<DerivedT>)

protected:
};

template <typename DerivedT>
class ResetInsertionBase : public ::mlir::OperationPass<calyx::ComponentOp> {
public:
  using Base = ResetInsertionBase;

  ResetInsertionBase() : ::mlir::OperationPass<calyx::ComponentOp>(::mlir::TypeID::get<DerivedT>()) {}
  ResetInsertionBase(const ResetInsertionBase &other) : ::mlir::OperationPass<calyx::ComponentOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("calyx-reset-insertion");
  }
  ::llvm::StringRef getArgument() const override { return "calyx-reset-insertion"; }

  ::llvm::StringRef getDescription() const override { return "Connect component reset to sub-component reset for applicable components."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ResetInsertion");
  }
  ::llvm::StringRef getName() const override { return "ResetInsertion"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ResetInsertionBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
