/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace circt {
namespace esi {
class ChannelOpInterface;
namespace detail {
struct ChannelOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    circt::esi::ChannelType (*channelType)(const Concept *impl, ::mlir::Operation *);
    mlir::Type (*innerType)(const Concept *impl, ::mlir::Operation *);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = circt::esi::ChannelOpInterface;
    Model() : Concept{channelType, innerType} {}

    static inline circt::esi::ChannelType channelType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::Type innerType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = circt::esi::ChannelOpInterface;
    FallbackModel() : Concept{channelType, innerType} {}

    static inline circt::esi::ChannelType channelType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::Type innerType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    mlir::Type innerType(::mlir::Operation *tablegen_opaque_val) const;
  };
};template <typename ConcreteOp>
struct ChannelOpInterfaceTrait;

} // namespace detail
class ChannelOpInterface : public ::mlir::OpInterface<ChannelOpInterface, detail::ChannelOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<ChannelOpInterface, detail::ChannelOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::ChannelOpInterfaceTrait<ConcreteOp> {};
  /// "Returns the channel type of this operation."
  circt::esi::ChannelType channelType();
  /// "Returns the inner type of this channel. This will be the type of the
  ///            data value of the channel, if the channel carries data semantics. Else,
  ///            return NoneType."
  mlir::Type innerType();
};
namespace detail {
  template <typename ConcreteOp>
  struct ChannelOpInterfaceTrait : public ::mlir::OpInterface<ChannelOpInterface, detail::ChannelOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
    /// "Returns the inner type of this channel. This will be the type of the
    ///            data value of the channel, if the channel carries data semantics. Else,
    ///            return NoneType."
    mlir::Type innerType() {
      return (*static_cast<ConcreteOp *>(this)).channelType().getInner();
    }
  };
}// namespace detail
} // namespace esi
} // namespace circt
namespace circt {
namespace esi {
class ServiceDeclOpInterface;
namespace detail {
struct ServiceDeclOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    void (*getPortList)(const Concept *impl, ::mlir::Operation *, llvm::SmallVectorImpl<ServicePortInfo>&);
    mlir::LogicalResult (*validateRequest)(const Concept *impl, ::mlir::Operation *, mlir::Operation*);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = circt::esi::ServiceDeclOpInterface;
    Model() : Concept{getPortList, validateRequest} {}

    static inline void getPortList(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, llvm::SmallVectorImpl<ServicePortInfo>& ports);
    static inline mlir::LogicalResult validateRequest(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, mlir::Operation* req);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = circt::esi::ServiceDeclOpInterface;
    FallbackModel() : Concept{getPortList, validateRequest} {}

    static inline void getPortList(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, llvm::SmallVectorImpl<ServicePortInfo>& ports);
    static inline mlir::LogicalResult validateRequest(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, mlir::Operation* req);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    mlir::LogicalResult validateRequest(::mlir::Operation *tablegen_opaque_val, mlir::Operation*req) const;
  };
};template <typename ConcreteOp>
struct ServiceDeclOpInterfaceTrait;

} // namespace detail
class ServiceDeclOpInterface : public ::mlir::OpInterface<ServiceDeclOpInterface, detail::ServiceDeclOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<ServiceDeclOpInterface, detail::ServiceDeclOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::ServiceDeclOpInterfaceTrait<ConcreteOp> {};
  /// Returns the list of interface ports for this service interface.
  void getPortList(llvm::SmallVectorImpl<ServicePortInfo>& ports);
  /// Validate this service request against this service decl.
  mlir::LogicalResult validateRequest(mlir::Operation* req);
};
namespace detail {
  template <typename ConcreteOp>
  struct ServiceDeclOpInterfaceTrait : public ::mlir::OpInterface<ServiceDeclOpInterface, detail::ServiceDeclOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
    /// Validate this service request against this service decl.
    mlir::LogicalResult validateRequest(mlir::Operation* req) {
      return circt::esi::validateServiceConnectionRequest((*static_cast<ConcreteOp *>(this)), req);
    }
  };
}// namespace detail
} // namespace esi
} // namespace circt
namespace circt {
namespace esi {
class ServiceReqOpInterface;
namespace detail {
struct ServiceReqOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    hw::InnerRefAttr (*getServicePort)(const Concept *impl, ::mlir::Operation *);
    ArrayAttr (*getClientNamePath)(const Concept *impl, ::mlir::Operation *);
    void (*setClientNamePath)(const Concept *impl, ::mlir::Operation *, ArrayAttr);
    Type (*getToClientType)(const Concept *impl, ::mlir::Operation *);
    Value (*getToClient)(const Concept *impl, ::mlir::Operation *);
    Type (*getToServerType)(const Concept *impl, ::mlir::Operation *);
    Value (*getToServer)(const Concept *impl, ::mlir::Operation *);
    void (*setToServer)(const Concept *impl, ::mlir::Operation *, Value);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = circt::esi::ServiceReqOpInterface;
    Model() : Concept{getServicePort, getClientNamePath, setClientNamePath, getToClientType, getToClient, getToServerType, getToServer, setToServer} {}

    static inline hw::InnerRefAttr getServicePort(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ArrayAttr getClientNamePath(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void setClientNamePath(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayAttr newClientNamePath);
    static inline Type getToClientType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline Value getToClient(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline Type getToServerType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline Value getToServer(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void setToServer(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, Value newValue);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = circt::esi::ServiceReqOpInterface;
    FallbackModel() : Concept{getServicePort, getClientNamePath, setClientNamePath, getToClientType, getToClient, getToServerType, getToServer, setToServer} {}

    static inline hw::InnerRefAttr getServicePort(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ArrayAttr getClientNamePath(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void setClientNamePath(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayAttr newClientNamePath);
    static inline Type getToClientType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline Value getToClient(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline Type getToServerType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline Value getToServer(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void setToServer(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, Value newValue);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    void setClientNamePath(::mlir::Operation *tablegen_opaque_val, ArrayAttr newClientNamePath) const;
    Value getToClient(::mlir::Operation *tablegen_opaque_val) const;
    Value getToServer(::mlir::Operation *tablegen_opaque_val) const;
    void setToServer(::mlir::Operation *tablegen_opaque_val, Value newValue) const;
  };
};template <typename ConcreteOp>
struct ServiceReqOpInterfaceTrait;

} // namespace detail
class ServiceReqOpInterface : public ::mlir::OpInterface<ServiceReqOpInterface, detail::ServiceReqOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<ServiceReqOpInterface, detail::ServiceReqOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::ServiceReqOpInterfaceTrait<ConcreteOp> {};
  /// Returns the service port symbol.
  hw::InnerRefAttr getServicePort();
  /// Returns the client name path.
  ArrayAttr getClientNamePath();
  /// Set the client name path.
  void setClientNamePath(ArrayAttr newClientNamePath);
  /// Returns the type headed to the client. Can be null.
  Type getToClientType();
  /// Returns the value headed to the client. Can be null.
  Value getToClient();
  /// Returns the type headed to the server. Can be null.
  Type getToServerType();
  /// Returns the value headed to the server. Can be null.
  Value getToServer();
  /// Set the value headed to the server. Can assert().
  void setToServer(Value newValue);
};
namespace detail {
  template <typename ConcreteOp>
  struct ServiceReqOpInterfaceTrait : public ::mlir::OpInterface<ServiceReqOpInterface, detail::ServiceReqOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
    /// Set the client name path.
    void setClientNamePath(ArrayAttr newClientNamePath) {
      (*static_cast<ConcreteOp *>(this)).setClientNamePathAttr(newClientNamePath);
    }
    /// Returns the value headed to the client. Can be null.
    Value getToClient() {
      return {};
    }
    /// Returns the value headed to the server. Can be null.
    Value getToServer() {
      return {};
    }
    /// Set the value headed to the server. Can assert().
    void setToServer(Value newValue) {
      assert(false && "This op doesn't support the to server direction");
    }
  };
}// namespace detail
} // namespace esi
} // namespace circt
namespace circt {
namespace esi {
template<typename ConcreteOp>
circt::esi::ChannelType detail::ChannelOpInterfaceInterfaceTraits::Model<ConcreteOp>::channelType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).channelType();
}
template<typename ConcreteOp>
mlir::Type detail::ChannelOpInterfaceInterfaceTraits::Model<ConcreteOp>::innerType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).innerType();
}
template<typename ConcreteOp>
circt::esi::ChannelType detail::ChannelOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::channelType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->channelType(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::Type detail::ChannelOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::innerType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->innerType(tablegen_opaque_val);
}
template<typename ConcreteModel, typename ConcreteOp>
mlir::Type detail::ChannelOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::innerType(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).channelType().getInner();
}
} // namespace esi
} // namespace circt
namespace circt {
namespace esi {
template<typename ConcreteOp>
void detail::ServiceDeclOpInterfaceInterfaceTraits::Model<ConcreteOp>::getPortList(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, llvm::SmallVectorImpl<ServicePortInfo>& ports) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getPortList(ports);
}
template<typename ConcreteOp>
mlir::LogicalResult detail::ServiceDeclOpInterfaceInterfaceTraits::Model<ConcreteOp>::validateRequest(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, mlir::Operation* req) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).validateRequest(req);
}
template<typename ConcreteOp>
void detail::ServiceDeclOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getPortList(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, llvm::SmallVectorImpl<ServicePortInfo>& ports) {
  return static_cast<const ConcreteOp *>(impl)->getPortList(tablegen_opaque_val, ports);
}
template<typename ConcreteOp>
mlir::LogicalResult detail::ServiceDeclOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::validateRequest(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, mlir::Operation* req) {
  return static_cast<const ConcreteOp *>(impl)->validateRequest(tablegen_opaque_val, req);
}
template<typename ConcreteModel, typename ConcreteOp>
mlir::LogicalResult detail::ServiceDeclOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::validateRequest(::mlir::Operation *tablegen_opaque_val, mlir::Operation*req) const {
return circt::esi::validateServiceConnectionRequest((llvm::cast<ConcreteOp>(tablegen_opaque_val)), req);
}
} // namespace esi
} // namespace circt
namespace circt {
namespace esi {
template<typename ConcreteOp>
hw::InnerRefAttr detail::ServiceReqOpInterfaceInterfaceTraits::Model<ConcreteOp>::getServicePort(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getServicePort();
}
template<typename ConcreteOp>
ArrayAttr detail::ServiceReqOpInterfaceInterfaceTraits::Model<ConcreteOp>::getClientNamePath(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getClientNamePath();
}
template<typename ConcreteOp>
void detail::ServiceReqOpInterfaceInterfaceTraits::Model<ConcreteOp>::setClientNamePath(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayAttr newClientNamePath) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).setClientNamePath(newClientNamePath);
}
template<typename ConcreteOp>
Type detail::ServiceReqOpInterfaceInterfaceTraits::Model<ConcreteOp>::getToClientType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  Value toClient = (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getToClient();
        if (!toClient)
          return {};
        return toClient.getType();
}
template<typename ConcreteOp>
Value detail::ServiceReqOpInterfaceInterfaceTraits::Model<ConcreteOp>::getToClient(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getToClient();
}
template<typename ConcreteOp>
Type detail::ServiceReqOpInterfaceInterfaceTraits::Model<ConcreteOp>::getToServerType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  Value toServer = (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getToServer();
        if (!toServer)
          return {};
        return toServer.getType();
}
template<typename ConcreteOp>
Value detail::ServiceReqOpInterfaceInterfaceTraits::Model<ConcreteOp>::getToServer(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getToServer();
}
template<typename ConcreteOp>
void detail::ServiceReqOpInterfaceInterfaceTraits::Model<ConcreteOp>::setToServer(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, Value newValue) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).setToServer(newValue);
}
template<typename ConcreteOp>
hw::InnerRefAttr detail::ServiceReqOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getServicePort(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getServicePort(tablegen_opaque_val);
}
template<typename ConcreteOp>
ArrayAttr detail::ServiceReqOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getClientNamePath(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getClientNamePath(tablegen_opaque_val);
}
template<typename ConcreteOp>
void detail::ServiceReqOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::setClientNamePath(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayAttr newClientNamePath) {
  return static_cast<const ConcreteOp *>(impl)->setClientNamePath(tablegen_opaque_val, newClientNamePath);
}
template<typename ConcreteOp>
Type detail::ServiceReqOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getToClientType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getToClientType(tablegen_opaque_val);
}
template<typename ConcreteOp>
Value detail::ServiceReqOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getToClient(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getToClient(tablegen_opaque_val);
}
template<typename ConcreteOp>
Type detail::ServiceReqOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getToServerType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getToServerType(tablegen_opaque_val);
}
template<typename ConcreteOp>
Value detail::ServiceReqOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getToServer(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getToServer(tablegen_opaque_val);
}
template<typename ConcreteOp>
void detail::ServiceReqOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::setToServer(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, Value newValue) {
  return static_cast<const ConcreteOp *>(impl)->setToServer(tablegen_opaque_val, newValue);
}
template<typename ConcreteModel, typename ConcreteOp>
void detail::ServiceReqOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::setClientNamePath(::mlir::Operation *tablegen_opaque_val, ArrayAttr newClientNamePath) const {
(llvm::cast<ConcreteOp>(tablegen_opaque_val)).setClientNamePathAttr(newClientNamePath);
}
template<typename ConcreteModel, typename ConcreteOp>
Value detail::ServiceReqOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getToClient(::mlir::Operation *tablegen_opaque_val) const {
return {};
}
template<typename ConcreteModel, typename ConcreteOp>
Value detail::ServiceReqOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getToServer(::mlir::Operation *tablegen_opaque_val) const {
return {};
}
template<typename ConcreteModel, typename ConcreteOp>
void detail::ServiceReqOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::setToServer(::mlir::Operation *tablegen_opaque_val, Value newValue) const {
assert(false && "This op doesn't support the to server direction");
}
} // namespace esi
} // namespace circt
