/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_ESIADDCPPAPI
#define GEN_PASS_DECL_ESICLEANMETADATA
#define GEN_PASS_DECL_ESICONNECTSERVICES
#define GEN_PASS_DECL_ESIEMITCOLLATERAL
#define GEN_PASS_DECL_LOWERESIPORTS
#define GEN_PASS_DECL_LOWERESITOPHYSICAL
#define GEN_PASS_DECL_LOWERESITYPES
#define GEN_PASS_DECL_LOWERESITOHW
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// ESIAddCPPAPI
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ESIADDCPPAPI
struct ESIAddCPPAPIOptions {
  std::string outputFile = "ESISystem.h";
  bool toStdErr = false;
};
#undef GEN_PASS_DECL_ESIADDCPPAPI
#endif // GEN_PASS_DECL_ESIADDCPPAPI
#ifdef GEN_PASS_DEF_ESIADDCPPAPI
namespace impl {

template <typename DerivedT>
class ESIAddCPPAPIBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIAddCPPAPIBase;

  ESIAddCPPAPIBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIAddCPPAPIBase(const ESIAddCPPAPIBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-emit-cpp-api");
  }
  ::llvm::StringRef getArgument() const override { return "esi-emit-cpp-api"; }

  ::llvm::StringRef getDescription() const override { return "Add C++ cosimulation API to the module"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIAddCPPAPI");
  }
  ::llvm::StringRef getName() const override { return "ESIAddCPPAPI"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIAddCPPAPIBase<DerivedT>)

  ESIAddCPPAPIBase(const ESIAddCPPAPIOptions &options) : ESIAddCPPAPIBase() {
    outputFile = options.outputFile;
    toStdErr = options.toStdErr;
  }
protected:
  ::mlir::Pass::Option<std::string> outputFile{*this, "output-file", ::llvm::cl::desc("File to output C++ API into"), ::llvm::cl::init("ESISystem.h")};
  ::mlir::Pass::Option<bool> toStdErr{*this, "to-stderr", ::llvm::cl::desc("If true, will emit the generated API to stderr"), ::llvm::cl::init(false)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ESIADDCPPAPI
#endif // GEN_PASS_DEF_ESIADDCPPAPI

//===----------------------------------------------------------------------===//
// ESICleanMetadata
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ESICLEANMETADATA
#undef GEN_PASS_DECL_ESICLEANMETADATA
#endif // GEN_PASS_DECL_ESICLEANMETADATA
#ifdef GEN_PASS_DEF_ESICLEANMETADATA
namespace impl {

template <typename DerivedT>
class ESICleanMetadataBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESICleanMetadataBase;

  ESICleanMetadataBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESICleanMetadataBase(const ESICleanMetadataBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-clean-metadata");
  }
  ::llvm::StringRef getArgument() const override { return "esi-clean-metadata"; }

  ::llvm::StringRef getDescription() const override { return "Clean up ESI service metadata"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESICleanMetadata");
  }
  ::llvm::StringRef getName() const override { return "ESICleanMetadata"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESICleanMetadataBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ESICLEANMETADATA
#endif // GEN_PASS_DEF_ESICLEANMETADATA

//===----------------------------------------------------------------------===//
// ESIConnectServices
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ESICONNECTSERVICES
#undef GEN_PASS_DECL_ESICONNECTSERVICES
#endif // GEN_PASS_DECL_ESICONNECTSERVICES
#ifdef GEN_PASS_DEF_ESICONNECTSERVICES
namespace impl {

template <typename DerivedT>
class ESIConnectServicesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIConnectServicesBase;

  ESIConnectServicesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIConnectServicesBase(const ESIConnectServicesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-connect-services");
  }
  ::llvm::StringRef getArgument() const override { return "esi-connect-services"; }

  ::llvm::StringRef getDescription() const override { return "Connect up ESI service requests to service providers"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIConnectServices");
  }
  ::llvm::StringRef getName() const override { return "ESIConnectServices"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  registry.insert<circt::sv::SVDialect>();

  registry.insert<circt::seq::SeqDialect>();

  registry.insert<circt::comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIConnectServicesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ESICONNECTSERVICES
#endif // GEN_PASS_DEF_ESICONNECTSERVICES

//===----------------------------------------------------------------------===//
// ESIEmitCollateral
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ESIEMITCOLLATERAL
struct ESIEmitCollateralOptions {
  std::string schemaFile;
  ::llvm::ArrayRef<std::string> tops;
};
#undef GEN_PASS_DECL_ESIEMITCOLLATERAL
#endif // GEN_PASS_DECL_ESIEMITCOLLATERAL
#ifdef GEN_PASS_DEF_ESIEMITCOLLATERAL
namespace impl {

template <typename DerivedT>
class ESIEmitCollateralBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIEmitCollateralBase;

  ESIEmitCollateralBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIEmitCollateralBase(const ESIEmitCollateralBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-emit-collateral");
  }
  ::llvm::StringRef getArgument() const override { return "esi-emit-collateral"; }

  ::llvm::StringRef getDescription() const override { return "Emit all the neccessary collateral"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIEmitCollateral");
  }
  ::llvm::StringRef getName() const override { return "ESIEmitCollateral"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIEmitCollateralBase<DerivedT>)

  ESIEmitCollateralBase(const ESIEmitCollateralOptions &options) : ESIEmitCollateralBase() {
    schemaFile = options.schemaFile;
    tops = options.tops;
  }
protected:
  ::mlir::Pass::Option<std::string> schemaFile{*this, "schema-file", ::llvm::cl::desc("File to output capnp schema into")};
  ::mlir::Pass::ListOption<std::string> tops{*this, "tops", ::llvm::cl::desc("List of top modules to export Tcl for"), llvm::cl::ZeroOrMore,};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ESIEMITCOLLATERAL
#endif // GEN_PASS_DEF_ESIEMITCOLLATERAL

//===----------------------------------------------------------------------===//
// LowerESIPorts
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERESIPORTS
#undef GEN_PASS_DECL_LOWERESIPORTS
#endif // GEN_PASS_DECL_LOWERESIPORTS
#ifdef GEN_PASS_DEF_LOWERESIPORTS
namespace impl {

template <typename DerivedT>
class LowerESIPortsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESIPortsBase;

  LowerESIPortsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESIPortsBase(const LowerESIPortsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-ports");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-ports"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI input and/or output ports."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESIPorts");
  }
  ::llvm::StringRef getName() const override { return "LowerESIPorts"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::comb::CombDialect>();

  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESIPortsBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERESIPORTS
#endif // GEN_PASS_DEF_LOWERESIPORTS

//===----------------------------------------------------------------------===//
// LowerESIToPhysical
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERESITOPHYSICAL
#undef GEN_PASS_DECL_LOWERESITOPHYSICAL
#endif // GEN_PASS_DECL_LOWERESITOPHYSICAL
#ifdef GEN_PASS_DEF_LOWERESITOPHYSICAL
namespace impl {

template <typename DerivedT>
class LowerESIToPhysicalBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESIToPhysicalBase;

  LowerESIToPhysicalBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESIToPhysicalBase(const LowerESIToPhysicalBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-to-physical");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-to-physical"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI abstract Ops to ESI physical ops."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESIToPhysical");
  }
  ::llvm::StringRef getName() const override { return "LowerESIToPhysical"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESIToPhysicalBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERESITOPHYSICAL
#endif // GEN_PASS_DEF_LOWERESITOPHYSICAL

//===----------------------------------------------------------------------===//
// LowerESITypes
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERESITYPES
#undef GEN_PASS_DECL_LOWERESITYPES
#endif // GEN_PASS_DECL_LOWERESITYPES
#ifdef GEN_PASS_DEF_LOWERESITYPES
namespace impl {

template <typename DerivedT>
class LowerESITypesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESITypesBase;

  LowerESITypesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESITypesBase(const LowerESITypesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-types");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-types"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI high level types."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESITypes");
  }
  ::llvm::StringRef getName() const override { return "LowerESITypes"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESITypesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERESITYPES
#endif // GEN_PASS_DEF_LOWERESITYPES

//===----------------------------------------------------------------------===//
// LowerESItoHW
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERESITOHW
#undef GEN_PASS_DECL_LOWERESITOHW
#endif // GEN_PASS_DECL_LOWERESITOHW
#ifdef GEN_PASS_DEF_LOWERESITOHW
namespace impl {

template <typename DerivedT>
class LowerESItoHWBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESItoHWBase;

  LowerESItoHWBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESItoHWBase(const LowerESItoHWBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-to-hw");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-to-hw"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI to HW where possible and SV elsewhere."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESItoHW");
  }
  ::llvm::StringRef getName() const override { return "LowerESItoHW"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::comb::CombDialect>();

  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESItoHWBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERESITOHW
#endif // GEN_PASS_DEF_LOWERESITOHW
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ESIAddCPPAPI Registration
//===----------------------------------------------------------------------===//

inline void registerESIAddCPPAPI() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIAddCPPAPIPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerESIAddCPPAPIPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIAddCPPAPIPass();
  });
}

//===----------------------------------------------------------------------===//
// ESICleanMetadata Registration
//===----------------------------------------------------------------------===//

inline void registerESICleanMetadata() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESICleanMetadataPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerESICleanMetadataPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESICleanMetadataPass();
  });
}

//===----------------------------------------------------------------------===//
// ESIConnectServices Registration
//===----------------------------------------------------------------------===//

inline void registerESIConnectServices() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIConnectServicesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerESIConnectServicesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIConnectServicesPass();
  });
}

//===----------------------------------------------------------------------===//
// ESIEmitCollateral Registration
//===----------------------------------------------------------------------===//

inline void registerESIEmitCollateral() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIEmitCollateralPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerESIEmitCollateralPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIEmitCollateralPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerESIPorts Registration
//===----------------------------------------------------------------------===//

inline void registerLowerESIPorts() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIPortLoweringPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerESIPortsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIPortLoweringPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerESIToPhysical Registration
//===----------------------------------------------------------------------===//

inline void registerLowerESIToPhysical() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIPhysicalLoweringPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerESIToPhysicalPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIPhysicalLoweringPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerESITypes Registration
//===----------------------------------------------------------------------===//

inline void registerLowerESITypes() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESITypeLoweringPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerESITypesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESITypeLoweringPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerESItoHW Registration
//===----------------------------------------------------------------------===//

inline void registerLowerESItoHW() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESItoHWPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerESItoHWPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESItoHWPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerESIAddCPPAPI();
  registerESICleanMetadata();
  registerESIConnectServices();
  registerESIEmitCollateral();
  registerLowerESIPorts();
  registerLowerESIToPhysical();
  registerLowerESITypes();
  registerLowerESItoHW();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class ESIAddCPPAPIBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIAddCPPAPIBase;

  ESIAddCPPAPIBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIAddCPPAPIBase(const ESIAddCPPAPIBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-emit-cpp-api");
  }
  ::llvm::StringRef getArgument() const override { return "esi-emit-cpp-api"; }

  ::llvm::StringRef getDescription() const override { return "Add C++ cosimulation API to the module"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIAddCPPAPI");
  }
  ::llvm::StringRef getName() const override { return "ESIAddCPPAPI"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIAddCPPAPIBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> outputFile{*this, "output-file", ::llvm::cl::desc("File to output C++ API into"), ::llvm::cl::init("ESISystem.h")};
  ::mlir::Pass::Option<bool> toStdErr{*this, "to-stderr", ::llvm::cl::desc("If true, will emit the generated API to stderr"), ::llvm::cl::init(false)};
};

template <typename DerivedT>
class ESICleanMetadataBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESICleanMetadataBase;

  ESICleanMetadataBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESICleanMetadataBase(const ESICleanMetadataBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-clean-metadata");
  }
  ::llvm::StringRef getArgument() const override { return "esi-clean-metadata"; }

  ::llvm::StringRef getDescription() const override { return "Clean up ESI service metadata"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESICleanMetadata");
  }
  ::llvm::StringRef getName() const override { return "ESICleanMetadata"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESICleanMetadataBase<DerivedT>)

protected:
};

template <typename DerivedT>
class ESIConnectServicesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIConnectServicesBase;

  ESIConnectServicesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIConnectServicesBase(const ESIConnectServicesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-connect-services");
  }
  ::llvm::StringRef getArgument() const override { return "esi-connect-services"; }

  ::llvm::StringRef getDescription() const override { return "Connect up ESI service requests to service providers"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIConnectServices");
  }
  ::llvm::StringRef getName() const override { return "ESIConnectServices"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  registry.insert<circt::sv::SVDialect>();

  registry.insert<circt::seq::SeqDialect>();

  registry.insert<circt::comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIConnectServicesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class ESIEmitCollateralBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIEmitCollateralBase;

  ESIEmitCollateralBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIEmitCollateralBase(const ESIEmitCollateralBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-emit-collateral");
  }
  ::llvm::StringRef getArgument() const override { return "esi-emit-collateral"; }

  ::llvm::StringRef getDescription() const override { return "Emit all the neccessary collateral"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIEmitCollateral");
  }
  ::llvm::StringRef getName() const override { return "ESIEmitCollateral"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIEmitCollateralBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> schemaFile{*this, "schema-file", ::llvm::cl::desc("File to output capnp schema into")};
  ::mlir::Pass::ListOption<std::string> tops{*this, "tops", ::llvm::cl::desc("List of top modules to export Tcl for"), llvm::cl::ZeroOrMore,};
};

template <typename DerivedT>
class LowerESIPortsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESIPortsBase;

  LowerESIPortsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESIPortsBase(const LowerESIPortsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-ports");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-ports"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI input and/or output ports."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESIPorts");
  }
  ::llvm::StringRef getName() const override { return "LowerESIPorts"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::comb::CombDialect>();

  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESIPortsBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerESIToPhysicalBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESIToPhysicalBase;

  LowerESIToPhysicalBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESIToPhysicalBase(const LowerESIToPhysicalBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-to-physical");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-to-physical"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI abstract Ops to ESI physical ops."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESIToPhysical");
  }
  ::llvm::StringRef getName() const override { return "LowerESIToPhysical"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESIToPhysicalBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerESITypesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESITypesBase;

  LowerESITypesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESITypesBase(const LowerESITypesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-types");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-types"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI high level types."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESITypes");
  }
  ::llvm::StringRef getName() const override { return "LowerESITypes"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESITypesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerESItoHWBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESItoHWBase;

  LowerESItoHWBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESItoHWBase(const LowerESItoHWBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-to-hw");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-to-hw"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI to HW where possible and SV elsewhere."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESItoHW");
  }
  ::llvm::StringRef getName() const override { return "LowerESItoHW"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::comb::CombDialect>();

  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESItoHWBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
