/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Op Declarations                                                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#if defined(GET_OP_CLASSES) || defined(GET_OP_FWD_DEFINES)
#undef GET_OP_FWD_DEFINES
namespace circt {
namespace chirrtl {
class CombMemOp;
} // namespace chirrtl
} // namespace circt
namespace circt {
namespace chirrtl {
class MemoryDebugPortOp;
} // namespace chirrtl
} // namespace circt
namespace circt {
namespace chirrtl {
class MemoryPortAccessOp;
} // namespace chirrtl
} // namespace circt
namespace circt {
namespace chirrtl {
class MemoryPortOp;
} // namespace chirrtl
} // namespace circt
namespace circt {
namespace chirrtl {
class SeqMemOp;
} // namespace chirrtl
} // namespace circt
#endif

#ifdef GET_OP_CLASSES
#undef GET_OP_CLASSES


//===----------------------------------------------------------------------===//
// Local Utility Method Definitions
//===----------------------------------------------------------------------===//

namespace circt {
namespace chirrtl {

//===----------------------------------------------------------------------===//
// ::circt::chirrtl::CombMemOp declarations
//===----------------------------------------------------------------------===//

namespace detail {
class CombMemOpGenericAdaptorBase {
public:
protected:
  ::mlir::DictionaryAttr odsAttrs;
  ::std::optional<::mlir::OperationName> odsOpName;
  ::mlir::RegionRange odsRegions;
public:
  CombMemOpGenericAdaptorBase(::mlir::DictionaryAttr attrs = nullptr, const ::mlir::EmptyProperties &properties = {}, ::mlir::RegionRange regions = {});

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize);
  ::mlir::DictionaryAttr getAttributes();
  ::mlir::StringAttr getNameAttr();
  ::llvm::StringRef getName();
  ::circt::firrtl::NameKindEnumAttr getNameKindAttr();
  ::circt::firrtl::NameKindEnum getNameKind();
  ::mlir::ArrayAttr getAnnotationsAttr();
  ::mlir::ArrayAttr getAnnotations();
  ::circt::hw::InnerSymAttr getInnerSymAttr();
  ::std::optional<::circt::hw::InnerSymAttr> getInnerSym();
  ::circt::firrtl::MemoryInitAttr getInitAttr();
  ::std::optional<::circt::firrtl::MemoryInitAttr> getInit();
};
} // namespace detail
template <typename RangeT>
class CombMemOpGenericAdaptor : public detail::CombMemOpGenericAdaptorBase {
  using ValueT = ::llvm::detail::ValueOfRange<RangeT>;
  using Base = detail::CombMemOpGenericAdaptorBase;
public:
  CombMemOpGenericAdaptor(RangeT values, ::mlir::DictionaryAttr attrs = nullptr, const ::mlir::EmptyProperties &properties = {}, ::mlir::RegionRange regions = {}) : Base(attrs, properties, regions), odsOperands(values) {}

  CombMemOpGenericAdaptor(RangeT values, ::mlir::DictionaryAttr attrs, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions = {}) : CombMemOpGenericAdaptor(values, attrs, (properties ? *properties.as<::mlir::EmptyProperties *>() : ::mlir::EmptyProperties{}), regions) {}

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index) {
    return Base::getODSOperandIndexAndLength(index, odsOperands.size());
  }

  RangeT getODSOperands(unsigned index) {
    auto valueRange = getODSOperandIndexAndLength(index);
    return {std::next(odsOperands.begin(), valueRange.first),
             std::next(odsOperands.begin(), valueRange.first + valueRange.second)};
  }

  RangeT getOperands() {
    return odsOperands;
  }

private:
  RangeT odsOperands;
};
class CombMemOpAdaptor : public CombMemOpGenericAdaptor<::mlir::ValueRange> {
public:
  using CombMemOpGenericAdaptor::CombMemOpGenericAdaptor;
  CombMemOpAdaptor(CombMemOp op);

  ::mlir::LogicalResult verify(::mlir::Location loc);
};
class CombMemOp : public ::mlir::Op<CombMemOp, ::mlir::OpTrait::ZeroRegions, ::mlir::OpTrait::OneResult, ::mlir::OpTrait::OneTypedResult<::circt::chirrtl::CMemoryType>::Impl, ::mlir::OpTrait::ZeroSuccessors, ::mlir::OpTrait::ZeroOperands, ::mlir::OpTrait::OpInvariants, ::mlir::OpAsmOpInterface::Trait, ::circt::hw::InnerSymbolOpInterface::Trait, circt::firrtl::FNamableOp::Trait> {
public:
  using Op::Op;
  using Op::print;
  using Adaptor = CombMemOpAdaptor;
  template <typename RangeT>
  using GenericAdaptor = CombMemOpGenericAdaptor<RangeT>;
  using FoldAdaptor = GenericAdaptor<::llvm::ArrayRef<::mlir::Attribute>>;
  static ::llvm::ArrayRef<::llvm::StringRef> getAttributeNames() {
    static ::llvm::StringRef attrNames[] = {::llvm::StringRef("annotations"), ::llvm::StringRef("init"), ::llvm::StringRef("inner_sym"), ::llvm::StringRef("name"), ::llvm::StringRef("nameKind")};
    return ::llvm::ArrayRef(attrNames);
  }

  ::mlir::StringAttr getAnnotationsAttrName() {
    return getAttributeNameForIndex(0);
  }

  static ::mlir::StringAttr getAnnotationsAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 0);
  }

  ::mlir::StringAttr getInitAttrName() {
    return getAttributeNameForIndex(1);
  }

  static ::mlir::StringAttr getInitAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 1);
  }

  ::mlir::StringAttr getInnerSymAttrName() {
    return getAttributeNameForIndex(2);
  }

  static ::mlir::StringAttr getInnerSymAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 2);
  }

  ::mlir::StringAttr getNameAttrName() {
    return getAttributeNameForIndex(3);
  }

  static ::mlir::StringAttr getNameAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 3);
  }

  ::mlir::StringAttr getNameKindAttrName() {
    return getAttributeNameForIndex(4);
  }

  static ::mlir::StringAttr getNameKindAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 4);
  }

  static constexpr ::llvm::StringLiteral getOperationName() {
    return ::llvm::StringLiteral("chirrtl.combmem");
  }

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index);
  ::mlir::Operation::operand_range getODSOperands(unsigned index);
  std::pair<unsigned, unsigned> getODSResultIndexAndLength(unsigned index);
  ::mlir::Operation::result_range getODSResults(unsigned index);
  ::mlir::TypedValue<::circt::chirrtl::CMemoryType> getResult();
  ::mlir::StringAttr getNameAttr();
  ::llvm::StringRef getName();
  ::circt::firrtl::NameKindEnumAttr getNameKindAttr();
  ::circt::firrtl::NameKindEnum getNameKind();
  ::mlir::ArrayAttr getAnnotationsAttr();
  ::mlir::ArrayAttr getAnnotations();
  ::circt::hw::InnerSymAttr getInnerSymAttr();
  ::std::optional<::circt::hw::InnerSymAttr> getInnerSym();
  ::circt::firrtl::MemoryInitAttr getInitAttr();
  ::std::optional<::circt::firrtl::MemoryInitAttr> getInit();
  void setNameAttr(::mlir::StringAttr attr);
  void setName(::llvm::StringRef attrValue);
  void setNameKindAttr(::circt::firrtl::NameKindEnumAttr attr);
  void setNameKind(::circt::firrtl::NameKindEnum attrValue);
  void setAnnotationsAttr(::mlir::ArrayAttr attr);
  void setInnerSymAttr(::circt::hw::InnerSymAttr attr);
  void setInitAttr(::circt::firrtl::MemoryInitAttr attr);
  ::mlir::Attribute removeInnerSymAttr();
  ::mlir::Attribute removeInitAttr();
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, firrtl::FIRRTLBaseType elementType, uint64_t numElements, mlir::StringRef name, firrtl::NameKindEnum nameKind, ArrayAttr annotations, StringAttr inner_sym = StringAttr(), firrtl::MemoryInitAttr init = firrtl::MemoryInitAttr{});
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type result, ::mlir::StringAttr name, ::circt::firrtl::NameKindEnumAttr nameKind, ::mlir::ArrayAttr annotations, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::firrtl::MemoryInitAttr init);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr name, ::circt::firrtl::NameKindEnumAttr nameKind, ::mlir::ArrayAttr annotations, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::firrtl::MemoryInitAttr init);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type result, ::llvm::StringRef name, ::circt::firrtl::NameKindEnum nameKind, ::mlir::ArrayAttr annotations, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::firrtl::MemoryInitAttr init);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef name, ::circt::firrtl::NameKindEnum nameKind, ::mlir::ArrayAttr annotations, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::firrtl::MemoryInitAttr init);
  static void build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes = {});
  ::mlir::LogicalResult verifyInvariantsImpl();
  ::mlir::LogicalResult verifyInvariants();
  void getAsmResultNames(::mlir::OpAsmSetValueNameFn setNameFn);
  static std::optional<size_t> getTargetResultIndex();
  static ::mlir::ParseResult parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result);
  void print(::mlir::OpAsmPrinter &_odsPrinter);
private:
  ::mlir::StringAttr getAttributeNameForIndex(unsigned index) {
    return getAttributeNameForIndex((*this)->getName(), index);
  }

  static ::mlir::StringAttr getAttributeNameForIndex(::mlir::OperationName name, unsigned index) {
    assert(index < 5 && "invalid attribute index");
    assert(name.getStringRef() == getOperationName() && "invalid operation name");
    return name.getAttributeNames()[index];
  }

public:
};
} // namespace chirrtl
} // namespace circt
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::chirrtl::CombMemOp)

namespace circt {
namespace chirrtl {

//===----------------------------------------------------------------------===//
// ::circt::chirrtl::MemoryDebugPortOp declarations
//===----------------------------------------------------------------------===//

namespace detail {
class MemoryDebugPortOpGenericAdaptorBase {
public:
protected:
  ::mlir::DictionaryAttr odsAttrs;
  ::std::optional<::mlir::OperationName> odsOpName;
  ::mlir::RegionRange odsRegions;
public:
  MemoryDebugPortOpGenericAdaptorBase(::mlir::DictionaryAttr attrs = nullptr, const ::mlir::EmptyProperties &properties = {}, ::mlir::RegionRange regions = {});

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize);
  ::mlir::DictionaryAttr getAttributes();
  ::mlir::StringAttr getNameAttr();
  ::llvm::StringRef getName();
  ::mlir::ArrayAttr getAnnotationsAttr();
  ::mlir::ArrayAttr getAnnotations();
};
} // namespace detail
template <typename RangeT>
class MemoryDebugPortOpGenericAdaptor : public detail::MemoryDebugPortOpGenericAdaptorBase {
  using ValueT = ::llvm::detail::ValueOfRange<RangeT>;
  using Base = detail::MemoryDebugPortOpGenericAdaptorBase;
public:
  MemoryDebugPortOpGenericAdaptor(RangeT values, ::mlir::DictionaryAttr attrs = nullptr, const ::mlir::EmptyProperties &properties = {}, ::mlir::RegionRange regions = {}) : Base(attrs, properties, regions), odsOperands(values) {}

  MemoryDebugPortOpGenericAdaptor(RangeT values, ::mlir::DictionaryAttr attrs, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions = {}) : MemoryDebugPortOpGenericAdaptor(values, attrs, (properties ? *properties.as<::mlir::EmptyProperties *>() : ::mlir::EmptyProperties{}), regions) {}

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index) {
    return Base::getODSOperandIndexAndLength(index, odsOperands.size());
  }

  RangeT getODSOperands(unsigned index) {
    auto valueRange = getODSOperandIndexAndLength(index);
    return {std::next(odsOperands.begin(), valueRange.first),
             std::next(odsOperands.begin(), valueRange.first + valueRange.second)};
  }

  ValueT getMemory() {
    return (*getODSOperands(0).begin());
  }

  RangeT getOperands() {
    return odsOperands;
  }

private:
  RangeT odsOperands;
};
class MemoryDebugPortOpAdaptor : public MemoryDebugPortOpGenericAdaptor<::mlir::ValueRange> {
public:
  using MemoryDebugPortOpGenericAdaptor::MemoryDebugPortOpGenericAdaptor;
  MemoryDebugPortOpAdaptor(MemoryDebugPortOp op);

  ::mlir::LogicalResult verify(::mlir::Location loc);
};
class MemoryDebugPortOp : public ::mlir::Op<MemoryDebugPortOp, ::mlir::OpTrait::ZeroRegions, ::mlir::OpTrait::OneResult, ::mlir::OpTrait::OneTypedResult<::circt::firrtl::RefType>::Impl, ::mlir::OpTrait::ZeroSuccessors, ::mlir::OpTrait::OneOperand, ::mlir::OpTrait::OpInvariants, ::mlir::InferTypeOpInterface::Trait, ::mlir::OpAsmOpInterface::Trait> {
public:
  using Op::Op;
  using Op::print;
  using Adaptor = MemoryDebugPortOpAdaptor;
  template <typename RangeT>
  using GenericAdaptor = MemoryDebugPortOpGenericAdaptor<RangeT>;
  using FoldAdaptor = GenericAdaptor<::llvm::ArrayRef<::mlir::Attribute>>;
  static ::llvm::ArrayRef<::llvm::StringRef> getAttributeNames() {
    static ::llvm::StringRef attrNames[] = {::llvm::StringRef("annotations"), ::llvm::StringRef("name")};
    return ::llvm::ArrayRef(attrNames);
  }

  ::mlir::StringAttr getAnnotationsAttrName() {
    return getAttributeNameForIndex(0);
  }

  static ::mlir::StringAttr getAnnotationsAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 0);
  }

  ::mlir::StringAttr getNameAttrName() {
    return getAttributeNameForIndex(1);
  }

  static ::mlir::StringAttr getNameAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 1);
  }

  static constexpr ::llvm::StringLiteral getOperationName() {
    return ::llvm::StringLiteral("chirrtl.debugport");
  }

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index);
  ::mlir::Operation::operand_range getODSOperands(unsigned index);
  ::mlir::TypedValue<::circt::chirrtl::CMemoryType> getMemory();
  ::mlir::MutableOperandRange getMemoryMutable();
  std::pair<unsigned, unsigned> getODSResultIndexAndLength(unsigned index);
  ::mlir::Operation::result_range getODSResults(unsigned index);
  ::mlir::TypedValue<::circt::firrtl::RefType> getData();
  ::mlir::StringAttr getNameAttr();
  ::llvm::StringRef getName();
  ::mlir::ArrayAttr getAnnotationsAttr();
  ::mlir::ArrayAttr getAnnotations();
  void setNameAttr(::mlir::StringAttr attr);
  void setName(::llvm::StringRef attrValue);
  void setAnnotationsAttr(::mlir::ArrayAttr attr);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type dataType, ::mlir::Value memory, StringRef name = {}, ArrayRef<Attribute> annotations = {});
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Value memory, ::mlir::StringAttr name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::mlir::StringAttr name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::StringAttr name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Value memory, ::llvm::StringRef name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::llvm::StringRef name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::llvm::StringRef name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes = {});
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes = {});
  ::mlir::LogicalResult verifyInvariantsImpl();
  ::mlir::LogicalResult verifyInvariants();
  void getAsmResultNames(::mlir::OpAsmSetValueNameFn setNameFn);
  static ::mlir::ParseResult parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result);
  void print(::mlir::OpAsmPrinter &_odsPrinter);
private:
  ::mlir::StringAttr getAttributeNameForIndex(unsigned index) {
    return getAttributeNameForIndex((*this)->getName(), index);
  }

  static ::mlir::StringAttr getAttributeNameForIndex(::mlir::OperationName name, unsigned index) {
    assert(index < 2 && "invalid attribute index");
    assert(name.getStringRef() == getOperationName() && "invalid operation name");
    return name.getAttributeNames()[index];
  }

public:
  /// Infer the return types of this operation.
  static LogicalResult inferReturnTypes(MLIRContext *context,
                                        std::optional<Location> loc,
                                        ValueRange operands,
                                        DictionaryAttr attrs,
                                        mlir::OpaqueProperties properties,
                                        mlir::RegionRange regions,
                                        SmallVectorImpl<Type> &results);
};
} // namespace chirrtl
} // namespace circt
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::chirrtl::MemoryDebugPortOp)

namespace circt {
namespace chirrtl {

//===----------------------------------------------------------------------===//
// ::circt::chirrtl::MemoryPortAccessOp declarations
//===----------------------------------------------------------------------===//

namespace detail {
class MemoryPortAccessOpGenericAdaptorBase {
public:
protected:
  ::mlir::DictionaryAttr odsAttrs;
  ::std::optional<::mlir::OperationName> odsOpName;
  ::mlir::RegionRange odsRegions;
public:
  MemoryPortAccessOpGenericAdaptorBase(::mlir::DictionaryAttr attrs = nullptr, const ::mlir::EmptyProperties &properties = {}, ::mlir::RegionRange regions = {});

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize);
  ::mlir::DictionaryAttr getAttributes();
};
} // namespace detail
template <typename RangeT>
class MemoryPortAccessOpGenericAdaptor : public detail::MemoryPortAccessOpGenericAdaptorBase {
  using ValueT = ::llvm::detail::ValueOfRange<RangeT>;
  using Base = detail::MemoryPortAccessOpGenericAdaptorBase;
public:
  MemoryPortAccessOpGenericAdaptor(RangeT values, ::mlir::DictionaryAttr attrs = nullptr, const ::mlir::EmptyProperties &properties = {}, ::mlir::RegionRange regions = {}) : Base(attrs, properties, regions), odsOperands(values) {}

  MemoryPortAccessOpGenericAdaptor(RangeT values, ::mlir::DictionaryAttr attrs, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions = {}) : MemoryPortAccessOpGenericAdaptor(values, attrs, (properties ? *properties.as<::mlir::EmptyProperties *>() : ::mlir::EmptyProperties{}), regions) {}

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index) {
    return Base::getODSOperandIndexAndLength(index, odsOperands.size());
  }

  RangeT getODSOperands(unsigned index) {
    auto valueRange = getODSOperandIndexAndLength(index);
    return {std::next(odsOperands.begin(), valueRange.first),
             std::next(odsOperands.begin(), valueRange.first + valueRange.second)};
  }

  ValueT getPort() {
    return (*getODSOperands(0).begin());
  }

  ValueT getIndex() {
    return (*getODSOperands(1).begin());
  }

  ValueT getClock() {
    return (*getODSOperands(2).begin());
  }

  RangeT getOperands() {
    return odsOperands;
  }

private:
  RangeT odsOperands;
};
class MemoryPortAccessOpAdaptor : public MemoryPortAccessOpGenericAdaptor<::mlir::ValueRange> {
public:
  using MemoryPortAccessOpGenericAdaptor::MemoryPortAccessOpGenericAdaptor;
  MemoryPortAccessOpAdaptor(MemoryPortAccessOp op);

  ::mlir::LogicalResult verify(::mlir::Location loc);
};
class MemoryPortAccessOp : public ::mlir::Op<MemoryPortAccessOp, ::mlir::OpTrait::ZeroRegions, ::mlir::OpTrait::ZeroResults, ::mlir::OpTrait::ZeroSuccessors, ::mlir::OpTrait::NOperands<3>::Impl, ::mlir::OpTrait::OpInvariants> {
public:
  using Op::Op;
  using Op::print;
  using Adaptor = MemoryPortAccessOpAdaptor;
  template <typename RangeT>
  using GenericAdaptor = MemoryPortAccessOpGenericAdaptor<RangeT>;
  using FoldAdaptor = GenericAdaptor<::llvm::ArrayRef<::mlir::Attribute>>;
  static ::llvm::ArrayRef<::llvm::StringRef> getAttributeNames() {
    return {};
  }

  static constexpr ::llvm::StringLiteral getOperationName() {
    return ::llvm::StringLiteral("chirrtl.memoryport.access");
  }

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index);
  ::mlir::Operation::operand_range getODSOperands(unsigned index);
  ::mlir::TypedValue<::circt::chirrtl::CMemoryPortType> getPort();
  ::mlir::TypedValue<::circt::firrtl::IntType> getIndex();
  ::mlir::TypedValue<::circt::firrtl::ClockType> getClock();
  ::mlir::MutableOperandRange getPortMutable();
  ::mlir::MutableOperandRange getIndexMutable();
  ::mlir::MutableOperandRange getClockMutable();
  std::pair<unsigned, unsigned> getODSResultIndexAndLength(unsigned index);
  ::mlir::Operation::result_range getODSResults(unsigned index);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value port, ::mlir::Value index, ::mlir::Value clock);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value port, ::mlir::Value index, ::mlir::Value clock);
  static void build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes = {});
  ::mlir::LogicalResult verifyInvariantsImpl();
  ::mlir::LogicalResult verifyInvariants();
  static ::mlir::ParseResult parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result);
  void print(::mlir::OpAsmPrinter &_odsPrinter);
public:
};
} // namespace chirrtl
} // namespace circt
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::chirrtl::MemoryPortAccessOp)

namespace circt {
namespace chirrtl {

//===----------------------------------------------------------------------===//
// ::circt::chirrtl::MemoryPortOp declarations
//===----------------------------------------------------------------------===//

namespace detail {
class MemoryPortOpGenericAdaptorBase {
public:
protected:
  ::mlir::DictionaryAttr odsAttrs;
  ::std::optional<::mlir::OperationName> odsOpName;
  ::mlir::RegionRange odsRegions;
public:
  MemoryPortOpGenericAdaptorBase(::mlir::DictionaryAttr attrs = nullptr, const ::mlir::EmptyProperties &properties = {}, ::mlir::RegionRange regions = {});

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize);
  ::mlir::DictionaryAttr getAttributes();
  ::MemDirAttrAttr getDirectionAttr();
  ::MemDirAttr getDirection();
  ::mlir::StringAttr getNameAttr();
  ::llvm::StringRef getName();
  ::mlir::ArrayAttr getAnnotationsAttr();
  ::mlir::ArrayAttr getAnnotations();
};
} // namespace detail
template <typename RangeT>
class MemoryPortOpGenericAdaptor : public detail::MemoryPortOpGenericAdaptorBase {
  using ValueT = ::llvm::detail::ValueOfRange<RangeT>;
  using Base = detail::MemoryPortOpGenericAdaptorBase;
public:
  MemoryPortOpGenericAdaptor(RangeT values, ::mlir::DictionaryAttr attrs = nullptr, const ::mlir::EmptyProperties &properties = {}, ::mlir::RegionRange regions = {}) : Base(attrs, properties, regions), odsOperands(values) {}

  MemoryPortOpGenericAdaptor(RangeT values, ::mlir::DictionaryAttr attrs, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions = {}) : MemoryPortOpGenericAdaptor(values, attrs, (properties ? *properties.as<::mlir::EmptyProperties *>() : ::mlir::EmptyProperties{}), regions) {}

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index) {
    return Base::getODSOperandIndexAndLength(index, odsOperands.size());
  }

  RangeT getODSOperands(unsigned index) {
    auto valueRange = getODSOperandIndexAndLength(index);
    return {std::next(odsOperands.begin(), valueRange.first),
             std::next(odsOperands.begin(), valueRange.first + valueRange.second)};
  }

  ValueT getMemory() {
    return (*getODSOperands(0).begin());
  }

  RangeT getOperands() {
    return odsOperands;
  }

private:
  RangeT odsOperands;
};
class MemoryPortOpAdaptor : public MemoryPortOpGenericAdaptor<::mlir::ValueRange> {
public:
  using MemoryPortOpGenericAdaptor::MemoryPortOpGenericAdaptor;
  MemoryPortOpAdaptor(MemoryPortOp op);

  ::mlir::LogicalResult verify(::mlir::Location loc);
};
class MemoryPortOp : public ::mlir::Op<MemoryPortOp, ::mlir::OpTrait::ZeroRegions, ::mlir::OpTrait::NResults<2>::Impl, ::mlir::OpTrait::ZeroSuccessors, ::mlir::OpTrait::OneOperand, ::mlir::OpTrait::OpInvariants, ::mlir::InferTypeOpInterface::Trait, ::mlir::OpAsmOpInterface::Trait> {
public:
  using Op::Op;
  using Op::print;
  using Adaptor = MemoryPortOpAdaptor;
  template <typename RangeT>
  using GenericAdaptor = MemoryPortOpGenericAdaptor<RangeT>;
  using FoldAdaptor = GenericAdaptor<::llvm::ArrayRef<::mlir::Attribute>>;
  static ::llvm::ArrayRef<::llvm::StringRef> getAttributeNames() {
    static ::llvm::StringRef attrNames[] = {::llvm::StringRef("annotations"), ::llvm::StringRef("direction"), ::llvm::StringRef("name")};
    return ::llvm::ArrayRef(attrNames);
  }

  ::mlir::StringAttr getAnnotationsAttrName() {
    return getAttributeNameForIndex(0);
  }

  static ::mlir::StringAttr getAnnotationsAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 0);
  }

  ::mlir::StringAttr getDirectionAttrName() {
    return getAttributeNameForIndex(1);
  }

  static ::mlir::StringAttr getDirectionAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 1);
  }

  ::mlir::StringAttr getNameAttrName() {
    return getAttributeNameForIndex(2);
  }

  static ::mlir::StringAttr getNameAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 2);
  }

  static constexpr ::llvm::StringLiteral getOperationName() {
    return ::llvm::StringLiteral("chirrtl.memoryport");
  }

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index);
  ::mlir::Operation::operand_range getODSOperands(unsigned index);
  ::mlir::TypedValue<::circt::chirrtl::CMemoryType> getMemory();
  ::mlir::MutableOperandRange getMemoryMutable();
  std::pair<unsigned, unsigned> getODSResultIndexAndLength(unsigned index);
  ::mlir::Operation::result_range getODSResults(unsigned index);
  ::mlir::TypedValue<::circt::firrtl::FIRRTLBaseType> getData();
  ::mlir::TypedValue<::circt::chirrtl::CMemoryPortType> getPort();
  ::MemDirAttrAttr getDirectionAttr();
  ::MemDirAttr getDirection();
  ::mlir::StringAttr getNameAttr();
  ::llvm::StringRef getName();
  ::mlir::ArrayAttr getAnnotationsAttr();
  ::mlir::ArrayAttr getAnnotations();
  void setDirectionAttr(::MemDirAttrAttr attr);
  void setDirection(::MemDirAttr attrValue);
  void setNameAttr(::mlir::StringAttr attr);
  void setName(::llvm::StringRef attrValue);
  void setAnnotationsAttr(::mlir::ArrayAttr attr);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type dataType, ::mlir::Value memory, MemDirAttr direction, StringRef name = {}, ArrayRef<Attribute> annotations = {});
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Type port, ::mlir::Value memory, ::MemDirAttrAttr direction, ::mlir::StringAttr name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::MemDirAttrAttr direction, ::mlir::StringAttr name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::MemDirAttrAttr direction, ::mlir::StringAttr name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Type port, ::mlir::Value memory, ::MemDirAttr direction, ::llvm::StringRef name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::MemDirAttr direction, ::llvm::StringRef name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::MemDirAttr direction, ::llvm::StringRef name, ::mlir::ArrayAttr annotations);
  static void build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes = {});
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes = {});
  ::mlir::LogicalResult verifyInvariantsImpl();
  ::mlir::LogicalResult verifyInvariants();
  ::mlir::LogicalResult verify();
  void getAsmResultNames(::mlir::OpAsmSetValueNameFn setNameFn);
  static ::mlir::ParseResult parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result);
  void print(::mlir::OpAsmPrinter &_odsPrinter);
private:
  ::mlir::StringAttr getAttributeNameForIndex(unsigned index) {
    return getAttributeNameForIndex((*this)->getName(), index);
  }

  static ::mlir::StringAttr getAttributeNameForIndex(::mlir::OperationName name, unsigned index) {
    assert(index < 3 && "invalid attribute index");
    assert(name.getStringRef() == getOperationName() && "invalid operation name");
    return name.getAttributeNames()[index];
  }

public:
  /// Get the assocated access op.
  MemoryPortAccessOp getAccess();

  /// Infer the return types of this operation.
  static LogicalResult inferReturnTypes(MLIRContext *context,
                                        std::optional<Location> loc,
                                        ValueRange operands,
                                        DictionaryAttr attrs,
                                        mlir::OpaqueProperties properties,
                                        mlir::RegionRange regions,
                                        SmallVectorImpl<Type> &results);
};
} // namespace chirrtl
} // namespace circt
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::chirrtl::MemoryPortOp)

namespace circt {
namespace chirrtl {

//===----------------------------------------------------------------------===//
// ::circt::chirrtl::SeqMemOp declarations
//===----------------------------------------------------------------------===//

namespace detail {
class SeqMemOpGenericAdaptorBase {
public:
protected:
  ::mlir::DictionaryAttr odsAttrs;
  ::std::optional<::mlir::OperationName> odsOpName;
  ::mlir::RegionRange odsRegions;
public:
  SeqMemOpGenericAdaptorBase(::mlir::DictionaryAttr attrs = nullptr, const ::mlir::EmptyProperties &properties = {}, ::mlir::RegionRange regions = {});

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize);
  ::mlir::DictionaryAttr getAttributes();
  ::RUWAttrAttr getRuwAttr();
  ::RUWAttr getRuw();
  ::mlir::StringAttr getNameAttr();
  ::llvm::StringRef getName();
  ::circt::firrtl::NameKindEnumAttr getNameKindAttr();
  ::circt::firrtl::NameKindEnum getNameKind();
  ::mlir::ArrayAttr getAnnotationsAttr();
  ::mlir::ArrayAttr getAnnotations();
  ::circt::hw::InnerSymAttr getInnerSymAttr();
  ::std::optional<::circt::hw::InnerSymAttr> getInnerSym();
  ::circt::firrtl::MemoryInitAttr getInitAttr();
  ::std::optional<::circt::firrtl::MemoryInitAttr> getInit();
};
} // namespace detail
template <typename RangeT>
class SeqMemOpGenericAdaptor : public detail::SeqMemOpGenericAdaptorBase {
  using ValueT = ::llvm::detail::ValueOfRange<RangeT>;
  using Base = detail::SeqMemOpGenericAdaptorBase;
public:
  SeqMemOpGenericAdaptor(RangeT values, ::mlir::DictionaryAttr attrs = nullptr, const ::mlir::EmptyProperties &properties = {}, ::mlir::RegionRange regions = {}) : Base(attrs, properties, regions), odsOperands(values) {}

  SeqMemOpGenericAdaptor(RangeT values, ::mlir::DictionaryAttr attrs, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions = {}) : SeqMemOpGenericAdaptor(values, attrs, (properties ? *properties.as<::mlir::EmptyProperties *>() : ::mlir::EmptyProperties{}), regions) {}

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index) {
    return Base::getODSOperandIndexAndLength(index, odsOperands.size());
  }

  RangeT getODSOperands(unsigned index) {
    auto valueRange = getODSOperandIndexAndLength(index);
    return {std::next(odsOperands.begin(), valueRange.first),
             std::next(odsOperands.begin(), valueRange.first + valueRange.second)};
  }

  RangeT getOperands() {
    return odsOperands;
  }

private:
  RangeT odsOperands;
};
class SeqMemOpAdaptor : public SeqMemOpGenericAdaptor<::mlir::ValueRange> {
public:
  using SeqMemOpGenericAdaptor::SeqMemOpGenericAdaptor;
  SeqMemOpAdaptor(SeqMemOp op);

  ::mlir::LogicalResult verify(::mlir::Location loc);
};
class SeqMemOp : public ::mlir::Op<SeqMemOp, ::mlir::OpTrait::ZeroRegions, ::mlir::OpTrait::OneResult, ::mlir::OpTrait::OneTypedResult<::circt::chirrtl::CMemoryType>::Impl, ::mlir::OpTrait::ZeroSuccessors, ::mlir::OpTrait::ZeroOperands, ::mlir::OpTrait::OpInvariants, ::mlir::OpAsmOpInterface::Trait, ::circt::hw::InnerSymbolOpInterface::Trait, circt::firrtl::FNamableOp::Trait> {
public:
  using Op::Op;
  using Op::print;
  using Adaptor = SeqMemOpAdaptor;
  template <typename RangeT>
  using GenericAdaptor = SeqMemOpGenericAdaptor<RangeT>;
  using FoldAdaptor = GenericAdaptor<::llvm::ArrayRef<::mlir::Attribute>>;
  static ::llvm::ArrayRef<::llvm::StringRef> getAttributeNames() {
    static ::llvm::StringRef attrNames[] = {::llvm::StringRef("annotations"), ::llvm::StringRef("init"), ::llvm::StringRef("inner_sym"), ::llvm::StringRef("name"), ::llvm::StringRef("nameKind"), ::llvm::StringRef("ruw")};
    return ::llvm::ArrayRef(attrNames);
  }

  ::mlir::StringAttr getAnnotationsAttrName() {
    return getAttributeNameForIndex(0);
  }

  static ::mlir::StringAttr getAnnotationsAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 0);
  }

  ::mlir::StringAttr getInitAttrName() {
    return getAttributeNameForIndex(1);
  }

  static ::mlir::StringAttr getInitAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 1);
  }

  ::mlir::StringAttr getInnerSymAttrName() {
    return getAttributeNameForIndex(2);
  }

  static ::mlir::StringAttr getInnerSymAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 2);
  }

  ::mlir::StringAttr getNameAttrName() {
    return getAttributeNameForIndex(3);
  }

  static ::mlir::StringAttr getNameAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 3);
  }

  ::mlir::StringAttr getNameKindAttrName() {
    return getAttributeNameForIndex(4);
  }

  static ::mlir::StringAttr getNameKindAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 4);
  }

  ::mlir::StringAttr getRuwAttrName() {
    return getAttributeNameForIndex(5);
  }

  static ::mlir::StringAttr getRuwAttrName(::mlir::OperationName name) {
    return getAttributeNameForIndex(name, 5);
  }

  static constexpr ::llvm::StringLiteral getOperationName() {
    return ::llvm::StringLiteral("chirrtl.seqmem");
  }

  std::pair<unsigned, unsigned> getODSOperandIndexAndLength(unsigned index);
  ::mlir::Operation::operand_range getODSOperands(unsigned index);
  std::pair<unsigned, unsigned> getODSResultIndexAndLength(unsigned index);
  ::mlir::Operation::result_range getODSResults(unsigned index);
  ::mlir::TypedValue<::circt::chirrtl::CMemoryType> getResult();
  ::RUWAttrAttr getRuwAttr();
  ::RUWAttr getRuw();
  ::mlir::StringAttr getNameAttr();
  ::llvm::StringRef getName();
  ::circt::firrtl::NameKindEnumAttr getNameKindAttr();
  ::circt::firrtl::NameKindEnum getNameKind();
  ::mlir::ArrayAttr getAnnotationsAttr();
  ::mlir::ArrayAttr getAnnotations();
  ::circt::hw::InnerSymAttr getInnerSymAttr();
  ::std::optional<::circt::hw::InnerSymAttr> getInnerSym();
  ::circt::firrtl::MemoryInitAttr getInitAttr();
  ::std::optional<::circt::firrtl::MemoryInitAttr> getInit();
  void setRuwAttr(::RUWAttrAttr attr);
  void setRuw(::RUWAttr attrValue);
  void setNameAttr(::mlir::StringAttr attr);
  void setName(::llvm::StringRef attrValue);
  void setNameKindAttr(::circt::firrtl::NameKindEnumAttr attr);
  void setNameKind(::circt::firrtl::NameKindEnum attrValue);
  void setAnnotationsAttr(::mlir::ArrayAttr attr);
  void setInnerSymAttr(::circt::hw::InnerSymAttr attr);
  void setInitAttr(::circt::firrtl::MemoryInitAttr attr);
  ::mlir::Attribute removeInnerSymAttr();
  ::mlir::Attribute removeInitAttr();
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, firrtl::FIRRTLBaseType elementType, uint64_t numElements, RUWAttr ruw, mlir::StringRef name, firrtl::NameKindEnum nameKind, ArrayAttr annotations, StringAttr inner_sym = StringAttr(), firrtl::MemoryInitAttr init = firrtl::MemoryInitAttr{});
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type result, ::RUWAttrAttr ruw, ::mlir::StringAttr name, ::circt::firrtl::NameKindEnumAttr nameKind, ::mlir::ArrayAttr annotations, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::firrtl::MemoryInitAttr init);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::RUWAttrAttr ruw, ::mlir::StringAttr name, ::circt::firrtl::NameKindEnumAttr nameKind, ::mlir::ArrayAttr annotations, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::firrtl::MemoryInitAttr init);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type result, ::RUWAttr ruw, ::llvm::StringRef name, ::circt::firrtl::NameKindEnum nameKind, ::mlir::ArrayAttr annotations, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::firrtl::MemoryInitAttr init);
  static void build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::RUWAttr ruw, ::llvm::StringRef name, ::circt::firrtl::NameKindEnum nameKind, ::mlir::ArrayAttr annotations, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::firrtl::MemoryInitAttr init);
  static void build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes = {});
  ::mlir::LogicalResult verifyInvariantsImpl();
  ::mlir::LogicalResult verifyInvariants();
  void getAsmResultNames(::mlir::OpAsmSetValueNameFn setNameFn);
  static std::optional<size_t> getTargetResultIndex();
  static ::mlir::ParseResult parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result);
  void print(::mlir::OpAsmPrinter &_odsPrinter);
private:
  ::mlir::StringAttr getAttributeNameForIndex(unsigned index) {
    return getAttributeNameForIndex((*this)->getName(), index);
  }

  static ::mlir::StringAttr getAttributeNameForIndex(::mlir::OperationName name, unsigned index) {
    assert(index < 6 && "invalid attribute index");
    assert(name.getStringRef() == getOperationName() && "invalid operation name");
    return name.getAttributeNames()[index];
  }

public:
};
} // namespace chirrtl
} // namespace circt
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::chirrtl::SeqMemOp)


#endif  // GET_OP_CLASSES

