/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Enum Utility Definitions                                                   *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

::llvm::StringRef stringifyConvention(Convention val) {
  switch (val) {
    case Convention::Internal: return "internal";
    case Convention::Scalarized: return "scalarized";
  }
  return "";
}

::std::optional<Convention> symbolizeConvention(::llvm::StringRef str) {
  return ::llvm::StringSwitch<::std::optional<Convention>>(str)
      .Case("internal", Convention::Internal)
      .Case("scalarized", Convention::Scalarized)
      .Default(::std::nullopt);
}
::std::optional<Convention> symbolizeConvention(uint32_t value) {
  switch (value) {
  case 0: return Convention::Internal;
  case 1: return Convention::Scalarized;
  default: return ::std::nullopt;
  }
}


::llvm::StringRef stringifyEventControl(EventControl val) {
  switch (val) {
    case EventControl::AtPosEdge: return "posedge";
    case EventControl::AtNegEdge: return "negedge";
    case EventControl::AtEdge: return "edge";
  }
  return "";
}

::std::optional<EventControl> symbolizeEventControl(::llvm::StringRef str) {
  return ::llvm::StringSwitch<::std::optional<EventControl>>(str)
      .Case("posedge", EventControl::AtPosEdge)
      .Case("negedge", EventControl::AtNegEdge)
      .Case("edge", EventControl::AtEdge)
      .Default(::std::nullopt);
}
::std::optional<EventControl> symbolizeEventControl(uint32_t value) {
  switch (value) {
  case 0: return EventControl::AtPosEdge;
  case 1: return EventControl::AtNegEdge;
  case 2: return EventControl::AtEdge;
  default: return ::std::nullopt;
  }
}

bool EventControlAttr::classof(::mlir::Attribute attr) {
  return (((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(32)))) && (((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 0)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 1)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 2)));
}
EventControlAttr EventControlAttr::get(::mlir::MLIRContext *context, EventControl val) {
  ::mlir::IntegerType intType = ::mlir::IntegerType::get(context, 32);
  ::mlir::IntegerAttr baseAttr = ::mlir::IntegerAttr::get(intType, static_cast<uint32_t>(val));
  return ::llvm::cast<EventControlAttr>(baseAttr);
}
EventControl EventControlAttr::getValue() const {
  return static_cast<EventControl>(::mlir::IntegerAttr::getInt());
}

::llvm::StringRef stringifyGroupConvention(GroupConvention val) {
  switch (val) {
    case GroupConvention::Bind: return "bind";
  }
  return "";
}

::std::optional<GroupConvention> symbolizeGroupConvention(::llvm::StringRef str) {
  return ::llvm::StringSwitch<::std::optional<GroupConvention>>(str)
      .Case("bind", GroupConvention::Bind)
      .Default(::std::nullopt);
}
::std::optional<GroupConvention> symbolizeGroupConvention(uint32_t value) {
  switch (value) {
  case 0: return GroupConvention::Bind;
  default: return ::std::nullopt;
  }
}


::llvm::StringRef stringifyMemDirAttr(MemDirAttr val) {
  switch (val) {
    case MemDirAttr::Infer: return "Infer";
    case MemDirAttr::Read: return "Read";
    case MemDirAttr::Write: return "Write";
    case MemDirAttr::ReadWrite: return "ReadWrite";
  }
  return "";
}

::std::optional<MemDirAttr> symbolizeMemDirAttr(::llvm::StringRef str) {
  return ::llvm::StringSwitch<::std::optional<MemDirAttr>>(str)
      .Case("Infer", MemDirAttr::Infer)
      .Case("Read", MemDirAttr::Read)
      .Case("Write", MemDirAttr::Write)
      .Case("ReadWrite", MemDirAttr::ReadWrite)
      .Default(::std::nullopt);
}
::std::optional<MemDirAttr> symbolizeMemDirAttr(uint32_t value) {
  switch (value) {
  case 0: return MemDirAttr::Infer;
  case 1: return MemDirAttr::Read;
  case 2: return MemDirAttr::Write;
  case 3: return MemDirAttr::ReadWrite;
  default: return ::std::nullopt;
  }
}

bool MemDirAttrAttr::classof(::mlir::Attribute attr) {
  return (((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(32)))) && (((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 0)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 1)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 2)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 3)));
}
MemDirAttrAttr MemDirAttrAttr::get(::mlir::MLIRContext *context, MemDirAttr val) {
  ::mlir::IntegerType intType = ::mlir::IntegerType::get(context, 32);
  ::mlir::IntegerAttr baseAttr = ::mlir::IntegerAttr::get(intType, static_cast<uint32_t>(val));
  return ::llvm::cast<MemDirAttrAttr>(baseAttr);
}
MemDirAttr MemDirAttrAttr::getValue() const {
  return static_cast<MemDirAttr>(::mlir::IntegerAttr::getInt());
}

namespace circt {
namespace firrtl {
::llvm::StringRef stringifyNameKindEnum(NameKindEnum val) {
  switch (val) {
    case NameKindEnum::DroppableName: return "droppable_name";
    case NameKindEnum::InterestingName: return "interesting_name";
  }
  return "";
}

::std::optional<NameKindEnum> symbolizeNameKindEnum(::llvm::StringRef str) {
  return ::llvm::StringSwitch<::std::optional<NameKindEnum>>(str)
      .Case("droppable_name", NameKindEnum::DroppableName)
      .Case("interesting_name", NameKindEnum::InterestingName)
      .Default(::std::nullopt);
}
::std::optional<NameKindEnum> symbolizeNameKindEnum(uint32_t value) {
  switch (value) {
  case 0: return NameKindEnum::DroppableName;
  case 1: return NameKindEnum::InterestingName;
  default: return ::std::nullopt;
  }
}

} // namespace firrtl
} // namespace circt

::llvm::StringRef stringifyRUWAttr(RUWAttr val) {
  switch (val) {
    case RUWAttr::Undefined: return "Undefined";
    case RUWAttr::Old: return "Old";
    case RUWAttr::New: return "New";
  }
  return "";
}

::std::optional<RUWAttr> symbolizeRUWAttr(::llvm::StringRef str) {
  return ::llvm::StringSwitch<::std::optional<RUWAttr>>(str)
      .Case("Undefined", RUWAttr::Undefined)
      .Case("Old", RUWAttr::Old)
      .Case("New", RUWAttr::New)
      .Default(::std::nullopt);
}
::std::optional<RUWAttr> symbolizeRUWAttr(uint32_t value) {
  switch (value) {
  case 0: return RUWAttr::Undefined;
  case 1: return RUWAttr::Old;
  case 2: return RUWAttr::New;
  default: return ::std::nullopt;
  }
}

bool RUWAttrAttr::classof(::mlir::Attribute attr) {
  return (((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(32)))) && (((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 0)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 1)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 2)));
}
RUWAttrAttr RUWAttrAttr::get(::mlir::MLIRContext *context, RUWAttr val) {
  ::mlir::IntegerType intType = ::mlir::IntegerType::get(context, 32);
  ::mlir::IntegerAttr baseAttr = ::mlir::IntegerAttr::get(intType, static_cast<uint32_t>(val));
  return ::llvm::cast<RUWAttrAttr>(baseAttr);
}
RUWAttr RUWAttrAttr::getValue() const {
  return static_cast<RUWAttr>(::mlir::IntegerAttr::getInt());
}

