/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Enum Utility Declarations                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// lowering convention
enum class Convention : uint32_t {
  Internal = 0,
  Scalarized = 1,
};

::std::optional<Convention> symbolizeConvention(uint32_t);
::llvm::StringRef stringifyConvention(Convention);
::std::optional<Convention> symbolizeConvention(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForConvention() {
  return 1;
}


inline ::llvm::StringRef stringifyEnum(Convention enumValue) {
  return stringifyConvention(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<Convention> symbolizeEnum<Convention>(::llvm::StringRef str) {
  return symbolizeConvention(str);
}

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::Convention, ::Convention> {
  template <typename ParserT>
  static FailureOr<::Convention> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for lowering convention");

    // Symbolize the keyword.
    if (::std::optional<::Convention> attr = ::symbolizeEnum<::Convention>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid lowering convention specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::Convention value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::Convention> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::Convention getEmptyKey() {
    return static_cast<::Convention>(StorageInfo::getEmptyKey());
  }

  static inline ::Convention getTombstoneKey() {
    return static_cast<::Convention>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::Convention &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::Convention &lhs, const ::Convention &rhs) {
    return lhs == rhs;
  }
};
}

// edge control trigger
enum class EventControl : uint32_t {
  AtPosEdge = 0,
  AtNegEdge = 1,
  AtEdge = 2,
};

::std::optional<EventControl> symbolizeEventControl(uint32_t);
::llvm::StringRef stringifyEventControl(EventControl);
::std::optional<EventControl> symbolizeEventControl(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForEventControl() {
  return 2;
}


inline ::llvm::StringRef stringifyEnum(EventControl enumValue) {
  return stringifyEventControl(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<EventControl> symbolizeEnum<EventControl>(::llvm::StringRef str) {
  return symbolizeEventControl(str);
}

class EventControlAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = EventControl;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static EventControlAttr get(::mlir::MLIRContext *context, EventControl val);
  EventControl getValue() const;
};

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::EventControl, ::EventControl> {
  template <typename ParserT>
  static FailureOr<::EventControl> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for edge control trigger");

    // Symbolize the keyword.
    if (::std::optional<::EventControl> attr = ::symbolizeEnum<::EventControl>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid edge control trigger specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::EventControl value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::EventControl> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::EventControl getEmptyKey() {
    return static_cast<::EventControl>(StorageInfo::getEmptyKey());
  }

  static inline ::EventControl getTombstoneKey() {
    return static_cast<::EventControl>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::EventControl &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::EventControl &lhs, const ::EventControl &rhs) {
    return lhs == rhs;
  }
};
}

// group convention
enum class GroupConvention : uint32_t {
  Bind = 0,
};

::std::optional<GroupConvention> symbolizeGroupConvention(uint32_t);
::llvm::StringRef stringifyGroupConvention(GroupConvention);
::std::optional<GroupConvention> symbolizeGroupConvention(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForGroupConvention() {
  return 0;
}


inline ::llvm::StringRef stringifyEnum(GroupConvention enumValue) {
  return stringifyGroupConvention(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<GroupConvention> symbolizeEnum<GroupConvention>(::llvm::StringRef str) {
  return symbolizeGroupConvention(str);
}

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::GroupConvention, ::GroupConvention> {
  template <typename ParserT>
  static FailureOr<::GroupConvention> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for group convention");

    // Symbolize the keyword.
    if (::std::optional<::GroupConvention> attr = ::symbolizeEnum<::GroupConvention>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid group convention specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::GroupConvention value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::GroupConvention> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::GroupConvention getEmptyKey() {
    return static_cast<::GroupConvention>(StorageInfo::getEmptyKey());
  }

  static inline ::GroupConvention getTombstoneKey() {
    return static_cast<::GroupConvention>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::GroupConvention &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::GroupConvention &lhs, const ::GroupConvention &rhs) {
    return lhs == rhs;
  }
};
}

// Memory Direction Enum
enum class MemDirAttr : uint32_t {
  Infer = 0,
  Read = 1,
  Write = 2,
  ReadWrite = 3,
};

::std::optional<MemDirAttr> symbolizeMemDirAttr(uint32_t);
::llvm::StringRef stringifyMemDirAttr(MemDirAttr);
::std::optional<MemDirAttr> symbolizeMemDirAttr(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForMemDirAttr() {
  return 3;
}


inline ::llvm::StringRef stringifyEnum(MemDirAttr enumValue) {
  return stringifyMemDirAttr(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<MemDirAttr> symbolizeEnum<MemDirAttr>(::llvm::StringRef str) {
  return symbolizeMemDirAttr(str);
}

class MemDirAttrAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = MemDirAttr;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static MemDirAttrAttr get(::mlir::MLIRContext *context, MemDirAttr val);
  MemDirAttr getValue() const;
};

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::MemDirAttr, ::MemDirAttr> {
  template <typename ParserT>
  static FailureOr<::MemDirAttr> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for Memory Direction Enum");

    // Symbolize the keyword.
    if (::std::optional<::MemDirAttr> attr = ::symbolizeEnum<::MemDirAttr>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid Memory Direction Enum specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::MemDirAttr value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::MemDirAttr> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::MemDirAttr getEmptyKey() {
    return static_cast<::MemDirAttr>(StorageInfo::getEmptyKey());
  }

  static inline ::MemDirAttr getTombstoneKey() {
    return static_cast<::MemDirAttr>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::MemDirAttr &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::MemDirAttr &lhs, const ::MemDirAttr &rhs) {
    return lhs == rhs;
  }
};
}

namespace circt {
namespace firrtl {
// name kind
enum class NameKindEnum : uint32_t {
  DroppableName = 0,
  InterestingName = 1,
};

::std::optional<NameKindEnum> symbolizeNameKindEnum(uint32_t);
::llvm::StringRef stringifyNameKindEnum(NameKindEnum);
::std::optional<NameKindEnum> symbolizeNameKindEnum(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForNameKindEnum() {
  return 1;
}


inline ::llvm::StringRef stringifyEnum(NameKindEnum enumValue) {
  return stringifyNameKindEnum(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<NameKindEnum> symbolizeEnum<NameKindEnum>(::llvm::StringRef str) {
  return symbolizeNameKindEnum(str);
}
} // namespace firrtl
} // namespace circt

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::circt::firrtl::NameKindEnum, ::circt::firrtl::NameKindEnum> {
  template <typename ParserT>
  static FailureOr<::circt::firrtl::NameKindEnum> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for name kind");

    // Symbolize the keyword.
    if (::std::optional<::circt::firrtl::NameKindEnum> attr = ::circt::firrtl::symbolizeEnum<::circt::firrtl::NameKindEnum>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid name kind specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::circt::firrtl::NameKindEnum value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::circt::firrtl::NameKindEnum> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::circt::firrtl::NameKindEnum getEmptyKey() {
    return static_cast<::circt::firrtl::NameKindEnum>(StorageInfo::getEmptyKey());
  }

  static inline ::circt::firrtl::NameKindEnum getTombstoneKey() {
    return static_cast<::circt::firrtl::NameKindEnum>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::circt::firrtl::NameKindEnum &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::circt::firrtl::NameKindEnum &lhs, const ::circt::firrtl::NameKindEnum &rhs) {
    return lhs == rhs;
  }
};
}

// Read Under Write Enum
enum class RUWAttr : uint32_t {
  Undefined = 0,
  Old = 1,
  New = 2,
};

::std::optional<RUWAttr> symbolizeRUWAttr(uint32_t);
::llvm::StringRef stringifyRUWAttr(RUWAttr);
::std::optional<RUWAttr> symbolizeRUWAttr(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForRUWAttr() {
  return 2;
}


inline ::llvm::StringRef stringifyEnum(RUWAttr enumValue) {
  return stringifyRUWAttr(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<RUWAttr> symbolizeEnum<RUWAttr>(::llvm::StringRef str) {
  return symbolizeRUWAttr(str);
}

class RUWAttrAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = RUWAttr;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static RUWAttrAttr get(::mlir::MLIRContext *context, RUWAttr val);
  RUWAttr getValue() const;
};

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::RUWAttr, ::RUWAttr> {
  template <typename ParserT>
  static FailureOr<::RUWAttr> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for Read Under Write Enum");

    // Symbolize the keyword.
    if (::std::optional<::RUWAttr> attr = ::symbolizeEnum<::RUWAttr>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid Read Under Write Enum specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::RUWAttr value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::RUWAttr> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::RUWAttr getEmptyKey() {
    return static_cast<::RUWAttr>(StorageInfo::getEmptyKey());
  }

  static inline ::RUWAttr getTombstoneKey() {
    return static_cast<::RUWAttr>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::RUWAttr &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::RUWAttr &lhs, const ::RUWAttr &rhs) {
    return lhs == rhs;
  }
};
}

