/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* TypeDef Declarations                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_TYPEDEF_CLASSES
#undef GET_TYPEDEF_CLASSES


namespace mlir {
class AsmParser;
class AsmPrinter;
} // namespace mlir
namespace circt {
namespace firrtl {
class AnalogType;
class AsyncResetType;
class BaseTypeAliasType;
class BigIntType;
class BundleType;
class ClockType;
class FEnumType;
class FVectorType;
class ListType;
class MapType;
class OpenBundleType;
class OpenVectorType;
class PathType;
class RefType;
class ResetType;
class SIntType;
class StringType;
class UIntType;
class AnalogType : public ::mlir::Type::TypeBase<AnalogType, ::circt::firrtl::FIRRTLBaseType, detail::WidthTypeStorage, ::circt::firrtl::WidthQualifiedTypeTrait, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  int32_t getWidthOrSentinel() const;
  AnalogType getConstType(bool isConst);
  using Base::getChecked;
  static AnalogType get(::mlir::MLIRContext *context, int32_t widthOrSentinel, bool isConst);
  static AnalogType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, int32_t widthOrSentinel, bool isConst);
  static AnalogType get(::mlir::MLIRContext *context, std::optional<int32_t> width, bool isConst = false);
  static AnalogType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, std::optional<int32_t> width, bool isConst = false);
  static AnalogType get(::mlir::MLIRContext *context);
  static AnalogType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, int32_t widthOrSentinel, bool isConst);
};
class AsyncResetType : public ::mlir::Type::TypeBase<AsyncResetType, ::circt::firrtl::FIRRTLBaseType, detail::FIRRTLBaseTypeStorage, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  AsyncResetType getConstType(bool isConst);
  static AsyncResetType get(::mlir::MLIRContext *context, bool isConst);
  static AsyncResetType get(::mlir::MLIRContext *context);
};
class BaseTypeAliasType : public ::mlir::Type::TypeBase<BaseTypeAliasType, ::circt::firrtl::FIRRTLBaseType, detail::BaseTypeAliasStorage, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  // FIRRTLBaseType utils.
  FIRRTLBaseType getAnonymousType();
  FIRRTLBaseType getPassiveType();
  FIRRTLBaseType getConstType(bool isConst);
  FIRRTLBaseType getAllConstDroppedType();

  /// Return the recursive properties of the type.
  RecursiveTypeProperties getRecursiveTypeProperties() const;

  // If a given `newInnerType` is identical to innerType, return `*this`
  // because we can reuse the type alias. Otherwise return `newInnerType`.
  FIRRTLBaseType getModifiedType(FIRRTLBaseType newInnerType);

  /// Implement FieldIDTypeInterface.

  /// Strip off a single layer of this type and return the sub-type and a
  /// field ID targeting the same field, but rebased on the sub-type.
  std::pair<circt::hw::FieldIDTypeInterface, uint64_t>
  getSubTypeByFieldID(uint64_t fieldID);

  /// Get the maximum field ID.
  uint64_t getMaxFieldID();

  /// Returns the effective field id when treating the index field as the root
  /// of the type.  Essentially maps a fieldID to a fieldID after a subfield
  /// op. Returns the new id and whether the id is in the given child.
  std::pair<uint64_t, bool> rootChildFieldID(uint64_t fieldID, uint64_t index);
  static BaseTypeAliasType get(::mlir::StringAttr name, ::circt::firrtl::FIRRTLBaseType innerType);
  StringAttr getName() const;
  ::circt::firrtl::FIRRTLBaseType getInnerType() const;
};
class BigIntType : public ::mlir::Type::TypeBase<BigIntType, circt::firrtl::FIRRTLType, ::mlir::TypeStorage> {
public:
  using Base::Base;
};
class BundleType : public ::mlir::Type::TypeBase<BundleType, ::circt::firrtl::FIRRTLBaseType, detail::BundleTypeStorage, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  using ElementType = ::circt::firrtl::FIRRTLBaseType;

  /// Each element of a bundle, which is a name and type.
  struct BundleElement {
    StringAttr name;
    bool isFlip;
    ElementType type;

    BundleElement(StringAttr name, bool isFlip, ElementType type)
        : name(name), isFlip(isFlip), type(type) {}

    bool operator==(const BundleElement &rhs) const {
      return name == rhs.name && isFlip == rhs.isFlip && type == rhs.type;
    }
    bool operator!=(const BundleElement &rhs) const {
      return !operator==(rhs);
    }

    friend llvm::hash_code hash_value(const BundleElement &arg) {
      return llvm::hash_combine(arg.name, arg.isFlip, arg.type);
    }
  };

  ArrayRef<BundleElement> getElements() const;

  size_t getNumElements() { return getElements().size(); }

  /// Look up an element's index by name.  This returns None on failure.
  std::optional<unsigned> getElementIndex(StringAttr name);
  std::optional<unsigned> getElementIndex(StringRef name);

  /// Look up an element's name by index. This asserts if index is invalid.
  StringAttr getElementNameAttr(size_t index);
  StringRef getElementName(size_t index);

  /// Look up an element by name.  This returns None on failure.
  std::optional<BundleElement> getElement(StringAttr name);
  std::optional<BundleElement> getElement(StringRef name);

  /// Look up an element by index.  This asserts if index is invalid.
  BundleElement getElement(size_t index);

  /// Look up an element type by name.
  ElementType getElementType(StringAttr name);
  ElementType getElementType(StringRef name);

  /// Look up an element type by index.
  ElementType getElementType(size_t index);

  /// Return the recursive properties of the type.
  RecursiveTypeProperties getRecursiveTypeProperties() const;

  /// Get an integer ID for the field. Field IDs start at 1, and are assigned
  /// to each field in a bundle in a recursive pre-order walk of all fields,
  /// visiting all nested bundle fields.  A field ID of 0 is used to reference
  /// the bundle itself. The ID can be used to uniquely identify any specific
  /// field in this bundle.
  uint64_t getFieldID(uint64_t index);

  /// Find the element index corresponding to the desired fieldID.  If the
  /// fieldID corresponds to a field in a nested bundle, it will return the
  /// index of the parent field.
  uint64_t getIndexForFieldID(uint64_t fieldID);

  /// Find the index of the element that contains the given fieldID.
  /// As well, rebase the fieldID to the element.
  std::pair<uint64_t, uint64_t> getIndexAndSubfieldID(uint64_t fieldID);

  /// Strip off a single layer of this type and return the sub-type and a
  /// field ID targeting the same field, but rebased on the sub-type.
  std::pair<circt::hw::FieldIDTypeInterface, uint64_t>
  getSubTypeByFieldID(uint64_t fieldID);

  /// Get the maximum field ID in this bundle.  This is helpful for
  /// constructing field IDs when this BundleType is nested in another
  /// aggregate type.
  uint64_t getMaxFieldID();

  /// Returns the effective field id when treating the index field as the root
  /// of the type.  Essentially maps a fieldID to a fieldID after a subfield
  /// op. Returns the new id and whether the id is in the given child.
  std::pair<uint64_t, bool> rootChildFieldID(uint64_t fieldID,
                                             uint64_t index);

  using iterator = ArrayRef<BundleElement>::iterator;
  iterator begin() const { return getElements().begin(); }
  iterator end() const { return getElements().end(); }

  /// Const support.
  bool isConst();
  ElementType getElementTypePreservingConst(size_t index);

  /// Return a 'const' or non-'const' version of this type.
  BundleType getConstType(bool isConst);


  /// Return this type with any flip types recursively removed from itself.
  FIRRTLBaseType getPassiveType();

  /// Return this type with a 'const' modifiers dropped
  BundleType getAllConstDroppedType();

  /// Return this type with any type alias types recursively removed from itself.
  FIRRTLBaseType getAnonymousType();
  static BundleType get(::mlir::MLIRContext *context, ArrayRef<BundleElement> elements, bool isConst = false);
};
class ClockType : public ::mlir::Type::TypeBase<ClockType, ::circt::firrtl::FIRRTLBaseType, detail::FIRRTLBaseTypeStorage, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  ClockType getConstType(bool isConst);
  static ClockType get(::mlir::MLIRContext *context, bool isConst);
  static ClockType get(::mlir::MLIRContext *context);
};
class FEnumType : public ::mlir::Type::TypeBase<FEnumType, ::circt::firrtl::FIRRTLBaseType, detail::FEnumTypeStorage, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  /// Each element of an enum, which is a name and type.
  struct EnumElement {
    StringAttr name;
    FIRRTLBaseType type;

    EnumElement(StringAttr name, FIRRTLBaseType type)
        : name(name), type(type) {}

    bool operator==(const EnumElement &rhs) const {
      return name == rhs.name && type == rhs.type;
    }
    bool operator!=(const EnumElement &rhs) const {
      return !operator==(rhs);
    }

    friend llvm::hash_code hash_value(const FEnumType::EnumElement &arg) {
      return mlir::hash_value(arg.name) ^ mlir::hash_value(arg.type);
    }
  };

  ArrayRef<EnumElement> getElements() const;

  size_t getNumElements() { return getElements().size(); }

  FEnumType getConstType(bool isConst);

  /// Return this type with a 'const' modifiers dropped
  FEnumType getAllConstDroppedType();

  /// Return this type with any type alias types recursively removed from itself.
  FIRRTLBaseType getAnonymousType();

  /// Look up an element's index by name.  This returns None on failure.
  std::optional<unsigned> getElementIndex(StringAttr name);
  std::optional<unsigned> getElementIndex(StringRef name);

  /// Look up an element's name by index. This asserts if index is invalid.
  StringAttr getElementNameAttr(size_t index);
  StringRef getElementName(size_t index);

  /// Look up an element by name.  This returns None on failure.
  std::optional<EnumElement> getElement(StringAttr name);
  std::optional<EnumElement> getElement(StringRef name);

  /// Look up an element by index.  This asserts if index is invalid.
  EnumElement getElement(size_t index);

  /// Look up an element type by name.
  FIRRTLBaseType getElementType(StringAttr name);
  FIRRTLBaseType getElementType(StringRef name);

  /// Look up an element type by index.
  FIRRTLBaseType getElementType(size_t index);
  FIRRTLBaseType getElementTypePreservingConst(size_t index);

  /// Return the recursive properties of the type.
  RecursiveTypeProperties getRecursiveTypeProperties() const;

  /// Get an integer ID for the field. Field IDs start at 1, and are assigned
  /// to each field in a enum in a recursive pre-order walk of all fields,
  /// visiting all nested enum fields.  A field ID of 0 is used to reference
  /// the enum itself. The ID can be used to uniquely identify any specific
  /// field in this enum.
  uint64_t getFieldID(uint64_t index);

  /// Find the element index corresponding to the desired fieldID.  If the
  /// fieldID corresponds to a field in a nested enum, it will return the
  /// index of the parent field.
  uint64_t getIndexForFieldID(uint64_t fieldID);

  /// Find the index of the element that contains the given fieldID.
  /// As well, rebase the fieldID to the element.
  std::pair<uint64_t, uint64_t> getIndexAndSubfieldID(uint64_t fieldID);

  /// Strip off a single layer of this type and return the sub-type and a
  /// field ID targeting the same field, but rebased on the sub-type.
  std::pair<circt::hw::FieldIDTypeInterface, uint64_t>
  getSubTypeByFieldID(uint64_t fieldID);

  /// Get the maximum field ID in this bundle.  This is helpful for
  /// constructing field IDs when this FEnumType is nested in another
  /// aggregate type.
  uint64_t getMaxFieldID();

  /// Returns the effective field id when treating the index field as the root
  /// of the type.  Essentially maps a fieldID to a fieldID after a subfield
  /// op. Returns the new id and whether the id is in the given child.
  std::pair<uint64_t, bool> rootChildFieldID(uint64_t fieldID,
                                             uint64_t index);

  using iterator = ArrayRef<EnumElement>::iterator;
  iterator begin() const { return getElements().begin(); }
  iterator end() const { return getElements().end(); }
  using Base::getChecked;
  static FEnumType get(::mlir::MLIRContext *context, ArrayRef<EnumElement> elements, bool isConst = false);
  static FEnumType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, ArrayRef<EnumElement> elements, bool isConst = false);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ArrayRef<EnumElement> elements, bool isConst);
};
class FVectorType : public ::mlir::Type::TypeBase<FVectorType, ::circt::firrtl::FIRRTLBaseType, detail::FVectorTypeStorage, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  using ElementType = ::circt::firrtl::FIRRTLBaseType;

  ElementType getElementType() const;
  size_t getNumElements() const;

  /// Return the recursive properties of the type.
  RecursiveTypeProperties getRecursiveTypeProperties() const;

  /// Get an integer ID for the field. Field IDs start at 1, and are assigned
  /// to each field in a vector in a recursive depth-first walk of all
  /// elements. A field ID of 0 is used to reference the vector itself.
  uint64_t getFieldID(uint64_t index);

  /// Find the element index corresponding to the desired fieldID.  If the
  /// fieldID corresponds to a field in nested under an element, it will
  /// return the index of the parent element.
  uint64_t getIndexForFieldID(uint64_t fieldID);

  /// Find the index of the element that contains the given fieldID.
  /// As well, rebase the fieldID to the element.
  std::pair<uint64_t, uint64_t> getIndexAndSubfieldID(uint64_t fieldID);

  /// Strip off a single layer of this type and return the sub-type and a
  /// field ID targeting the same field, but rebased on the sub-type.
  std::pair<circt::hw::FieldIDTypeInterface, uint64_t>
  getSubTypeByFieldID(uint64_t fieldID);

  /// Get the maximum field ID in this vector.  This is helpful for
  /// constructing field IDs when this VectorType is nested in another
  /// aggregate type.
  uint64_t getMaxFieldID();

  /// Returns the effective field id when treating the index field as the root
  /// of the type.  Essentially maps a fieldID to a fieldID after a subfield
  /// op. Returns the new id and whether the id is in the given child.
  std::pair<uint64_t, bool> rootChildFieldID(uint64_t fieldID, uint64_t index);

  /// Const support.
  bool isConst();
  ElementType getElementTypePreservingConst();

  /// Return a 'const' or non-'const' version of this type.
  FVectorType getConstType(bool isConst);


  /// Return this type with any flip types recursively removed from itself.
  FIRRTLBaseType getPassiveType();

  /// Return this type with a 'const' modifiers dropped
  FVectorType getAllConstDroppedType();

  /// Return this type with any type alias types recursively removed from itself.
  FIRRTLBaseType getAnonymousType();
  static FVectorType get(::circt::firrtl::FIRRTLBaseType elementType, size_t numElements, bool isConst = false);
};
namespace detail {
struct ListTypeStorage;
} // namespace detail
class ListType : public ::mlir::Type::TypeBase<ListType, circt::firrtl::FIRRTLType, detail::ListTypeStorage> {
public:
  using Base::Base;
  static ListType get(::mlir::MLIRContext *context, circt::firrtl::PropertyType elementType);
  circt::firrtl::PropertyType getElementType() const;
};
namespace detail {
struct MapTypeStorage;
} // namespace detail
class MapType : public ::mlir::Type::TypeBase<MapType, circt::firrtl::FIRRTLType, detail::MapTypeStorage> {
public:
  using Base::Base;
  static MapType get(::mlir::MLIRContext *context, circt::firrtl::PropertyType keyType, circt::firrtl::PropertyType valueType);
  circt::firrtl::PropertyType getKeyType() const;
  circt::firrtl::PropertyType getValueType() const;
};
class OpenBundleType : public ::mlir::Type::TypeBase<OpenBundleType, ::circt::firrtl::FIRRTLType, detail::OpenBundleTypeStorage, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  using ElementType = ::circt::firrtl::FIRRTLType;

  /// Each element of a bundle, which is a name and type.
  struct BundleElement {
    StringAttr name;
    bool isFlip;
    ElementType type;

    BundleElement(StringAttr name, bool isFlip, ElementType type)
        : name(name), isFlip(isFlip), type(type) {}

    bool operator==(const BundleElement &rhs) const {
      return name == rhs.name && isFlip == rhs.isFlip && type == rhs.type;
    }
    bool operator!=(const BundleElement &rhs) const {
      return !operator==(rhs);
    }

    friend llvm::hash_code hash_value(const BundleElement &arg) {
      return llvm::hash_combine(arg.name, arg.isFlip, arg.type);
    }
  };

  ArrayRef<BundleElement> getElements() const;

  size_t getNumElements() { return getElements().size(); }

  /// Look up an element's index by name.  This returns None on failure.
  std::optional<unsigned> getElementIndex(StringAttr name);
  std::optional<unsigned> getElementIndex(StringRef name);

  /// Look up an element's name by index. This asserts if index is invalid.
  StringAttr getElementNameAttr(size_t index);
  StringRef getElementName(size_t index);

  /// Look up an element by name.  This returns None on failure.
  std::optional<BundleElement> getElement(StringAttr name);
  std::optional<BundleElement> getElement(StringRef name);

  /// Look up an element by index.  This asserts if index is invalid.
  BundleElement getElement(size_t index);

  /// Look up an element type by name.
  ElementType getElementType(StringAttr name);
  ElementType getElementType(StringRef name);

  /// Look up an element type by index.
  ElementType getElementType(size_t index);

  /// Return the recursive properties of the type.
  RecursiveTypeProperties getRecursiveTypeProperties() const;

  /// Get an integer ID for the field. Field IDs start at 1, and are assigned
  /// to each field in a bundle in a recursive pre-order walk of all fields,
  /// visiting all nested bundle fields.  A field ID of 0 is used to reference
  /// the bundle itself. The ID can be used to uniquely identify any specific
  /// field in this bundle.
  uint64_t getFieldID(uint64_t index);

  /// Find the element index corresponding to the desired fieldID.  If the
  /// fieldID corresponds to a field in a nested bundle, it will return the
  /// index of the parent field.
  uint64_t getIndexForFieldID(uint64_t fieldID);

  /// Find the index of the element that contains the given fieldID.
  /// As well, rebase the fieldID to the element.
  std::pair<uint64_t, uint64_t> getIndexAndSubfieldID(uint64_t fieldID);

  /// Strip off a single layer of this type and return the sub-type and a
  /// field ID targeting the same field, but rebased on the sub-type.
  std::pair<circt::hw::FieldIDTypeInterface, uint64_t>
  getSubTypeByFieldID(uint64_t fieldID);

  /// Get the maximum field ID in this bundle.  This is helpful for
  /// constructing field IDs when this BundleType is nested in another
  /// aggregate type.
  uint64_t getMaxFieldID();

  /// Returns the effective field id when treating the index field as the root
  /// of the type.  Essentially maps a fieldID to a fieldID after a subfield
  /// op. Returns the new id and whether the id is in the given child.
  std::pair<uint64_t, bool> rootChildFieldID(uint64_t fieldID,
                                             uint64_t index);

  using iterator = ArrayRef<BundleElement>::iterator;
  iterator begin() const { return getElements().begin(); }
  iterator end() const { return getElements().end(); }

  /// Const support.
  bool isConst();
  ElementType getElementTypePreservingConst(size_t index);

  /// Return a 'const' or non-'const' version of this type.
  OpenBundleType getConstType(bool isConst);

  using Base::getChecked;
  static OpenBundleType get(::mlir::MLIRContext *context, ArrayRef<BundleElement> elements, bool isConst = false);
  static OpenBundleType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, ArrayRef<BundleElement> elements, bool isConst = false);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ArrayRef<BundleElement> elements, bool isConst);
  uint64_t getMaxFieldID() const;
  std::pair<circt::hw::FieldIDTypeInterface, uint64_t> getSubTypeByFieldID(uint64_t fieldID) const;
  circt::hw::FieldIDTypeInterface getFinalTypeByFieldID(uint64_t fieldID) const;
  std::pair<uint64_t, bool> rootChildFieldID(uint64_t fieldID, uint64_t index) const;
};
class OpenVectorType : public ::mlir::Type::TypeBase<OpenVectorType, ::circt::firrtl::FIRRTLType, detail::OpenVectorTypeStorage, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  using ElementType = ::circt::firrtl::FIRRTLType;

  ElementType getElementType() const;
  size_t getNumElements() const;

  /// Return the recursive properties of the type.
  RecursiveTypeProperties getRecursiveTypeProperties() const;

  /// Get an integer ID for the field. Field IDs start at 1, and are assigned
  /// to each field in a vector in a recursive depth-first walk of all
  /// elements. A field ID of 0 is used to reference the vector itself.
  uint64_t getFieldID(uint64_t index);

  /// Find the element index corresponding to the desired fieldID.  If the
  /// fieldID corresponds to a field in nested under an element, it will
  /// return the index of the parent element.
  uint64_t getIndexForFieldID(uint64_t fieldID);

  /// Find the index of the element that contains the given fieldID.
  /// As well, rebase the fieldID to the element.
  std::pair<uint64_t, uint64_t> getIndexAndSubfieldID(uint64_t fieldID);

  /// Strip off a single layer of this type and return the sub-type and a
  /// field ID targeting the same field, but rebased on the sub-type.
  std::pair<circt::hw::FieldIDTypeInterface, uint64_t>
  getSubTypeByFieldID(uint64_t fieldID);

  /// Get the maximum field ID in this vector.  This is helpful for
  /// constructing field IDs when this VectorType is nested in another
  /// aggregate type.
  uint64_t getMaxFieldID();

  /// Returns the effective field id when treating the index field as the root
  /// of the type.  Essentially maps a fieldID to a fieldID after a subfield
  /// op. Returns the new id and whether the id is in the given child.
  std::pair<uint64_t, bool> rootChildFieldID(uint64_t fieldID, uint64_t index);

  /// Const support.
  bool isConst();
  ElementType getElementTypePreservingConst();

  /// Return a 'const' or non-'const' version of this type.
  OpenVectorType getConstType(bool isConst);

  using Base::getChecked;
  static OpenVectorType get(::circt::firrtl::FIRRTLType elementType, size_t numElements, bool isConst = false);
  static OpenVectorType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::circt::firrtl::FIRRTLType elementType, size_t numElements, bool isConst = false);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::circt::firrtl::FIRRTLType elementType, size_t numElements, bool isConst);
  uint64_t getMaxFieldID() const;
  std::pair<circt::hw::FieldIDTypeInterface, uint64_t> getSubTypeByFieldID(uint64_t fieldID) const;
  circt::hw::FieldIDTypeInterface getFinalTypeByFieldID(uint64_t fieldID) const;
  std::pair<uint64_t, bool> rootChildFieldID(uint64_t fieldID, uint64_t index) const;
};
class PathType : public ::mlir::Type::TypeBase<PathType, circt::firrtl::FIRRTLType, ::mlir::TypeStorage> {
public:
  using Base::Base;
};
namespace detail {
struct RefTypeStorage;
} // namespace detail
class RefType : public ::mlir::Type::TypeBase<RefType, ::circt::firrtl::FIRRTLType, detail::RefTypeStorage, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  /// Return the recursive properties of the type.
  RecursiveTypeProperties getRecursiveTypeProperties() const;
  using Base::getChecked;
  static RefType get(::circt::firrtl::FIRRTLBaseType type, bool forceable = false);
  static RefType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::circt::firrtl::FIRRTLBaseType type, bool forceable = false);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::circt::firrtl::FIRRTLBaseType type, bool forceable);
  ::circt::firrtl::FIRRTLBaseType getType() const;
  bool getForceable() const;
  uint64_t getMaxFieldID() const;
  std::pair<circt::hw::FieldIDTypeInterface, uint64_t> getSubTypeByFieldID(uint64_t fieldID) const;
  circt::hw::FieldIDTypeInterface getFinalTypeByFieldID(uint64_t fieldID) const;
  std::pair<uint64_t, bool> rootChildFieldID(uint64_t fieldID, uint64_t index) const;
};
class ResetType : public ::mlir::Type::TypeBase<ResetType, ::circt::firrtl::FIRRTLBaseType, detail::FIRRTLBaseTypeStorage, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  ResetType getConstType(bool isConst);
  static ResetType get(::mlir::MLIRContext *context, bool isConst);
  static ResetType get(::mlir::MLIRContext *context);
};
class SIntType : public ::mlir::Type::TypeBase<SIntType, ::circt::firrtl::IntType, detail::WidthTypeStorage, ::circt::firrtl::WidthQualifiedTypeTrait, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  using WidthQualifiedTypeTrait<SIntType>::getWidth;
  using WidthQualifiedTypeTrait<SIntType>::hasWidth;
  int32_t getWidthOrSentinel() const;
  SIntType getConstType(bool isConst);
  using Base::getChecked;
  static SIntType get(::mlir::MLIRContext *context, int32_t widthOrSentinel, bool isConst);
  static SIntType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, int32_t widthOrSentinel, bool isConst);
  static SIntType get(::mlir::MLIRContext *context, std::optional<int32_t> width, bool isConst = false);
  static SIntType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, std::optional<int32_t> width, bool isConst = false);
  static SIntType get(::mlir::MLIRContext *context);
  static SIntType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, int32_t widthOrSentinel, bool isConst);
};
class StringType : public ::mlir::Type::TypeBase<StringType, circt::firrtl::FIRRTLType, ::mlir::TypeStorage> {
public:
  using Base::Base;
};
class UIntType : public ::mlir::Type::TypeBase<UIntType, ::circt::firrtl::IntType, detail::WidthTypeStorage, ::circt::firrtl::WidthQualifiedTypeTrait, circt::hw::FieldIDTypeInterface::Trait> {
public:
  using Base::Base;
  using WidthQualifiedTypeTrait<UIntType>::getWidth;
  using WidthQualifiedTypeTrait<UIntType>::hasWidth;
  int32_t getWidthOrSentinel() const;
  UIntType getConstType(bool isConst);
  using Base::getChecked;
  static UIntType get(::mlir::MLIRContext *context, int32_t widthOrSentinel, bool isConst);
  static UIntType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, int32_t widthOrSentinel, bool isConst);
  static UIntType get(::mlir::MLIRContext *context, std::optional<int32_t> width, bool isConst = false);
  static UIntType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, std::optional<int32_t> width, bool isConst = false);
  static UIntType get(::mlir::MLIRContext *context);
  static UIntType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, int32_t widthOrSentinel, bool isConst);
};
} // namespace firrtl
} // namespace circt
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::AnalogType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::AsyncResetType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::BaseTypeAliasType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::BigIntType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::BundleType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::ClockType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::FEnumType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::FVectorType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::ListType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::MapType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::OpenBundleType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::OpenVectorType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::PathType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::RefType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::ResetType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::SIntType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::StringType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::firrtl::UIntType)

#endif  // GET_TYPEDEF_CLASSES

