/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace circt {
namespace hw {
class HWModuleLike;
namespace detail {
struct HWModuleLikeInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    ::llvm::StringRef (*getModuleName)(const Concept *impl, ::mlir::Operation *);
    ::mlir::StringAttr (*getModuleNameAttr)(const Concept *impl, ::mlir::Operation *);
    size_t (*getNumPorts)(const Concept *impl, ::mlir::Operation *);
    ::circt::hw::InnerSymAttr (*getPortSymbolAttr)(const Concept *impl, ::mlir::Operation *, size_t);
    ::circt::hw::ModuleType (*getHWModuleType)(const Concept *impl, ::mlir::Operation *);
    mlir::ArrayAttr (*getInputNames)(const Concept *impl, ::mlir::Operation *);
    mlir::ArrayAttr (*getOutputNames)(const Concept *impl, ::mlir::Operation *);
    mlir::ArrayAttr (*getInputLocs)(const Concept *impl, ::mlir::Operation *);
    mlir::ArrayAttr (*getOutputLocs)(const Concept *impl, ::mlir::Operation *);
    /// The base classes of this interface.
    const ::mlir::SymbolOpInterface::Concept *implSymbolOpInterface = nullptr;

    void initializeInterfaceConcept(::mlir::detail::InterfaceMap &interfaceMap) {
      implSymbolOpInterface = interfaceMap.lookup<::mlir::SymbolOpInterface>();
      assert(implSymbolOpInterface && "`circt::hw::HWModuleLike` expected its base interface `::mlir::SymbolOpInterface` to be registered");
    }
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = circt::hw::HWModuleLike;
    Model() : Concept{getModuleName, getModuleNameAttr, getNumPorts, getPortSymbolAttr, getHWModuleType, getInputNames, getOutputNames, getInputLocs, getOutputLocs} {}

    static inline ::llvm::StringRef getModuleName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::StringAttr getModuleNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline size_t getNumPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::circt::hw::InnerSymAttr getPortSymbolAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, size_t portIndex);
    static inline ::circt::hw::ModuleType getHWModuleType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::ArrayAttr getInputNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::ArrayAttr getOutputNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::ArrayAttr getInputLocs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::ArrayAttr getOutputLocs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = circt::hw::HWModuleLike;
    FallbackModel() : Concept{getModuleName, getModuleNameAttr, getNumPorts, getPortSymbolAttr, getHWModuleType, getInputNames, getOutputNames, getInputLocs, getOutputLocs} {}

    static inline ::llvm::StringRef getModuleName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::StringAttr getModuleNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline size_t getNumPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::circt::hw::InnerSymAttr getPortSymbolAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, size_t portIndex);
    static inline ::circt::hw::ModuleType getHWModuleType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::ArrayAttr getInputNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::ArrayAttr getOutputNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::ArrayAttr getInputLocs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::ArrayAttr getOutputLocs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    ::llvm::StringRef getModuleName(::mlir::Operation *tablegen_opaque_val) const;
    ::mlir::StringAttr getModuleNameAttr(::mlir::Operation *tablegen_opaque_val) const;
    ::circt::hw::ModuleType getHWModuleType(::mlir::Operation *tablegen_opaque_val) const;
    mlir::ArrayAttr getInputNames(::mlir::Operation *tablegen_opaque_val) const;
    mlir::ArrayAttr getOutputNames(::mlir::Operation *tablegen_opaque_val) const;
    mlir::ArrayAttr getInputLocs(::mlir::Operation *tablegen_opaque_val) const;
    mlir::ArrayAttr getOutputLocs(::mlir::Operation *tablegen_opaque_val) const;
  };
};template <typename ConcreteOp>
struct HWModuleLikeTrait;

} // namespace detail
class HWModuleLike : public ::mlir::OpInterface<HWModuleLike, detail::HWModuleLikeInterfaceTraits> {
public:
  using ::mlir::OpInterface<HWModuleLike, detail::HWModuleLikeInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::HWModuleLikeTrait<ConcreteOp> {};
  /// Get the module name
  ::llvm::StringRef getModuleName();
  /// Get the module name
  ::mlir::StringAttr getModuleNameAttr();
  /// Get the number of ports
  size_t getNumPorts();
  /// Get a port symbol attribute
  ::circt::hw::InnerSymAttr getPortSymbolAttr(size_t portIndex);
  /// Get the module type
  ::circt::hw::ModuleType getHWModuleType();
  /// Return the names of the inputs to this module
  mlir::ArrayAttr getInputNames();
  /// Return the names of the outputs this module
  mlir::ArrayAttr getOutputNames();
  /// Return the locations of the inputs to this module
  mlir::ArrayAttr getInputLocs();
  /// Return the locations of the outputs of this module
  mlir::ArrayAttr getOutputLocs();


    // Return the number of inputs to this module
    unsigned getNumInputs() {
      return getInputNames().size();
    }

    // Return the number of outputs from this module
    unsigned getNumOutputs() {
      return getOutputNames().size();
    }

    // Return the name of an input.
    mlir::StringRef getInputName(unsigned idx) {
      return getInputNameAttr(idx).getValue();
    }

    // Return the name of an output
    mlir::StringRef getOutputName(unsigned idx) {
      return getOutputNameAttr(idx).getValue();
    }

    // Return the name of an input to this module
    mlir::StringAttr getInputNameAttr(unsigned idx) {
      return cast<StringAttr>(getInputNames()[idx]);
    }

    // Return the name of an output to this module
    mlir::StringAttr getOutputNameAttr(unsigned idx) {
      return cast<StringAttr>(getOutputNames()[idx]);
    }
  //===----------------------------------------------------------------===//
  // Inherited from ::mlir::SymbolOpInterface
  //===----------------------------------------------------------------===//

  operator ::mlir::SymbolOpInterface () const {
    return ::mlir::SymbolOpInterface(*this, getImpl()->implSymbolOpInterface);
  }

  /// Returns the name of this symbol.
  StringAttr getNameAttr();
  /// Sets the name of this symbol.
  void setName(::mlir::StringAttr name);
  /// Gets the visibility of this symbol.
  mlir::SymbolTable::Visibility getVisibility();
  /// Returns true if this symbol has nested visibility.
  bool isNested();
  /// Returns true if this symbol has private visibility.
  bool isPrivate();
  /// Returns true if this symbol has public visibility.
  bool isPublic();
  /// Sets the visibility of this symbol.
  void setVisibility(mlir::SymbolTable::Visibility vis);
  /// Sets the visibility of this symbol to be nested.
  void setNested();
  /// Sets the visibility of this symbol to be private.
  void setPrivate();
  /// Sets the visibility of this symbol to be public.
  void setPublic();
  /// Get all of the uses of the current symbol that are nested within the
  /// given operation 'from'.
  /// Note: See mlir::SymbolTable::getSymbolUses for more details.
  ::std::optional<::mlir::SymbolTable::UseRange> getSymbolUses(::mlir::Operation * from);
  /// Return if the current symbol is known to have no uses that are nested
  /// within the given operation 'from'.
  /// Note: See mlir::SymbolTable::symbolKnownUseEmpty for more details.
  bool symbolKnownUseEmpty(::mlir::Operation * from);
  /// Attempt to replace all uses of the current symbol with the provided
  /// symbol 'newSymbol' that are nested within the given operation 'from'.
  /// Note: See mlir::SymbolTable::replaceAllSymbolUses for more details.
  ::mlir::LogicalResult replaceAllSymbolUses(::mlir::StringAttr newSymbol, ::mlir::Operation * from);
  /// Returns true if this operation optionally defines a symbol based on the
  /// presence of the symbol name.
  bool isOptionalSymbol();
  /// Returns true if this operation can be discarded if it has no remaining
  /// symbol uses.
  bool canDiscardOnUseEmpty();
  /// Returns true if this operation is a declaration of a symbol (as opposed
  /// to a definition).
  bool isDeclaration();

    using Visibility = mlir::SymbolTable::Visibility;

    /// Convenience version of `getNameAttr` that returns a StringRef.
    StringRef getName() {
      return getNameAttr().getValue();
    }

    /// Convenience version of `setName` that take a StringRef.
    void setName(StringRef name) {
      setName(StringAttr::get((*this)->getContext(), name));
    }
};
namespace detail {
  template <typename ConcreteOp>
  struct HWModuleLikeTrait : public ::mlir::OpInterface<HWModuleLike, detail::HWModuleLikeInterfaceTraits>::Trait<ConcreteOp> {
    /// Get the module name
    ::llvm::StringRef getModuleName() {
      return (*static_cast<ConcreteOp *>(this)).getName();
    }
    /// Get the module name
    ::mlir::StringAttr getModuleNameAttr() {
      return (*static_cast<ConcreteOp *>(this)).getNameAttr();
    }
    /// Get the module type
    ::circt::hw::ModuleType getHWModuleType() {
      return ::circt::hw::detail::fnToMod((*static_cast<ConcreteOp *>(this)), getInputNames(), getOutputNames());
    }
    /// Return the names of the inputs to this module
    mlir::ArrayAttr getInputNames() {
      return (*static_cast<ConcreteOp *>(this))->template getAttrOfType<ArrayAttr>("argNames");
    }
    /// Return the names of the outputs this module
    mlir::ArrayAttr getOutputNames() {
      return (*static_cast<ConcreteOp *>(this))->template getAttrOfType<ArrayAttr>("resultNames");
    }
    /// Return the locations of the inputs to this module
    mlir::ArrayAttr getInputLocs() {
      return (*static_cast<ConcreteOp *>(this))->template getAttrOfType<ArrayAttr>("argLocs");
    }
    /// Return the locations of the outputs of this module
    mlir::ArrayAttr getOutputLocs() {
      return (*static_cast<ConcreteOp *>(this))->template getAttrOfType<ArrayAttr>("resultLocs");
    }
    static ::mlir::LogicalResult verifyTrait(::mlir::Operation *op) {
      static_assert(
        ConcreteOp::template hasTrait<::mlir::SymbolOpInterface::Trait>(),
        "expected operation to be a symbol");
    return success();
    }


    // Return the number of inputs to this module
    unsigned getNumInputs() {
      return getInputNames().size();
    }

    // Return the number of outputs from this module
    unsigned getNumOutputs() {
      return getOutputNames().size();
    }

    // Return the name of an input.
    mlir::StringRef getInputName(unsigned idx) {
      return getInputNameAttr(idx).getValue();
    }

    // Return the name of an output
    mlir::StringRef getOutputName(unsigned idx) {
      return getOutputNameAttr(idx).getValue();
    }

    // Return the name of an input to this module
    mlir::StringAttr getInputNameAttr(unsigned idx) {
      return cast<StringAttr>(getInputNames()[idx]);
    }

    // Return the name of an output to this module
    mlir::StringAttr getOutputNameAttr(unsigned idx) {
      return cast<StringAttr>(getOutputNames()[idx]);
    }

  
  };
}// namespace detail
} // namespace hw
} // namespace circt
namespace circt {
namespace hw {
class HWMutableModuleLike;
namespace detail {
struct HWMutableModuleLikeInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    ::circt::hw::ModulePortInfo (*getPorts)(const Concept *impl, ::mlir::Operation *);
    ::circt::hw::ModulePortLookupInfo (*getPortLookupInfo)(const Concept *impl, ::mlir::Operation *);
    void (*modifyPorts)(const Concept *impl, ::mlir::Operation *, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>>, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>>, ArrayRef<unsigned>, ArrayRef<unsigned>);
    void (*insertPorts)(const Concept *impl, ::mlir::Operation *, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>>, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>>);
    void (*erasePorts)(const Concept *impl, ::mlir::Operation *, ArrayRef<unsigned>, ArrayRef<unsigned>);
    void (*appendOutputs)(const Concept *impl, ::mlir::Operation *, ArrayRef<std::pair<StringAttr, Value>>);
    /// The base classes of this interface.
    const ::mlir::SymbolOpInterface::Concept *implSymbolOpInterface = nullptr;
    const circt::hw::HWModuleLike::Concept *implHWModuleLike = nullptr;

    void initializeInterfaceConcept(::mlir::detail::InterfaceMap &interfaceMap) {
      implSymbolOpInterface = interfaceMap.lookup<::mlir::SymbolOpInterface>();
      assert(implSymbolOpInterface && "`circt::hw::HWMutableModuleLike` expected its base interface `::mlir::SymbolOpInterface` to be registered");
      implHWModuleLike = interfaceMap.lookup<circt::hw::HWModuleLike>();
      assert(implHWModuleLike && "`circt::hw::HWMutableModuleLike` expected its base interface `circt::hw::HWModuleLike` to be registered");
    }
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = circt::hw::HWMutableModuleLike;
    Model() : Concept{getPorts, getPortLookupInfo, modifyPorts, insertPorts, erasePorts, appendOutputs} {}

    static inline ::circt::hw::ModulePortInfo getPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::circt::hw::ModulePortLookupInfo getPortLookupInfo(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void modifyPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs, ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs);
    static inline void insertPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs);
    static inline void erasePorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs);
    static inline void appendOutputs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<StringAttr, Value>> outputs);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = circt::hw::HWMutableModuleLike;
    FallbackModel() : Concept{getPorts, getPortLookupInfo, modifyPorts, insertPorts, erasePorts, appendOutputs} {}

    static inline ::circt::hw::ModulePortInfo getPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::circt::hw::ModulePortLookupInfo getPortLookupInfo(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void modifyPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs, ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs);
    static inline void insertPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs);
    static inline void erasePorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs);
    static inline void appendOutputs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<StringAttr, Value>> outputs);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    ::circt::hw::ModulePortInfo getPorts(::mlir::Operation *tablegen_opaque_val) const;
    ::circt::hw::ModulePortLookupInfo getPortLookupInfo(::mlir::Operation *tablegen_opaque_val) const;
    void insertPorts(::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs) const;
    void erasePorts(::mlir::Operation *tablegen_opaque_val, ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs) const;
  };
};template <typename ConcreteOp>
struct HWMutableModuleLikeTrait;

} // namespace detail
class HWMutableModuleLike : public ::mlir::OpInterface<HWMutableModuleLike, detail::HWMutableModuleLikeInterfaceTraits> {
public:
  using ::mlir::OpInterface<HWMutableModuleLike, detail::HWMutableModuleLikeInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::HWMutableModuleLikeTrait<ConcreteOp> {};
  /// Decode information about the input and output ports on this module.
  ::circt::hw::ModulePortInfo getPorts();
  /// Get a handle to a utility class which provides by-name lookup of port indices. The returned object does _not_ update if the module is mutated.
  ::circt::hw::ModulePortLookupInfo getPortLookupInfo();
  /// Insert and remove input and output ports
  void modifyPorts(ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs, ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs);
  /// Insert ports into this module
  void insertPorts(ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs);
  /// Erase ports from this module
  void erasePorts(ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs);
  /// Append output values to this module
  void appendOutputs(ArrayRef<std::pair<StringAttr, Value>> outputs);
  //===----------------------------------------------------------------===//
  // Inherited from ::mlir::SymbolOpInterface
  //===----------------------------------------------------------------===//

  operator ::mlir::SymbolOpInterface () const {
    return ::mlir::SymbolOpInterface(*this, getImpl()->implSymbolOpInterface);
  }

  /// Returns the name of this symbol.
  StringAttr getNameAttr();
  /// Sets the name of this symbol.
  void setName(::mlir::StringAttr name);
  /// Gets the visibility of this symbol.
  mlir::SymbolTable::Visibility getVisibility();
  /// Returns true if this symbol has nested visibility.
  bool isNested();
  /// Returns true if this symbol has private visibility.
  bool isPrivate();
  /// Returns true if this symbol has public visibility.
  bool isPublic();
  /// Sets the visibility of this symbol.
  void setVisibility(mlir::SymbolTable::Visibility vis);
  /// Sets the visibility of this symbol to be nested.
  void setNested();
  /// Sets the visibility of this symbol to be private.
  void setPrivate();
  /// Sets the visibility of this symbol to be public.
  void setPublic();
  /// Get all of the uses of the current symbol that are nested within the
  /// given operation 'from'.
  /// Note: See mlir::SymbolTable::getSymbolUses for more details.
  ::std::optional<::mlir::SymbolTable::UseRange> getSymbolUses(::mlir::Operation * from);
  /// Return if the current symbol is known to have no uses that are nested
  /// within the given operation 'from'.
  /// Note: See mlir::SymbolTable::symbolKnownUseEmpty for more details.
  bool symbolKnownUseEmpty(::mlir::Operation * from);
  /// Attempt to replace all uses of the current symbol with the provided
  /// symbol 'newSymbol' that are nested within the given operation 'from'.
  /// Note: See mlir::SymbolTable::replaceAllSymbolUses for more details.
  ::mlir::LogicalResult replaceAllSymbolUses(::mlir::StringAttr newSymbol, ::mlir::Operation * from);
  /// Returns true if this operation optionally defines a symbol based on the
  /// presence of the symbol name.
  bool isOptionalSymbol();
  /// Returns true if this operation can be discarded if it has no remaining
  /// symbol uses.
  bool canDiscardOnUseEmpty();
  /// Returns true if this operation is a declaration of a symbol (as opposed
  /// to a definition).
  bool isDeclaration();

    using Visibility = mlir::SymbolTable::Visibility;

    /// Convenience version of `getNameAttr` that returns a StringRef.
    StringRef getName() {
      return getNameAttr().getValue();
    }

    /// Convenience version of `setName` that take a StringRef.
    void setName(StringRef name) {
      setName(StringAttr::get((*this)->getContext(), name));
    }
  //===----------------------------------------------------------------===//
  // Inherited from circt::hw::HWModuleLike
  //===----------------------------------------------------------------===//

  operator circt::hw::HWModuleLike () const {
    return circt::hw::HWModuleLike(*this, getImpl()->implHWModuleLike);
  }

  /// Get the module name
  ::llvm::StringRef getModuleName();
  /// Get the module name
  ::mlir::StringAttr getModuleNameAttr();
  /// Get the number of ports
  size_t getNumPorts();
  /// Get a port symbol attribute
  ::circt::hw::InnerSymAttr getPortSymbolAttr(size_t portIndex);
  /// Get the module type
  ::circt::hw::ModuleType getHWModuleType();
  /// Return the names of the inputs to this module
  mlir::ArrayAttr getInputNames();
  /// Return the names of the outputs this module
  mlir::ArrayAttr getOutputNames();
  /// Return the locations of the inputs to this module
  mlir::ArrayAttr getInputLocs();
  /// Return the locations of the outputs of this module
  mlir::ArrayAttr getOutputLocs();


    // Return the number of inputs to this module
    unsigned getNumInputs() {
      return getInputNames().size();
    }

    // Return the number of outputs from this module
    unsigned getNumOutputs() {
      return getOutputNames().size();
    }

    // Return the name of an input.
    mlir::StringRef getInputName(unsigned idx) {
      return getInputNameAttr(idx).getValue();
    }

    // Return the name of an output
    mlir::StringRef getOutputName(unsigned idx) {
      return getOutputNameAttr(idx).getValue();
    }

    // Return the name of an input to this module
    mlir::StringAttr getInputNameAttr(unsigned idx) {
      return cast<StringAttr>(getInputNames()[idx]);
    }

    // Return the name of an output to this module
    mlir::StringAttr getOutputNameAttr(unsigned idx) {
      return cast<StringAttr>(getOutputNames()[idx]);
    }
};
namespace detail {
  template <typename ConcreteOp>
  struct HWMutableModuleLikeTrait : public ::mlir::OpInterface<HWMutableModuleLike, detail::HWMutableModuleLikeInterfaceTraits>::Trait<ConcreteOp> {
    /// Decode information about the input and output ports on this module.
    ::circt::hw::ModulePortInfo getPorts() {
      return getModulePortInfo((*static_cast<ConcreteOp *>(this)));
    }
    /// Get a handle to a utility class which provides by-name lookup of port indices. The returned object does _not_ update if the module is mutated.
    ::circt::hw::ModulePortLookupInfo getPortLookupInfo() {
      return hw::ModulePortLookupInfo(
        (*static_cast<ConcreteOp *>(this))->getContext(),
        this->getPorts());
    }
    /// Insert ports into this module
    void insertPorts(ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs) {
      (*static_cast<ConcreteOp *>(this)).modifyPorts(insertInputs, insertOutputs, {}, {});
    }
    /// Erase ports from this module
    void erasePorts(ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs) {
      (*static_cast<ConcreteOp *>(this)).modifyPorts({}, {}, eraseInputs, eraseOutputs);
    }
  };
}// namespace detail
} // namespace hw
} // namespace circt
namespace circt {
namespace hw {
class HWInstanceLike;
namespace detail {
struct HWInstanceLikeInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    ::llvm::StringRef (*getInstanceName)(const Concept *impl, ::mlir::Operation *);
    ::mlir::StringAttr (*getInstanceNameAttr)(const Concept *impl, ::mlir::Operation *);
    ::llvm::StringRef (*getReferencedModuleName)(const Concept *impl, ::mlir::Operation *);
    ::mlir::StringAttr (*getReferencedModuleNameAttr)(const Concept *impl, ::mlir::Operation *);
    ::mlir::Operation *(*getReferencedModule)(const Concept *impl, ::mlir::Operation *);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = circt::hw::HWInstanceLike;
    Model() : Concept{getInstanceName, getInstanceNameAttr, getReferencedModuleName, getReferencedModuleNameAttr, getReferencedModule} {}

    static inline ::llvm::StringRef getInstanceName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::StringAttr getInstanceNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::llvm::StringRef getReferencedModuleName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::StringAttr getReferencedModuleNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::Operation *getReferencedModule(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = circt::hw::HWInstanceLike;
    FallbackModel() : Concept{getInstanceName, getInstanceNameAttr, getReferencedModuleName, getReferencedModuleNameAttr, getReferencedModule} {}

    static inline ::llvm::StringRef getInstanceName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::StringAttr getInstanceNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::llvm::StringRef getReferencedModuleName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::StringAttr getReferencedModuleNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::Operation *getReferencedModule(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    ::llvm::StringRef getReferencedModuleName(::mlir::Operation *tablegen_opaque_val) const;
    ::mlir::StringAttr getReferencedModuleNameAttr(::mlir::Operation *tablegen_opaque_val) const;
  };
};template <typename ConcreteOp>
struct HWInstanceLikeTrait;

} // namespace detail
class HWInstanceLike : public ::mlir::OpInterface<HWInstanceLike, detail::HWInstanceLikeInterfaceTraits> {
public:
  using ::mlir::OpInterface<HWInstanceLike, detail::HWInstanceLikeInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::HWInstanceLikeTrait<ConcreteOp> {};
  /// Get the name of the instance
  ::llvm::StringRef getInstanceName();
  /// Get the name of the instance
  ::mlir::StringAttr getInstanceNameAttr();
  /// Get the name of the instantiated module
  ::llvm::StringRef getReferencedModuleName();
  /// Get the name of the instantiated module
  ::mlir::StringAttr getReferencedModuleNameAttr();
  /// Get the referenced module
  ::mlir::Operation *getReferencedModule();
};
namespace detail {
  template <typename ConcreteOp>
  struct HWInstanceLikeTrait : public ::mlir::OpInterface<HWInstanceLike, detail::HWInstanceLikeInterfaceTraits>::Trait<ConcreteOp> {
    /// Get the name of the instantiated module
    ::llvm::StringRef getReferencedModuleName() {
      return (*static_cast<ConcreteOp *>(this)).getModuleName();
    }
    /// Get the name of the instantiated module
    ::mlir::StringAttr getReferencedModuleNameAttr() {
      return (*static_cast<ConcreteOp *>(this)).getModuleNameAttr().getAttr();
    }
  };
}// namespace detail
} // namespace hw
} // namespace circt
namespace circt {
namespace hw {
class InnerSymbolOpInterface;
namespace detail {
struct InnerSymbolOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    ::mlir::StringAttr (*getInnerNameAttr)(const Concept *impl, ::mlir::Operation *);
    ::std::optional<::mlir::StringRef> (*getInnerName)(const Concept *impl, ::mlir::Operation *);
    void (*setInnerSymbol)(const Concept *impl, ::mlir::Operation *, ::mlir::StringAttr);
    void (*setInnerSymbolAttr)(const Concept *impl, ::mlir::Operation *, ::circt::hw::InnerSymAttr);
    ::circt::hw::InnerRefAttr (*getInnerRef)(const Concept *impl, ::mlir::Operation *);
    ::circt::hw::InnerSymAttr (*getInnerSymAttr)(const Concept *impl, ::mlir::Operation *);
    bool (*supportsPerFieldSymbols)();
    std::optional<size_t> (*getTargetResultIndex)();
    OpResult (*getTargetResult)(const Concept *impl, ::mlir::Operation *);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::circt::hw::InnerSymbolOpInterface;
    Model() : Concept{getInnerNameAttr, getInnerName, setInnerSymbol, setInnerSymbolAttr, getInnerRef, getInnerSymAttr, supportsPerFieldSymbols, getTargetResultIndex, getTargetResult} {}

    static inline ::mlir::StringAttr getInnerNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::std::optional<::mlir::StringRef> getInnerName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void setInnerSymbol(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::StringAttr name);
    static inline void setInnerSymbolAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::InnerSymAttr sym);
    static inline ::circt::hw::InnerRefAttr getInnerRef(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::circt::hw::InnerSymAttr getInnerSymAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline bool supportsPerFieldSymbols();
    static inline std::optional<size_t> getTargetResultIndex();
    static inline OpResult getTargetResult(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::circt::hw::InnerSymbolOpInterface;
    FallbackModel() : Concept{getInnerNameAttr, getInnerName, setInnerSymbol, setInnerSymbolAttr, getInnerRef, getInnerSymAttr, supportsPerFieldSymbols, getTargetResultIndex, getTargetResult} {}

    static inline ::mlir::StringAttr getInnerNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::std::optional<::mlir::StringRef> getInnerName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void setInnerSymbol(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::StringAttr name);
    static inline void setInnerSymbolAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::InnerSymAttr sym);
    static inline ::circt::hw::InnerRefAttr getInnerRef(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::circt::hw::InnerSymAttr getInnerSymAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline bool supportsPerFieldSymbols();
    static inline std::optional<size_t> getTargetResultIndex();
    static inline OpResult getTargetResult(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    ::mlir::StringAttr getInnerNameAttr(::mlir::Operation *tablegen_opaque_val) const;
    ::std::optional<::mlir::StringRef> getInnerName(::mlir::Operation *tablegen_opaque_val) const;
    void setInnerSymbol(::mlir::Operation *tablegen_opaque_val, ::mlir::StringAttr name) const;
    void setInnerSymbolAttr(::mlir::Operation *tablegen_opaque_val, ::circt::hw::InnerSymAttr sym) const;
    ::circt::hw::InnerRefAttr getInnerRef(::mlir::Operation *tablegen_opaque_val) const;
    ::circt::hw::InnerSymAttr getInnerSymAttr(::mlir::Operation *tablegen_opaque_val) const;
    static bool supportsPerFieldSymbols();
    OpResult getTargetResult(::mlir::Operation *tablegen_opaque_val) const;
  };
};template <typename ConcreteOp>
struct InnerSymbolOpInterfaceTrait;

} // namespace detail
class InnerSymbolOpInterface : public ::mlir::OpInterface<InnerSymbolOpInterface, detail::InnerSymbolOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<InnerSymbolOpInterface, detail::InnerSymbolOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::InnerSymbolOpInterfaceTrait<ConcreteOp> {};
  /// Returns the name of the top-level inner symbol defined by this operation, if present.
  ::mlir::StringAttr getInnerNameAttr();
  /// Returns the name of the top-level inner symbol defined by this operation, if present.
  ::std::optional<::mlir::StringRef> getInnerName();
  /// Sets the name of the top-level inner symbol defined by this operation to the specified string, dropping any symbols on fields.
  void setInnerSymbol(::mlir::StringAttr name);
  /// Sets the inner symbols defined by this operation.
  void setInnerSymbolAttr(::circt::hw::InnerSymAttr sym);
  /// Returns an InnerRef to this operation's top-level inner symbol, which must be present.
  ::circt::hw::InnerRefAttr getInnerRef();
  /// Returns the InnerSymAttr representing all inner symbols defined by this operation.
  ::circt::hw::InnerSymAttr getInnerSymAttr();
  /// Returns whether per-field symbols are supported for this operation type.
  bool supportsPerFieldSymbols();
  /// Returns the index of the result the innner symbol targets, if applicable.  Per-field symbols are resolved into this.
  std::optional<size_t> getTargetResultIndex();
  /// Returns the result the innner symbol targets, if applicable.  Per-field symbols are resolved into this.
  OpResult getTargetResult();
};
namespace detail {
  template <typename ConcreteOp>
  struct InnerSymbolOpInterfaceTrait : public ::mlir::OpInterface<InnerSymbolOpInterface, detail::InnerSymbolOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
    /// Returns the name of the top-level inner symbol defined by this operation, if present.
    ::mlir::StringAttr getInnerNameAttr() {
      if (auto attr =
              this->getOperation()->template getAttrOfType<hw::InnerSymAttr>(
              circt::hw::InnerSymbolTable::getInnerSymbolAttrName()))
          return attr.getSymName();
        return {};
    }
    /// Returns the name of the top-level inner symbol defined by this operation, if present.
    ::std::optional<::mlir::StringRef> getInnerName() {
      auto attr = this->getInnerNameAttr();
        return attr ? ::std::optional<StringRef>(attr.getValue()) : ::std::nullopt;
    }
    /// Sets the name of the top-level inner symbol defined by this operation to the specified string, dropping any symbols on fields.
    void setInnerSymbol(::mlir::StringAttr name) {
      this->getOperation()->setAttr(
            InnerSymbolTable::getInnerSymbolAttrName(), hw::InnerSymAttr::get(name));
    }
    /// Sets the inner symbols defined by this operation.
    void setInnerSymbolAttr(::circt::hw::InnerSymAttr sym) {
      if (sym && !sym.empty())
          this->getOperation()->setAttr(
              InnerSymbolTable::getInnerSymbolAttrName(), sym);
        else
          this->getOperation()->removeAttr(InnerSymbolTable::getInnerSymbolAttrName());
    }
    /// Returns an InnerRef to this operation's top-level inner symbol, which must be present.
    ::circt::hw::InnerRefAttr getInnerRef() {
      auto *op = this->getOperation();
        return hw::InnerRefAttr::get(
            SymbolTable::getSymbolName(
                op->template getParentWithTrait<OpTrait::InnerSymbolTable>()),
            InnerSymbolTable::getInnerSymbol(op));
    }
    /// Returns the InnerSymAttr representing all inner symbols defined by this operation.
    ::circt::hw::InnerSymAttr getInnerSymAttr() {
      return this->getOperation()->template getAttrOfType<hw::InnerSymAttr>(
              circt::hw::InnerSymbolTable::getInnerSymbolAttrName());
    }
    /// Returns whether per-field symbols are supported for this operation type.
    static bool supportsPerFieldSymbols() {
      return ConcreteOp::getTargetResultIndex().has_value();
    }
    /// Returns the result the innner symbol targets, if applicable.  Per-field symbols are resolved into this.
    OpResult getTargetResult() {
      auto idx = ConcreteOp::getTargetResultIndex();
        if (!idx)
          return {};
        return (*static_cast<ConcreteOp *>(this))->getResult(*idx);
    }
    static ::mlir::LogicalResult verifyTrait(::mlir::Operation *op) {
      return verifyInnerSymAttr(cast<circt::hw::InnerSymbolOpInterface>(op));
    }
  };
}// namespace detail
} // namespace hw
} // namespace circt
namespace circt {
namespace hw {
class InnerRefUserOpInterface;
namespace detail {
struct InnerRefUserOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    ::mlir::LogicalResult (*verifyInnerRefs)(const Concept *impl, ::mlir::Operation *, ::circt::hw::InnerRefNamespace&);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::circt::hw::InnerRefUserOpInterface;
    Model() : Concept{verifyInnerRefs} {}

    static inline ::mlir::LogicalResult verifyInnerRefs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::InnerRefNamespace& ns);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::circt::hw::InnerRefUserOpInterface;
    FallbackModel() : Concept{verifyInnerRefs} {}

    static inline ::mlir::LogicalResult verifyInnerRefs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::InnerRefNamespace& ns);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
  };
};template <typename ConcreteOp>
struct InnerRefUserOpInterfaceTrait;

} // namespace detail
class InnerRefUserOpInterface : public ::mlir::OpInterface<InnerRefUserOpInterface, detail::InnerRefUserOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<InnerRefUserOpInterface, detail::InnerRefUserOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::InnerRefUserOpInterfaceTrait<ConcreteOp> {};
  /// Verify the inner ref uses held by this operation.
  ::mlir::LogicalResult verifyInnerRefs(::circt::hw::InnerRefNamespace& ns);
};
namespace detail {
  template <typename ConcreteOp>
  struct InnerRefUserOpInterfaceTrait : public ::mlir::OpInterface<InnerRefUserOpInterface, detail::InnerRefUserOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
  };
}// namespace detail
} // namespace hw
} // namespace circt
namespace circt {
namespace hw {
template<typename ConcreteOp>
::llvm::StringRef detail::HWModuleLikeInterfaceTraits::Model<ConcreteOp>::getModuleName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getModuleName();
}
template<typename ConcreteOp>
::mlir::StringAttr detail::HWModuleLikeInterfaceTraits::Model<ConcreteOp>::getModuleNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getModuleNameAttr();
}
template<typename ConcreteOp>
size_t detail::HWModuleLikeInterfaceTraits::Model<ConcreteOp>::getNumPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getNumPorts();
}
template<typename ConcreteOp>
::circt::hw::InnerSymAttr detail::HWModuleLikeInterfaceTraits::Model<ConcreteOp>::getPortSymbolAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, size_t portIndex) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getPortSymbolAttr(portIndex);
}
template<typename ConcreteOp>
::circt::hw::ModuleType detail::HWModuleLikeInterfaceTraits::Model<ConcreteOp>::getHWModuleType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getHWModuleType();
}
template<typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::Model<ConcreteOp>::getInputNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getInputNames();
}
template<typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::Model<ConcreteOp>::getOutputNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getOutputNames();
}
template<typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::Model<ConcreteOp>::getInputLocs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getInputLocs();
}
template<typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::Model<ConcreteOp>::getOutputLocs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getOutputLocs();
}
template<typename ConcreteOp>
::llvm::StringRef detail::HWModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::getModuleName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getModuleName(tablegen_opaque_val);
}
template<typename ConcreteOp>
::mlir::StringAttr detail::HWModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::getModuleNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getModuleNameAttr(tablegen_opaque_val);
}
template<typename ConcreteOp>
size_t detail::HWModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::getNumPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getNumPorts(tablegen_opaque_val);
}
template<typename ConcreteOp>
::circt::hw::InnerSymAttr detail::HWModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::getPortSymbolAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, size_t portIndex) {
  return static_cast<const ConcreteOp *>(impl)->getPortSymbolAttr(tablegen_opaque_val, portIndex);
}
template<typename ConcreteOp>
::circt::hw::ModuleType detail::HWModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::getHWModuleType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getHWModuleType(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::getInputNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getInputNames(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::getOutputNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getOutputNames(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::getInputLocs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getInputLocs(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::getOutputLocs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getOutputLocs(tablegen_opaque_val);
}
template<typename ConcreteModel, typename ConcreteOp>
::llvm::StringRef detail::HWModuleLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getModuleName(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getName();
}
template<typename ConcreteModel, typename ConcreteOp>
::mlir::StringAttr detail::HWModuleLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getModuleNameAttr(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getNameAttr();
}
template<typename ConcreteModel, typename ConcreteOp>
::circt::hw::ModuleType detail::HWModuleLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getHWModuleType(::mlir::Operation *tablegen_opaque_val) const {
return ::circt::hw::detail::fnToMod((llvm::cast<ConcreteOp>(tablegen_opaque_val)), getInputNames(), getOutputNames());
}
template<typename ConcreteModel, typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getInputNames(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val))->template getAttrOfType<ArrayAttr>("argNames");
}
template<typename ConcreteModel, typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getOutputNames(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val))->template getAttrOfType<ArrayAttr>("resultNames");
}
template<typename ConcreteModel, typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getInputLocs(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val))->template getAttrOfType<ArrayAttr>("argLocs");
}
template<typename ConcreteModel, typename ConcreteOp>
mlir::ArrayAttr detail::HWModuleLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getOutputLocs(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val))->template getAttrOfType<ArrayAttr>("resultLocs");
}
} // namespace hw
} // namespace circt
namespace circt {
namespace hw {
template<typename ConcreteOp>
::circt::hw::ModulePortInfo detail::HWMutableModuleLikeInterfaceTraits::Model<ConcreteOp>::getPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getPorts();
}
template<typename ConcreteOp>
::circt::hw::ModulePortLookupInfo detail::HWMutableModuleLikeInterfaceTraits::Model<ConcreteOp>::getPortLookupInfo(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getPortLookupInfo();
}
template<typename ConcreteOp>
void detail::HWMutableModuleLikeInterfaceTraits::Model<ConcreteOp>::modifyPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs, ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs) {
  (llvm::cast<ConcreteOp>(tablegen_opaque_val)).modifyPorts(insertInputs, insertOutputs, eraseInputs, eraseOutputs);
}
template<typename ConcreteOp>
void detail::HWMutableModuleLikeInterfaceTraits::Model<ConcreteOp>::insertPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).insertPorts(insertInputs, insertOutputs);
}
template<typename ConcreteOp>
void detail::HWMutableModuleLikeInterfaceTraits::Model<ConcreteOp>::erasePorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).erasePorts(eraseInputs, eraseOutputs);
}
template<typename ConcreteOp>
void detail::HWMutableModuleLikeInterfaceTraits::Model<ConcreteOp>::appendOutputs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<StringAttr, Value>> outputs) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).appendOutputs(outputs);
}
template<typename ConcreteOp>
::circt::hw::ModulePortInfo detail::HWMutableModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::getPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getPorts(tablegen_opaque_val);
}
template<typename ConcreteOp>
::circt::hw::ModulePortLookupInfo detail::HWMutableModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::getPortLookupInfo(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getPortLookupInfo(tablegen_opaque_val);
}
template<typename ConcreteOp>
void detail::HWMutableModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::modifyPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs, ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs) {
  return static_cast<const ConcreteOp *>(impl)->modifyPorts(tablegen_opaque_val, insertInputs, insertOutputs, eraseInputs, eraseOutputs);
}
template<typename ConcreteOp>
void detail::HWMutableModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::insertPorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs) {
  return static_cast<const ConcreteOp *>(impl)->insertPorts(tablegen_opaque_val, insertInputs, insertOutputs);
}
template<typename ConcreteOp>
void detail::HWMutableModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::erasePorts(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs) {
  return static_cast<const ConcreteOp *>(impl)->erasePorts(tablegen_opaque_val, eraseInputs, eraseOutputs);
}
template<typename ConcreteOp>
void detail::HWMutableModuleLikeInterfaceTraits::FallbackModel<ConcreteOp>::appendOutputs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<StringAttr, Value>> outputs) {
  return static_cast<const ConcreteOp *>(impl)->appendOutputs(tablegen_opaque_val, outputs);
}
template<typename ConcreteModel, typename ConcreteOp>
::circt::hw::ModulePortInfo detail::HWMutableModuleLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getPorts(::mlir::Operation *tablegen_opaque_val) const {
return getModulePortInfo((llvm::cast<ConcreteOp>(tablegen_opaque_val)));
}
template<typename ConcreteModel, typename ConcreteOp>
::circt::hw::ModulePortLookupInfo detail::HWMutableModuleLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getPortLookupInfo(::mlir::Operation *tablegen_opaque_val) const {
return hw::ModulePortLookupInfo(
        (llvm::cast<ConcreteOp>(tablegen_opaque_val))->getContext(),
        this->getPorts());
}
template<typename ConcreteModel, typename ConcreteOp>
void detail::HWMutableModuleLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::insertPorts(::mlir::Operation *tablegen_opaque_val, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertInputs, ArrayRef<std::pair<unsigned, circt::hw::PortInfo>> insertOutputs) const {
(llvm::cast<ConcreteOp>(tablegen_opaque_val)).modifyPorts(insertInputs, insertOutputs, {}, {});
}
template<typename ConcreteModel, typename ConcreteOp>
void detail::HWMutableModuleLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::erasePorts(::mlir::Operation *tablegen_opaque_val, ArrayRef<unsigned> eraseInputs, ArrayRef<unsigned> eraseOutputs) const {
(llvm::cast<ConcreteOp>(tablegen_opaque_val)).modifyPorts({}, {}, eraseInputs, eraseOutputs);
}
} // namespace hw
} // namespace circt
namespace circt {
namespace hw {
template<typename ConcreteOp>
::llvm::StringRef detail::HWInstanceLikeInterfaceTraits::Model<ConcreteOp>::getInstanceName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getInstanceName();
}
template<typename ConcreteOp>
::mlir::StringAttr detail::HWInstanceLikeInterfaceTraits::Model<ConcreteOp>::getInstanceNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getInstanceNameAttr();
}
template<typename ConcreteOp>
::llvm::StringRef detail::HWInstanceLikeInterfaceTraits::Model<ConcreteOp>::getReferencedModuleName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getReferencedModuleName();
}
template<typename ConcreteOp>
::mlir::StringAttr detail::HWInstanceLikeInterfaceTraits::Model<ConcreteOp>::getReferencedModuleNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getReferencedModuleNameAttr();
}
template<typename ConcreteOp>
::mlir::Operation *detail::HWInstanceLikeInterfaceTraits::Model<ConcreteOp>::getReferencedModule(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getReferencedModule();
}
template<typename ConcreteOp>
::llvm::StringRef detail::HWInstanceLikeInterfaceTraits::FallbackModel<ConcreteOp>::getInstanceName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getInstanceName(tablegen_opaque_val);
}
template<typename ConcreteOp>
::mlir::StringAttr detail::HWInstanceLikeInterfaceTraits::FallbackModel<ConcreteOp>::getInstanceNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getInstanceNameAttr(tablegen_opaque_val);
}
template<typename ConcreteOp>
::llvm::StringRef detail::HWInstanceLikeInterfaceTraits::FallbackModel<ConcreteOp>::getReferencedModuleName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getReferencedModuleName(tablegen_opaque_val);
}
template<typename ConcreteOp>
::mlir::StringAttr detail::HWInstanceLikeInterfaceTraits::FallbackModel<ConcreteOp>::getReferencedModuleNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getReferencedModuleNameAttr(tablegen_opaque_val);
}
template<typename ConcreteOp>
::mlir::Operation *detail::HWInstanceLikeInterfaceTraits::FallbackModel<ConcreteOp>::getReferencedModule(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getReferencedModule(tablegen_opaque_val);
}
template<typename ConcreteModel, typename ConcreteOp>
::llvm::StringRef detail::HWInstanceLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getReferencedModuleName(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getModuleName();
}
template<typename ConcreteModel, typename ConcreteOp>
::mlir::StringAttr detail::HWInstanceLikeInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getReferencedModuleNameAttr(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getModuleNameAttr().getAttr();
}
} // namespace hw
} // namespace circt
namespace circt {
namespace hw {
template<typename ConcreteOp>
::mlir::StringAttr detail::InnerSymbolOpInterfaceInterfaceTraits::Model<ConcreteOp>::getInnerNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getInnerNameAttr();
}
template<typename ConcreteOp>
::std::optional<::mlir::StringRef> detail::InnerSymbolOpInterfaceInterfaceTraits::Model<ConcreteOp>::getInnerName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getInnerName();
}
template<typename ConcreteOp>
void detail::InnerSymbolOpInterfaceInterfaceTraits::Model<ConcreteOp>::setInnerSymbol(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::StringAttr name) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).setInnerSymbol(name);
}
template<typename ConcreteOp>
void detail::InnerSymbolOpInterfaceInterfaceTraits::Model<ConcreteOp>::setInnerSymbolAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::InnerSymAttr sym) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).setInnerSymbolAttr(sym);
}
template<typename ConcreteOp>
::circt::hw::InnerRefAttr detail::InnerSymbolOpInterfaceInterfaceTraits::Model<ConcreteOp>::getInnerRef(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getInnerRef();
}
template<typename ConcreteOp>
::circt::hw::InnerSymAttr detail::InnerSymbolOpInterfaceInterfaceTraits::Model<ConcreteOp>::getInnerSymAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getInnerSymAttr();
}
template<typename ConcreteOp>
bool detail::InnerSymbolOpInterfaceInterfaceTraits::Model<ConcreteOp>::supportsPerFieldSymbols() {
  return ConcreteOp::supportsPerFieldSymbols();
}
template<typename ConcreteOp>
std::optional<size_t> detail::InnerSymbolOpInterfaceInterfaceTraits::Model<ConcreteOp>::getTargetResultIndex() {
  return ConcreteOp::getTargetResultIndex();
}
template<typename ConcreteOp>
OpResult detail::InnerSymbolOpInterfaceInterfaceTraits::Model<ConcreteOp>::getTargetResult(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getTargetResult();
}
template<typename ConcreteOp>
::mlir::StringAttr detail::InnerSymbolOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getInnerNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getInnerNameAttr(tablegen_opaque_val);
}
template<typename ConcreteOp>
::std::optional<::mlir::StringRef> detail::InnerSymbolOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getInnerName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getInnerName(tablegen_opaque_val);
}
template<typename ConcreteOp>
void detail::InnerSymbolOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::setInnerSymbol(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::StringAttr name) {
  return static_cast<const ConcreteOp *>(impl)->setInnerSymbol(tablegen_opaque_val, name);
}
template<typename ConcreteOp>
void detail::InnerSymbolOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::setInnerSymbolAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::InnerSymAttr sym) {
  return static_cast<const ConcreteOp *>(impl)->setInnerSymbolAttr(tablegen_opaque_val, sym);
}
template<typename ConcreteOp>
::circt::hw::InnerRefAttr detail::InnerSymbolOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getInnerRef(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getInnerRef(tablegen_opaque_val);
}
template<typename ConcreteOp>
::circt::hw::InnerSymAttr detail::InnerSymbolOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getInnerSymAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getInnerSymAttr(tablegen_opaque_val);
}
template<typename ConcreteOp>
bool detail::InnerSymbolOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::supportsPerFieldSymbols() {
  return ConcreteOp::supportsPerFieldSymbols();
}
template<typename ConcreteOp>
std::optional<size_t> detail::InnerSymbolOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getTargetResultIndex() {
  return ConcreteOp::getTargetResultIndex();
}
template<typename ConcreteOp>
OpResult detail::InnerSymbolOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getTargetResult(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getTargetResult(tablegen_opaque_val);
}
template<typename ConcreteModel, typename ConcreteOp>
::mlir::StringAttr detail::InnerSymbolOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getInnerNameAttr(::mlir::Operation *tablegen_opaque_val) const {
if (auto attr =
              this->getOperation()->template getAttrOfType<hw::InnerSymAttr>(
              circt::hw::InnerSymbolTable::getInnerSymbolAttrName()))
          return attr.getSymName();
        return {};
}
template<typename ConcreteModel, typename ConcreteOp>
::std::optional<::mlir::StringRef> detail::InnerSymbolOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getInnerName(::mlir::Operation *tablegen_opaque_val) const {
auto attr = this->getInnerNameAttr();
        return attr ? ::std::optional<StringRef>(attr.getValue()) : ::std::nullopt;
}
template<typename ConcreteModel, typename ConcreteOp>
void detail::InnerSymbolOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::setInnerSymbol(::mlir::Operation *tablegen_opaque_val, ::mlir::StringAttr name) const {
this->getOperation()->setAttr(
            InnerSymbolTable::getInnerSymbolAttrName(), hw::InnerSymAttr::get(name));
}
template<typename ConcreteModel, typename ConcreteOp>
void detail::InnerSymbolOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::setInnerSymbolAttr(::mlir::Operation *tablegen_opaque_val, ::circt::hw::InnerSymAttr sym) const {
if (sym && !sym.empty())
          this->getOperation()->setAttr(
              InnerSymbolTable::getInnerSymbolAttrName(), sym);
        else
          this->getOperation()->removeAttr(InnerSymbolTable::getInnerSymbolAttrName());
}
template<typename ConcreteModel, typename ConcreteOp>
::circt::hw::InnerRefAttr detail::InnerSymbolOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getInnerRef(::mlir::Operation *tablegen_opaque_val) const {
auto *op = this->getOperation();
        return hw::InnerRefAttr::get(
            SymbolTable::getSymbolName(
                op->template getParentWithTrait<OpTrait::InnerSymbolTable>()),
            InnerSymbolTable::getInnerSymbol(op));
}
template<typename ConcreteModel, typename ConcreteOp>
::circt::hw::InnerSymAttr detail::InnerSymbolOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getInnerSymAttr(::mlir::Operation *tablegen_opaque_val) const {
return this->getOperation()->template getAttrOfType<hw::InnerSymAttr>(
              circt::hw::InnerSymbolTable::getInnerSymbolAttrName());
}
template<typename ConcreteModel, typename ConcreteOp>
bool detail::InnerSymbolOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::supportsPerFieldSymbols() {
return ConcreteOp::getTargetResultIndex().has_value();
}
template<typename ConcreteModel, typename ConcreteOp>
OpResult detail::InnerSymbolOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getTargetResult(::mlir::Operation *tablegen_opaque_val) const {
auto idx = ConcreteOp::getTargetResultIndex();
        if (!idx)
          return {};
        return (llvm::cast<ConcreteOp>(tablegen_opaque_val))->getResult(*idx);
}
} // namespace hw
} // namespace circt
namespace circt {
namespace hw {
template<typename ConcreteOp>
::mlir::LogicalResult detail::InnerRefUserOpInterfaceInterfaceTraits::Model<ConcreteOp>::verifyInnerRefs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::InnerRefNamespace& ns) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).verifyInnerRefs(ns);
}
template<typename ConcreteOp>
::mlir::LogicalResult detail::InnerRefUserOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::verifyInnerRefs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::InnerRefNamespace& ns) {
  return static_cast<const ConcreteOp *>(impl)->verifyInnerRefs(tablegen_opaque_val, ns);
}
} // namespace hw
} // namespace circt
