/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace circt {
namespace hw {
class FieldIDTypeInterface;
namespace detail {
struct FieldIDTypeInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    uint64_t (*getMaxFieldID)(const Concept *impl, ::mlir::Type );
    std::pair<circt::hw::FieldIDTypeInterface, uint64_t> (*getSubTypeByFieldID)(const Concept *impl, ::mlir::Type , uint64_t);
    circt::hw::FieldIDTypeInterface (*getFinalTypeByFieldID)(const Concept *impl, ::mlir::Type , uint64_t);
    std::pair<uint64_t, bool> (*rootChildFieldID)(const Concept *impl, ::mlir::Type , uint64_t, uint64_t);
  };
  template<typename ConcreteType>
  class Model : public Concept {
  public:
    using Interface = circt::hw::FieldIDTypeInterface;
    Model() : Concept{getMaxFieldID, getSubTypeByFieldID, getFinalTypeByFieldID, rootChildFieldID} {}

    static inline uint64_t getMaxFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val);
    static inline std::pair<circt::hw::FieldIDTypeInterface, uint64_t> getSubTypeByFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID);
    static inline circt::hw::FieldIDTypeInterface getFinalTypeByFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID);
    static inline std::pair<uint64_t, bool> rootChildFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID, uint64_t index);
  };
  template<typename ConcreteType>
  class FallbackModel : public Concept {
  public:
    using Interface = circt::hw::FieldIDTypeInterface;
    FallbackModel() : Concept{getMaxFieldID, getSubTypeByFieldID, getFinalTypeByFieldID, rootChildFieldID} {}

    static inline uint64_t getMaxFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val);
    static inline std::pair<circt::hw::FieldIDTypeInterface, uint64_t> getSubTypeByFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID);
    static inline circt::hw::FieldIDTypeInterface getFinalTypeByFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID);
    static inline std::pair<uint64_t, bool> rootChildFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID, uint64_t index);
  };
  template<typename ConcreteModel, typename ConcreteType>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteType;
  };
};template <typename ConcreteType>
struct FieldIDTypeInterfaceTrait;

} // namespace detail
class FieldIDTypeInterface : public ::mlir::TypeInterface<FieldIDTypeInterface, detail::FieldIDTypeInterfaceInterfaceTraits> {
public:
  using ::mlir::TypeInterface<FieldIDTypeInterface, detail::FieldIDTypeInterfaceInterfaceTraits>::TypeInterface;
  template <typename ConcreteType>
  struct Trait : public detail::FieldIDTypeInterfaceTrait<ConcreteType> {};
  /// Get the maximum field ID for this type
  uint64_t getMaxFieldID() const;
  /// Get the sub-type of a type for a field ID, and the subfield's ID. Strip
  /// off a single layer of this type and return the sub-type and a field ID
  /// targeting the same field, but rebased on the sub-type.
  std::pair<circt::hw::FieldIDTypeInterface, uint64_t> getSubTypeByFieldID(uint64_t fieldID) const;
  /// Return the final type targeted by this field ID by recursively walking all
  /// nested aggregate types. This is the identity function for ground types.
  circt::hw::FieldIDTypeInterface getFinalTypeByFieldID(uint64_t fieldID) const;
  /// Returns the effective field id when treating the index field as the
  /// root of the type.  Essentially maps a fieldID to a fieldID after a
  /// subfield op. Returns the new id and whether the id is in the given
  /// child.
  std::pair<uint64_t, bool> rootChildFieldID(uint64_t fieldID, uint64_t index) const;
};
namespace detail {
  template <typename ConcreteType>
  struct FieldIDTypeInterfaceTrait : public ::mlir::TypeInterface<FieldIDTypeInterface, detail::FieldIDTypeInterfaceInterfaceTraits>::Trait<ConcreteType> {
  };
}// namespace detail
} // namespace hw
} // namespace circt
namespace circt {
namespace hw {
template<typename ConcreteType>
uint64_t detail::FieldIDTypeInterfaceInterfaceTraits::Model<ConcreteType>::getMaxFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val) {
  return (::llvm::cast<ConcreteType>(tablegen_opaque_val)).getMaxFieldID();
}
template<typename ConcreteType>
std::pair<circt::hw::FieldIDTypeInterface, uint64_t> detail::FieldIDTypeInterfaceInterfaceTraits::Model<ConcreteType>::getSubTypeByFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID) {
  return (::llvm::cast<ConcreteType>(tablegen_opaque_val)).getSubTypeByFieldID(fieldID);
}
template<typename ConcreteType>
circt::hw::FieldIDTypeInterface detail::FieldIDTypeInterfaceInterfaceTraits::Model<ConcreteType>::getFinalTypeByFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID) {
  return (::llvm::cast<ConcreteType>(tablegen_opaque_val)).getFinalTypeByFieldID(fieldID);
}
template<typename ConcreteType>
std::pair<uint64_t, bool> detail::FieldIDTypeInterfaceInterfaceTraits::Model<ConcreteType>::rootChildFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID, uint64_t index) {
  return (::llvm::cast<ConcreteType>(tablegen_opaque_val)).rootChildFieldID(fieldID, index);
}
template<typename ConcreteType>
uint64_t detail::FieldIDTypeInterfaceInterfaceTraits::FallbackModel<ConcreteType>::getMaxFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val) {
  return static_cast<const ConcreteType *>(impl)->getMaxFieldID(tablegen_opaque_val);
}
template<typename ConcreteType>
std::pair<circt::hw::FieldIDTypeInterface, uint64_t> detail::FieldIDTypeInterfaceInterfaceTraits::FallbackModel<ConcreteType>::getSubTypeByFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID) {
  return static_cast<const ConcreteType *>(impl)->getSubTypeByFieldID(tablegen_opaque_val, fieldID);
}
template<typename ConcreteType>
circt::hw::FieldIDTypeInterface detail::FieldIDTypeInterfaceInterfaceTraits::FallbackModel<ConcreteType>::getFinalTypeByFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID) {
  return static_cast<const ConcreteType *>(impl)->getFinalTypeByFieldID(tablegen_opaque_val, fieldID);
}
template<typename ConcreteType>
std::pair<uint64_t, bool> detail::FieldIDTypeInterfaceInterfaceTraits::FallbackModel<ConcreteType>::rootChildFieldID(const Concept *impl, ::mlir::Type tablegen_opaque_val, uint64_t fieldID, uint64_t index) {
  return static_cast<const ConcreteType *>(impl)->rootChildFieldID(tablegen_opaque_val, fieldID, index);
}
} // namespace hw
} // namespace circt
