/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* TypeDef Declarations                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_TYPEDEF_CLASSES
#undef GET_TYPEDEF_CLASSES


namespace mlir {
class AsmParser;
class AsmPrinter;
} // namespace mlir
namespace circt {
namespace hw {
class ArrayType;
class EnumType;
class StringType;
class InOutType;
class IntType;
class ModuleType;
class StructType;
class TypeAliasType;
class UnionType;
class UnpackedArrayType;
namespace detail {
struct ArrayTypeStorage;
} // namespace detail
class ArrayType : public ::mlir::Type::TypeBase<ArrayType, ::mlir::Type, detail::ArrayTypeStorage> {
public:
  using Base::Base;
  static ArrayType get(Type elementType, size_t size) {
    auto *ctx = elementType.getContext();
    auto intType = ::mlir::IntegerType::get(ctx, 64);
    auto sizeAttr = ::mlir::IntegerAttr::get(intType, size);
    return ArrayType::get(ctx, elementType, sizeAttr);
  }
  size_t getSize() const;
  using Base::getChecked;
  static ArrayType get(::mlir::MLIRContext *context, ::mlir::Type elementType, ::mlir::Attribute sizeAttr);
  static ArrayType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, ::mlir::Type elementType, ::mlir::Attribute sizeAttr);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::Type elementType, ::mlir::Attribute sizeAttr);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"array"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::mlir::Type getElementType() const;
  ::mlir::Attribute getSizeAttr() const;
};
namespace detail {
struct EnumTypeStorage;
} // namespace detail
class EnumType : public ::mlir::Type::TypeBase<EnumType, ::mlir::Type, detail::EnumTypeStorage> {
public:
  using Base::Base;
  /// Returns true if the requested field is part of this enum
  bool contains(mlir::StringRef field);

  /// Returns the number of bits used by the enum
  size_t getBitWidth();

  /// Returns the index of the requested field, or a nullopt if the field is
  // not part of this enum.
  std::optional<size_t> indexOf(mlir::StringRef field);
  static EnumType get(::mlir::MLIRContext *context, mlir::ArrayAttr fields);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"enum"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  mlir::ArrayAttr getFields() const;
};
class StringType : public ::mlir::Type::TypeBase<StringType, ::mlir::Type, ::mlir::TypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"string"};
  }

};
namespace detail {
struct InOutTypeStorage;
} // namespace detail
class InOutType : public ::mlir::Type::TypeBase<InOutType, ::mlir::Type, detail::InOutTypeStorage> {
public:
  using Base::Base;
  static InOutType get(Type elementType) {
    return get(elementType.getContext(), elementType);
  }
  using Base::getChecked;
  static InOutType get(::mlir::MLIRContext *context, ::mlir::Type elementType);
  static InOutType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, ::mlir::Type elementType);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::Type elementType);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"inout"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::mlir::Type getElementType() const;
};
namespace detail {
struct IntTypeStorage;
} // namespace detail
class IntType : public ::mlir::Type::TypeBase<IntType, ::mlir::Type, detail::IntTypeStorage> {
public:
  using Base::Base;
  /// Get an integer type for the specified width.  Note that this may return
  /// a builtin integer type if the width is a known-constant value.
  static Type get(::mlir::TypedAttr width);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"int"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::mlir::TypedAttr getWidth() const;
};
namespace detail {
struct ModuleTypeStorage;
} // namespace detail
class ModuleType : public ::mlir::Type::TypeBase<ModuleType, ::mlir::Type, detail::ModuleTypeStorage> {
public:
  using Base::Base;
  // Many of these are transitional and will be removed when modules and instances
  // have moved over to this type.
  size_t getNumInputs();
  size_t getNumOutputs();
  SmallVector<Type> getInputTypes();
  SmallVector<Type> getOutputTypes();
  Type getInputType(size_t);
  Type getOutputType(size_t);
  SmallVector<StringAttr> getInputNames();
  SmallVector<StringAttr> getOutputNames();
  StringAttr getNameAttr(size_t);
  StringRef getName(size_t);
  StringAttr getInputNameAttr(size_t);
  StringRef getInputName(size_t);
  StringAttr getOutputNameAttr(size_t);
  StringRef getOutputName(size_t);
  FunctionType getFuncType();
  using Base::getChecked;
  static ModuleType get(::mlir::MLIRContext *context, ::llvm::ArrayRef<::circt::hw::ModulePort> ports);
  static ModuleType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, ::llvm::ArrayRef<::circt::hw::ModulePort> ports);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::llvm::ArrayRef<::circt::hw::ModulePort> ports);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"module"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::llvm::ArrayRef<::circt::hw::ModulePort> getPorts() const;
};
namespace detail {
struct StructTypeStorage;
} // namespace detail
class StructType : public ::mlir::Type::TypeBase<StructType, ::mlir::Type, detail::StructTypeStorage> {
public:
  using Base::Base;
  using FieldInfo = ::circt::hw::detail::FieldInfo;
  mlir::Type getFieldType(mlir::StringRef fieldName);
  void getInnerTypes(mlir::SmallVectorImpl<mlir::Type>&);
  std::optional<unsigned> getFieldIndex(mlir::StringRef fieldName);
  std::optional<unsigned> getFieldIndex(mlir::StringAttr fieldName);
  static StructType get(::mlir::MLIRContext *context, ::llvm::ArrayRef<::circt::hw::StructType::FieldInfo> elements);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"struct"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::llvm::ArrayRef<::circt::hw::StructType::FieldInfo> getElements() const;
};
namespace detail {
struct TypeAliasTypeStorage;
} // namespace detail
class TypeAliasType : public ::mlir::Type::TypeBase<TypeAliasType, ::mlir::Type, detail::TypeAliasTypeStorage> {
public:
  using Base::Base;
  /// Return the Typedecl referenced by this TypeAlias, given the module to
  /// look in.  This returns null when the IR is malformed.
  TypedeclOp getTypeDecl(const HWSymbolCache &cache);
  static TypeAliasType get(::mlir::MLIRContext *context, mlir::SymbolRefAttr ref, mlir::Type innerType, mlir::Type canonicalType);
  static TypeAliasType get(mlir::SymbolRefAttr ref, mlir::Type innerType);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"typealias"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  mlir::SymbolRefAttr getRef() const;
  mlir::Type getInnerType() const;
  mlir::Type getCanonicalType() const;
};
namespace detail {
struct UnionTypeStorage;
} // namespace detail
class UnionType : public ::mlir::Type::TypeBase<UnionType, ::mlir::Type, detail::UnionTypeStorage> {
public:
  using Base::Base;
  using FieldInfo = ::circt::hw::detail::OffsetFieldInfo;

  FieldInfo getFieldInfo(::mlir::StringRef fieldName);

  ::mlir::Type getFieldType(::mlir::StringRef fieldName);
  static UnionType get(::mlir::MLIRContext *context, ::llvm::ArrayRef<::circt::hw::UnionType::FieldInfo> elements);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"union"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::llvm::ArrayRef<::circt::hw::UnionType::FieldInfo> getElements() const;
};
namespace detail {
struct UnpackedArrayTypeStorage;
} // namespace detail
class UnpackedArrayType : public ::mlir::Type::TypeBase<UnpackedArrayType, ::mlir::Type, detail::UnpackedArrayTypeStorage> {
public:
  using Base::Base;
  static UnpackedArrayType get(Type elementType, size_t size) {
    auto *ctx = elementType.getContext();
    auto intType = ::mlir::IntegerType::get(ctx, 64);
    auto sizeAttr = ::mlir::IntegerAttr::get(intType, size);
    return UnpackedArrayType::get(ctx, elementType, sizeAttr);
  }
  size_t getSize() const;
  using Base::getChecked;
  static UnpackedArrayType get(::mlir::MLIRContext *context, ::mlir::Type elementType, ::mlir::Attribute sizeAttr);
  static UnpackedArrayType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, ::mlir::Type elementType, ::mlir::Attribute sizeAttr);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::Type elementType, ::mlir::Attribute sizeAttr);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"uarray"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::mlir::Type getElementType() const;
  ::mlir::Attribute getSizeAttr() const;
};
} // namespace hw
} // namespace circt
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::hw::ArrayType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::hw::EnumType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::hw::StringType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::hw::InOutType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::hw::IntType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::hw::ModuleType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::hw::StructType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::hw::TypeAliasType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::hw::UnionType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::hw::UnpackedArrayType)

#endif  // GET_TYPEDEF_CLASSES

