/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_FLATTENIO
#define GEN_PASS_DECL_HWSPECIALIZE
#define GEN_PASS_DECL_PRINTHWMODULEGRAPH
#define GEN_PASS_DECL_PRINTINSTANCEGRAPH
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// FlattenIO
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_FLATTENIO
struct FlattenIOOptions {
  bool recursive = false;
};
#undef GEN_PASS_DECL_FLATTENIO
#endif // GEN_PASS_DECL_FLATTENIO
#ifdef GEN_PASS_DEF_FLATTENIO
namespace impl {

template <typename DerivedT>
class FlattenIOBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = FlattenIOBase;

  FlattenIOBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FlattenIOBase(const FlattenIOBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-flatten-io");
  }
  ::llvm::StringRef getArgument() const override { return "hw-flatten-io"; }

  ::llvm::StringRef getDescription() const override { return "Flattens hw::Structure typed in- and output ports."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FlattenIO");
  }
  ::llvm::StringRef getName() const override { return "FlattenIO"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FlattenIOBase<DerivedT>)

  FlattenIOBase(const FlattenIOOptions &options) : FlattenIOBase() {
    recursive = options.recursive;
  }
protected:
  ::mlir::Pass::Option<bool> recursive{*this, "recursive", ::llvm::cl::desc("Recursively flatten nested structs."), ::llvm::cl::init(false)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_FLATTENIO
#endif // GEN_PASS_DEF_FLATTENIO

//===----------------------------------------------------------------------===//
// HWSpecialize
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_HWSPECIALIZE
#undef GEN_PASS_DECL_HWSPECIALIZE
#endif // GEN_PASS_DECL_HWSPECIALIZE
#ifdef GEN_PASS_DEF_HWSPECIALIZE
namespace impl {

template <typename DerivedT>
class HWSpecializeBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = HWSpecializeBase;

  HWSpecializeBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWSpecializeBase(const HWSpecializeBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-specialize");
  }
  ::llvm::StringRef getArgument() const override { return "hw-specialize"; }

  ::llvm::StringRef getDescription() const override { return "Specializes instances of parametric hw.modules"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWSpecialize");
  }
  ::llvm::StringRef getName() const override { return "HWSpecialize"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWSpecializeBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_HWSPECIALIZE
#endif // GEN_PASS_DEF_HWSPECIALIZE

//===----------------------------------------------------------------------===//
// PrintHWModuleGraph
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_PRINTHWMODULEGRAPH
struct PrintHWModuleGraphOptions {
  bool verboseEdges = false;
};
#undef GEN_PASS_DECL_PRINTHWMODULEGRAPH
#endif // GEN_PASS_DECL_PRINTHWMODULEGRAPH
#ifdef GEN_PASS_DEF_PRINTHWMODULEGRAPH
namespace impl {

template <typename DerivedT>
class PrintHWModuleGraphBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintHWModuleGraphBase;

  PrintHWModuleGraphBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintHWModuleGraphBase(const PrintHWModuleGraphBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-print-module-graph");
  }
  ::llvm::StringRef getArgument() const override { return "hw-print-module-graph"; }

  ::llvm::StringRef getDescription() const override { return "Print a DOT graph of the HWModule's within a top-level module."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrintHWModuleGraph");
  }
  ::llvm::StringRef getName() const override { return "PrintHWModuleGraph"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintHWModuleGraphBase<DerivedT>)

  PrintHWModuleGraphBase(const PrintHWModuleGraphOptions &options) : PrintHWModuleGraphBase() {
    verboseEdges = options.verboseEdges;
  }
protected:
  ::mlir::Pass::Option<bool> verboseEdges{*this, "verbose-edges", ::llvm::cl::desc("Print information on SSA edges (types, operand #, ...)"), ::llvm::cl::init(false)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_PRINTHWMODULEGRAPH
#endif // GEN_PASS_DEF_PRINTHWMODULEGRAPH

//===----------------------------------------------------------------------===//
// PrintInstanceGraph
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_PRINTINSTANCEGRAPH
#undef GEN_PASS_DECL_PRINTINSTANCEGRAPH
#endif // GEN_PASS_DECL_PRINTINSTANCEGRAPH
#ifdef GEN_PASS_DEF_PRINTINSTANCEGRAPH
namespace impl {

template <typename DerivedT>
class PrintInstanceGraphBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintInstanceGraphBase;

  PrintInstanceGraphBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintInstanceGraphBase(const PrintInstanceGraphBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-print-instance-graph");
  }
  ::llvm::StringRef getArgument() const override { return "hw-print-instance-graph"; }

  ::llvm::StringRef getDescription() const override { return "Print a DOT graph of the module hierarchy."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrintInstanceGraph");
  }
  ::llvm::StringRef getName() const override { return "PrintInstanceGraph"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintInstanceGraphBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_PRINTINSTANCEGRAPH
#endif // GEN_PASS_DEF_PRINTINSTANCEGRAPH
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// FlattenIO Registration
//===----------------------------------------------------------------------===//

inline void registerFlattenIO() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createFlattenIOPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerFlattenIOPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createFlattenIOPass();
  });
}

//===----------------------------------------------------------------------===//
// HWSpecialize Registration
//===----------------------------------------------------------------------===//

inline void registerHWSpecialize() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createHWSpecializePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerHWSpecializePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createHWSpecializePass();
  });
}

//===----------------------------------------------------------------------===//
// PrintHWModuleGraph Registration
//===----------------------------------------------------------------------===//

inline void registerPrintHWModuleGraph() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createPrintHWModuleGraphPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerPrintHWModuleGraphPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createPrintHWModuleGraphPass();
  });
}

//===----------------------------------------------------------------------===//
// PrintInstanceGraph Registration
//===----------------------------------------------------------------------===//

inline void registerPrintInstanceGraph() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createPrintInstanceGraphPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerPrintInstanceGraphPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createPrintInstanceGraphPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerFlattenIO();
  registerHWSpecialize();
  registerPrintHWModuleGraph();
  registerPrintInstanceGraph();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class FlattenIOBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = FlattenIOBase;

  FlattenIOBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FlattenIOBase(const FlattenIOBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-flatten-io");
  }
  ::llvm::StringRef getArgument() const override { return "hw-flatten-io"; }

  ::llvm::StringRef getDescription() const override { return "Flattens hw::Structure typed in- and output ports."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FlattenIO");
  }
  ::llvm::StringRef getName() const override { return "FlattenIO"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FlattenIOBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> recursive{*this, "recursive", ::llvm::cl::desc("Recursively flatten nested structs."), ::llvm::cl::init(false)};
};

template <typename DerivedT>
class HWSpecializeBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = HWSpecializeBase;

  HWSpecializeBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWSpecializeBase(const HWSpecializeBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-specialize");
  }
  ::llvm::StringRef getArgument() const override { return "hw-specialize"; }

  ::llvm::StringRef getDescription() const override { return "Specializes instances of parametric hw.modules"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWSpecialize");
  }
  ::llvm::StringRef getName() const override { return "HWSpecialize"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWSpecializeBase<DerivedT>)

protected:
};

template <typename DerivedT>
class PrintHWModuleGraphBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintHWModuleGraphBase;

  PrintHWModuleGraphBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintHWModuleGraphBase(const PrintHWModuleGraphBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-print-module-graph");
  }
  ::llvm::StringRef getArgument() const override { return "hw-print-module-graph"; }

  ::llvm::StringRef getDescription() const override { return "Print a DOT graph of the HWModule's within a top-level module."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrintHWModuleGraph");
  }
  ::llvm::StringRef getName() const override { return "PrintHWModuleGraph"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintHWModuleGraphBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> verboseEdges{*this, "verbose-edges", ::llvm::cl::desc("Print information on SSA edges (types, operand #, ...)"), ::llvm::cl::init(false)};
};

template <typename DerivedT>
class PrintInstanceGraphBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintInstanceGraphBase;

  PrintInstanceGraphBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintInstanceGraphBase(const PrintInstanceGraphBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-print-instance-graph");
  }
  ::llvm::StringRef getArgument() const override { return "hw-print-instance-graph"; }

  ::llvm::StringRef getDescription() const override { return "Print a DOT graph of the module hierarchy."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrintInstanceGraph");
  }
  ::llvm::StringRef getName() const override { return "PrintInstanceGraph"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintInstanceGraphBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
