/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Op Definitions                                                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_OP_LIST
#undef GET_OP_LIST

::circt::interop::ProceduralAllocOp,
::circt::interop::ProceduralDeallocOp,
::circt::interop::ProceduralInitOp,
::circt::interop::ProceduralUpdateOp,
::circt::interop::ReturnOp
#endif  // GET_OP_LIST

#ifdef GET_OP_CLASSES
#undef GET_OP_CLASSES


//===----------------------------------------------------------------------===//
// Local Utility Method Definitions
//===----------------------------------------------------------------------===//

namespace circt {
namespace interop {

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Interop0(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((true))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be any type, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Interop0(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::InteropMechanismAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: interface through which interoperability is achieved";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Interop0(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Interop0(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_region_constraint_Interop0(
    ::mlir::Operation *op, ::mlir::Region &region, ::llvm::StringRef regionName,
    unsigned regionIndex) {
  if (!((::llvm::hasNItems(region, 1)))) {
    return op->emitOpError("region #") << regionIndex
        << (regionName.empty() ? " " : " ('" + regionName + "') ")
        << "failed to verify constraint: region with 1 blocks";
  }
  return ::mlir::success();
}
} // namespace interop
} // namespace circt
namespace circt {
namespace interop {

//===----------------------------------------------------------------------===//
// ::circt::interop::ProceduralAllocOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ProceduralAllocOpGenericAdaptorBase::ProceduralAllocOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("interop.procedural.alloc", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ProceduralAllocOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ProceduralAllocOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::InteropMechanismAttr ProceduralAllocOpGenericAdaptorBase::getInteropMechanismAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::InteropMechanismAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, ProceduralAllocOp::getInteropMechanismAttrName(*odsOpName)));
  return attr;
}

::InteropMechanism ProceduralAllocOpGenericAdaptorBase::getInteropMechanism() {
  auto attr = getInteropMechanismAttr();
  return attr.getValue();
}

} // namespace detail
ProceduralAllocOpAdaptor::ProceduralAllocOpAdaptor(ProceduralAllocOp op) : ProceduralAllocOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ProceduralAllocOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_interopMechanism;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'interop.procedural.alloc' op ""requires attribute 'interopMechanism'");
    if (namedAttrIt->getName() == ProceduralAllocOp::getInteropMechanismAttrName(*odsOpName)) {
      tblgen_interopMechanism = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_interopMechanism && !((::llvm::isa<::InteropMechanismAttr>(tblgen_interopMechanism))))
    return emitError(loc, "'interop.procedural.alloc' op ""attribute 'interopMechanism' failed to satisfy constraint: interface through which interoperability is achieved");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ProceduralAllocOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ProceduralAllocOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> ProceduralAllocOp::getODSResultIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumResults() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::result_range ProceduralAllocOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::result_range ProceduralAllocOp::getStates() {
  return getODSResults(0);
}

::InteropMechanismAttr ProceduralAllocOp::getInteropMechanismAttr() {
  return ::llvm::cast<::InteropMechanismAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getInteropMechanismAttrName()));
}

::InteropMechanism ProceduralAllocOp::getInteropMechanism() {
  auto attr = getInteropMechanismAttr();
  return attr.getValue();
}

void ProceduralAllocOp::setInteropMechanismAttr(::InteropMechanismAttr attr) {
  (*this)->setAttr(getInteropMechanismAttrName(), attr);
}

void ProceduralAllocOp::setInteropMechanism(::InteropMechanism attrValue) {
  (*this)->setAttr(getInteropMechanismAttrName(), ::InteropMechanismAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

void ProceduralAllocOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange states, ::InteropMechanismAttr interopMechanism) {
  odsState.addAttribute(getInteropMechanismAttrName(odsState.name), interopMechanism);
  odsState.addTypes(states);
}

void ProceduralAllocOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange states, ::InteropMechanism interopMechanism) {
  odsState.addAttribute(getInteropMechanismAttrName(odsState.name), ::InteropMechanismAttr::get(odsBuilder.getContext(), interopMechanism));
  odsState.addTypes(states);
}

void ProceduralAllocOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ProceduralAllocOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_interopMechanism;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'interopMechanism'");
    if (namedAttrIt->getName() == getInteropMechanismAttrName()) {
      tblgen_interopMechanism = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Interop0(*this, tblgen_interopMechanism, "interopMechanism")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Interop0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ProceduralAllocOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult ProceduralAllocOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::InteropMechanismAttr interopMechanismAttr;
  ::llvm::SmallVector<::mlir::Type, 1> statesTypes;

  {
    ::llvm::StringRef attrStr;
    ::mlir::NamedAttrList attrStorage;
    auto loc = parser.getCurrentLocation();
    if (parser.parseOptionalKeyword(&attrStr, {"cffi","cpp"})) {
      ::mlir::StringAttr attrVal;
      ::mlir::OptionalParseResult parseResult =
        parser.parseOptionalAttribute(attrVal,
                                      parser.getBuilder().getNoneType(),
                                      "interopMechanism", attrStorage);
      if (parseResult.has_value()) {
        if (failed(*parseResult))
          return ::mlir::failure();
        attrStr = attrVal.getValue();
      } else {
        return parser.emitError(loc, "expected string or keyword containing one of the following enum values for attribute 'interopMechanism' [cffi, cpp]");
      }
    }
    if (!attrStr.empty()) {
      auto attrOptional = ::symbolizeInteropMechanism(attrStr);
      if (!attrOptional)
        return parser.emitError(loc, "invalid ")
               << "interopMechanism attribute specification: \"" << attrStr << '"';;

      interopMechanismAttr = ::InteropMechanismAttr::get(parser.getBuilder().getContext(), *attrOptional);
      result.addAttribute("interopMechanism", interopMechanismAttr);
    }
  }
  if (::mlir::succeeded(parser.parseOptionalColon())) {

  if (parser.parseTypeList(statesTypes))
    return ::mlir::failure();
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  result.addTypes(statesTypes);
  return ::mlir::success();
}

void ProceduralAllocOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';

  {
    auto caseValue = getInteropMechanism();
    auto caseValueStr = stringifyInteropMechanism(caseValue);
    _odsPrinter << caseValueStr;
  }
  if (!getStates().empty()) {
    _odsPrinter << ' ' << ":";
    _odsPrinter << ' ';
    _odsPrinter << getStates().getTypes();
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("interopMechanism");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace interop
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::interop::ProceduralAllocOp)

namespace circt {
namespace interop {

//===----------------------------------------------------------------------===//
// ::circt::interop::ProceduralDeallocOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ProceduralDeallocOpGenericAdaptorBase::ProceduralDeallocOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("interop.procedural.dealloc", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ProceduralDeallocOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr ProceduralDeallocOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::InteropMechanismAttr ProceduralDeallocOpGenericAdaptorBase::getInteropMechanismAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::InteropMechanismAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, ProceduralDeallocOp::getInteropMechanismAttrName(*odsOpName)));
  return attr;
}

::InteropMechanism ProceduralDeallocOpGenericAdaptorBase::getInteropMechanism() {
  auto attr = getInteropMechanismAttr();
  return attr.getValue();
}

::mlir::Region &ProceduralDeallocOpGenericAdaptorBase::getDeallocRegion() {
  return *odsRegions[0];
}

::mlir::RegionRange ProceduralDeallocOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
ProceduralDeallocOpAdaptor::ProceduralDeallocOpAdaptor(ProceduralDeallocOp op) : ProceduralDeallocOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ProceduralDeallocOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_interopMechanism;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'interop.procedural.dealloc' op ""requires attribute 'interopMechanism'");
    if (namedAttrIt->getName() == ProceduralDeallocOp::getInteropMechanismAttrName(*odsOpName)) {
      tblgen_interopMechanism = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_interopMechanism && !((::llvm::isa<::InteropMechanismAttr>(tblgen_interopMechanism))))
    return emitError(loc, "'interop.procedural.dealloc' op ""attribute 'interopMechanism' failed to satisfy constraint: interface through which interoperability is achieved");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ProceduralDeallocOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range ProceduralDeallocOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range ProceduralDeallocOp::getStates() {
  return getODSOperands(0);
}

::mlir::MutableOperandRange ProceduralDeallocOp::getStatesMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> ProceduralDeallocOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ProceduralDeallocOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Region &ProceduralDeallocOp::getDeallocRegion() {
  return (*this)->getRegion(0);
}

::InteropMechanismAttr ProceduralDeallocOp::getInteropMechanismAttr() {
  return ::llvm::cast<::InteropMechanismAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getInteropMechanismAttrName()));
}

::InteropMechanism ProceduralDeallocOp::getInteropMechanism() {
  auto attr = getInteropMechanismAttr();
  return attr.getValue();
}

void ProceduralDeallocOp::setInteropMechanismAttr(::InteropMechanismAttr attr) {
  (*this)->setAttr(getInteropMechanismAttrName(), attr);
}

void ProceduralDeallocOp::setInteropMechanism(::InteropMechanism attrValue) {
  (*this)->setAttr(getInteropMechanismAttrName(), ::InteropMechanismAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

::mlir::LogicalResult ProceduralDeallocOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_interopMechanism;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'interopMechanism'");
    if (namedAttrIt->getName() == getInteropMechanismAttrName()) {
      tblgen_interopMechanism = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Interop0(*this, tblgen_interopMechanism, "interopMechanism")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Interop0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_Interop0(*this, region, "deallocRegion", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult ProceduralDeallocOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult ProceduralDeallocOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::InteropMechanismAttr interopMechanismAttr;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> statesOperands;
  ::llvm::SMLoc statesOperandsLoc;
  (void)statesOperandsLoc;
  ::llvm::SmallVector<::mlir::Type, 1> statesTypes;
  std::unique_ptr<::mlir::Region> deallocRegionRegion = std::make_unique<::mlir::Region>();

  {
    ::llvm::StringRef attrStr;
    ::mlir::NamedAttrList attrStorage;
    auto loc = parser.getCurrentLocation();
    if (parser.parseOptionalKeyword(&attrStr, {"cffi","cpp"})) {
      ::mlir::StringAttr attrVal;
      ::mlir::OptionalParseResult parseResult =
        parser.parseOptionalAttribute(attrVal,
                                      parser.getBuilder().getNoneType(),
                                      "interopMechanism", attrStorage);
      if (parseResult.has_value()) {
        if (failed(*parseResult))
          return ::mlir::failure();
        attrStr = attrVal.getValue();
      } else {
        return parser.emitError(loc, "expected string or keyword containing one of the following enum values for attribute 'interopMechanism' [cffi, cpp]");
      }
    }
    if (!attrStr.empty()) {
      auto attrOptional = ::symbolizeInteropMechanism(attrStr);
      if (!attrOptional)
        return parser.emitError(loc, "invalid ")
               << "interopMechanism attribute specification: \"" << attrStr << '"';;

      interopMechanismAttr = ::InteropMechanismAttr::get(parser.getBuilder().getContext(), *attrOptional);
      result.addAttribute("interopMechanism", interopMechanismAttr);
    }
  }

  statesOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperandList(statesOperands))
    return ::mlir::failure();
  if (!statesOperands.empty()) {
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseTypeList(statesTypes))
    return ::mlir::failure();
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDictWithKeyword(result.attributes))
      return ::mlir::failure();
  }

  if (parser.parseRegion(*deallocRegionRegion))
    return ::mlir::failure();

  if (deallocRegionRegion->empty()) deallocRegionRegion->emplaceBlock();
  result.addRegion(std::move(deallocRegionRegion));
  if (parser.resolveOperands(statesOperands, statesTypes, statesOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ProceduralDeallocOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';

  {
    auto caseValue = getInteropMechanism();
    auto caseValueStr = stringifyInteropMechanism(caseValue);
    _odsPrinter << caseValueStr;
  }
  if (!getStates().empty()) {
    _odsPrinter << ' ';
    _odsPrinter << getStates();
    _odsPrinter << ' ' << ":";
    _odsPrinter << ' ';
    _odsPrinter << getStates().getTypes();
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("interopMechanism");
  _odsPrinter.printOptionalAttrDictWithKeyword((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ';
  _odsPrinter.printRegion(getDeallocRegion());
}

} // namespace interop
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::interop::ProceduralDeallocOp)

namespace circt {
namespace interop {

//===----------------------------------------------------------------------===//
// ::circt::interop::ProceduralInitOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ProceduralInitOpGenericAdaptorBase::ProceduralInitOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("interop.procedural.init", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ProceduralInitOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr ProceduralInitOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::InteropMechanismAttr ProceduralInitOpGenericAdaptorBase::getInteropMechanismAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::InteropMechanismAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, ProceduralInitOp::getInteropMechanismAttrName(*odsOpName)));
  return attr;
}

::InteropMechanism ProceduralInitOpGenericAdaptorBase::getInteropMechanism() {
  auto attr = getInteropMechanismAttr();
  return attr.getValue();
}

::mlir::Region &ProceduralInitOpGenericAdaptorBase::getInitRegion() {
  return *odsRegions[0];
}

::mlir::RegionRange ProceduralInitOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
ProceduralInitOpAdaptor::ProceduralInitOpAdaptor(ProceduralInitOp op) : ProceduralInitOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ProceduralInitOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_interopMechanism;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'interop.procedural.init' op ""requires attribute 'interopMechanism'");
    if (namedAttrIt->getName() == ProceduralInitOp::getInteropMechanismAttrName(*odsOpName)) {
      tblgen_interopMechanism = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_interopMechanism && !((::llvm::isa<::InteropMechanismAttr>(tblgen_interopMechanism))))
    return emitError(loc, "'interop.procedural.init' op ""attribute 'interopMechanism' failed to satisfy constraint: interface through which interoperability is achieved");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ProceduralInitOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range ProceduralInitOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range ProceduralInitOp::getStates() {
  return getODSOperands(0);
}

::mlir::MutableOperandRange ProceduralInitOp::getStatesMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> ProceduralInitOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ProceduralInitOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Region &ProceduralInitOp::getInitRegion() {
  return (*this)->getRegion(0);
}

::InteropMechanismAttr ProceduralInitOp::getInteropMechanismAttr() {
  return ::llvm::cast<::InteropMechanismAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getInteropMechanismAttrName()));
}

::InteropMechanism ProceduralInitOp::getInteropMechanism() {
  auto attr = getInteropMechanismAttr();
  return attr.getValue();
}

void ProceduralInitOp::setInteropMechanismAttr(::InteropMechanismAttr attr) {
  (*this)->setAttr(getInteropMechanismAttrName(), attr);
}

void ProceduralInitOp::setInteropMechanism(::InteropMechanism attrValue) {
  (*this)->setAttr(getInteropMechanismAttrName(), ::InteropMechanismAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

::mlir::LogicalResult ProceduralInitOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_interopMechanism;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'interopMechanism'");
    if (namedAttrIt->getName() == getInteropMechanismAttrName()) {
      tblgen_interopMechanism = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Interop0(*this, tblgen_interopMechanism, "interopMechanism")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Interop0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_Interop0(*this, region, "initRegion", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult ProceduralInitOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult ProceduralInitOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::InteropMechanismAttr interopMechanismAttr;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> statesOperands;
  ::llvm::SMLoc statesOperandsLoc;
  (void)statesOperandsLoc;
  ::llvm::SmallVector<::mlir::Type, 1> statesTypes;
  std::unique_ptr<::mlir::Region> initRegionRegion = std::make_unique<::mlir::Region>();

  {
    ::llvm::StringRef attrStr;
    ::mlir::NamedAttrList attrStorage;
    auto loc = parser.getCurrentLocation();
    if (parser.parseOptionalKeyword(&attrStr, {"cffi","cpp"})) {
      ::mlir::StringAttr attrVal;
      ::mlir::OptionalParseResult parseResult =
        parser.parseOptionalAttribute(attrVal,
                                      parser.getBuilder().getNoneType(),
                                      "interopMechanism", attrStorage);
      if (parseResult.has_value()) {
        if (failed(*parseResult))
          return ::mlir::failure();
        attrStr = attrVal.getValue();
      } else {
        return parser.emitError(loc, "expected string or keyword containing one of the following enum values for attribute 'interopMechanism' [cffi, cpp]");
      }
    }
    if (!attrStr.empty()) {
      auto attrOptional = ::symbolizeInteropMechanism(attrStr);
      if (!attrOptional)
        return parser.emitError(loc, "invalid ")
               << "interopMechanism attribute specification: \"" << attrStr << '"';;

      interopMechanismAttr = ::InteropMechanismAttr::get(parser.getBuilder().getContext(), *attrOptional);
      result.addAttribute("interopMechanism", interopMechanismAttr);
    }
  }

  statesOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperandList(statesOperands))
    return ::mlir::failure();
  if (!statesOperands.empty()) {
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseTypeList(statesTypes))
    return ::mlir::failure();
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDictWithKeyword(result.attributes))
      return ::mlir::failure();
  }

  if (parser.parseRegion(*initRegionRegion))
    return ::mlir::failure();

  if (initRegionRegion->empty()) initRegionRegion->emplaceBlock();
  result.addRegion(std::move(initRegionRegion));
  if (parser.resolveOperands(statesOperands, statesTypes, statesOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ProceduralInitOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';

  {
    auto caseValue = getInteropMechanism();
    auto caseValueStr = stringifyInteropMechanism(caseValue);
    _odsPrinter << caseValueStr;
  }
  if (!getStates().empty()) {
    _odsPrinter << ' ';
    _odsPrinter << getStates();
    _odsPrinter << ' ' << ":";
    _odsPrinter << ' ';
    _odsPrinter << getStates().getTypes();
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("interopMechanism");
  _odsPrinter.printOptionalAttrDictWithKeyword((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ';
  _odsPrinter.printRegion(getInitRegion());
}

} // namespace interop
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::interop::ProceduralInitOp)

namespace circt {
namespace interop {

//===----------------------------------------------------------------------===//
// ::circt::interop::ProceduralUpdateOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ProceduralUpdateOpGenericAdaptorBase::ProceduralUpdateOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("interop.procedural.update", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ProceduralUpdateOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  assert(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, ProceduralUpdateOp::getOperandSegmentSizesAttrName(*odsOpName)) && "missing segment size attribute for op");
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, ProceduralUpdateOp::getOperandSegmentSizesAttrName(*odsOpName)));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr ProceduralUpdateOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::InteropMechanismAttr ProceduralUpdateOpGenericAdaptorBase::getInteropMechanismAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::InteropMechanismAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, ProceduralUpdateOp::getInteropMechanismAttrName(*odsOpName)));
  return attr;
}

::InteropMechanism ProceduralUpdateOpGenericAdaptorBase::getInteropMechanism() {
  auto attr = getInteropMechanismAttr();
  return attr.getValue();
}

::mlir::Region &ProceduralUpdateOpGenericAdaptorBase::getUpdateRegion() {
  return *odsRegions[0];
}

::mlir::RegionRange ProceduralUpdateOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
ProceduralUpdateOpAdaptor::ProceduralUpdateOpAdaptor(ProceduralUpdateOp op) : ProceduralUpdateOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ProceduralUpdateOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_interopMechanism;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'interop.procedural.update' op ""requires attribute 'interopMechanism'");
    if (namedAttrIt->getName() == ProceduralUpdateOp::getInteropMechanismAttrName(*odsOpName)) {
      tblgen_interopMechanism = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_operand_segment_sizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'interop.procedural.update' op ""requires attribute 'operand_segment_sizes'");
    if (namedAttrIt->getName() == ProceduralUpdateOp::getOperandSegmentSizesAttrName(*odsOpName)) {
      tblgen_operand_segment_sizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operand_segment_sizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 2)
      return emitError(loc, "'interop.procedural.update' op ""'operand_segment_sizes' attribute for specifying operand segments must have 2 "
                "elements, but got ") << numElements;
  }

  if (tblgen_interopMechanism && !((::llvm::isa<::InteropMechanismAttr>(tblgen_interopMechanism))))
    return emitError(loc, "'interop.procedural.update' op ""attribute 'interopMechanism' failed to satisfy constraint: interface through which interoperability is achieved");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ProceduralUpdateOp::getODSOperandIndexAndLength(unsigned index) {
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName()));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range ProceduralUpdateOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range ProceduralUpdateOp::getStates() {
  return getODSOperands(0);
}

::mlir::Operation::operand_range ProceduralUpdateOp::getInputs() {
  return getODSOperands(1);
}

::mlir::MutableOperandRange ProceduralUpdateOp::getStatesMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(0u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange ProceduralUpdateOp::getInputsMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(1u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

std::pair<unsigned, unsigned> ProceduralUpdateOp::getODSResultIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumResults() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::result_range ProceduralUpdateOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::result_range ProceduralUpdateOp::getOutputs() {
  return getODSResults(0);
}

::mlir::Region &ProceduralUpdateOp::getUpdateRegion() {
  return (*this)->getRegion(0);
}

::InteropMechanismAttr ProceduralUpdateOp::getInteropMechanismAttr() {
  return ::llvm::cast<::InteropMechanismAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getInteropMechanismAttrName()));
}

::InteropMechanism ProceduralUpdateOp::getInteropMechanism() {
  auto attr = getInteropMechanismAttr();
  return attr.getValue();
}

void ProceduralUpdateOp::setInteropMechanismAttr(::InteropMechanismAttr attr) {
  (*this)->setAttr(getInteropMechanismAttrName(), attr);
}

void ProceduralUpdateOp::setInteropMechanism(::InteropMechanism attrValue) {
  (*this)->setAttr(getInteropMechanismAttrName(), ::InteropMechanismAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

::mlir::LogicalResult ProceduralUpdateOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_interopMechanism;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'interopMechanism'");
    if (namedAttrIt->getName() == getInteropMechanismAttrName()) {
      tblgen_interopMechanism = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_operand_segment_sizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'operand_segment_sizes'");
    if (namedAttrIt->getName() == getOperandSegmentSizesAttrName()) {
      tblgen_operand_segment_sizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operand_segment_sizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 2)
      return emitOpError("'operand_segment_sizes' attribute for specifying operand segments must have 2 "
                "elements, but got ") << numElements;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Interop0(*this, tblgen_interopMechanism, "interopMechanism")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Interop0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Interop0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Interop0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_Interop0(*this, region, "updateRegion", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult ProceduralUpdateOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult ProceduralUpdateOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::InteropMechanismAttr interopMechanismAttr;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> statesOperands;
  ::llvm::SMLoc statesOperandsLoc;
  (void)statesOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> inputsOperands;
  ::llvm::SMLoc inputsOperandsLoc;
  (void)inputsOperandsLoc;
  ::llvm::SmallVector<::mlir::Type, 1> statesTypes;
  ::llvm::ArrayRef<::mlir::Type> inputsTypes;
  ::llvm::ArrayRef<::mlir::Type> outputsTypes;
  std::unique_ptr<::mlir::Region> updateRegionRegion = std::make_unique<::mlir::Region>();

  {
    ::llvm::StringRef attrStr;
    ::mlir::NamedAttrList attrStorage;
    auto loc = parser.getCurrentLocation();
    if (parser.parseOptionalKeyword(&attrStr, {"cffi","cpp"})) {
      ::mlir::StringAttr attrVal;
      ::mlir::OptionalParseResult parseResult =
        parser.parseOptionalAttribute(attrVal,
                                      parser.getBuilder().getNoneType(),
                                      "interopMechanism", attrStorage);
      if (parseResult.has_value()) {
        if (failed(*parseResult))
          return ::mlir::failure();
        attrStr = attrVal.getValue();
      } else {
        return parser.emitError(loc, "expected string or keyword containing one of the following enum values for attribute 'interopMechanism' [cffi, cpp]");
      }
    }
    if (!attrStr.empty()) {
      auto attrOptional = ::symbolizeInteropMechanism(attrStr);
      if (!attrOptional)
        return parser.emitError(loc, "invalid ")
               << "interopMechanism attribute specification: \"" << attrStr << '"';;

      interopMechanismAttr = ::InteropMechanismAttr::get(parser.getBuilder().getContext(), *attrOptional);
      result.addAttribute("interopMechanism", interopMechanismAttr);
    }
  }
  if (::mlir::succeeded(parser.parseOptionalLSquare())) {

  statesOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperandList(statesOperands))
    return ::mlir::failure();
  if (parser.parseRSquare())
    return ::mlir::failure();
  }
  if (::mlir::succeeded(parser.parseOptionalLParen())) {

  inputsOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperandList(inputsOperands))
    return ::mlir::failure();
  if (parser.parseRParen())
    return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalLSquare())) {

  if (parser.parseTypeList(statesTypes))
    return ::mlir::failure();
  if (parser.parseRSquare())
    return ::mlir::failure();
  }

  ::mlir::FunctionType inputs__outputs_functionType;
  if (parser.parseType(inputs__outputs_functionType))
    return ::mlir::failure();
  inputsTypes = inputs__outputs_functionType.getInputs();
  outputsTypes = inputs__outputs_functionType.getResults();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDictWithKeyword(result.attributes))
      return ::mlir::failure();
  }

  if (parser.parseRegion(*updateRegionRegion))
    return ::mlir::failure();

  if (updateRegionRegion->empty()) updateRegionRegion->emplaceBlock();
  result.addRegion(std::move(updateRegionRegion));
  result.addAttribute("operand_segment_sizes", parser.getBuilder().getDenseI32ArrayAttr({static_cast<int32_t>(statesOperands.size()), static_cast<int32_t>(inputsOperands.size())}));
  result.addTypes(outputsTypes);
  if (parser.resolveOperands(statesOperands, statesTypes, statesOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(inputsOperands, inputsTypes, inputsOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ProceduralUpdateOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';

  {
    auto caseValue = getInteropMechanism();
    auto caseValueStr = stringifyInteropMechanism(caseValue);
    _odsPrinter << caseValueStr;
  }
  if (!getStates().empty()) {
    _odsPrinter << ' ';
    _odsPrinter << "[";
    _odsPrinter << getStates();
    _odsPrinter << "]";
  }
  if (!getInputs().empty()) {
    _odsPrinter << ' ' << "(";
    _odsPrinter << getInputs();
    _odsPrinter << ")";
  }
  _odsPrinter << ' ' << ":";
  if (!getStates().empty()) {
    _odsPrinter << ' ' << "[";
    _odsPrinter << getStates().getTypes();
    _odsPrinter << "]";
  }
  _odsPrinter << ' ';
  _odsPrinter.printFunctionalType(getInputs().getTypes(), getOutputs().getTypes());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("operand_segment_sizes");
  elidedAttrs.push_back("interopMechanism");
  _odsPrinter.printOptionalAttrDictWithKeyword((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ';
  _odsPrinter.printRegion(getUpdateRegion());
}

} // namespace interop
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::interop::ProceduralUpdateOp)

namespace circt {
namespace interop {

//===----------------------------------------------------------------------===//
// ::circt::interop::ReturnOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ReturnOpGenericAdaptorBase::ReturnOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("interop.return", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ReturnOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr ReturnOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
ReturnOpAdaptor::ReturnOpAdaptor(ReturnOp op) : ReturnOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ReturnOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ReturnOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range ReturnOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range ReturnOp::getReturnValues() {
  return getODSOperands(0);
}

::mlir::MutableOperandRange ReturnOp::getReturnValuesMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> ReturnOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ReturnOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

void ReturnOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState) {
    build(odsBuilder, odsState, std::nullopt);
  
}

void ReturnOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange returnValues) {
  odsState.addOperands(returnValues);
}

void ReturnOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ReturnOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Interop0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ReturnOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult ReturnOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> returnValuesOperands;
  ::llvm::SMLoc returnValuesOperandsLoc;
  (void)returnValuesOperandsLoc;
  ::llvm::SmallVector<::mlir::Type, 1> returnValuesTypes;
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }

  returnValuesOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperandList(returnValuesOperands))
    return ::mlir::failure();
  if (!returnValuesOperands.empty()) {
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseTypeList(returnValuesTypes))
    return ::mlir::failure();
  }
  if (parser.resolveOperands(returnValuesOperands, returnValuesTypes, returnValuesOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ReturnOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  if (!getReturnValues().empty()) {
    _odsPrinter << ' ';
    _odsPrinter << getReturnValues();
    _odsPrinter << ' ' << ":";
    _odsPrinter << ' ';
    _odsPrinter << getReturnValues().getTypes();
  }
}

} // namespace interop
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::interop::ReturnOp)


#endif  // GET_OP_CLASSES

