/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace circt {
namespace msft {
class DynInstDataOpInterface;
namespace detail {
struct DynInstDataOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    void (*setGlobalRef)(const Concept *impl, ::mlir::Operation *, ::circt::hw::GlobalRefOp);
    FlatSymbolRefAttr (*getGlobalRefSym)(const Concept *impl, ::mlir::Operation *);
    Operation *(*getTopModule)(const Concept *impl, ::mlir::Operation *, circt::hw::HWSymbolCache &);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::circt::msft::DynInstDataOpInterface;
    Model() : Concept{setGlobalRef, getGlobalRefSym, getTopModule} {}

    static inline void setGlobalRef(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::GlobalRefOp ref);
    static inline FlatSymbolRefAttr getGlobalRefSym(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline Operation *getTopModule(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, circt::hw::HWSymbolCache & symCache);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::circt::msft::DynInstDataOpInterface;
    FallbackModel() : Concept{setGlobalRef, getGlobalRefSym, getTopModule} {}

    static inline void setGlobalRef(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::GlobalRefOp ref);
    static inline FlatSymbolRefAttr getGlobalRefSym(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline Operation *getTopModule(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, circt::hw::HWSymbolCache & symCache);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    void setGlobalRef(::mlir::Operation *tablegen_opaque_val, ::circt::hw::GlobalRefOp ref) const;
    FlatSymbolRefAttr getGlobalRefSym(::mlir::Operation *tablegen_opaque_val) const;
    Operation *getTopModule(::mlir::Operation *tablegen_opaque_val, circt::hw::HWSymbolCache &symCache) const;
  };
};template <typename ConcreteOp>
struct DynInstDataOpInterfaceTrait;

} // namespace detail
class DynInstDataOpInterface : public ::mlir::OpInterface<DynInstDataOpInterface, detail::DynInstDataOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<DynInstDataOpInterface, detail::DynInstDataOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::DynInstDataOpInterfaceTrait<ConcreteOp> {};
  /// Set the GlobalRefOp to which this op is referring.
  void setGlobalRef(::circt::hw::GlobalRefOp ref);
  /// Get the symbol of the GlobalRefOp to which this op is referring.
  FlatSymbolRefAttr getGlobalRefSym();
  /// Get the top module op to which the GlobalRefOp which this op is referring.
  Operation *getTopModule(circt::hw::HWSymbolCache & symCache);
};
namespace detail {
  template <typename ConcreteOp>
  struct DynInstDataOpInterfaceTrait : public ::mlir::OpInterface<DynInstDataOpInterface, detail::DynInstDataOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
    /// Set the GlobalRefOp to which this op is referring.
    void setGlobalRef(::circt::hw::GlobalRefOp ref) {
      (*static_cast<ConcreteOp *>(this)).setRefAttr(FlatSymbolRefAttr::get(ref));
    }
    /// Get the symbol of the GlobalRefOp to which this op is referring.
    FlatSymbolRefAttr getGlobalRefSym() {
      return (*static_cast<ConcreteOp *>(this)).getRefAttr();
    }
    /// Get the top module op to which the GlobalRefOp which this op is referring.
    Operation *getTopModule(circt::hw::HWSymbolCache & symCache) {
      FlatSymbolRefAttr refSym = (*static_cast<ConcreteOp *>(this)).getGlobalRefSym();
        if (!refSym) {
          (*static_cast<ConcreteOp *>(this))->emitOpError("must run dynamic instance lowering first");
          return nullptr;
        }
        auto ref = dyn_cast_or_null<hw::GlobalRefOp>(
            symCache.getDefinition(refSym));
        if (!ref) {
          (*static_cast<ConcreteOp *>(this))->emitOpError("could not find hw.globalRef ") << refSym;
          return nullptr;
        }
        if (ref.getNamepath().empty())
          return nullptr;
        auto modSym = FlatSymbolRefAttr::get(
            ref.getNamepath()[0].cast<hw::InnerRefAttr>().getModule());
        return symCache.getDefinition(modSym);
    }
    static ::mlir::LogicalResult verifyTrait(::mlir::Operation *op) {
      return ::circt::msft::verifyDynInstData(op);
    }
  };
}// namespace detail
} // namespace msft
} // namespace circt
namespace circt {
namespace msft {
template<typename ConcreteOp>
void detail::DynInstDataOpInterfaceInterfaceTraits::Model<ConcreteOp>::setGlobalRef(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::GlobalRefOp ref) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).setGlobalRef(ref);
}
template<typename ConcreteOp>
FlatSymbolRefAttr detail::DynInstDataOpInterfaceInterfaceTraits::Model<ConcreteOp>::getGlobalRefSym(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getGlobalRefSym();
}
template<typename ConcreteOp>
Operation *detail::DynInstDataOpInterfaceInterfaceTraits::Model<ConcreteOp>::getTopModule(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, circt::hw::HWSymbolCache & symCache) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getTopModule(symCache);
}
template<typename ConcreteOp>
void detail::DynInstDataOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::setGlobalRef(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::circt::hw::GlobalRefOp ref) {
  return static_cast<const ConcreteOp *>(impl)->setGlobalRef(tablegen_opaque_val, ref);
}
template<typename ConcreteOp>
FlatSymbolRefAttr detail::DynInstDataOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getGlobalRefSym(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getGlobalRefSym(tablegen_opaque_val);
}
template<typename ConcreteOp>
Operation *detail::DynInstDataOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getTopModule(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, circt::hw::HWSymbolCache & symCache) {
  return static_cast<const ConcreteOp *>(impl)->getTopModule(tablegen_opaque_val, symCache);
}
template<typename ConcreteModel, typename ConcreteOp>
void detail::DynInstDataOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::setGlobalRef(::mlir::Operation *tablegen_opaque_val, ::circt::hw::GlobalRefOp ref) const {
(llvm::cast<ConcreteOp>(tablegen_opaque_val)).setRefAttr(FlatSymbolRefAttr::get(ref));
}
template<typename ConcreteModel, typename ConcreteOp>
FlatSymbolRefAttr detail::DynInstDataOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getGlobalRefSym(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getRefAttr();
}
template<typename ConcreteModel, typename ConcreteOp>
Operation *detail::DynInstDataOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getTopModule(::mlir::Operation *tablegen_opaque_val, circt::hw::HWSymbolCache &symCache) const {
FlatSymbolRefAttr refSym = (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getGlobalRefSym();
        if (!refSym) {
          (llvm::cast<ConcreteOp>(tablegen_opaque_val))->emitOpError("must run dynamic instance lowering first");
          return nullptr;
        }
        auto ref = dyn_cast_or_null<hw::GlobalRefOp>(
            symCache.getDefinition(refSym));
        if (!ref) {
          (llvm::cast<ConcreteOp>(tablegen_opaque_val))->emitOpError("could not find hw.globalRef ") << refSym;
          return nullptr;
        }
        if (ref.getNamepath().empty())
          return nullptr;
        auto modSym = FlatSymbolRefAttr::get(
            ref.getNamepath()[0].cast<hw::InnerRefAttr>().getModule());
        return symCache.getDefinition(modSym);
}
} // namespace msft
} // namespace circt
