/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_DISCOVERAPPIDS
#define GEN_PASS_DECL_EXPORTTCL
#define GEN_PASS_DECL_LOWERCONSTRUCTS
#define GEN_PASS_DECL_LOWERINSTANCES
#define GEN_PASS_DECL_LOWERTOHW
#define GEN_PASS_DECL_PARTITION
#define GEN_PASS_DECL_WIRECLEANUP
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// DiscoverAppIDs
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_DISCOVERAPPIDS
#undef GEN_PASS_DECL_DISCOVERAPPIDS
#endif // GEN_PASS_DECL_DISCOVERAPPIDS
#ifdef GEN_PASS_DEF_DISCOVERAPPIDS
namespace impl {

template <typename DerivedT>
class DiscoverAppIDsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = DiscoverAppIDsBase;

  DiscoverAppIDsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  DiscoverAppIDsBase(const DiscoverAppIDsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-discover-appids");
  }
  ::llvm::StringRef getArgument() const override { return "msft-discover-appids"; }

  ::llvm::StringRef getDescription() const override { return "Discover the appids in a module hierarchy"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("DiscoverAppIDs");
  }
  ::llvm::StringRef getName() const override { return "DiscoverAppIDs"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(DiscoverAppIDsBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_DISCOVERAPPIDS
#endif // GEN_PASS_DEF_DISCOVERAPPIDS

//===----------------------------------------------------------------------===//
// ExportTcl
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_EXPORTTCL
struct ExportTclOptions {
  ::llvm::ArrayRef<std::string> tops;
  std::string tclFile;
};
#undef GEN_PASS_DECL_EXPORTTCL
#endif // GEN_PASS_DECL_EXPORTTCL
#ifdef GEN_PASS_DEF_EXPORTTCL
namespace impl {

template <typename DerivedT>
class ExportTclBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ExportTclBase;

  ExportTclBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ExportTclBase(const ExportTclBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-export-tcl");
  }
  ::llvm::StringRef getArgument() const override { return "msft-export-tcl"; }

  ::llvm::StringRef getDescription() const override { return "Create tcl ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ExportTcl");
  }
  ::llvm::StringRef getName() const override { return "ExportTcl"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ExportTclBase<DerivedT>)

  ExportTclBase(const ExportTclOptions &options) : ExportTclBase() {
    tops = options.tops;
    tclFile = options.tclFile;
  }
protected:
  ::mlir::Pass::ListOption<std::string> tops{*this, "tops", ::llvm::cl::desc("List of top modules to export Tcl for"), llvm::cl::ZeroOrMore,};
  ::mlir::Pass::Option<std::string> tclFile{*this, "tcl-file", ::llvm::cl::desc("File to output Tcl into")};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_EXPORTTCL
#endif // GEN_PASS_DEF_EXPORTTCL

//===----------------------------------------------------------------------===//
// LowerConstructs
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERCONSTRUCTS
#undef GEN_PASS_DECL_LOWERCONSTRUCTS
#endif // GEN_PASS_DECL_LOWERCONSTRUCTS
#ifdef GEN_PASS_DEF_LOWERCONSTRUCTS
namespace impl {

template <typename DerivedT>
class LowerConstructsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerConstructsBase;

  LowerConstructsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerConstructsBase(const LowerConstructsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-lower-constructs");
  }
  ::llvm::StringRef getArgument() const override { return "msft-lower-constructs"; }

  ::llvm::StringRef getDescription() const override { return "Lower high-level constructs"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerConstructs");
  }
  ::llvm::StringRef getName() const override { return "LowerConstructs"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerConstructsBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERCONSTRUCTS
#endif // GEN_PASS_DEF_LOWERCONSTRUCTS

//===----------------------------------------------------------------------===//
// LowerInstances
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERINSTANCES
#undef GEN_PASS_DECL_LOWERINSTANCES
#endif // GEN_PASS_DECL_LOWERINSTANCES
#ifdef GEN_PASS_DEF_LOWERINSTANCES
namespace impl {

template <typename DerivedT>
class LowerInstancesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerInstancesBase;

  LowerInstancesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerInstancesBase(const LowerInstancesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-lower-instances");
  }
  ::llvm::StringRef getArgument() const override { return "msft-lower-instances"; }

  ::llvm::StringRef getDescription() const override { return "Lower dynamic instances"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerInstances");
  }
  ::llvm::StringRef getName() const override { return "LowerInstances"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerInstancesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERINSTANCES
#endif // GEN_PASS_DEF_LOWERINSTANCES

//===----------------------------------------------------------------------===//
// LowerToHW
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERTOHW
struct LowerToHWOptions {
  std::string verilogFile;
};
#undef GEN_PASS_DECL_LOWERTOHW
#endif // GEN_PASS_DECL_LOWERTOHW
#ifdef GEN_PASS_DEF_LOWERTOHW
namespace impl {

template <typename DerivedT>
class LowerToHWBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerToHWBase;

  LowerToHWBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerToHWBase(const LowerToHWBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-msft-to-hw");
  }
  ::llvm::StringRef getArgument() const override { return "lower-msft-to-hw"; }

  ::llvm::StringRef getDescription() const override { return "Lower MSFT ops to hw ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerToHW");
  }
  ::llvm::StringRef getName() const override { return "LowerToHW"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerToHWBase<DerivedT>)

  LowerToHWBase(const LowerToHWOptions &options) : LowerToHWBase() {
    verilogFile = options.verilogFile;
  }
protected:
  ::mlir::Pass::Option<std::string> verilogFile{*this, "verilog-file", ::llvm::cl::desc("File to output Verilog into")};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERTOHW
#endif // GEN_PASS_DEF_LOWERTOHW

//===----------------------------------------------------------------------===//
// Partition
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_PARTITION
#undef GEN_PASS_DECL_PARTITION
#endif // GEN_PASS_DECL_PARTITION
#ifdef GEN_PASS_DEF_PARTITION
namespace impl {

template <typename DerivedT>
class PartitionBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PartitionBase;

  PartitionBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PartitionBase(const PartitionBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-partition");
  }
  ::llvm::StringRef getArgument() const override { return "msft-partition"; }

  ::llvm::StringRef getDescription() const override { return "Move the entities targeted for a design partition"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Partition");
  }
  ::llvm::StringRef getName() const override { return "Partition"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PartitionBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_PARTITION
#endif // GEN_PASS_DEF_PARTITION

//===----------------------------------------------------------------------===//
// WireCleanup
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_WIRECLEANUP
#undef GEN_PASS_DECL_WIRECLEANUP
#endif // GEN_PASS_DECL_WIRECLEANUP
#ifdef GEN_PASS_DEF_WIRECLEANUP
namespace impl {

template <typename DerivedT>
class WireCleanupBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = WireCleanupBase;

  WireCleanupBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  WireCleanupBase(const WireCleanupBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-wire-cleanup");
  }
  ::llvm::StringRef getArgument() const override { return "msft-wire-cleanup"; }

  ::llvm::StringRef getDescription() const override { return "Cleanup unnecessary ports and wires"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("WireCleanup");
  }
  ::llvm::StringRef getName() const override { return "WireCleanup"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(WireCleanupBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_WIRECLEANUP
#endif // GEN_PASS_DEF_WIRECLEANUP
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// DiscoverAppIDs Registration
//===----------------------------------------------------------------------===//

inline void registerDiscoverAppIDs() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createDiscoverAppIDsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerDiscoverAppIDsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createDiscoverAppIDsPass();
  });
}

//===----------------------------------------------------------------------===//
// ExportTcl Registration
//===----------------------------------------------------------------------===//

inline void registerExportTcl() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createExportTclPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerExportTclPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createExportTclPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerConstructs Registration
//===----------------------------------------------------------------------===//

inline void registerLowerConstructs() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createLowerConstructsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerConstructsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createLowerConstructsPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerInstances Registration
//===----------------------------------------------------------------------===//

inline void registerLowerInstances() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createLowerInstancesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerInstancesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createLowerInstancesPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerToHW Registration
//===----------------------------------------------------------------------===//

inline void registerLowerToHW() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createLowerToHWPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerToHWPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createLowerToHWPass();
  });
}

//===----------------------------------------------------------------------===//
// Partition Registration
//===----------------------------------------------------------------------===//

inline void registerPartition() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createPartitionPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerPartitionPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createPartitionPass();
  });
}

//===----------------------------------------------------------------------===//
// WireCleanup Registration
//===----------------------------------------------------------------------===//

inline void registerWireCleanup() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createWireCleanupPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerWireCleanupPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::msft::createWireCleanupPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerDiscoverAppIDs();
  registerExportTcl();
  registerLowerConstructs();
  registerLowerInstances();
  registerLowerToHW();
  registerPartition();
  registerWireCleanup();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class DiscoverAppIDsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = DiscoverAppIDsBase;

  DiscoverAppIDsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  DiscoverAppIDsBase(const DiscoverAppIDsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-discover-appids");
  }
  ::llvm::StringRef getArgument() const override { return "msft-discover-appids"; }

  ::llvm::StringRef getDescription() const override { return "Discover the appids in a module hierarchy"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("DiscoverAppIDs");
  }
  ::llvm::StringRef getName() const override { return "DiscoverAppIDs"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(DiscoverAppIDsBase<DerivedT>)

protected:
};

template <typename DerivedT>
class ExportTclBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ExportTclBase;

  ExportTclBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ExportTclBase(const ExportTclBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-export-tcl");
  }
  ::llvm::StringRef getArgument() const override { return "msft-export-tcl"; }

  ::llvm::StringRef getDescription() const override { return "Create tcl ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ExportTcl");
  }
  ::llvm::StringRef getName() const override { return "ExportTcl"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ExportTclBase<DerivedT>)

protected:
  ::mlir::Pass::ListOption<std::string> tops{*this, "tops", ::llvm::cl::desc("List of top modules to export Tcl for"), llvm::cl::ZeroOrMore,};
  ::mlir::Pass::Option<std::string> tclFile{*this, "tcl-file", ::llvm::cl::desc("File to output Tcl into")};
};

template <typename DerivedT>
class LowerConstructsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerConstructsBase;

  LowerConstructsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerConstructsBase(const LowerConstructsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-lower-constructs");
  }
  ::llvm::StringRef getArgument() const override { return "msft-lower-constructs"; }

  ::llvm::StringRef getDescription() const override { return "Lower high-level constructs"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerConstructs");
  }
  ::llvm::StringRef getName() const override { return "LowerConstructs"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerConstructsBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerInstancesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerInstancesBase;

  LowerInstancesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerInstancesBase(const LowerInstancesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-lower-instances");
  }
  ::llvm::StringRef getArgument() const override { return "msft-lower-instances"; }

  ::llvm::StringRef getDescription() const override { return "Lower dynamic instances"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerInstances");
  }
  ::llvm::StringRef getName() const override { return "LowerInstances"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerInstancesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerToHWBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerToHWBase;

  LowerToHWBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerToHWBase(const LowerToHWBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-msft-to-hw");
  }
  ::llvm::StringRef getArgument() const override { return "lower-msft-to-hw"; }

  ::llvm::StringRef getDescription() const override { return "Lower MSFT ops to hw ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerToHW");
  }
  ::llvm::StringRef getName() const override { return "LowerToHW"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerToHWBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> verilogFile{*this, "verilog-file", ::llvm::cl::desc("File to output Verilog into")};
};

template <typename DerivedT>
class PartitionBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PartitionBase;

  PartitionBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PartitionBase(const PartitionBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-partition");
  }
  ::llvm::StringRef getArgument() const override { return "msft-partition"; }

  ::llvm::StringRef getDescription() const override { return "Move the entities targeted for a design partition"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Partition");
  }
  ::llvm::StringRef getName() const override { return "Partition"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PartitionBase<DerivedT>)

protected:
};

template <typename DerivedT>
class WireCleanupBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = WireCleanupBase;

  WireCleanupBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  WireCleanupBase(const WireCleanupBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("msft-wire-cleanup");
  }
  ::llvm::StringRef getArgument() const override { return "msft-wire-cleanup"; }

  ::llvm::StringRef getDescription() const override { return "Cleanup unnecessary ports and wires"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("WireCleanup");
  }
  ::llvm::StringRef getName() const override { return "WireCleanup"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(WireCleanupBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
