/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_EXPLICITREGS
#define GEN_PASS_DECL_SCHEDULELINEARPIPELINE
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// ExplicitRegs
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_EXPLICITREGS
#undef GEN_PASS_DECL_EXPLICITREGS
#endif // GEN_PASS_DECL_EXPLICITREGS
#ifdef GEN_PASS_DEF_EXPLICITREGS
namespace impl {

template <typename DerivedT>
class ExplicitRegsBase : public ::mlir::OperationPass<pipeline::ScheduledPipelineOp> {
public:
  using Base = ExplicitRegsBase;

  ExplicitRegsBase() : ::mlir::OperationPass<pipeline::ScheduledPipelineOp>(::mlir::TypeID::get<DerivedT>()) {}
  ExplicitRegsBase(const ExplicitRegsBase &other) : ::mlir::OperationPass<pipeline::ScheduledPipelineOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("pipeline-explicit-regs");
  }
  ::llvm::StringRef getArgument() const override { return "pipeline-explicit-regs"; }

  ::llvm::StringRef getDescription() const override { return "Makes stage registers explicit."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ExplicitRegs");
  }
  ::llvm::StringRef getName() const override { return "ExplicitRegs"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ExplicitRegsBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_EXPLICITREGS
#endif // GEN_PASS_DEF_EXPLICITREGS

//===----------------------------------------------------------------------===//
// ScheduleLinearPipeline
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_SCHEDULELINEARPIPELINE
#undef GEN_PASS_DECL_SCHEDULELINEARPIPELINE
#endif // GEN_PASS_DECL_SCHEDULELINEARPIPELINE
#ifdef GEN_PASS_DEF_SCHEDULELINEARPIPELINE
namespace impl {

template <typename DerivedT>
class ScheduleLinearPipelineBase : public ::mlir::InterfacePass<circt::hw::HWModuleLike> {
public:
  using Base = ScheduleLinearPipelineBase;

  ScheduleLinearPipelineBase() : ::mlir::InterfacePass<circt::hw::HWModuleLike>(::mlir::TypeID::get<DerivedT>()) {}
  ScheduleLinearPipelineBase(const ScheduleLinearPipelineBase &other) : ::mlir::InterfacePass<circt::hw::HWModuleLike>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("pipeline-schedule-linear");
  }
  ::llvm::StringRef getArgument() const override { return "pipeline-schedule-linear"; }

  ::llvm::StringRef getDescription() const override { return "Schedules `pipeline.unscheduled` operations."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ScheduleLinearPipeline");
  }
  ::llvm::StringRef getName() const override { return "ScheduleLinearPipeline"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ScheduleLinearPipelineBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_SCHEDULELINEARPIPELINE
#endif // GEN_PASS_DEF_SCHEDULELINEARPIPELINE
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ExplicitRegs Registration
//===----------------------------------------------------------------------===//

inline void registerExplicitRegs() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::pipeline::createExplicitRegsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerExplicitRegsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::pipeline::createExplicitRegsPass();
  });
}

//===----------------------------------------------------------------------===//
// ScheduleLinearPipeline Registration
//===----------------------------------------------------------------------===//

inline void registerScheduleLinearPipeline() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::pipeline::createScheduleLinearPipelinePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerScheduleLinearPipelinePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::pipeline::createScheduleLinearPipelinePass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerExplicitRegs();
  registerScheduleLinearPipeline();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class ExplicitRegsBase : public ::mlir::OperationPass<pipeline::ScheduledPipelineOp> {
public:
  using Base = ExplicitRegsBase;

  ExplicitRegsBase() : ::mlir::OperationPass<pipeline::ScheduledPipelineOp>(::mlir::TypeID::get<DerivedT>()) {}
  ExplicitRegsBase(const ExplicitRegsBase &other) : ::mlir::OperationPass<pipeline::ScheduledPipelineOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("pipeline-explicit-regs");
  }
  ::llvm::StringRef getArgument() const override { return "pipeline-explicit-regs"; }

  ::llvm::StringRef getDescription() const override { return "Makes stage registers explicit."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ExplicitRegs");
  }
  ::llvm::StringRef getName() const override { return "ExplicitRegs"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ExplicitRegsBase<DerivedT>)

protected:
};

template <typename DerivedT>
class ScheduleLinearPipelineBase : public ::mlir::InterfacePass<circt::hw::HWModuleLike> {
public:
  using Base = ScheduleLinearPipelineBase;

  ScheduleLinearPipelineBase() : ::mlir::InterfacePass<circt::hw::HWModuleLike>(::mlir::TypeID::get<DerivedT>()) {}
  ScheduleLinearPipelineBase(const ScheduleLinearPipelineBase &other) : ::mlir::InterfacePass<circt::hw::HWModuleLike>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("pipeline-schedule-linear");
  }
  ::llvm::StringRef getArgument() const override { return "pipeline-schedule-linear"; }

  ::llvm::StringRef getDescription() const override { return "Schedules `pipeline.unscheduled` operations."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ScheduleLinearPipeline");
  }
  ::llvm::StringRef getName() const override { return "ScheduleLinearPipeline"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ScheduleLinearPipelineBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
