/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_EXTERNALIZECLOCKGATE
#define GEN_PASS_DECL_LOWERFIRMEM
#define GEN_PASS_DECL_LOWERSEQFIFO
#define GEN_PASS_DECL_LOWERSEQFIRRTLINITTOSV
#define GEN_PASS_DECL_LOWERSEQFIRRTLTOSV
#define GEN_PASS_DECL_LOWERSEQHLMEM
#define GEN_PASS_DECL_LOWERSEQTOSV
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// ExternalizeClockGate
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_EXTERNALIZECLOCKGATE
struct ExternalizeClockGateOptions {
  std::string moduleName = "CKG";
  std::string inputName = "I";
  std::string outputName = "O";
  std::string enableName = "E";
  std::string testEnableName = "TE";
  std::string instName = "ckg";
};
#undef GEN_PASS_DECL_EXTERNALIZECLOCKGATE
#endif // GEN_PASS_DECL_EXTERNALIZECLOCKGATE
#ifdef GEN_PASS_DEF_EXTERNALIZECLOCKGATE
namespace impl {

template <typename DerivedT>
class ExternalizeClockGateBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ExternalizeClockGateBase;

  ExternalizeClockGateBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ExternalizeClockGateBase(const ExternalizeClockGateBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("externalize-clock-gate");
  }
  ::llvm::StringRef getArgument() const override { return "externalize-clock-gate"; }

  ::llvm::StringRef getDescription() const override { return "Convert seq.clock_gate ops into hw.module.extern instances"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ExternalizeClockGate");
  }
  ::llvm::StringRef getName() const override { return "ExternalizeClockGate"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  registry.insert<circt::comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ExternalizeClockGateBase<DerivedT>)

  ExternalizeClockGateBase(const ExternalizeClockGateOptions &options) : ExternalizeClockGateBase() {
    moduleName = options.moduleName;
    inputName = options.inputName;
    outputName = options.outputName;
    enableName = options.enableName;
    testEnableName = options.testEnableName;
    instName = options.instName;
  }
protected:
  ::mlir::Pass::Option<std::string> moduleName{*this, "name", ::llvm::cl::desc("Name of the external clock gate module"), ::llvm::cl::init("CKG")};
  ::mlir::Pass::Option<std::string> inputName{*this, "input", ::llvm::cl::desc("Name of the clock input"), ::llvm::cl::init("I")};
  ::mlir::Pass::Option<std::string> outputName{*this, "output", ::llvm::cl::desc("Name of the gated clock output"), ::llvm::cl::init("O")};
  ::mlir::Pass::Option<std::string> enableName{*this, "enable", ::llvm::cl::desc("Name of the enable input"), ::llvm::cl::init("E")};
  ::mlir::Pass::Option<std::string> testEnableName{*this, "test-enable", ::llvm::cl::desc("Name of the optional test enable input"), ::llvm::cl::init("TE")};
  ::mlir::Pass::Option<std::string> instName{*this, "instance-name", ::llvm::cl::desc("Name of the generated instances"), ::llvm::cl::init("ckg")};
  ::mlir::Pass::Statistic numClockGatesConverted{this, "num-clock-gates-converted", "Number of clock gates converted to external module instances"};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_EXTERNALIZECLOCKGATE
#endif // GEN_PASS_DEF_EXTERNALIZECLOCKGATE

//===----------------------------------------------------------------------===//
// LowerFirMem
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERFIRMEM
#undef GEN_PASS_DECL_LOWERFIRMEM
#endif // GEN_PASS_DECL_LOWERFIRMEM
#ifdef GEN_PASS_DEF_LOWERFIRMEM
namespace impl {

template <typename DerivedT>
class LowerFirMemBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerFirMemBase;

  LowerFirMemBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerFirMemBase(const LowerFirMemBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-firmem");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-firmem"; }

  ::llvm::StringRef getDescription() const override { return "Lower seq.firmem ops to instances of hw.module.generated ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerFirMem");
  }
  ::llvm::StringRef getName() const override { return "LowerFirMem"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerFirMemBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERFIRMEM
#endif // GEN_PASS_DEF_LOWERFIRMEM

//===----------------------------------------------------------------------===//
// LowerSeqFIFO
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERSEQFIFO
#undef GEN_PASS_DECL_LOWERSEQFIFO
#endif // GEN_PASS_DECL_LOWERSEQFIFO
#ifdef GEN_PASS_DEF_LOWERSEQFIFO
namespace impl {

template <typename DerivedT>
class LowerSeqFIFOBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqFIFOBase;

  LowerSeqFIFOBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqFIFOBase(const LowerSeqFIFOBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-fifo");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-fifo"; }

  ::llvm::StringRef getDescription() const override { return "Lower seq.fifo ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqFIFO");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqFIFO"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  registry.insert<circt::comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqFIFOBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERSEQFIFO
#endif // GEN_PASS_DEF_LOWERSEQFIFO

//===----------------------------------------------------------------------===//
// LowerSeqFIRRTLInitToSV
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERSEQFIRRTLINITTOSV
#undef GEN_PASS_DECL_LOWERSEQFIRRTLINITTOSV
#endif // GEN_PASS_DECL_LOWERSEQFIRRTLINITTOSV
#ifdef GEN_PASS_DEF_LOWERSEQFIRRTLINITTOSV
namespace impl {

template <typename DerivedT>
class LowerSeqFIRRTLInitToSVBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerSeqFIRRTLInitToSVBase;

  LowerSeqFIRRTLInitToSVBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqFIRRTLInitToSVBase(const LowerSeqFIRRTLInitToSVBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-firrtl-init-to-sv");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-firrtl-init-to-sv"; }

  ::llvm::StringRef getDescription() const override { return "Prep the module with macro definitions for firrtl registers."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqFIRRTLInitToSV");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqFIRRTLInitToSV"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqFIRRTLInitToSVBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERSEQFIRRTLINITTOSV
#endif // GEN_PASS_DEF_LOWERSEQFIRRTLINITTOSV

//===----------------------------------------------------------------------===//
// LowerSeqFIRRTLToSV
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERSEQFIRRTLTOSV
struct LowerSeqFIRRTLToSVOptions {
  bool disableRegRandomization = false;
  bool emitSeparateAlwaysBlocks = false;
};
#undef GEN_PASS_DECL_LOWERSEQFIRRTLTOSV
#endif // GEN_PASS_DECL_LOWERSEQFIRRTLTOSV
#ifdef GEN_PASS_DEF_LOWERSEQFIRRTLTOSV
namespace impl {

template <typename DerivedT>
class LowerSeqFIRRTLToSVBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqFIRRTLToSVBase;

  LowerSeqFIRRTLToSVBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqFIRRTLToSVBase(const LowerSeqFIRRTLToSVBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-firrtl-to-sv");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-firrtl-to-sv"; }

  ::llvm::StringRef getDescription() const override { return "Lower sequential firrtl ops to SV."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqFIRRTLToSV");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqFIRRTLToSV"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqFIRRTLToSVBase<DerivedT>)

  LowerSeqFIRRTLToSVBase(const LowerSeqFIRRTLToSVOptions &options) : LowerSeqFIRRTLToSVBase() {
    disableRegRandomization = options.disableRegRandomization;
    emitSeparateAlwaysBlocks = options.emitSeparateAlwaysBlocks;
  }
protected:
  ::mlir::Pass::Option<bool> disableRegRandomization{*this, "disable-reg-randomization", ::llvm::cl::desc("Disable emission of register randomization code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> emitSeparateAlwaysBlocks{*this, "emit-separate-always-blocks", ::llvm::cl::desc("Emit assigments to registers in separate always blocks"), ::llvm::cl::init(false)};
  ::mlir::Pass::Statistic numSubaccessRestored{this, "num-subaccess-restored", "Number of lhs subaccess operations restored "};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERSEQFIRRTLTOSV
#endif // GEN_PASS_DEF_LOWERSEQFIRRTLTOSV

//===----------------------------------------------------------------------===//
// LowerSeqHLMem
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERSEQHLMEM
#undef GEN_PASS_DECL_LOWERSEQHLMEM
#endif // GEN_PASS_DECL_LOWERSEQHLMEM
#ifdef GEN_PASS_DEF_LOWERSEQHLMEM
namespace impl {

template <typename DerivedT>
class LowerSeqHLMemBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqHLMemBase;

  LowerSeqHLMemBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqHLMemBase(const LowerSeqHLMemBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-hlmem");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-hlmem"; }

  ::llvm::StringRef getDescription() const override { return "Lowers seq.hlmem operations."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqHLMem");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqHLMem"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqHLMemBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERSEQHLMEM
#endif // GEN_PASS_DEF_LOWERSEQHLMEM

//===----------------------------------------------------------------------===//
// LowerSeqToSV
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERSEQTOSV
struct LowerSeqToSVOptions {
  bool lowerToAlwaysFF = true;
};
#undef GEN_PASS_DECL_LOWERSEQTOSV
#endif // GEN_PASS_DECL_LOWERSEQTOSV
#ifdef GEN_PASS_DEF_LOWERSEQTOSV
namespace impl {

template <typename DerivedT>
class LowerSeqToSVBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerSeqToSVBase;

  LowerSeqToSVBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqToSVBase(const LowerSeqToSVBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-to-sv");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-to-sv"; }

  ::llvm::StringRef getDescription() const override { return "Lower sequential ops to SV."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqToSV");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqToSV"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqToSVBase<DerivedT>)

  LowerSeqToSVBase(const LowerSeqToSVOptions &options) : LowerSeqToSVBase() {
    lowerToAlwaysFF = options.lowerToAlwaysFF;
  }
protected:
  ::mlir::Pass::Option<bool> lowerToAlwaysFF{*this, "lower-to-always-ff", ::llvm::cl::desc("Place assignments to registers into `always_ff` blocks"), ::llvm::cl::init(true)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERSEQTOSV
#endif // GEN_PASS_DEF_LOWERSEQTOSV
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ExternalizeClockGate Registration
//===----------------------------------------------------------------------===//

inline void registerExternalizeClockGate() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createExternalizeClockGatePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerExternalizeClockGatePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createExternalizeClockGatePass();
  });
}

//===----------------------------------------------------------------------===//
// LowerFirMem Registration
//===----------------------------------------------------------------------===//

inline void registerLowerFirMem() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerFirMemPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerFirMemPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerFirMemPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerSeqFIFO Registration
//===----------------------------------------------------------------------===//

inline void registerLowerSeqFIFO() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqFIFOPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerSeqFIFOPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqFIFOPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerSeqFIRRTLInitToSV Registration
//===----------------------------------------------------------------------===//

inline void registerLowerSeqFIRRTLInitToSV() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqFIRRTLInitToSV();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerSeqFIRRTLInitToSVPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqFIRRTLInitToSV();
  });
}

//===----------------------------------------------------------------------===//
// LowerSeqFIRRTLToSV Registration
//===----------------------------------------------------------------------===//

inline void registerLowerSeqFIRRTLToSV() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createSeqFIRRTLLowerToSVPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerSeqFIRRTLToSVPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createSeqFIRRTLLowerToSVPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerSeqHLMem Registration
//===----------------------------------------------------------------------===//

inline void registerLowerSeqHLMem() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqHLMemPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerSeqHLMemPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqHLMemPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerSeqToSV Registration
//===----------------------------------------------------------------------===//

inline void registerLowerSeqToSV() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createSeqLowerToSVPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerSeqToSVPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createSeqLowerToSVPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerExternalizeClockGate();
  registerLowerFirMem();
  registerLowerSeqFIFO();
  registerLowerSeqFIRRTLInitToSV();
  registerLowerSeqFIRRTLToSV();
  registerLowerSeqHLMem();
  registerLowerSeqToSV();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class ExternalizeClockGateBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ExternalizeClockGateBase;

  ExternalizeClockGateBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ExternalizeClockGateBase(const ExternalizeClockGateBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("externalize-clock-gate");
  }
  ::llvm::StringRef getArgument() const override { return "externalize-clock-gate"; }

  ::llvm::StringRef getDescription() const override { return "Convert seq.clock_gate ops into hw.module.extern instances"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ExternalizeClockGate");
  }
  ::llvm::StringRef getName() const override { return "ExternalizeClockGate"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  registry.insert<circt::comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ExternalizeClockGateBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> moduleName{*this, "name", ::llvm::cl::desc("Name of the external clock gate module"), ::llvm::cl::init("CKG")};
  ::mlir::Pass::Option<std::string> inputName{*this, "input", ::llvm::cl::desc("Name of the clock input"), ::llvm::cl::init("I")};
  ::mlir::Pass::Option<std::string> outputName{*this, "output", ::llvm::cl::desc("Name of the gated clock output"), ::llvm::cl::init("O")};
  ::mlir::Pass::Option<std::string> enableName{*this, "enable", ::llvm::cl::desc("Name of the enable input"), ::llvm::cl::init("E")};
  ::mlir::Pass::Option<std::string> testEnableName{*this, "test-enable", ::llvm::cl::desc("Name of the optional test enable input"), ::llvm::cl::init("TE")};
  ::mlir::Pass::Option<std::string> instName{*this, "instance-name", ::llvm::cl::desc("Name of the generated instances"), ::llvm::cl::init("ckg")};
  ::mlir::Pass::Statistic numClockGatesConverted{this, "num-clock-gates-converted", "Number of clock gates converted to external module instances"};
};

template <typename DerivedT>
class LowerFirMemBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerFirMemBase;

  LowerFirMemBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerFirMemBase(const LowerFirMemBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-firmem");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-firmem"; }

  ::llvm::StringRef getDescription() const override { return "Lower seq.firmem ops to instances of hw.module.generated ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerFirMem");
  }
  ::llvm::StringRef getName() const override { return "LowerFirMem"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerFirMemBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerSeqFIFOBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqFIFOBase;

  LowerSeqFIFOBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqFIFOBase(const LowerSeqFIFOBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-fifo");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-fifo"; }

  ::llvm::StringRef getDescription() const override { return "Lower seq.fifo ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqFIFO");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqFIFO"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::hw::HWDialect>();

  registry.insert<circt::comb::CombDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqFIFOBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerSeqFIRRTLInitToSVBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerSeqFIRRTLInitToSVBase;

  LowerSeqFIRRTLInitToSVBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqFIRRTLInitToSVBase(const LowerSeqFIRRTLInitToSVBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-firrtl-init-to-sv");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-firrtl-init-to-sv"; }

  ::llvm::StringRef getDescription() const override { return "Prep the module with macro definitions for firrtl registers."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqFIRRTLInitToSV");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqFIRRTLInitToSV"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqFIRRTLInitToSVBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerSeqFIRRTLToSVBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqFIRRTLToSVBase;

  LowerSeqFIRRTLToSVBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqFIRRTLToSVBase(const LowerSeqFIRRTLToSVBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-firrtl-to-sv");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-firrtl-to-sv"; }

  ::llvm::StringRef getDescription() const override { return "Lower sequential firrtl ops to SV."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqFIRRTLToSV");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqFIRRTLToSV"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqFIRRTLToSVBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> disableRegRandomization{*this, "disable-reg-randomization", ::llvm::cl::desc("Disable emission of register randomization code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> emitSeparateAlwaysBlocks{*this, "emit-separate-always-blocks", ::llvm::cl::desc("Emit assigments to registers in separate always blocks"), ::llvm::cl::init(false)};
  ::mlir::Pass::Statistic numSubaccessRestored{this, "num-subaccess-restored", "Number of lhs subaccess operations restored "};
};

template <typename DerivedT>
class LowerSeqHLMemBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqHLMemBase;

  LowerSeqHLMemBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqHLMemBase(const LowerSeqHLMemBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-hlmem");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-hlmem"; }

  ::llvm::StringRef getDescription() const override { return "Lowers seq.hlmem operations."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqHLMem");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqHLMem"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqHLMemBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerSeqToSVBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerSeqToSVBase;

  LowerSeqToSVBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqToSVBase(const LowerSeqToSVBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-to-sv");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-to-sv"; }

  ::llvm::StringRef getDescription() const override { return "Lower sequential ops to SV."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqToSV");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqToSV"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<circt::sv::SVDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqToSVBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> lowerToAlwaysFF{*this, "lower-to-always-ff", ::llvm::cl::desc("Place assignments to registers into `always_ff` blocks"), ::llvm::cl::init(true)};
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
