/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Op Definitions                                                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_OP_LIST
#undef GET_OP_LIST

::circt::esi::CapnpDecodeOp,
::circt::esi::CapnpEncodeOp,
::circt::esi::ChannelBufferOp,
::circt::esi::CosimEndpointOp,
::circt::esi::CustomServiceDeclOp,
::circt::esi::ESIPureModuleInputOp,
::circt::esi::ESIPureModuleOp,
::circt::esi::ESIPureModuleOutputOp,
::circt::esi::ESIPureModuleParamOp,
::circt::esi::NullSourceOp,
::circt::esi::PipelineStageOp,
::circt::esi::RandomAccessMemoryDeclOp,
::circt::esi::RequestInOutChannelOp,
::circt::esi::RequestToClientConnectionOp,
::circt::esi::RequestToServerConnectionOp,
::circt::esi::ServiceDeclInOutOp,
::circt::esi::ServiceHierarchyMetadataOp,
::circt::esi::ServiceImplementReqOp,
::circt::esi::ServiceInstanceOp,
::circt::esi::ToClientOp,
::circt::esi::ToServerOp,
::circt::esi::UnwrapFIFOOp,
::circt::esi::UnwrapSVInterfaceOp,
::circt::esi::UnwrapValidReadyOp,
::circt::esi::UnwrapWindow,
::circt::esi::WrapFIFOOp,
::circt::esi::WrapSVInterfaceOp,
::circt::esi::WrapValidReadyOp,
::circt::esi::WrapWindow
#endif  // GET_OP_LIST

#ifdef GET_OP_CLASSES
#undef GET_OP_CLASSES


//===----------------------------------------------------------------------===//
// Local Utility Method Definitions
//===----------------------------------------------------------------------===//

namespace circt {
namespace esi {

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_ESI0(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((type.isSignlessInteger(1)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be 1-bit signless integer, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_ESI1(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((type.isa<::circt::hw::ArrayType>() && type.cast<::circt::hw::ArrayType>().getElementType() ==   ::mlir::IntegerType::get(type.getContext(), 1)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be an HW bit array, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_ESI2(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((true))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be any type, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_ESI3(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::llvm::isa<::circt::esi::ChannelType>(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be An ESI-compatible channel port, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_ESI4(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((type.isa<::circt::sv::ModportType>()))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be sv.interface, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_ESI5(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::llvm::isa<::circt::esi::WindowType>(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be a data window, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_ESI6(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::circt::hw::type_isa<circt::hw::UnionType>(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be a UnionType, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI0(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() >= 1))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 1";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI0(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_ESI0(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI1(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::mlir::StringAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: string attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI1(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_ESI1(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI2(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::TypeAttr>(attr))) && ((::llvm::isa<::mlir::Type>(::llvm::cast<::mlir::TypeAttr>(attr).getValue()))) && ((true))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: any type attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI2(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_ESI2(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI3(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(64)))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: 64-bit signless integer attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI3(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_ESI3(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI4(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::circt::hw::InnerRefAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: Refer to a name inside a module";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI4(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_ESI4(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI5(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::ArrayAttr>(attr))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(attr), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: string array attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI5(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_ESI5(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI6(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: flat symbol reference attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI6(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_ESI6(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI7(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::mlir::ArrayAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: array attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI7(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_ESI7(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI8(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::mlir::DictionaryAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: dictionary of named attribute values";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_ESI8(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_ESI8(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_region_constraint_ESI0(
    ::mlir::Operation *op, ::mlir::Region &region, ::llvm::StringRef regionName,
    unsigned regionIndex) {
  if (!((::llvm::hasNItems(region, 1)))) {
    return op->emitOpError("region #") << regionIndex
        << (regionName.empty() ? " " : " ('" + regionName + "') ")
        << "failed to verify constraint: region with 1 blocks";
  }
  return ::mlir::success();
}
} // namespace esi
} // namespace circt
namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::CapnpDecodeOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
CapnpDecodeOpGenericAdaptorBase::CapnpDecodeOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.decode.capnp", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> CapnpDecodeOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr CapnpDecodeOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
CapnpDecodeOpAdaptor::CapnpDecodeOpAdaptor(CapnpDecodeOp op) : CapnpDecodeOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult CapnpDecodeOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> CapnpDecodeOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range CapnpDecodeOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> CapnpDecodeOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> CapnpDecodeOp::getValid() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::Value CapnpDecodeOp::getCapnpBits() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(2).begin());
}

::mlir::MutableOperandRange CapnpDecodeOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CapnpDecodeOp::getValidMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CapnpDecodeOp::getCapnpBitsMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> CapnpDecodeOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range CapnpDecodeOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value CapnpDecodeOp::getDecodedData() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

void CapnpDecodeOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type decodedData, ::mlir::Value clk, ::mlir::Value valid, ::mlir::Value capnpBits) {
  odsState.addOperands(clk);
  odsState.addOperands(valid);
  odsState.addOperands(capnpBits);
  odsState.addTypes(decodedData);
}

void CapnpDecodeOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clk, ::mlir::Value valid, ::mlir::Value capnpBits) {
  odsState.addOperands(clk);
  odsState.addOperands(valid);
  odsState.addOperands(capnpBits);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CapnpDecodeOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult CapnpDecodeOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult CapnpDecodeOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult CapnpDecodeOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand validRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> validOperands(validRawOperands);  ::llvm::SMLoc validOperandsLoc;
  (void)validOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand capnpBitsRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> capnpBitsOperands(capnpBitsRawOperands);  ::llvm::SMLoc capnpBitsOperandsLoc;
  (void)capnpBitsOperandsLoc;
  ::mlir::Type capnpBitsRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> capnpBitsTypes(capnpBitsRawTypes);
  ::mlir::Type decodedDataRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> decodedDataTypes(decodedDataRawTypes);

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();

  validOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(validRawOperands[0]))
    return ::mlir::failure();

  capnpBitsOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(capnpBitsRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseType(capnpBitsRawTypes[0]))
    return ::mlir::failure();
  if (parser.parseArrow())
    return ::mlir::failure();

  if (parser.parseType(decodedDataRawTypes[0]))
    return ::mlir::failure();
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  result.addTypes(decodedDataTypes);
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(validOperands, odsBuildableType0, validOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(capnpBitsOperands, capnpBitsTypes, capnpBitsOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void CapnpDecodeOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  _odsPrinter << ' ';
  _odsPrinter << getValid();
  _odsPrinter << ' ';
  _odsPrinter << getCapnpBits();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
   _odsPrinter << getCapnpBits().getType();
  _odsPrinter << ' ' << "->";
  _odsPrinter << ' ';
   _odsPrinter << getDecodedData().getType();
}

void CapnpDecodeOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::CapnpDecodeOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::CapnpEncodeOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
CapnpEncodeOpGenericAdaptorBase::CapnpEncodeOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.encode.capnp", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> CapnpEncodeOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr CapnpEncodeOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
CapnpEncodeOpAdaptor::CapnpEncodeOpAdaptor(CapnpEncodeOp op) : CapnpEncodeOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult CapnpEncodeOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> CapnpEncodeOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range CapnpEncodeOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> CapnpEncodeOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> CapnpEncodeOp::getValid() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::Value CapnpEncodeOp::getDataToEncode() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(2).begin());
}

::mlir::MutableOperandRange CapnpEncodeOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CapnpEncodeOp::getValidMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CapnpEncodeOp::getDataToEncodeMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> CapnpEncodeOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range CapnpEncodeOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value CapnpEncodeOp::getCapnpBits() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

void CapnpEncodeOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type capnpBits, ::mlir::Value clk, ::mlir::Value valid, ::mlir::Value dataToEncode) {
  odsState.addOperands(clk);
  odsState.addOperands(valid);
  odsState.addOperands(dataToEncode);
  odsState.addTypes(capnpBits);
}

void CapnpEncodeOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clk, ::mlir::Value valid, ::mlir::Value dataToEncode) {
  odsState.addOperands(clk);
  odsState.addOperands(valid);
  odsState.addOperands(dataToEncode);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CapnpEncodeOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult CapnpEncodeOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult CapnpEncodeOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult CapnpEncodeOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand validRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> validOperands(validRawOperands);  ::llvm::SMLoc validOperandsLoc;
  (void)validOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand dataToEncodeRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> dataToEncodeOperands(dataToEncodeRawOperands);  ::llvm::SMLoc dataToEncodeOperandsLoc;
  (void)dataToEncodeOperandsLoc;
  ::mlir::Type dataToEncodeRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> dataToEncodeTypes(dataToEncodeRawTypes);
  ::mlir::Type capnpBitsRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> capnpBitsTypes(capnpBitsRawTypes);

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();

  validOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(validRawOperands[0]))
    return ::mlir::failure();

  dataToEncodeOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(dataToEncodeRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseType(dataToEncodeRawTypes[0]))
    return ::mlir::failure();
  if (parser.parseArrow())
    return ::mlir::failure();

  if (parser.parseType(capnpBitsRawTypes[0]))
    return ::mlir::failure();
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  result.addTypes(capnpBitsTypes);
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(validOperands, odsBuildableType0, validOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(dataToEncodeOperands, dataToEncodeTypes, dataToEncodeOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void CapnpEncodeOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  _odsPrinter << ' ';
  _odsPrinter << getValid();
  _odsPrinter << ' ';
  _odsPrinter << getDataToEncode();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
   _odsPrinter << getDataToEncode().getType();
  _odsPrinter << ' ' << "->";
  _odsPrinter << ' ';
   _odsPrinter << getCapnpBits().getType();
}

void CapnpEncodeOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::CapnpEncodeOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::ChannelBufferOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ChannelBufferOpGenericAdaptorBase::ChannelBufferOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.buffer", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ChannelBufferOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ChannelBufferOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr ChannelBufferOpGenericAdaptorBase::getStagesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, ChannelBufferOp::getStagesAttrName(*odsOpName)));
  return attr;
}

::std::optional<uint64_t> ChannelBufferOpGenericAdaptorBase::getStages() {
  auto attr = getStagesAttr();
  return attr ? ::std::optional<uint64_t>(attr.getValue().getZExtValue()) : (::std::nullopt);
}

::mlir::StringAttr ChannelBufferOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, ChannelBufferOp::getNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > ChannelBufferOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

} // namespace detail
ChannelBufferOpAdaptor::ChannelBufferOpAdaptor(ChannelBufferOp op) : ChannelBufferOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ChannelBufferOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;
  ::mlir::Attribute tblgen_stages;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == ChannelBufferOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == ChannelBufferOp::getStagesAttrName(*odsOpName)) {
      tblgen_stages = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_stages && !((((::llvm::isa<::mlir::IntegerAttr>(tblgen_stages))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_stages).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_stages).getInt() >= 1))))
    return emitError(loc, "'esi.buffer' op ""attribute 'stages' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 1");

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'esi.buffer' op ""attribute 'name' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ChannelBufferOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ChannelBufferOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> ChannelBufferOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> ChannelBufferOp::getRst() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::circt::esi::ChannelType> ChannelBufferOp::getInput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSOperands(2).begin());
}

::mlir::MutableOperandRange ChannelBufferOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange ChannelBufferOp::getRstMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange ChannelBufferOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> ChannelBufferOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ChannelBufferOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> ChannelBufferOp::getOutput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSResults(0).begin());
}

::mlir::IntegerAttr ChannelBufferOp::getStagesAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getStagesAttrName()));
}

::std::optional<uint64_t> ChannelBufferOp::getStages() {
  auto attr = getStagesAttr();
  return attr ? ::std::optional<uint64_t>(attr.getValue().getZExtValue()) : (::std::nullopt);
}

::mlir::StringAttr ChannelBufferOp::getNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getNameAttrName()));
}

::std::optional< ::llvm::StringRef > ChannelBufferOp::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

void ChannelBufferOp::setStagesAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getStagesAttrName(), attr);
}

void ChannelBufferOp::setStages(::std::optional<uint64_t> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getStagesAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), *attrValue));
    (*this)->removeAttr(getStagesAttrName());
}

void ChannelBufferOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void ChannelBufferOp::setName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getNameAttrName());
}

::mlir::Attribute ChannelBufferOp::removeStagesAttr() {
return (*this)->removeAttr(getStagesAttrName());
}

::mlir::Attribute ChannelBufferOp::removeNameAttr() {
return (*this)->removeAttr(getNameAttrName());
}

void ChannelBufferOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Value clk, ::mlir::Value rst, ::mlir::Value input, /*optional*/::mlir::IntegerAttr stages, /*optional*/::mlir::StringAttr name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addOperands(input);
  if (stages) {
    odsState.addAttribute(getStagesAttrName(odsState.name), stages);
  }
  if (name) {
    odsState.addAttribute(getNameAttrName(odsState.name), name);
  }
  odsState.addTypes(output);
}

void ChannelBufferOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clk, ::mlir::Value rst, ::mlir::Value input, /*optional*/::mlir::IntegerAttr stages, /*optional*/::mlir::StringAttr name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addOperands(input);
  if (stages) {
    odsState.addAttribute(getStagesAttrName(odsState.name), stages);
  }
  if (name) {
    odsState.addAttribute(getNameAttrName(odsState.name), name);
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ChannelBufferOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ChannelBufferOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;
  ::mlir::Attribute tblgen_stages;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getStagesAttrName()) {
      tblgen_stages = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI0(*this, tblgen_stages, "stages")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_name, "name")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ChannelBufferOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

void ChannelBufferOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::ChannelBufferOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::CosimEndpointOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
CosimEndpointOpGenericAdaptorBase::CosimEndpointOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.cosim", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> CosimEndpointOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr CosimEndpointOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr CosimEndpointOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, CosimEndpointOp::getNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef CosimEndpointOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

} // namespace detail
CosimEndpointOpAdaptor::CosimEndpointOpAdaptor(CosimEndpointOp op) : CosimEndpointOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult CosimEndpointOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.cosim' op ""requires attribute 'name'");
    if (namedAttrIt->getName() == CosimEndpointOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'esi.cosim' op ""attribute 'name' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> CosimEndpointOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range CosimEndpointOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> CosimEndpointOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> CosimEndpointOp::getRst() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::circt::esi::ChannelType> CosimEndpointOp::getSend() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSOperands(2).begin());
}

::mlir::MutableOperandRange CosimEndpointOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CosimEndpointOp::getRstMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CosimEndpointOp::getSendMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> CosimEndpointOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range CosimEndpointOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> CosimEndpointOp::getRecv() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSResults(0).begin());
}

::mlir::StringAttr CosimEndpointOp::getNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getNameAttrName()));
}

::llvm::StringRef CosimEndpointOp::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

void CosimEndpointOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void CosimEndpointOp::setName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void CosimEndpointOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type recv, ::mlir::Value clk, ::mlir::Value rst, ::mlir::Value send, ::mlir::StringAttr name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addOperands(send);
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  odsState.addTypes(recv);
}

void CosimEndpointOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clk, ::mlir::Value rst, ::mlir::Value send, ::mlir::StringAttr name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addOperands(send);
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CosimEndpointOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type recv, ::mlir::Value clk, ::mlir::Value rst, ::mlir::Value send, ::llvm::StringRef name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addOperands(send);
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  odsState.addTypes(recv);
}

void CosimEndpointOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clk, ::mlir::Value rst, ::mlir::Value send, ::llvm::StringRef name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addOperands(send);
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CosimEndpointOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult CosimEndpointOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'name'");
    if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_name, "name")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult CosimEndpointOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult CosimEndpointOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand rstRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> rstOperands(rstRawOperands);  ::llvm::SMLoc rstOperandsLoc;
  (void)rstOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand sendRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> sendOperands(sendRawOperands);  ::llvm::SMLoc sendOperandsLoc;
  (void)sendOperandsLoc;
  ::mlir::StringAttr nameAttr;
  ::mlir::Type sendRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> sendTypes(sendRawTypes);
  ::mlir::Type recvRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> recvTypes(recvRawTypes);

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  rstOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(rstRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  sendOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(sendRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(nameAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (nameAttr) result.attributes.append("name", nameAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseType(sendRawTypes[0]))
    return ::mlir::failure();
  if (parser.parseArrow())
    return ::mlir::failure();

  if (parser.parseType(recvRawTypes[0]))
    return ::mlir::failure();
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  result.addTypes(recvTypes);
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(rstOperands, odsBuildableType0, rstOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(sendOperands, sendTypes, sendOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void CosimEndpointOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getRst();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getSend();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getNameAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("name");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
   _odsPrinter << getSend().getType();
  _odsPrinter << ' ' << "->";
  _odsPrinter << ' ';
   _odsPrinter << getRecv().getType();
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::CosimEndpointOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::CustomServiceDeclOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
CustomServiceDeclOpGenericAdaptorBase::CustomServiceDeclOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.service.decl", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> CustomServiceDeclOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr CustomServiceDeclOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr CustomServiceDeclOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, CustomServiceDeclOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef CustomServiceDeclOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::Region &CustomServiceDeclOpGenericAdaptorBase::getPorts() {
  return *odsRegions[0];
}

::mlir::RegionRange CustomServiceDeclOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
CustomServiceDeclOpAdaptor::CustomServiceDeclOpAdaptor(CustomServiceDeclOp op) : CustomServiceDeclOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult CustomServiceDeclOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.decl' op ""requires attribute 'sym_name'");
    if (namedAttrIt->getName() == CustomServiceDeclOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'esi.service.decl' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> CustomServiceDeclOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range CustomServiceDeclOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> CustomServiceDeclOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range CustomServiceDeclOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Region &CustomServiceDeclOp::getPorts() {
  return (*this)->getRegion(0);
}

::mlir::StringAttr CustomServiceDeclOp::getSymNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::llvm::StringRef CustomServiceDeclOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

void CustomServiceDeclOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void CustomServiceDeclOp::setSymName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void CustomServiceDeclOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr sym_name) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  (void)odsState.addRegion();
}

void CustomServiceDeclOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr sym_name) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  (void)odsState.addRegion();
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CustomServiceDeclOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef sym_name) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  (void)odsState.addRegion();
}

void CustomServiceDeclOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef sym_name) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  (void)odsState.addRegion();
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CustomServiceDeclOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  for (unsigned i = 0; i != 1; ++i)
    (void)odsState.addRegion();
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult CustomServiceDeclOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'sym_name'");
    if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_ESI0(*this, region, "ports", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult CustomServiceDeclOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult CustomServiceDeclOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  std::unique_ptr<::mlir::Region> portsRegion = std::make_unique<::mlir::Region>();

  if (parser.parseSymbolName(sym_nameAttr))
    return ::mlir::failure();
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);

  if (parser.parseRegion(*portsRegion))
    return ::mlir::failure();

  if (portsRegion->empty()) portsRegion->emplaceBlock();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  result.addRegion(std::move(portsRegion));
  return ::mlir::success();
}

void CustomServiceDeclOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  _odsPrinter << ' ';
  _odsPrinter.printRegion(getPorts());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::CustomServiceDeclOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::ESIPureModuleInputOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ESIPureModuleInputOpGenericAdaptorBase::ESIPureModuleInputOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.pure_module.input", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ESIPureModuleInputOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ESIPureModuleInputOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr ESIPureModuleInputOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, ESIPureModuleInputOp::getNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef ESIPureModuleInputOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

} // namespace detail
ESIPureModuleInputOpAdaptor::ESIPureModuleInputOpAdaptor(ESIPureModuleInputOp op) : ESIPureModuleInputOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ESIPureModuleInputOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.pure_module.input' op ""requires attribute 'name'");
    if (namedAttrIt->getName() == ESIPureModuleInputOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'esi.pure_module.input' op ""attribute 'name' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ESIPureModuleInputOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ESIPureModuleInputOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> ESIPureModuleInputOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ESIPureModuleInputOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value ESIPureModuleInputOp::getValue() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::StringAttr ESIPureModuleInputOp::getNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getNameAttrName()));
}

::llvm::StringRef ESIPureModuleInputOp::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

void ESIPureModuleInputOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void ESIPureModuleInputOp::setName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void ESIPureModuleInputOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type value, ::mlir::StringAttr name) {
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  odsState.addTypes(value);
}

void ESIPureModuleInputOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr name) {
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ESIPureModuleInputOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type value, ::llvm::StringRef name) {
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  odsState.addTypes(value);
}

void ESIPureModuleInputOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef name) {
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ESIPureModuleInputOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ESIPureModuleInputOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'name'");
    if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_name, "name")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ESIPureModuleInputOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult ESIPureModuleInputOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr nameAttr;
  ::mlir::Type valueRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> valueTypes(valueRawTypes);

  if (parser.parseCustomAttributeWithFallback(nameAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (nameAttr) result.attributes.append("name", nameAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::mlir::Type type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    valueRawTypes[0] = type;
  }
  result.addTypes(valueTypes);
  return ::mlir::success();
}

void ESIPureModuleInputOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getNameAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("name");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getValue().getType();
    if (auto validType = ::llvm::dyn_cast<::mlir::Type>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::ESIPureModuleInputOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::ESIPureModuleOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ESIPureModuleOpGenericAdaptorBase::ESIPureModuleOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.pure_module", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ESIPureModuleOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ESIPureModuleOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr ESIPureModuleOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, ESIPureModuleOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef ESIPureModuleOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::Region &ESIPureModuleOpGenericAdaptorBase::getBody() {
  return *odsRegions[0];
}

::mlir::RegionRange ESIPureModuleOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
ESIPureModuleOpAdaptor::ESIPureModuleOpAdaptor(ESIPureModuleOp op) : ESIPureModuleOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ESIPureModuleOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.pure_module' op ""requires attribute 'sym_name'");
    if (namedAttrIt->getName() == ESIPureModuleOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'esi.pure_module' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ESIPureModuleOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ESIPureModuleOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> ESIPureModuleOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ESIPureModuleOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Region &ESIPureModuleOp::getBody() {
  return (*this)->getRegion(0);
}

::mlir::StringAttr ESIPureModuleOp::getSymNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::llvm::StringRef ESIPureModuleOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

void ESIPureModuleOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void ESIPureModuleOp::setSymName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void ESIPureModuleOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr sym_name) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  (void)odsState.addRegion();
}

void ESIPureModuleOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr sym_name) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  (void)odsState.addRegion();
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ESIPureModuleOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef sym_name) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  (void)odsState.addRegion();
}

void ESIPureModuleOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef sym_name) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  (void)odsState.addRegion();
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ESIPureModuleOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  for (unsigned i = 0; i != 1; ++i)
    (void)odsState.addRegion();
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ESIPureModuleOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'sym_name'");
    if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_ESI0(*this, region, "body", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult ESIPureModuleOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult ESIPureModuleOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  std::unique_ptr<::mlir::Region> bodyRegion = std::make_unique<::mlir::Region>();

  if (parser.parseSymbolName(sym_nameAttr))
    return ::mlir::failure();
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDictWithKeyword(result.attributes))
      return ::mlir::failure();
  }

  if (parser.parseRegion(*bodyRegion))
    return ::mlir::failure();

  if (bodyRegion->empty()) bodyRegion->emplaceBlock();
  result.addRegion(std::move(bodyRegion));
  return ::mlir::success();
}

void ESIPureModuleOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  _odsPrinter.printOptionalAttrDictWithKeyword((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ';
  _odsPrinter.printRegion(getBody());
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::ESIPureModuleOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::ESIPureModuleOutputOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ESIPureModuleOutputOpGenericAdaptorBase::ESIPureModuleOutputOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.pure_module.output", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ESIPureModuleOutputOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ESIPureModuleOutputOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr ESIPureModuleOutputOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, ESIPureModuleOutputOp::getNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef ESIPureModuleOutputOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

} // namespace detail
ESIPureModuleOutputOpAdaptor::ESIPureModuleOutputOpAdaptor(ESIPureModuleOutputOp op) : ESIPureModuleOutputOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ESIPureModuleOutputOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.pure_module.output' op ""requires attribute 'name'");
    if (namedAttrIt->getName() == ESIPureModuleOutputOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'esi.pure_module.output' op ""attribute 'name' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ESIPureModuleOutputOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ESIPureModuleOutputOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value ESIPureModuleOutputOp::getValue() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::MutableOperandRange ESIPureModuleOutputOp::getValueMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> ESIPureModuleOutputOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ESIPureModuleOutputOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr ESIPureModuleOutputOp::getNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getNameAttrName()));
}

::llvm::StringRef ESIPureModuleOutputOp::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

void ESIPureModuleOutputOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void ESIPureModuleOutputOp::setName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void ESIPureModuleOutputOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr name, ::mlir::Value value) {
  odsState.addOperands(value);
  odsState.addAttribute(getNameAttrName(odsState.name), name);
}

void ESIPureModuleOutputOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr name, ::mlir::Value value) {
  odsState.addOperands(value);
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ESIPureModuleOutputOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef name, ::mlir::Value value) {
  odsState.addOperands(value);
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
}

void ESIPureModuleOutputOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef name, ::mlir::Value value) {
  odsState.addOperands(value);
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ESIPureModuleOutputOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ESIPureModuleOutputOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'name'");
    if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_name, "name")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ESIPureModuleOutputOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult ESIPureModuleOutputOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr nameAttr;
  ::mlir::OpAsmParser::UnresolvedOperand valueRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> valueOperands(valueRawOperands);  ::llvm::SMLoc valueOperandsLoc;
  (void)valueOperandsLoc;
  ::mlir::Type valueRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> valueTypes(valueRawTypes);

  if (parser.parseCustomAttributeWithFallback(nameAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (nameAttr) result.attributes.append("name", nameAttr);
  if (parser.parseComma())
    return ::mlir::failure();

  valueOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(valueRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::mlir::Type type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    valueRawTypes[0] = type;
  }
  if (parser.resolveOperands(valueOperands, valueTypes, valueOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ESIPureModuleOutputOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getNameAttr());
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getValue();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("name");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getValue().getType();
    if (auto validType = ::llvm::dyn_cast<::mlir::Type>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::ESIPureModuleOutputOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::ESIPureModuleParamOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ESIPureModuleParamOpGenericAdaptorBase::ESIPureModuleParamOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.pure_module.param", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ESIPureModuleParamOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ESIPureModuleParamOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr ESIPureModuleParamOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, ESIPureModuleParamOp::getNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef ESIPureModuleParamOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::mlir::TypeAttr ESIPureModuleParamOpGenericAdaptorBase::getTypeAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, ESIPureModuleParamOp::getTypeAttrName(*odsOpName)));
  return attr;
}

::mlir::Type ESIPureModuleParamOpGenericAdaptorBase::getType() {
  auto attr = getTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

} // namespace detail
ESIPureModuleParamOpAdaptor::ESIPureModuleParamOpAdaptor(ESIPureModuleParamOp op) : ESIPureModuleParamOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ESIPureModuleParamOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.pure_module.param' op ""requires attribute 'name'");
    if (namedAttrIt->getName() == ESIPureModuleParamOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_type;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.pure_module.param' op ""requires attribute 'type'");
    if (namedAttrIt->getName() == ESIPureModuleParamOp::getTypeAttrName(*odsOpName)) {
      tblgen_type = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'esi.pure_module.param' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_type && !(((::llvm::isa<::mlir::TypeAttr>(tblgen_type))) && ((::llvm::isa<::mlir::Type>(::llvm::cast<::mlir::TypeAttr>(tblgen_type).getValue()))) && ((true))))
    return emitError(loc, "'esi.pure_module.param' op ""attribute 'type' failed to satisfy constraint: any type attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ESIPureModuleParamOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ESIPureModuleParamOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> ESIPureModuleParamOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ESIPureModuleParamOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr ESIPureModuleParamOp::getNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getNameAttrName()));
}

::llvm::StringRef ESIPureModuleParamOp::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::mlir::TypeAttr ESIPureModuleParamOp::getTypeAttr() {
  return ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getTypeAttrName()));
}

::mlir::Type ESIPureModuleParamOp::getType() {
  auto attr = getTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

void ESIPureModuleParamOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void ESIPureModuleParamOp::setName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void ESIPureModuleParamOp::setTypeAttr(::mlir::TypeAttr attr) {
  (*this)->setAttr(getTypeAttrName(), attr);
}

void ESIPureModuleParamOp::setType(::mlir::Type attrValue) {
  (*this)->setAttr(getTypeAttrName(), ::mlir::TypeAttr::get(attrValue));
}

void ESIPureModuleParamOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr name, ::mlir::TypeAttr type) {
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  odsState.addAttribute(getTypeAttrName(odsState.name), type);
}

void ESIPureModuleParamOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr name, ::mlir::TypeAttr type) {
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  odsState.addAttribute(getTypeAttrName(odsState.name), type);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ESIPureModuleParamOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef name, ::mlir::Type type) {
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  odsState.addAttribute(getTypeAttrName(odsState.name), ::mlir::TypeAttr::get(type));
}

void ESIPureModuleParamOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef name, ::mlir::Type type) {
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  odsState.addAttribute(getTypeAttrName(odsState.name), ::mlir::TypeAttr::get(type));
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ESIPureModuleParamOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ESIPureModuleParamOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'name'");
    if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_type;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'type'");
    if (namedAttrIt->getName() == getTypeAttrName()) {
      tblgen_type = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI2(*this, tblgen_type, "type")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult ESIPureModuleParamOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult ESIPureModuleParamOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr nameAttr;
  ::mlir::TypeAttr typeAttr;

  if (parser.parseCustomAttributeWithFallback(nameAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (nameAttr) result.attributes.append("name", nameAttr);
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(typeAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (typeAttr) result.attributes.append("type", typeAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void ESIPureModuleParamOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getNameAttr());
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getTypeAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("name");
  elidedAttrs.push_back("type");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::ESIPureModuleParamOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::NullSourceOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
NullSourceOpGenericAdaptorBase::NullSourceOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.null", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> NullSourceOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr NullSourceOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
NullSourceOpAdaptor::NullSourceOpAdaptor(NullSourceOp op) : NullSourceOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult NullSourceOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> NullSourceOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range NullSourceOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> NullSourceOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range NullSourceOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> NullSourceOp::getOut() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSResults(0).begin());
}

void NullSourceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type out) {
  odsState.addTypes(out);
}

void NullSourceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes) {
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void NullSourceOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult NullSourceOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult NullSourceOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult NullSourceOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::Type outRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> outTypes(outRawTypes);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseType(outRawTypes[0]))
    return ::mlir::failure();
  result.addTypes(outTypes);
  return ::mlir::success();
}

void NullSourceOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
   _odsPrinter << getOut().getType();
}

void NullSourceOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::NullSourceOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::PipelineStageOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
PipelineStageOpGenericAdaptorBase::PipelineStageOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.stage", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> PipelineStageOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr PipelineStageOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
PipelineStageOpAdaptor::PipelineStageOpAdaptor(PipelineStageOp op) : PipelineStageOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult PipelineStageOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> PipelineStageOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range PipelineStageOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> PipelineStageOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> PipelineStageOp::getRst() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::circt::esi::ChannelType> PipelineStageOp::getInput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSOperands(2).begin());
}

::mlir::MutableOperandRange PipelineStageOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange PipelineStageOp::getRstMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange PipelineStageOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> PipelineStageOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range PipelineStageOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> PipelineStageOp::getOutput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSResults(0).begin());
}

void PipelineStageOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Value clk, ::mlir::Value rst, ::mlir::Value input) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addOperands(input);
  odsState.addTypes(output);
}

void PipelineStageOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clk, ::mlir::Value rst, ::mlir::Value input) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addOperands(input);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void PipelineStageOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult PipelineStageOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult PipelineStageOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

void PipelineStageOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::PipelineStageOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::RandomAccessMemoryDeclOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
RandomAccessMemoryDeclOpGenericAdaptorBase::RandomAccessMemoryDeclOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.mem.ram", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> RandomAccessMemoryDeclOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr RandomAccessMemoryDeclOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr RandomAccessMemoryDeclOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 0, RandomAccessMemoryDeclOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef RandomAccessMemoryDeclOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::TypeAttr RandomAccessMemoryDeclOpGenericAdaptorBase::getInnerTypeAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 1, RandomAccessMemoryDeclOp::getInnerTypeAttrName(*odsOpName)));
  return attr;
}

::mlir::Type RandomAccessMemoryDeclOpGenericAdaptorBase::getInnerType() {
  auto attr = getInnerTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

::mlir::IntegerAttr RandomAccessMemoryDeclOpGenericAdaptorBase::getDepthAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 2, RandomAccessMemoryDeclOp::getDepthAttrName(*odsOpName)));
  return attr;
}

uint64_t RandomAccessMemoryDeclOpGenericAdaptorBase::getDepth() {
  auto attr = getDepthAttr();
  return attr.getValue().getZExtValue();
}

} // namespace detail
RandomAccessMemoryDeclOpAdaptor::RandomAccessMemoryDeclOpAdaptor(RandomAccessMemoryDeclOp op) : RandomAccessMemoryDeclOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult RandomAccessMemoryDeclOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_depth;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.mem.ram' op ""requires attribute 'depth'");
    if (namedAttrIt->getName() == RandomAccessMemoryDeclOp::getDepthAttrName(*odsOpName)) {
      tblgen_depth = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_innerType;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.mem.ram' op ""requires attribute 'innerType'");
    if (namedAttrIt->getName() == RandomAccessMemoryDeclOp::getInnerTypeAttrName(*odsOpName)) {
      tblgen_innerType = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.mem.ram' op ""requires attribute 'sym_name'");
    if (namedAttrIt->getName() == RandomAccessMemoryDeclOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'esi.mem.ram' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");

  if (tblgen_innerType && !(((::llvm::isa<::mlir::TypeAttr>(tblgen_innerType))) && ((::llvm::isa<::mlir::Type>(::llvm::cast<::mlir::TypeAttr>(tblgen_innerType).getValue()))) && ((true))))
    return emitError(loc, "'esi.mem.ram' op ""attribute 'innerType' failed to satisfy constraint: any type attribute");

  if (tblgen_depth && !(((::llvm::isa<::mlir::IntegerAttr>(tblgen_depth))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_depth).getType().isSignlessInteger(64)))))
    return emitError(loc, "'esi.mem.ram' op ""attribute 'depth' failed to satisfy constraint: 64-bit signless integer attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> RandomAccessMemoryDeclOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range RandomAccessMemoryDeclOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> RandomAccessMemoryDeclOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range RandomAccessMemoryDeclOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr RandomAccessMemoryDeclOp::getSymNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::llvm::StringRef RandomAccessMemoryDeclOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::TypeAttr RandomAccessMemoryDeclOp::getInnerTypeAttr() {
  return ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getInnerTypeAttrName()));
}

::mlir::Type RandomAccessMemoryDeclOp::getInnerType() {
  auto attr = getInnerTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

::mlir::IntegerAttr RandomAccessMemoryDeclOp::getDepthAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 2, getDepthAttrName()));
}

uint64_t RandomAccessMemoryDeclOp::getDepth() {
  auto attr = getDepthAttr();
  return attr.getValue().getZExtValue();
}

void RandomAccessMemoryDeclOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void RandomAccessMemoryDeclOp::setSymName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void RandomAccessMemoryDeclOp::setInnerTypeAttr(::mlir::TypeAttr attr) {
  (*this)->setAttr(getInnerTypeAttrName(), attr);
}

void RandomAccessMemoryDeclOp::setInnerType(::mlir::Type attrValue) {
  (*this)->setAttr(getInnerTypeAttrName(), ::mlir::TypeAttr::get(attrValue));
}

void RandomAccessMemoryDeclOp::setDepthAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getDepthAttrName(), attr);
}

void RandomAccessMemoryDeclOp::setDepth(uint64_t attrValue) {
  (*this)->setAttr(getDepthAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), attrValue));
}

void RandomAccessMemoryDeclOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr sym_name, ::mlir::TypeAttr innerType, ::mlir::IntegerAttr depth) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getInnerTypeAttrName(odsState.name), innerType);
  odsState.addAttribute(getDepthAttrName(odsState.name), depth);
}

void RandomAccessMemoryDeclOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr sym_name, ::mlir::TypeAttr innerType, ::mlir::IntegerAttr depth) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getInnerTypeAttrName(odsState.name), innerType);
  odsState.addAttribute(getDepthAttrName(odsState.name), depth);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void RandomAccessMemoryDeclOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef sym_name, ::mlir::Type innerType, uint64_t depth) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getInnerTypeAttrName(odsState.name), ::mlir::TypeAttr::get(innerType));
  odsState.addAttribute(getDepthAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), depth));
}

void RandomAccessMemoryDeclOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef sym_name, ::mlir::Type innerType, uint64_t depth) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getInnerTypeAttrName(odsState.name), ::mlir::TypeAttr::get(innerType));
  odsState.addAttribute(getDepthAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), depth));
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void RandomAccessMemoryDeclOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult RandomAccessMemoryDeclOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_depth;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'depth'");
    if (namedAttrIt->getName() == getDepthAttrName()) {
      tblgen_depth = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_innerType;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'innerType'");
    if (namedAttrIt->getName() == getInnerTypeAttrName()) {
      tblgen_innerType = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'sym_name'");
    if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI2(*this, tblgen_innerType, "innerType")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI3(*this, tblgen_depth, "depth")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult RandomAccessMemoryDeclOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult RandomAccessMemoryDeclOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  ::mlir::TypeAttr innerTypeAttr;
  ::mlir::IntegerAttr depthAttr;

  if (parser.parseSymbolName(sym_nameAttr))
    return ::mlir::failure();
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);

  if (parser.parseCustomAttributeWithFallback(innerTypeAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (innerTypeAttr) result.attributes.append("innerType", innerTypeAttr);
  if (parser.parseKeyword("x"))
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(depthAttr, parser.getBuilder().getIntegerType(64))) {
    return ::mlir::failure();
  }
  if (depthAttr) result.attributes.append("depth", depthAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void RandomAccessMemoryDeclOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getInnerTypeAttr());
  _odsPrinter << ' ' << "x";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getDepthAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  elidedAttrs.push_back("innerType");
  elidedAttrs.push_back("depth");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::RandomAccessMemoryDeclOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::RequestInOutChannelOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
RequestInOutChannelOpGenericAdaptorBase::RequestInOutChannelOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.service.req.inout", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> RequestInOutChannelOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr RequestInOutChannelOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::circt::hw::InnerRefAttr RequestInOutChannelOpGenericAdaptorBase::getServicePortAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::circt::hw::InnerRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, RequestInOutChannelOp::getServicePortAttrName(*odsOpName)));
  return attr;
}

::circt::hw::InnerRefAttr RequestInOutChannelOpGenericAdaptorBase::getServicePort() {
  auto attr = getServicePortAttr();
  return ::llvm::cast<::circt::hw::InnerRefAttr>(attr);
}

::mlir::ArrayAttr RequestInOutChannelOpGenericAdaptorBase::getClientNamePathAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, RequestInOutChannelOp::getClientNamePathAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr RequestInOutChannelOpGenericAdaptorBase::getClientNamePath() {
  auto attr = getClientNamePathAttr();
  return attr;
}

} // namespace detail
RequestInOutChannelOpAdaptor::RequestInOutChannelOpAdaptor(RequestInOutChannelOp op) : RequestInOutChannelOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult RequestInOutChannelOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_clientNamePath;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.req.inout' op ""requires attribute 'clientNamePath'");
    if (namedAttrIt->getName() == RequestInOutChannelOp::getClientNamePathAttrName(*odsOpName)) {
      tblgen_clientNamePath = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_servicePort;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.req.inout' op ""requires attribute 'servicePort'");
    if (namedAttrIt->getName() == RequestInOutChannelOp::getServicePortAttrName(*odsOpName)) {
      tblgen_servicePort = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_servicePort && !((::llvm::isa<::circt::hw::InnerRefAttr>(tblgen_servicePort))))
    return emitError(loc, "'esi.service.req.inout' op ""attribute 'servicePort' failed to satisfy constraint: Refer to a name inside a module");

  if (tblgen_clientNamePath && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_clientNamePath))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_clientNamePath), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'esi.service.req.inout' op ""attribute 'clientNamePath' failed to satisfy constraint: string array attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> RequestInOutChannelOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range RequestInOutChannelOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> RequestInOutChannelOp::getToServer() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSOperands(0).begin());
}

::mlir::MutableOperandRange RequestInOutChannelOp::getToServerMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> RequestInOutChannelOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range RequestInOutChannelOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> RequestInOutChannelOp::getToClient() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSResults(0).begin());
}

::circt::hw::InnerRefAttr RequestInOutChannelOp::getServicePortAttr() {
  return ::llvm::cast<::circt::hw::InnerRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getServicePortAttrName()));
}

::circt::hw::InnerRefAttr RequestInOutChannelOp::getServicePort() {
  auto attr = getServicePortAttr();
  return ::llvm::cast<::circt::hw::InnerRefAttr>(attr);
}

::mlir::ArrayAttr RequestInOutChannelOp::getClientNamePathAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getClientNamePathAttrName()));
}

::mlir::ArrayAttr RequestInOutChannelOp::getClientNamePath() {
  auto attr = getClientNamePathAttr();
  return attr;
}

void RequestInOutChannelOp::setServicePortAttr(::circt::hw::InnerRefAttr attr) {
  (*this)->setAttr(getServicePortAttrName(), attr);
}

void RequestInOutChannelOp::setClientNamePathAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getClientNamePathAttrName(), attr);
}

void RequestInOutChannelOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type toClient, ::circt::hw::InnerRefAttr servicePort, ::mlir::Value toServer, ::mlir::ArrayAttr clientNamePath) {
  odsState.addOperands(toServer);
  odsState.addAttribute(getServicePortAttrName(odsState.name), servicePort);
  odsState.addAttribute(getClientNamePathAttrName(odsState.name), clientNamePath);
  odsState.addTypes(toClient);
}

void RequestInOutChannelOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::circt::hw::InnerRefAttr servicePort, ::mlir::Value toServer, ::mlir::ArrayAttr clientNamePath) {
  odsState.addOperands(toServer);
  odsState.addAttribute(getServicePortAttrName(odsState.name), servicePort);
  odsState.addAttribute(getClientNamePathAttrName(odsState.name), clientNamePath);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void RequestInOutChannelOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult RequestInOutChannelOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_clientNamePath;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'clientNamePath'");
    if (namedAttrIt->getName() == getClientNamePathAttrName()) {
      tblgen_clientNamePath = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_servicePort;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'servicePort'");
    if (namedAttrIt->getName() == getServicePortAttrName()) {
      tblgen_servicePort = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI4(*this, tblgen_servicePort, "servicePort")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI5(*this, tblgen_clientNamePath, "clientNamePath")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult RequestInOutChannelOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult RequestInOutChannelOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand toServerRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> toServerOperands(toServerRawOperands);  ::llvm::SMLoc toServerOperandsLoc;
  (void)toServerOperandsLoc;
  ::circt::hw::InnerRefAttr servicePortAttr;
  ::mlir::ArrayAttr clientNamePathAttr;
  ::mlir::Type toServerRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> toServerTypes(toServerRawTypes);
  ::mlir::Type toClientRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> toClientTypes(toClientRawTypes);

  toServerOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(toServerRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseArrow())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(servicePortAttr, ::mlir::Type{})) {
    return ::mlir::failure();
  }
  if (servicePortAttr) result.attributes.append("servicePort", servicePortAttr);
  if (parser.parseLParen())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(clientNamePathAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (clientNamePathAttr) result.attributes.append("clientNamePath", clientNamePathAttr);
  if (parser.parseRParen())
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseType(toServerRawTypes[0]))
    return ::mlir::failure();
  if (parser.parseArrow())
    return ::mlir::failure();

  if (parser.parseType(toClientRawTypes[0]))
    return ::mlir::failure();
  result.addTypes(toClientTypes);
  if (parser.resolveOperands(toServerOperands, toServerTypes, toServerOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void RequestInOutChannelOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getToServer();
  _odsPrinter << ' ' << "->";
  _odsPrinter << ' ';
_odsPrinter.printStrippedAttrOrType(getServicePortAttr());
  _odsPrinter << "(";
  _odsPrinter.printAttributeWithoutType(getClientNamePathAttr());
  _odsPrinter << ")";
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("servicePort");
  elidedAttrs.push_back("clientNamePath");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
   _odsPrinter << getToServer().getType();
  _odsPrinter << ' ' << "->";
  _odsPrinter << ' ';
   _odsPrinter << getToClient().getType();
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::RequestInOutChannelOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::RequestToClientConnectionOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
RequestToClientConnectionOpGenericAdaptorBase::RequestToClientConnectionOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.service.req.to_client", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> RequestToClientConnectionOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr RequestToClientConnectionOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::circt::hw::InnerRefAttr RequestToClientConnectionOpGenericAdaptorBase::getServicePortAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::circt::hw::InnerRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, RequestToClientConnectionOp::getServicePortAttrName(*odsOpName)));
  return attr;
}

::circt::hw::InnerRefAttr RequestToClientConnectionOpGenericAdaptorBase::getServicePort() {
  auto attr = getServicePortAttr();
  return ::llvm::cast<::circt::hw::InnerRefAttr>(attr);
}

::mlir::ArrayAttr RequestToClientConnectionOpGenericAdaptorBase::getClientNamePathAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, RequestToClientConnectionOp::getClientNamePathAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr RequestToClientConnectionOpGenericAdaptorBase::getClientNamePath() {
  auto attr = getClientNamePathAttr();
  return attr;
}

} // namespace detail
RequestToClientConnectionOpAdaptor::RequestToClientConnectionOpAdaptor(RequestToClientConnectionOp op) : RequestToClientConnectionOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult RequestToClientConnectionOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_clientNamePath;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.req.to_client' op ""requires attribute 'clientNamePath'");
    if (namedAttrIt->getName() == RequestToClientConnectionOp::getClientNamePathAttrName(*odsOpName)) {
      tblgen_clientNamePath = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_servicePort;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.req.to_client' op ""requires attribute 'servicePort'");
    if (namedAttrIt->getName() == RequestToClientConnectionOp::getServicePortAttrName(*odsOpName)) {
      tblgen_servicePort = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_servicePort && !((::llvm::isa<::circt::hw::InnerRefAttr>(tblgen_servicePort))))
    return emitError(loc, "'esi.service.req.to_client' op ""attribute 'servicePort' failed to satisfy constraint: Refer to a name inside a module");

  if (tblgen_clientNamePath && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_clientNamePath))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_clientNamePath), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'esi.service.req.to_client' op ""attribute 'clientNamePath' failed to satisfy constraint: string array attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> RequestToClientConnectionOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range RequestToClientConnectionOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> RequestToClientConnectionOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range RequestToClientConnectionOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> RequestToClientConnectionOp::getToClient() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSResults(0).begin());
}

::circt::hw::InnerRefAttr RequestToClientConnectionOp::getServicePortAttr() {
  return ::llvm::cast<::circt::hw::InnerRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getServicePortAttrName()));
}

::circt::hw::InnerRefAttr RequestToClientConnectionOp::getServicePort() {
  auto attr = getServicePortAttr();
  return ::llvm::cast<::circt::hw::InnerRefAttr>(attr);
}

::mlir::ArrayAttr RequestToClientConnectionOp::getClientNamePathAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getClientNamePathAttrName()));
}

::mlir::ArrayAttr RequestToClientConnectionOp::getClientNamePath() {
  auto attr = getClientNamePathAttr();
  return attr;
}

void RequestToClientConnectionOp::setServicePortAttr(::circt::hw::InnerRefAttr attr) {
  (*this)->setAttr(getServicePortAttrName(), attr);
}

void RequestToClientConnectionOp::setClientNamePathAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getClientNamePathAttrName(), attr);
}

void RequestToClientConnectionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type toClient, ::circt::hw::InnerRefAttr servicePort, ::mlir::ArrayAttr clientNamePath) {
  odsState.addAttribute(getServicePortAttrName(odsState.name), servicePort);
  odsState.addAttribute(getClientNamePathAttrName(odsState.name), clientNamePath);
  odsState.addTypes(toClient);
}

void RequestToClientConnectionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::circt::hw::InnerRefAttr servicePort, ::mlir::ArrayAttr clientNamePath) {
  odsState.addAttribute(getServicePortAttrName(odsState.name), servicePort);
  odsState.addAttribute(getClientNamePathAttrName(odsState.name), clientNamePath);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void RequestToClientConnectionOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult RequestToClientConnectionOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_clientNamePath;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'clientNamePath'");
    if (namedAttrIt->getName() == getClientNamePathAttrName()) {
      tblgen_clientNamePath = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_servicePort;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'servicePort'");
    if (namedAttrIt->getName() == getServicePortAttrName()) {
      tblgen_servicePort = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI4(*this, tblgen_servicePort, "servicePort")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI5(*this, tblgen_clientNamePath, "clientNamePath")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult RequestToClientConnectionOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult RequestToClientConnectionOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::circt::hw::InnerRefAttr servicePortAttr;
  ::mlir::ArrayAttr clientNamePathAttr;
  ::mlir::Type toClientRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> toClientTypes(toClientRawTypes);

  if (parser.parseCustomAttributeWithFallback(servicePortAttr, ::mlir::Type{})) {
    return ::mlir::failure();
  }
  if (servicePortAttr) result.attributes.append("servicePort", servicePortAttr);
  if (parser.parseLParen())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(clientNamePathAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (clientNamePathAttr) result.attributes.append("clientNamePath", clientNamePathAttr);
  if (parser.parseRParen())
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseType(toClientRawTypes[0]))
    return ::mlir::failure();
  result.addTypes(toClientTypes);
  return ::mlir::success();
}

void RequestToClientConnectionOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
_odsPrinter.printStrippedAttrOrType(getServicePortAttr());
  _odsPrinter << "(";
  _odsPrinter.printAttributeWithoutType(getClientNamePathAttr());
  _odsPrinter << ")";
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("servicePort");
  elidedAttrs.push_back("clientNamePath");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
   _odsPrinter << getToClient().getType();
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::RequestToClientConnectionOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::RequestToServerConnectionOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
RequestToServerConnectionOpGenericAdaptorBase::RequestToServerConnectionOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.service.req.to_server", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> RequestToServerConnectionOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr RequestToServerConnectionOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::circt::hw::InnerRefAttr RequestToServerConnectionOpGenericAdaptorBase::getServicePortAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::circt::hw::InnerRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, RequestToServerConnectionOp::getServicePortAttrName(*odsOpName)));
  return attr;
}

::circt::hw::InnerRefAttr RequestToServerConnectionOpGenericAdaptorBase::getServicePort() {
  auto attr = getServicePortAttr();
  return ::llvm::cast<::circt::hw::InnerRefAttr>(attr);
}

::mlir::ArrayAttr RequestToServerConnectionOpGenericAdaptorBase::getClientNamePathAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, RequestToServerConnectionOp::getClientNamePathAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr RequestToServerConnectionOpGenericAdaptorBase::getClientNamePath() {
  auto attr = getClientNamePathAttr();
  return attr;
}

} // namespace detail
RequestToServerConnectionOpAdaptor::RequestToServerConnectionOpAdaptor(RequestToServerConnectionOp op) : RequestToServerConnectionOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult RequestToServerConnectionOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_clientNamePath;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.req.to_server' op ""requires attribute 'clientNamePath'");
    if (namedAttrIt->getName() == RequestToServerConnectionOp::getClientNamePathAttrName(*odsOpName)) {
      tblgen_clientNamePath = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_servicePort;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.req.to_server' op ""requires attribute 'servicePort'");
    if (namedAttrIt->getName() == RequestToServerConnectionOp::getServicePortAttrName(*odsOpName)) {
      tblgen_servicePort = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_servicePort && !((::llvm::isa<::circt::hw::InnerRefAttr>(tblgen_servicePort))))
    return emitError(loc, "'esi.service.req.to_server' op ""attribute 'servicePort' failed to satisfy constraint: Refer to a name inside a module");

  if (tblgen_clientNamePath && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_clientNamePath))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_clientNamePath), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'esi.service.req.to_server' op ""attribute 'clientNamePath' failed to satisfy constraint: string array attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> RequestToServerConnectionOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range RequestToServerConnectionOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> RequestToServerConnectionOp::getToServer() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSOperands(0).begin());
}

::mlir::MutableOperandRange RequestToServerConnectionOp::getToServerMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> RequestToServerConnectionOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range RequestToServerConnectionOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::circt::hw::InnerRefAttr RequestToServerConnectionOp::getServicePortAttr() {
  return ::llvm::cast<::circt::hw::InnerRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getServicePortAttrName()));
}

::circt::hw::InnerRefAttr RequestToServerConnectionOp::getServicePort() {
  auto attr = getServicePortAttr();
  return ::llvm::cast<::circt::hw::InnerRefAttr>(attr);
}

::mlir::ArrayAttr RequestToServerConnectionOp::getClientNamePathAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getClientNamePathAttrName()));
}

::mlir::ArrayAttr RequestToServerConnectionOp::getClientNamePath() {
  auto attr = getClientNamePathAttr();
  return attr;
}

void RequestToServerConnectionOp::setServicePortAttr(::circt::hw::InnerRefAttr attr) {
  (*this)->setAttr(getServicePortAttrName(), attr);
}

void RequestToServerConnectionOp::setClientNamePathAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getClientNamePathAttrName(), attr);
}

void RequestToServerConnectionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::circt::hw::InnerRefAttr servicePort, ::mlir::Value toServer, ::mlir::ArrayAttr clientNamePath) {
  odsState.addOperands(toServer);
  odsState.addAttribute(getServicePortAttrName(odsState.name), servicePort);
  odsState.addAttribute(getClientNamePathAttrName(odsState.name), clientNamePath);
}

void RequestToServerConnectionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::circt::hw::InnerRefAttr servicePort, ::mlir::Value toServer, ::mlir::ArrayAttr clientNamePath) {
  odsState.addOperands(toServer);
  odsState.addAttribute(getServicePortAttrName(odsState.name), servicePort);
  odsState.addAttribute(getClientNamePathAttrName(odsState.name), clientNamePath);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void RequestToServerConnectionOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult RequestToServerConnectionOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_clientNamePath;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'clientNamePath'");
    if (namedAttrIt->getName() == getClientNamePathAttrName()) {
      tblgen_clientNamePath = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_servicePort;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'servicePort'");
    if (namedAttrIt->getName() == getServicePortAttrName()) {
      tblgen_servicePort = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI4(*this, tblgen_servicePort, "servicePort")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI5(*this, tblgen_clientNamePath, "clientNamePath")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult RequestToServerConnectionOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult RequestToServerConnectionOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand toServerRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> toServerOperands(toServerRawOperands);  ::llvm::SMLoc toServerOperandsLoc;
  (void)toServerOperandsLoc;
  ::circt::hw::InnerRefAttr servicePortAttr;
  ::mlir::ArrayAttr clientNamePathAttr;
  ::mlir::Type toServerRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> toServerTypes(toServerRawTypes);

  toServerOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(toServerRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseArrow())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(servicePortAttr, ::mlir::Type{})) {
    return ::mlir::failure();
  }
  if (servicePortAttr) result.attributes.append("servicePort", servicePortAttr);
  if (parser.parseLParen())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(clientNamePathAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (clientNamePathAttr) result.attributes.append("clientNamePath", clientNamePathAttr);
  if (parser.parseRParen())
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseType(toServerRawTypes[0]))
    return ::mlir::failure();
  if (parser.resolveOperands(toServerOperands, toServerTypes, toServerOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void RequestToServerConnectionOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getToServer();
  _odsPrinter << ' ' << "->";
  _odsPrinter << ' ';
_odsPrinter.printStrippedAttrOrType(getServicePortAttr());
  _odsPrinter << "(";
  _odsPrinter.printAttributeWithoutType(getClientNamePathAttr());
  _odsPrinter << ")";
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("servicePort");
  elidedAttrs.push_back("clientNamePath");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
   _odsPrinter << getToServer().getType();
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::RequestToServerConnectionOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::ServiceDeclInOutOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ServiceDeclInOutOpGenericAdaptorBase::ServiceDeclInOutOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.service.inout", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ServiceDeclInOutOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ServiceDeclInOutOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr ServiceDeclInOutOpGenericAdaptorBase::getInnerSymAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 2, ServiceDeclInOutOp::getInnerSymAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef ServiceDeclInOutOpGenericAdaptorBase::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr.getValue();
}

::mlir::TypeAttr ServiceDeclInOutOpGenericAdaptorBase::getToServerTypeAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 0, ServiceDeclInOutOp::getToServerTypeAttrName(*odsOpName)));
  return attr;
}

::mlir::Type ServiceDeclInOutOpGenericAdaptorBase::getToServerType() {
  auto attr = getToServerTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

::mlir::TypeAttr ServiceDeclInOutOpGenericAdaptorBase::getToClientTypeAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 1, ServiceDeclInOutOp::getToClientTypeAttrName(*odsOpName)));
  return attr;
}

::mlir::Type ServiceDeclInOutOpGenericAdaptorBase::getToClientType() {
  auto attr = getToClientTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

} // namespace detail
ServiceDeclInOutOpAdaptor::ServiceDeclInOutOpAdaptor(ServiceDeclInOutOp op) : ServiceDeclInOutOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ServiceDeclInOutOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_inner_sym;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.inout' op ""requires attribute 'inner_sym'");
    if (namedAttrIt->getName() == ServiceDeclInOutOp::getInnerSymAttrName(*odsOpName)) {
      tblgen_inner_sym = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_toClientType;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.inout' op ""requires attribute 'toClientType'");
    if (namedAttrIt->getName() == ServiceDeclInOutOp::getToClientTypeAttrName(*odsOpName)) {
      tblgen_toClientType = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_toServerType;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.inout' op ""requires attribute 'toServerType'");
    if (namedAttrIt->getName() == ServiceDeclInOutOp::getToServerTypeAttrName(*odsOpName)) {
      tblgen_toServerType = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_inner_sym && !((::llvm::isa<::mlir::StringAttr>(tblgen_inner_sym))))
    return emitError(loc, "'esi.service.inout' op ""attribute 'inner_sym' failed to satisfy constraint: string attribute");

  if (tblgen_toServerType && !(((::llvm::isa<::mlir::TypeAttr>(tblgen_toServerType))) && ((::llvm::isa<::mlir::Type>(::llvm::cast<::mlir::TypeAttr>(tblgen_toServerType).getValue()))) && ((true))))
    return emitError(loc, "'esi.service.inout' op ""attribute 'toServerType' failed to satisfy constraint: any type attribute");

  if (tblgen_toClientType && !(((::llvm::isa<::mlir::TypeAttr>(tblgen_toClientType))) && ((::llvm::isa<::mlir::Type>(::llvm::cast<::mlir::TypeAttr>(tblgen_toClientType).getValue()))) && ((true))))
    return emitError(loc, "'esi.service.inout' op ""attribute 'toClientType' failed to satisfy constraint: any type attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ServiceDeclInOutOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ServiceDeclInOutOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> ServiceDeclInOutOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ServiceDeclInOutOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr ServiceDeclInOutOp::getInnerSymAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 2, getInnerSymAttrName()));
}

::llvm::StringRef ServiceDeclInOutOp::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr.getValue();
}

::mlir::TypeAttr ServiceDeclInOutOp::getToServerTypeAttr() {
  return ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 0, getToServerTypeAttrName()));
}

::mlir::Type ServiceDeclInOutOp::getToServerType() {
  auto attr = getToServerTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

::mlir::TypeAttr ServiceDeclInOutOp::getToClientTypeAttr() {
  return ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getToClientTypeAttrName()));
}

::mlir::Type ServiceDeclInOutOp::getToClientType() {
  auto attr = getToClientTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

void ServiceDeclInOutOp::setInnerSymAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getInnerSymAttrName(), attr);
}

void ServiceDeclInOutOp::setInnerSym(::llvm::StringRef attrValue) {
  (*this)->setAttr(getInnerSymAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void ServiceDeclInOutOp::setToServerTypeAttr(::mlir::TypeAttr attr) {
  (*this)->setAttr(getToServerTypeAttrName(), attr);
}

void ServiceDeclInOutOp::setToServerType(::mlir::Type attrValue) {
  (*this)->setAttr(getToServerTypeAttrName(), ::mlir::TypeAttr::get(attrValue));
}

void ServiceDeclInOutOp::setToClientTypeAttr(::mlir::TypeAttr attr) {
  (*this)->setAttr(getToClientTypeAttrName(), attr);
}

void ServiceDeclInOutOp::setToClientType(::mlir::Type attrValue) {
  (*this)->setAttr(getToClientTypeAttrName(), ::mlir::TypeAttr::get(attrValue));
}

void ServiceDeclInOutOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr inner_sym, ::mlir::TypeAttr toServerType, ::mlir::TypeAttr toClientType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), inner_sym);
  odsState.addAttribute(getToServerTypeAttrName(odsState.name), toServerType);
  odsState.addAttribute(getToClientTypeAttrName(odsState.name), toClientType);
}

void ServiceDeclInOutOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr inner_sym, ::mlir::TypeAttr toServerType, ::mlir::TypeAttr toClientType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), inner_sym);
  odsState.addAttribute(getToServerTypeAttrName(odsState.name), toServerType);
  odsState.addAttribute(getToClientTypeAttrName(odsState.name), toClientType);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ServiceDeclInOutOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef inner_sym, ::mlir::Type toServerType, ::mlir::Type toClientType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), odsBuilder.getStringAttr(inner_sym));
  odsState.addAttribute(getToServerTypeAttrName(odsState.name), ::mlir::TypeAttr::get(toServerType));
  odsState.addAttribute(getToClientTypeAttrName(odsState.name), ::mlir::TypeAttr::get(toClientType));
}

void ServiceDeclInOutOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef inner_sym, ::mlir::Type toServerType, ::mlir::Type toClientType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), odsBuilder.getStringAttr(inner_sym));
  odsState.addAttribute(getToServerTypeAttrName(odsState.name), ::mlir::TypeAttr::get(toServerType));
  odsState.addAttribute(getToClientTypeAttrName(odsState.name), ::mlir::TypeAttr::get(toClientType));
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ServiceDeclInOutOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ServiceDeclInOutOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_inner_sym;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'inner_sym'");
    if (namedAttrIt->getName() == getInnerSymAttrName()) {
      tblgen_inner_sym = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_toClientType;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'toClientType'");
    if (namedAttrIt->getName() == getToClientTypeAttrName()) {
      tblgen_toClientType = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_toServerType;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'toServerType'");
    if (namedAttrIt->getName() == getToServerTypeAttrName()) {
      tblgen_toServerType = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_inner_sym, "inner_sym")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI2(*this, tblgen_toServerType, "toServerType")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI2(*this, tblgen_toClientType, "toClientType")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult ServiceDeclInOutOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult ServiceDeclInOutOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr inner_symAttr;
  ::mlir::TypeAttr toServerTypeAttr;
  ::mlir::TypeAttr toClientTypeAttr;

  if (parser.parseSymbolName(inner_symAttr))
    return ::mlir::failure();
  if (inner_symAttr) result.attributes.append("inner_sym", inner_symAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseAttribute(toServerTypeAttr, parser.getBuilder().getType<::mlir::NoneType>()))
    return ::mlir::failure();
  if (toServerTypeAttr) result.attributes.append("toServerType", toServerTypeAttr);
  if (parser.parseArrow())
    return ::mlir::failure();

  if (parser.parseAttribute(toClientTypeAttr, parser.getBuilder().getType<::mlir::NoneType>()))
    return ::mlir::failure();
  if (toClientTypeAttr) result.attributes.append("toClientType", toClientTypeAttr);
  return ::mlir::success();
}

void ServiceDeclInOutOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getInnerSymAttr().getValue());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("inner_sym");
  elidedAttrs.push_back("toServerType");
  elidedAttrs.push_back("toClientType");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getToServerTypeAttr());
  _odsPrinter << ' ' << "->";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getToClientTypeAttr());
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::ServiceDeclInOutOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::ServiceHierarchyMetadataOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ServiceHierarchyMetadataOpGenericAdaptorBase::ServiceHierarchyMetadataOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.service.hierarchy.metadata", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ServiceHierarchyMetadataOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ServiceHierarchyMetadataOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::FlatSymbolRefAttr ServiceHierarchyMetadataOpGenericAdaptorBase::getServiceSymbolAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 3, odsAttrs.end() - 0, ServiceHierarchyMetadataOp::getServiceSymbolAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > ServiceHierarchyMetadataOpGenericAdaptorBase::getServiceSymbol() {
  auto attr = getServiceSymbolAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::ArrayAttr ServiceHierarchyMetadataOpGenericAdaptorBase::getServerNamePathAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 0, ServiceHierarchyMetadataOp::getServerNamePathAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr ServiceHierarchyMetadataOpGenericAdaptorBase::getServerNamePath() {
  auto attr = getServerNamePathAttr();
  return attr;
}

::mlir::StringAttr ServiceHierarchyMetadataOpGenericAdaptorBase::getImplTypeAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 1, ServiceHierarchyMetadataOp::getImplTypeAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef ServiceHierarchyMetadataOpGenericAdaptorBase::getImplType() {
  auto attr = getImplTypeAttr();
  return attr.getValue();
}

::mlir::DictionaryAttr ServiceHierarchyMetadataOpGenericAdaptorBase::getImplDetailsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::DictionaryAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 2, ServiceHierarchyMetadataOp::getImplDetailsAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::DictionaryAttr > ServiceHierarchyMetadataOpGenericAdaptorBase::getImplDetails() {
  auto attr = getImplDetailsAttr();
  return attr ? ::std::optional< ::mlir::DictionaryAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr ServiceHierarchyMetadataOpGenericAdaptorBase::getClientsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 2, ServiceHierarchyMetadataOp::getClientsAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr ServiceHierarchyMetadataOpGenericAdaptorBase::getClients() {
  auto attr = getClientsAttr();
  return attr;
}

} // namespace detail
ServiceHierarchyMetadataOpAdaptor::ServiceHierarchyMetadataOpAdaptor(ServiceHierarchyMetadataOp op) : ServiceHierarchyMetadataOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ServiceHierarchyMetadataOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_clients;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.hierarchy.metadata' op ""requires attribute 'clients'");
    if (namedAttrIt->getName() == ServiceHierarchyMetadataOp::getClientsAttrName(*odsOpName)) {
      tblgen_clients = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_impl_type;
  ::mlir::Attribute tblgen_impl_details;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.hierarchy.metadata' op ""requires attribute 'impl_type'");
    if (namedAttrIt->getName() == ServiceHierarchyMetadataOp::getImplTypeAttrName(*odsOpName)) {
      tblgen_impl_type = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == ServiceHierarchyMetadataOp::getImplDetailsAttrName(*odsOpName)) {
      tblgen_impl_details = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_serverNamePath;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.hierarchy.metadata' op ""requires attribute 'serverNamePath'");
    if (namedAttrIt->getName() == ServiceHierarchyMetadataOp::getServerNamePathAttrName(*odsOpName)) {
      tblgen_serverNamePath = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_service_symbol;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == ServiceHierarchyMetadataOp::getServiceSymbolAttrName(*odsOpName)) {
      tblgen_service_symbol = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_service_symbol && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(tblgen_service_symbol))))
    return emitError(loc, "'esi.service.hierarchy.metadata' op ""attribute 'service_symbol' failed to satisfy constraint: flat symbol reference attribute");

  if (tblgen_serverNamePath && !((::llvm::isa<::mlir::ArrayAttr>(tblgen_serverNamePath))))
    return emitError(loc, "'esi.service.hierarchy.metadata' op ""attribute 'serverNamePath' failed to satisfy constraint: array attribute");

  if (tblgen_impl_type && !((::llvm::isa<::mlir::StringAttr>(tblgen_impl_type))))
    return emitError(loc, "'esi.service.hierarchy.metadata' op ""attribute 'impl_type' failed to satisfy constraint: string attribute");

  if (tblgen_impl_details && !((::llvm::isa<::mlir::DictionaryAttr>(tblgen_impl_details))))
    return emitError(loc, "'esi.service.hierarchy.metadata' op ""attribute 'impl_details' failed to satisfy constraint: dictionary of named attribute values");

  if (tblgen_clients && !((::llvm::isa<::mlir::ArrayAttr>(tblgen_clients))))
    return emitError(loc, "'esi.service.hierarchy.metadata' op ""attribute 'clients' failed to satisfy constraint: array attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ServiceHierarchyMetadataOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ServiceHierarchyMetadataOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> ServiceHierarchyMetadataOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ServiceHierarchyMetadataOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::FlatSymbolRefAttr ServiceHierarchyMetadataOp::getServiceSymbolAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 3, (*this)->getAttrs().end() - 0, getServiceSymbolAttrName()));
}

::std::optional< ::llvm::StringRef > ServiceHierarchyMetadataOp::getServiceSymbol() {
  auto attr = getServiceSymbolAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::ArrayAttr ServiceHierarchyMetadataOp::getServerNamePathAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 0, getServerNamePathAttrName()));
}

::mlir::ArrayAttr ServiceHierarchyMetadataOp::getServerNamePath() {
  auto attr = getServerNamePathAttr();
  return attr;
}

::mlir::StringAttr ServiceHierarchyMetadataOp::getImplTypeAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getImplTypeAttrName()));
}

::llvm::StringRef ServiceHierarchyMetadataOp::getImplType() {
  auto attr = getImplTypeAttr();
  return attr.getValue();
}

::mlir::DictionaryAttr ServiceHierarchyMetadataOp::getImplDetailsAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::DictionaryAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 2, getImplDetailsAttrName()));
}

::std::optional< ::mlir::DictionaryAttr > ServiceHierarchyMetadataOp::getImplDetails() {
  auto attr = getImplDetailsAttr();
  return attr ? ::std::optional< ::mlir::DictionaryAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr ServiceHierarchyMetadataOp::getClientsAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 2, getClientsAttrName()));
}

::mlir::ArrayAttr ServiceHierarchyMetadataOp::getClients() {
  auto attr = getClientsAttr();
  return attr;
}

void ServiceHierarchyMetadataOp::setServiceSymbolAttr(::mlir::FlatSymbolRefAttr attr) {
  (*this)->setAttr(getServiceSymbolAttrName(), attr);
}

void ServiceHierarchyMetadataOp::setServiceSymbol(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getServiceSymbolAttrName(), ::mlir::SymbolRefAttr::get(::mlir::Builder((*this)->getContext()).getContext(), *attrValue));
    (*this)->removeAttr(getServiceSymbolAttrName());
}

void ServiceHierarchyMetadataOp::setServerNamePathAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getServerNamePathAttrName(), attr);
}

void ServiceHierarchyMetadataOp::setImplTypeAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getImplTypeAttrName(), attr);
}

void ServiceHierarchyMetadataOp::setImplType(::llvm::StringRef attrValue) {
  (*this)->setAttr(getImplTypeAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void ServiceHierarchyMetadataOp::setImplDetailsAttr(::mlir::DictionaryAttr attr) {
  (*this)->setAttr(getImplDetailsAttrName(), attr);
}

void ServiceHierarchyMetadataOp::setClientsAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getClientsAttrName(), attr);
}

::mlir::Attribute ServiceHierarchyMetadataOp::removeServiceSymbolAttr() {
return (*this)->removeAttr(getServiceSymbolAttrName());
}

::mlir::Attribute ServiceHierarchyMetadataOp::removeImplDetailsAttr() {
return (*this)->removeAttr(getImplDetailsAttrName());
}

void ServiceHierarchyMetadataOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, /*optional*/::mlir::FlatSymbolRefAttr service_symbol, ::mlir::ArrayAttr serverNamePath, ::mlir::StringAttr impl_type, /*optional*/::mlir::DictionaryAttr impl_details, ::mlir::ArrayAttr clients) {
  if (service_symbol) {
    odsState.addAttribute(getServiceSymbolAttrName(odsState.name), service_symbol);
  }
  odsState.addAttribute(getServerNamePathAttrName(odsState.name), serverNamePath);
  odsState.addAttribute(getImplTypeAttrName(odsState.name), impl_type);
  if (impl_details) {
    odsState.addAttribute(getImplDetailsAttrName(odsState.name), impl_details);
  }
  odsState.addAttribute(getClientsAttrName(odsState.name), clients);
}

void ServiceHierarchyMetadataOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, /*optional*/::mlir::FlatSymbolRefAttr service_symbol, ::mlir::ArrayAttr serverNamePath, ::mlir::StringAttr impl_type, /*optional*/::mlir::DictionaryAttr impl_details, ::mlir::ArrayAttr clients) {
  if (service_symbol) {
    odsState.addAttribute(getServiceSymbolAttrName(odsState.name), service_symbol);
  }
  odsState.addAttribute(getServerNamePathAttrName(odsState.name), serverNamePath);
  odsState.addAttribute(getImplTypeAttrName(odsState.name), impl_type);
  if (impl_details) {
    odsState.addAttribute(getImplDetailsAttrName(odsState.name), impl_details);
  }
  odsState.addAttribute(getClientsAttrName(odsState.name), clients);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ServiceHierarchyMetadataOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, /*optional*/::mlir::FlatSymbolRefAttr service_symbol, ::mlir::ArrayAttr serverNamePath, ::llvm::StringRef impl_type, /*optional*/::mlir::DictionaryAttr impl_details, ::mlir::ArrayAttr clients) {
  if (service_symbol) {
    odsState.addAttribute(getServiceSymbolAttrName(odsState.name), service_symbol);
  }
  odsState.addAttribute(getServerNamePathAttrName(odsState.name), serverNamePath);
  odsState.addAttribute(getImplTypeAttrName(odsState.name), odsBuilder.getStringAttr(impl_type));
  if (impl_details) {
    odsState.addAttribute(getImplDetailsAttrName(odsState.name), impl_details);
  }
  odsState.addAttribute(getClientsAttrName(odsState.name), clients);
}

void ServiceHierarchyMetadataOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, /*optional*/::mlir::FlatSymbolRefAttr service_symbol, ::mlir::ArrayAttr serverNamePath, ::llvm::StringRef impl_type, /*optional*/::mlir::DictionaryAttr impl_details, ::mlir::ArrayAttr clients) {
  if (service_symbol) {
    odsState.addAttribute(getServiceSymbolAttrName(odsState.name), service_symbol);
  }
  odsState.addAttribute(getServerNamePathAttrName(odsState.name), serverNamePath);
  odsState.addAttribute(getImplTypeAttrName(odsState.name), odsBuilder.getStringAttr(impl_type));
  if (impl_details) {
    odsState.addAttribute(getImplDetailsAttrName(odsState.name), impl_details);
  }
  odsState.addAttribute(getClientsAttrName(odsState.name), clients);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ServiceHierarchyMetadataOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ServiceHierarchyMetadataOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_clients;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'clients'");
    if (namedAttrIt->getName() == getClientsAttrName()) {
      tblgen_clients = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_impl_type;
  ::mlir::Attribute tblgen_impl_details;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'impl_type'");
    if (namedAttrIt->getName() == getImplTypeAttrName()) {
      tblgen_impl_type = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getImplDetailsAttrName()) {
      tblgen_impl_details = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_serverNamePath;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'serverNamePath'");
    if (namedAttrIt->getName() == getServerNamePathAttrName()) {
      tblgen_serverNamePath = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_service_symbol;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getServiceSymbolAttrName()) {
      tblgen_service_symbol = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI6(*this, tblgen_service_symbol, "service_symbol")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI7(*this, tblgen_serverNamePath, "serverNamePath")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_impl_type, "impl_type")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI8(*this, tblgen_impl_details, "impl_details")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI7(*this, tblgen_clients, "clients")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult ServiceHierarchyMetadataOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult ServiceHierarchyMetadataOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::ArrayAttr serverNamePathAttr;
  ::mlir::FlatSymbolRefAttr service_symbolAttr;
  ::mlir::StringAttr impl_typeAttr;
  ::mlir::DictionaryAttr impl_detailsAttr;
  ::mlir::ArrayAttr clientsAttr;
  if (parser.parseKeyword("path"))
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(serverNamePathAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (serverNamePathAttr) result.attributes.append("serverNamePath", serverNamePathAttr);
  if (::mlir::succeeded(parser.parseOptionalKeyword("implementing"))) {

  if (parser.parseCustomAttributeWithFallback(service_symbolAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (service_symbolAttr) result.attributes.append("service_symbol", service_symbolAttr);
  }
  if (parser.parseKeyword("impl"))
    return ::mlir::failure();
  if (parser.parseKeyword("as"))
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(impl_typeAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (impl_typeAttr) result.attributes.append("impl_type", impl_typeAttr);
  if (::mlir::succeeded(parser.parseOptionalKeyword("opts"))) {

  if (parser.parseCustomAttributeWithFallback(impl_detailsAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (impl_detailsAttr) result.attributes.append("impl_details", impl_detailsAttr);
  }
  if (parser.parseKeyword("clients"))
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(clientsAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (clientsAttr) result.attributes.append("clients", clientsAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void ServiceHierarchyMetadataOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ' << "path";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getServerNamePathAttr());
  if (getServiceSymbolAttr()) {
    _odsPrinter << ' ' << "implementing";
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getServiceSymbolAttr());
  }
  _odsPrinter << ' ' << "impl";
  _odsPrinter << ' ' << "as";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getImplTypeAttr());
  if (getImplDetailsAttr()) {
    _odsPrinter << ' ' << "opts";
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getImplDetailsAttr());
  }
  _odsPrinter << ' ' << "clients";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getClientsAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("serverNamePath");
  elidedAttrs.push_back("service_symbol");
  elidedAttrs.push_back("impl_type");
  elidedAttrs.push_back("impl_details");
  elidedAttrs.push_back("clients");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::ServiceHierarchyMetadataOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::ServiceImplementReqOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ServiceImplementReqOpGenericAdaptorBase::ServiceImplementReqOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.service.impl_req", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ServiceImplementReqOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr ServiceImplementReqOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::FlatSymbolRefAttr ServiceImplementReqOpGenericAdaptorBase::getServiceSymbolAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, ServiceImplementReqOp::getServiceSymbolAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > ServiceImplementReqOpGenericAdaptorBase::getServiceSymbol() {
  auto attr = getServiceSymbolAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::StringAttr ServiceImplementReqOpGenericAdaptorBase::getImplTypeAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, ServiceImplementReqOp::getImplTypeAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef ServiceImplementReqOpGenericAdaptorBase::getImplType() {
  auto attr = getImplTypeAttr();
  return attr.getValue();
}

::mlir::DictionaryAttr ServiceImplementReqOpGenericAdaptorBase::getImplOptsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::DictionaryAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, ServiceImplementReqOp::getImplOptsAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::DictionaryAttr > ServiceImplementReqOpGenericAdaptorBase::getImplOpts() {
  auto attr = getImplOptsAttr();
  return attr ? ::std::optional< ::mlir::DictionaryAttr >(attr) : (::std::nullopt);
}

::mlir::Region &ServiceImplementReqOpGenericAdaptorBase::getPortReqs() {
  return *odsRegions[0];
}

::mlir::RegionRange ServiceImplementReqOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
ServiceImplementReqOpAdaptor::ServiceImplementReqOpAdaptor(ServiceImplementReqOp op) : ServiceImplementReqOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ServiceImplementReqOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_impl_type;
  ::mlir::Attribute tblgen_impl_opts;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.impl_req' op ""requires attribute 'impl_type'");
    if (namedAttrIt->getName() == ServiceImplementReqOp::getImplTypeAttrName(*odsOpName)) {
      tblgen_impl_type = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == ServiceImplementReqOp::getImplOptsAttrName(*odsOpName)) {
      tblgen_impl_opts = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_service_symbol;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == ServiceImplementReqOp::getServiceSymbolAttrName(*odsOpName)) {
      tblgen_service_symbol = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_service_symbol && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(tblgen_service_symbol))))
    return emitError(loc, "'esi.service.impl_req' op ""attribute 'service_symbol' failed to satisfy constraint: flat symbol reference attribute");

  if (tblgen_impl_type && !((::llvm::isa<::mlir::StringAttr>(tblgen_impl_type))))
    return emitError(loc, "'esi.service.impl_req' op ""attribute 'impl_type' failed to satisfy constraint: string attribute");

  if (tblgen_impl_opts && !((::llvm::isa<::mlir::DictionaryAttr>(tblgen_impl_opts))))
    return emitError(loc, "'esi.service.impl_req' op ""attribute 'impl_opts' failed to satisfy constraint: dictionary of named attribute values");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ServiceImplementReqOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range ServiceImplementReqOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range ServiceImplementReqOp::getInputs() {
  return getODSOperands(0);
}

::mlir::MutableOperandRange ServiceImplementReqOp::getInputsMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> ServiceImplementReqOp::getODSResultIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumResults() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::result_range ServiceImplementReqOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::result_range ServiceImplementReqOp::getOutputs() {
  return getODSResults(0);
}

::mlir::Region &ServiceImplementReqOp::getPortReqs() {
  return (*this)->getRegion(0);
}

::mlir::FlatSymbolRefAttr ServiceImplementReqOp::getServiceSymbolAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getServiceSymbolAttrName()));
}

::std::optional< ::llvm::StringRef > ServiceImplementReqOp::getServiceSymbol() {
  auto attr = getServiceSymbolAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::StringAttr ServiceImplementReqOp::getImplTypeAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getImplTypeAttrName()));
}

::llvm::StringRef ServiceImplementReqOp::getImplType() {
  auto attr = getImplTypeAttr();
  return attr.getValue();
}

::mlir::DictionaryAttr ServiceImplementReqOp::getImplOptsAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::DictionaryAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getImplOptsAttrName()));
}

::std::optional< ::mlir::DictionaryAttr > ServiceImplementReqOp::getImplOpts() {
  auto attr = getImplOptsAttr();
  return attr ? ::std::optional< ::mlir::DictionaryAttr >(attr) : (::std::nullopt);
}

void ServiceImplementReqOp::setServiceSymbolAttr(::mlir::FlatSymbolRefAttr attr) {
  (*this)->setAttr(getServiceSymbolAttrName(), attr);
}

void ServiceImplementReqOp::setServiceSymbol(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getServiceSymbolAttrName(), ::mlir::SymbolRefAttr::get(::mlir::Builder((*this)->getContext()).getContext(), *attrValue));
    (*this)->removeAttr(getServiceSymbolAttrName());
}

void ServiceImplementReqOp::setImplTypeAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getImplTypeAttrName(), attr);
}

void ServiceImplementReqOp::setImplType(::llvm::StringRef attrValue) {
  (*this)->setAttr(getImplTypeAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void ServiceImplementReqOp::setImplOptsAttr(::mlir::DictionaryAttr attr) {
  (*this)->setAttr(getImplOptsAttrName(), attr);
}

::mlir::Attribute ServiceImplementReqOp::removeServiceSymbolAttr() {
return (*this)->removeAttr(getServiceSymbolAttrName());
}

::mlir::Attribute ServiceImplementReqOp::removeImplOptsAttr() {
return (*this)->removeAttr(getImplOptsAttrName());
}

void ServiceImplementReqOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange outputs, /*optional*/::mlir::FlatSymbolRefAttr service_symbol, ::mlir::StringAttr impl_type, /*optional*/::mlir::DictionaryAttr impl_opts, ::mlir::ValueRange inputs) {
  odsState.addOperands(inputs);
  if (service_symbol) {
    odsState.addAttribute(getServiceSymbolAttrName(odsState.name), service_symbol);
  }
  odsState.addAttribute(getImplTypeAttrName(odsState.name), impl_type);
  if (impl_opts) {
    odsState.addAttribute(getImplOptsAttrName(odsState.name), impl_opts);
  }
  (void)odsState.addRegion();
  odsState.addTypes(outputs);
}

void ServiceImplementReqOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange outputs, /*optional*/::mlir::FlatSymbolRefAttr service_symbol, ::llvm::StringRef impl_type, /*optional*/::mlir::DictionaryAttr impl_opts, ::mlir::ValueRange inputs) {
  odsState.addOperands(inputs);
  if (service_symbol) {
    odsState.addAttribute(getServiceSymbolAttrName(odsState.name), service_symbol);
  }
  odsState.addAttribute(getImplTypeAttrName(odsState.name), odsBuilder.getStringAttr(impl_type));
  if (impl_opts) {
    odsState.addAttribute(getImplOptsAttrName(odsState.name), impl_opts);
  }
  (void)odsState.addRegion();
  odsState.addTypes(outputs);
}

void ServiceImplementReqOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  for (unsigned i = 0; i != 1; ++i)
    (void)odsState.addRegion();
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ServiceImplementReqOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_impl_type;
  ::mlir::Attribute tblgen_impl_opts;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'impl_type'");
    if (namedAttrIt->getName() == getImplTypeAttrName()) {
      tblgen_impl_type = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getImplOptsAttrName()) {
      tblgen_impl_opts = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_service_symbol;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getServiceSymbolAttrName()) {
      tblgen_service_symbol = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI6(*this, tblgen_service_symbol, "service_symbol")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_impl_type, "impl_type")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI8(*this, tblgen_impl_opts, "impl_opts")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_ESI0(*this, region, "portReqs", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult ServiceImplementReqOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult ServiceImplementReqOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::FlatSymbolRefAttr service_symbolAttr;
  ::mlir::StringAttr impl_typeAttr;
  ::mlir::DictionaryAttr impl_optsAttr;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> inputsOperands;
  ::llvm::SMLoc inputsOperandsLoc;
  (void)inputsOperandsLoc;
  ::llvm::ArrayRef<::mlir::Type> inputsTypes;
  ::llvm::ArrayRef<::mlir::Type> allResultTypes;
  std::unique_ptr<::mlir::Region> portReqsRegion = std::make_unique<::mlir::Region>();
  if (::mlir::succeeded(parser.parseOptionalKeyword("svc"))) {

  if (parser.parseCustomAttributeWithFallback(service_symbolAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (service_symbolAttr) result.attributes.append("service_symbol", service_symbolAttr);
  }
  if (parser.parseKeyword("impl"))
    return ::mlir::failure();
  if (parser.parseKeyword("as"))
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(impl_typeAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (impl_typeAttr) result.attributes.append("impl_type", impl_typeAttr);
  if (::mlir::succeeded(parser.parseOptionalKeyword("opts"))) {

  if (parser.parseCustomAttributeWithFallback(impl_optsAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (impl_optsAttr) result.attributes.append("impl_opts", impl_optsAttr);
  }
  if (parser.parseLParen())
    return ::mlir::failure();

  inputsOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperandList(inputsOperands))
    return ::mlir::failure();
  if (parser.parseRParen())
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  ::mlir::FunctionType inputs__allResult_functionType;
  if (parser.parseType(inputs__allResult_functionType))
    return ::mlir::failure();
  inputsTypes = inputs__allResult_functionType.getInputs();
  allResultTypes = inputs__allResult_functionType.getResults();

  if (parser.parseRegion(*portReqsRegion))
    return ::mlir::failure();
  result.addRegion(std::move(portReqsRegion));
  result.addTypes(allResultTypes);
  if (parser.resolveOperands(inputsOperands, inputsTypes, inputsOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ServiceImplementReqOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getServiceSymbolAttr()) {
    _odsPrinter << ' ' << "svc";
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getServiceSymbolAttr());
  }
  _odsPrinter << ' ' << "impl";
  _odsPrinter << ' ' << "as";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getImplTypeAttr());
  if (getImplOptsAttr()) {
    _odsPrinter << ' ' << "opts";
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getImplOptsAttr());
  }
  _odsPrinter << "(";
  _odsPrinter << getInputs();
  _odsPrinter << ")";
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("service_symbol");
  elidedAttrs.push_back("impl_type");
  elidedAttrs.push_back("impl_opts");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  _odsPrinter.printFunctionalType(getInputs().getTypes(), getOperation()->getResultTypes());
  _odsPrinter << ' ';
  _odsPrinter.printRegion(getPortReqs());
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::ServiceImplementReqOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::ServiceInstanceOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ServiceInstanceOpGenericAdaptorBase::ServiceInstanceOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.service.instance", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ServiceInstanceOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr ServiceInstanceOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::FlatSymbolRefAttr ServiceInstanceOpGenericAdaptorBase::getServiceSymbolAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, ServiceInstanceOp::getServiceSymbolAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > ServiceInstanceOpGenericAdaptorBase::getServiceSymbol() {
  auto attr = getServiceSymbolAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::StringAttr ServiceInstanceOpGenericAdaptorBase::getImplTypeAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, ServiceInstanceOp::getImplTypeAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef ServiceInstanceOpGenericAdaptorBase::getImplType() {
  auto attr = getImplTypeAttr();
  return attr.getValue();
}

::mlir::DictionaryAttr ServiceInstanceOpGenericAdaptorBase::getImplOptsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::DictionaryAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, ServiceInstanceOp::getImplOptsAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::DictionaryAttr > ServiceInstanceOpGenericAdaptorBase::getImplOpts() {
  auto attr = getImplOptsAttr();
  return attr ? ::std::optional< ::mlir::DictionaryAttr >(attr) : (::std::nullopt);
}

} // namespace detail
ServiceInstanceOpAdaptor::ServiceInstanceOpAdaptor(ServiceInstanceOp op) : ServiceInstanceOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ServiceInstanceOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_impl_type;
  ::mlir::Attribute tblgen_impl_opts;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.instance' op ""requires attribute 'impl_type'");
    if (namedAttrIt->getName() == ServiceInstanceOp::getImplTypeAttrName(*odsOpName)) {
      tblgen_impl_type = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == ServiceInstanceOp::getImplOptsAttrName(*odsOpName)) {
      tblgen_impl_opts = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_service_symbol;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == ServiceInstanceOp::getServiceSymbolAttrName(*odsOpName)) {
      tblgen_service_symbol = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_service_symbol && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(tblgen_service_symbol))))
    return emitError(loc, "'esi.service.instance' op ""attribute 'service_symbol' failed to satisfy constraint: flat symbol reference attribute");

  if (tblgen_impl_type && !((::llvm::isa<::mlir::StringAttr>(tblgen_impl_type))))
    return emitError(loc, "'esi.service.instance' op ""attribute 'impl_type' failed to satisfy constraint: string attribute");

  if (tblgen_impl_opts && !((::llvm::isa<::mlir::DictionaryAttr>(tblgen_impl_opts))))
    return emitError(loc, "'esi.service.instance' op ""attribute 'impl_opts' failed to satisfy constraint: dictionary of named attribute values");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ServiceInstanceOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range ServiceInstanceOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range ServiceInstanceOp::getInputs() {
  return getODSOperands(0);
}

::mlir::MutableOperandRange ServiceInstanceOp::getInputsMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> ServiceInstanceOp::getODSResultIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumResults() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::result_range ServiceInstanceOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::FlatSymbolRefAttr ServiceInstanceOp::getServiceSymbolAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getServiceSymbolAttrName()));
}

::std::optional< ::llvm::StringRef > ServiceInstanceOp::getServiceSymbol() {
  auto attr = getServiceSymbolAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::StringAttr ServiceInstanceOp::getImplTypeAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getImplTypeAttrName()));
}

::llvm::StringRef ServiceInstanceOp::getImplType() {
  auto attr = getImplTypeAttr();
  return attr.getValue();
}

::mlir::DictionaryAttr ServiceInstanceOp::getImplOptsAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::DictionaryAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getImplOptsAttrName()));
}

::std::optional< ::mlir::DictionaryAttr > ServiceInstanceOp::getImplOpts() {
  auto attr = getImplOptsAttr();
  return attr ? ::std::optional< ::mlir::DictionaryAttr >(attr) : (::std::nullopt);
}

void ServiceInstanceOp::setServiceSymbolAttr(::mlir::FlatSymbolRefAttr attr) {
  (*this)->setAttr(getServiceSymbolAttrName(), attr);
}

void ServiceInstanceOp::setServiceSymbol(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getServiceSymbolAttrName(), ::mlir::SymbolRefAttr::get(::mlir::Builder((*this)->getContext()).getContext(), *attrValue));
    (*this)->removeAttr(getServiceSymbolAttrName());
}

void ServiceInstanceOp::setImplTypeAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getImplTypeAttrName(), attr);
}

void ServiceInstanceOp::setImplType(::llvm::StringRef attrValue) {
  (*this)->setAttr(getImplTypeAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void ServiceInstanceOp::setImplOptsAttr(::mlir::DictionaryAttr attr) {
  (*this)->setAttr(getImplOptsAttrName(), attr);
}

::mlir::Attribute ServiceInstanceOp::removeServiceSymbolAttr() {
return (*this)->removeAttr(getServiceSymbolAttrName());
}

::mlir::Attribute ServiceInstanceOp::removeImplOptsAttr() {
return (*this)->removeAttr(getImplOptsAttrName());
}

void ServiceInstanceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultType0, /*optional*/::mlir::FlatSymbolRefAttr service_symbol, ::mlir::StringAttr impl_type, /*optional*/::mlir::DictionaryAttr impl_opts, ::mlir::ValueRange inputs) {
  odsState.addOperands(inputs);
  if (service_symbol) {
    odsState.addAttribute(getServiceSymbolAttrName(odsState.name), service_symbol);
  }
  odsState.addAttribute(getImplTypeAttrName(odsState.name), impl_type);
  if (impl_opts) {
    odsState.addAttribute(getImplOptsAttrName(odsState.name), impl_opts);
  }
  odsState.addTypes(resultType0);
}

void ServiceInstanceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultType0, /*optional*/::mlir::FlatSymbolRefAttr service_symbol, ::llvm::StringRef impl_type, /*optional*/::mlir::DictionaryAttr impl_opts, ::mlir::ValueRange inputs) {
  odsState.addOperands(inputs);
  if (service_symbol) {
    odsState.addAttribute(getServiceSymbolAttrName(odsState.name), service_symbol);
  }
  odsState.addAttribute(getImplTypeAttrName(odsState.name), odsBuilder.getStringAttr(impl_type));
  if (impl_opts) {
    odsState.addAttribute(getImplOptsAttrName(odsState.name), impl_opts);
  }
  odsState.addTypes(resultType0);
}

void ServiceInstanceOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ServiceInstanceOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_impl_type;
  ::mlir::Attribute tblgen_impl_opts;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'impl_type'");
    if (namedAttrIt->getName() == getImplTypeAttrName()) {
      tblgen_impl_type = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getImplOptsAttrName()) {
      tblgen_impl_opts = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_service_symbol;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getServiceSymbolAttrName()) {
      tblgen_service_symbol = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI6(*this, tblgen_service_symbol, "service_symbol")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_impl_type, "impl_type")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI8(*this, tblgen_impl_opts, "impl_opts")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ServiceInstanceOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult ServiceInstanceOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::FlatSymbolRefAttr service_symbolAttr;
  ::mlir::StringAttr impl_typeAttr;
  ::mlir::DictionaryAttr impl_optsAttr;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> inputsOperands;
  ::llvm::SMLoc inputsOperandsLoc;
  (void)inputsOperandsLoc;
  ::llvm::ArrayRef<::mlir::Type> inputsTypes;
  ::llvm::ArrayRef<::mlir::Type> allResultTypes;
  if (::mlir::succeeded(parser.parseOptionalKeyword("svc"))) {

  if (parser.parseCustomAttributeWithFallback(service_symbolAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (service_symbolAttr) result.attributes.append("service_symbol", service_symbolAttr);
  }
  if (parser.parseKeyword("impl"))
    return ::mlir::failure();
  if (parser.parseKeyword("as"))
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(impl_typeAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (impl_typeAttr) result.attributes.append("impl_type", impl_typeAttr);
  if (::mlir::succeeded(parser.parseOptionalKeyword("opts"))) {

  if (parser.parseCustomAttributeWithFallback(impl_optsAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (impl_optsAttr) result.attributes.append("impl_opts", impl_optsAttr);
  }
  if (parser.parseLParen())
    return ::mlir::failure();

  inputsOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperandList(inputsOperands))
    return ::mlir::failure();
  if (parser.parseRParen())
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  ::mlir::FunctionType inputs__allResult_functionType;
  if (parser.parseType(inputs__allResult_functionType))
    return ::mlir::failure();
  inputsTypes = inputs__allResult_functionType.getInputs();
  allResultTypes = inputs__allResult_functionType.getResults();
  result.addTypes(allResultTypes);
  if (parser.resolveOperands(inputsOperands, inputsTypes, inputsOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ServiceInstanceOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getServiceSymbolAttr()) {
    _odsPrinter << ' ' << "svc";
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getServiceSymbolAttr());
  }
  _odsPrinter << ' ' << "impl";
  _odsPrinter << ' ' << "as";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getImplTypeAttr());
  if (getImplOptsAttr()) {
    _odsPrinter << ' ' << "opts";
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getImplOptsAttr());
  }
  _odsPrinter << "(";
  _odsPrinter << getInputs();
  _odsPrinter << ")";
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("service_symbol");
  elidedAttrs.push_back("impl_type");
  elidedAttrs.push_back("impl_opts");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  _odsPrinter.printFunctionalType(getInputs().getTypes(), getOperation()->getResultTypes());
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::ServiceInstanceOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::ToClientOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ToClientOpGenericAdaptorBase::ToClientOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.service.to_client", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ToClientOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ToClientOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr ToClientOpGenericAdaptorBase::getInnerSymAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, ToClientOp::getInnerSymAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef ToClientOpGenericAdaptorBase::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr.getValue();
}

::mlir::TypeAttr ToClientOpGenericAdaptorBase::getToClientTypeAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, ToClientOp::getToClientTypeAttrName(*odsOpName)));
  return attr;
}

::mlir::Type ToClientOpGenericAdaptorBase::getToClientType() {
  auto attr = getToClientTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

} // namespace detail
ToClientOpAdaptor::ToClientOpAdaptor(ToClientOp op) : ToClientOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ToClientOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_inner_sym;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.to_client' op ""requires attribute 'inner_sym'");
    if (namedAttrIt->getName() == ToClientOp::getInnerSymAttrName(*odsOpName)) {
      tblgen_inner_sym = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_toClientType;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.to_client' op ""requires attribute 'toClientType'");
    if (namedAttrIt->getName() == ToClientOp::getToClientTypeAttrName(*odsOpName)) {
      tblgen_toClientType = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_inner_sym && !((::llvm::isa<::mlir::StringAttr>(tblgen_inner_sym))))
    return emitError(loc, "'esi.service.to_client' op ""attribute 'inner_sym' failed to satisfy constraint: string attribute");

  if (tblgen_toClientType && !(((::llvm::isa<::mlir::TypeAttr>(tblgen_toClientType))) && ((::llvm::isa<::mlir::Type>(::llvm::cast<::mlir::TypeAttr>(tblgen_toClientType).getValue()))) && ((true))))
    return emitError(loc, "'esi.service.to_client' op ""attribute 'toClientType' failed to satisfy constraint: any type attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ToClientOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ToClientOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> ToClientOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ToClientOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr ToClientOp::getInnerSymAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getInnerSymAttrName()));
}

::llvm::StringRef ToClientOp::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr.getValue();
}

::mlir::TypeAttr ToClientOp::getToClientTypeAttr() {
  return ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getToClientTypeAttrName()));
}

::mlir::Type ToClientOp::getToClientType() {
  auto attr = getToClientTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

void ToClientOp::setInnerSymAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getInnerSymAttrName(), attr);
}

void ToClientOp::setInnerSym(::llvm::StringRef attrValue) {
  (*this)->setAttr(getInnerSymAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void ToClientOp::setToClientTypeAttr(::mlir::TypeAttr attr) {
  (*this)->setAttr(getToClientTypeAttrName(), attr);
}

void ToClientOp::setToClientType(::mlir::Type attrValue) {
  (*this)->setAttr(getToClientTypeAttrName(), ::mlir::TypeAttr::get(attrValue));
}

void ToClientOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr inner_sym, ::mlir::TypeAttr toClientType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), inner_sym);
  odsState.addAttribute(getToClientTypeAttrName(odsState.name), toClientType);
}

void ToClientOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr inner_sym, ::mlir::TypeAttr toClientType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), inner_sym);
  odsState.addAttribute(getToClientTypeAttrName(odsState.name), toClientType);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ToClientOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef inner_sym, ::mlir::Type toClientType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), odsBuilder.getStringAttr(inner_sym));
  odsState.addAttribute(getToClientTypeAttrName(odsState.name), ::mlir::TypeAttr::get(toClientType));
}

void ToClientOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef inner_sym, ::mlir::Type toClientType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), odsBuilder.getStringAttr(inner_sym));
  odsState.addAttribute(getToClientTypeAttrName(odsState.name), ::mlir::TypeAttr::get(toClientType));
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ToClientOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ToClientOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_inner_sym;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'inner_sym'");
    if (namedAttrIt->getName() == getInnerSymAttrName()) {
      tblgen_inner_sym = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_toClientType;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'toClientType'");
    if (namedAttrIt->getName() == getToClientTypeAttrName()) {
      tblgen_toClientType = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_inner_sym, "inner_sym")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI2(*this, tblgen_toClientType, "toClientType")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult ToClientOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult ToClientOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr inner_symAttr;
  ::mlir::TypeAttr toClientTypeAttr;

  if (parser.parseSymbolName(inner_symAttr))
    return ::mlir::failure();
  if (inner_symAttr) result.attributes.append("inner_sym", inner_symAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(toClientTypeAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (toClientTypeAttr) result.attributes.append("toClientType", toClientTypeAttr);
  return ::mlir::success();
}

void ToClientOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getInnerSymAttr().getValue());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("inner_sym");
  elidedAttrs.push_back("toClientType");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getToClientTypeAttr());
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::ToClientOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::ToServerOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ToServerOpGenericAdaptorBase::ToServerOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.service.to_server", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ToServerOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ToServerOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr ToServerOpGenericAdaptorBase::getInnerSymAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, ToServerOp::getInnerSymAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef ToServerOpGenericAdaptorBase::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr.getValue();
}

::mlir::TypeAttr ToServerOpGenericAdaptorBase::getToServerTypeAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, ToServerOp::getToServerTypeAttrName(*odsOpName)));
  return attr;
}

::mlir::Type ToServerOpGenericAdaptorBase::getToServerType() {
  auto attr = getToServerTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

} // namespace detail
ToServerOpAdaptor::ToServerOpAdaptor(ToServerOp op) : ToServerOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ToServerOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_inner_sym;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.to_server' op ""requires attribute 'inner_sym'");
    if (namedAttrIt->getName() == ToServerOp::getInnerSymAttrName(*odsOpName)) {
      tblgen_inner_sym = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_toServerType;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'esi.service.to_server' op ""requires attribute 'toServerType'");
    if (namedAttrIt->getName() == ToServerOp::getToServerTypeAttrName(*odsOpName)) {
      tblgen_toServerType = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_inner_sym && !((::llvm::isa<::mlir::StringAttr>(tblgen_inner_sym))))
    return emitError(loc, "'esi.service.to_server' op ""attribute 'inner_sym' failed to satisfy constraint: string attribute");

  if (tblgen_toServerType && !(((::llvm::isa<::mlir::TypeAttr>(tblgen_toServerType))) && ((::llvm::isa<::mlir::Type>(::llvm::cast<::mlir::TypeAttr>(tblgen_toServerType).getValue()))) && ((true))))
    return emitError(loc, "'esi.service.to_server' op ""attribute 'toServerType' failed to satisfy constraint: any type attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ToServerOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ToServerOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> ToServerOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ToServerOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr ToServerOp::getInnerSymAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getInnerSymAttrName()));
}

::llvm::StringRef ToServerOp::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr.getValue();
}

::mlir::TypeAttr ToServerOp::getToServerTypeAttr() {
  return ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getToServerTypeAttrName()));
}

::mlir::Type ToServerOp::getToServerType() {
  auto attr = getToServerTypeAttr();
  return ::llvm::cast<::mlir::Type>(attr.getValue());
}

void ToServerOp::setInnerSymAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getInnerSymAttrName(), attr);
}

void ToServerOp::setInnerSym(::llvm::StringRef attrValue) {
  (*this)->setAttr(getInnerSymAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void ToServerOp::setToServerTypeAttr(::mlir::TypeAttr attr) {
  (*this)->setAttr(getToServerTypeAttrName(), attr);
}

void ToServerOp::setToServerType(::mlir::Type attrValue) {
  (*this)->setAttr(getToServerTypeAttrName(), ::mlir::TypeAttr::get(attrValue));
}

void ToServerOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr inner_sym, ::mlir::TypeAttr toServerType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), inner_sym);
  odsState.addAttribute(getToServerTypeAttrName(odsState.name), toServerType);
}

void ToServerOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr inner_sym, ::mlir::TypeAttr toServerType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), inner_sym);
  odsState.addAttribute(getToServerTypeAttrName(odsState.name), toServerType);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ToServerOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef inner_sym, ::mlir::Type toServerType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), odsBuilder.getStringAttr(inner_sym));
  odsState.addAttribute(getToServerTypeAttrName(odsState.name), ::mlir::TypeAttr::get(toServerType));
}

void ToServerOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef inner_sym, ::mlir::Type toServerType) {
  odsState.addAttribute(getInnerSymAttrName(odsState.name), odsBuilder.getStringAttr(inner_sym));
  odsState.addAttribute(getToServerTypeAttrName(odsState.name), ::mlir::TypeAttr::get(toServerType));
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ToServerOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ToServerOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_inner_sym;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'inner_sym'");
    if (namedAttrIt->getName() == getInnerSymAttrName()) {
      tblgen_inner_sym = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_toServerType;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'toServerType'");
    if (namedAttrIt->getName() == getToServerTypeAttrName()) {
      tblgen_toServerType = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI1(*this, tblgen_inner_sym, "inner_sym")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_ESI2(*this, tblgen_toServerType, "toServerType")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult ToServerOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult ToServerOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr inner_symAttr;
  ::mlir::TypeAttr toServerTypeAttr;

  if (parser.parseSymbolName(inner_symAttr))
    return ::mlir::failure();
  if (inner_symAttr) result.attributes.append("inner_sym", inner_symAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(toServerTypeAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (toServerTypeAttr) result.attributes.append("toServerType", toServerTypeAttr);
  return ::mlir::success();
}

void ToServerOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getInnerSymAttr().getValue());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("inner_sym");
  elidedAttrs.push_back("toServerType");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getToServerTypeAttr());
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::ToServerOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::UnwrapFIFOOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
UnwrapFIFOOpGenericAdaptorBase::UnwrapFIFOOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.unwrap.fifo", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> UnwrapFIFOOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr UnwrapFIFOOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
UnwrapFIFOOpAdaptor::UnwrapFIFOOpAdaptor(UnwrapFIFOOp op) : UnwrapFIFOOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult UnwrapFIFOOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

void UnwrapFIFOOp::getAsmResultNames(::mlir::OpAsmSetValueNameFn setNameFn) {
  auto resultGroup0 = getODSResults(0);
  if (!resultGroup0.empty())
    setNameFn(*resultGroup0.begin(), "data");
  auto resultGroup1 = getODSResults(1);
  if (!resultGroup1.empty())
    setNameFn(*resultGroup1.begin(), "empty");
}

std::pair<unsigned, unsigned> UnwrapFIFOOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range UnwrapFIFOOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> UnwrapFIFOOp::getChanInput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> UnwrapFIFOOp::getRden() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::MutableOperandRange UnwrapFIFOOp::getChanInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange UnwrapFIFOOp::getRdenMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> UnwrapFIFOOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range UnwrapFIFOOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value UnwrapFIFOOp::getData() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> UnwrapFIFOOp::getEmpty() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(1).begin());
}

void UnwrapFIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Type empty, ::mlir::Value chanInput, ::mlir::Value rden) {
  odsState.addOperands(chanInput);
  odsState.addOperands(rden);
  odsState.addTypes(data);
  odsState.addTypes(empty);
}

void UnwrapFIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value chanInput, ::mlir::Value rden) {
  odsState.addOperands(chanInput);
  odsState.addOperands(rden);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(UnwrapFIFOOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void UnwrapFIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value chanInput, ::mlir::Value rden) {
  odsState.addOperands(chanInput);
  odsState.addOperands(rden);
  assert(resultTypes.size() == 2u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void UnwrapFIFOOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 2u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void UnwrapFIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(UnwrapFIFOOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 2u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult UnwrapFIFOOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSResults(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult UnwrapFIFOOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

void UnwrapFIFOOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::ParseResult UnwrapFIFOOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand chanInputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> chanInputOperands(chanInputRawOperands);  ::llvm::SMLoc chanInputOperandsLoc;
  (void)chanInputOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand rdenRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> rdenOperands(rdenRawOperands);  ::llvm::SMLoc rdenOperandsLoc;
  (void)rdenOperandsLoc;
  ::mlir::Type chanInputRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> chanInputTypes(chanInputRawTypes);

  chanInputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(chanInputRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  rdenOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(rdenRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseType(chanInputRawTypes[0]))
    return ::mlir::failure();
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  if (parser.resolveOperands(chanInputOperands, chanInputTypes, chanInputOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(rdenOperands, odsBuildableType0, rdenOperandsLoc, result.operands))
    return ::mlir::failure();

  ::llvm::SmallVector<::mlir::Type> inferredReturnTypes;
  if (::mlir::failed(UnwrapFIFOOp::inferReturnTypes(parser.getContext(),
      result.location, result.operands,
      result.attributes.getDictionary(parser.getContext()),
      result.getRawProperties(),
      result.regions, inferredReturnTypes)))
    return ::mlir::failure();
  result.addTypes(inferredReturnTypes);
  return ::mlir::success();
}

void UnwrapFIFOOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getChanInput();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getRden();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
   _odsPrinter << getChanInput().getType();
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::UnwrapFIFOOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::UnwrapSVInterfaceOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
UnwrapSVInterfaceOpGenericAdaptorBase::UnwrapSVInterfaceOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.unwrap.iface", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> UnwrapSVInterfaceOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr UnwrapSVInterfaceOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
UnwrapSVInterfaceOpAdaptor::UnwrapSVInterfaceOpAdaptor(UnwrapSVInterfaceOp op) : UnwrapSVInterfaceOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult UnwrapSVInterfaceOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> UnwrapSVInterfaceOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range UnwrapSVInterfaceOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> UnwrapSVInterfaceOp::getChanInput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSOperands(0).begin());
}

::mlir::Value UnwrapSVInterfaceOp::getInterfaceSource() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(1).begin());
}

::mlir::MutableOperandRange UnwrapSVInterfaceOp::getChanInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange UnwrapSVInterfaceOp::getInterfaceSourceMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> UnwrapSVInterfaceOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range UnwrapSVInterfaceOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

void UnwrapSVInterfaceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value chanInput, ::mlir::Value interfaceSource) {
  odsState.addOperands(chanInput);
  odsState.addOperands(interfaceSource);
}

void UnwrapSVInterfaceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value chanInput, ::mlir::Value interfaceSource) {
  odsState.addOperands(chanInput);
  odsState.addOperands(interfaceSource);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void UnwrapSVInterfaceOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult UnwrapSVInterfaceOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult UnwrapSVInterfaceOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult UnwrapSVInterfaceOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand chanInputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> chanInputOperands(chanInputRawOperands);  ::llvm::SMLoc chanInputOperandsLoc;
  (void)chanInputOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand interfaceSourceRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> interfaceSourceOperands(interfaceSourceRawOperands);  ::llvm::SMLoc interfaceSourceOperandsLoc;
  (void)interfaceSourceOperandsLoc;
  ::mlir::Type chanInputRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> chanInputTypes(chanInputRawTypes);
  ::mlir::Type interfaceSourceRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> interfaceSourceTypes(interfaceSourceRawTypes);

  chanInputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(chanInputRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("into"))
    return ::mlir::failure();

  interfaceSourceOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(interfaceSourceRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();
  if (parser.parseLParen())
    return ::mlir::failure();

  if (parser.parseType(chanInputRawTypes[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  if (parser.parseType(interfaceSourceRawTypes[0]))
    return ::mlir::failure();
  if (parser.parseRParen())
    return ::mlir::failure();
  if (parser.resolveOperands(chanInputOperands, chanInputTypes, chanInputOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(interfaceSourceOperands, interfaceSourceTypes, interfaceSourceOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void UnwrapSVInterfaceOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getChanInput();
  _odsPrinter << ' ' << "into";
  _odsPrinter << ' ';
  _odsPrinter << getInterfaceSource();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ' << "(";
   _odsPrinter << getChanInput().getType();
  _odsPrinter << ",";
  _odsPrinter << ' ';
   _odsPrinter << getInterfaceSource().getType();
  _odsPrinter << ")";
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::UnwrapSVInterfaceOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::UnwrapValidReadyOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
UnwrapValidReadyOpGenericAdaptorBase::UnwrapValidReadyOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.unwrap.vr", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> UnwrapValidReadyOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr UnwrapValidReadyOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
UnwrapValidReadyOpAdaptor::UnwrapValidReadyOpAdaptor(UnwrapValidReadyOp op) : UnwrapValidReadyOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult UnwrapValidReadyOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

void UnwrapValidReadyOp::getAsmResultNames(::mlir::OpAsmSetValueNameFn setNameFn) {
  auto resultGroup0 = getODSResults(0);
  if (!resultGroup0.empty())
    setNameFn(*resultGroup0.begin(), "rawOutput");
  auto resultGroup1 = getODSResults(1);
  if (!resultGroup1.empty())
    setNameFn(*resultGroup1.begin(), "valid");
}

std::pair<unsigned, unsigned> UnwrapValidReadyOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range UnwrapValidReadyOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> UnwrapValidReadyOp::getChanInput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> UnwrapValidReadyOp::getReady() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::MutableOperandRange UnwrapValidReadyOp::getChanInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange UnwrapValidReadyOp::getReadyMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> UnwrapValidReadyOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range UnwrapValidReadyOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value UnwrapValidReadyOp::getRawOutput() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> UnwrapValidReadyOp::getValid() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(1).begin());
}

void UnwrapValidReadyOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type rawOutput, ::mlir::Type valid, ::mlir::Value chanInput, ::mlir::Value ready) {
  odsState.addOperands(chanInput);
  odsState.addOperands(ready);
  odsState.addTypes(rawOutput);
  odsState.addTypes(valid);
}

void UnwrapValidReadyOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value chanInput, ::mlir::Value ready) {
  odsState.addOperands(chanInput);
  odsState.addOperands(ready);
  assert(resultTypes.size() == 2u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void UnwrapValidReadyOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 2u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult UnwrapValidReadyOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSResults(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult UnwrapValidReadyOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::UnwrapValidReadyOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::UnwrapWindow definitions
//===----------------------------------------------------------------------===//

namespace detail {
UnwrapWindowGenericAdaptorBase::UnwrapWindowGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.window.unwrap", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> UnwrapWindowGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr UnwrapWindowGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
UnwrapWindowAdaptor::UnwrapWindowAdaptor(UnwrapWindow op) : UnwrapWindowAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult UnwrapWindowAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> UnwrapWindow::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range UnwrapWindow::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::WindowType> UnwrapWindow::getWindow() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::WindowType>>(*getODSOperands(0).begin());
}

::mlir::MutableOperandRange UnwrapWindow::getWindowMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> UnwrapWindow::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range UnwrapWindow::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::hw::TypeAliasOr<hw::UnionType>> UnwrapWindow::getFrame() {
  return ::llvm::cast<::mlir::TypedValue<::circt::hw::TypeAliasOr<hw::UnionType>>>(*getODSResults(0).begin());
}

void UnwrapWindow::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type frame, ::mlir::Value window) {
  odsState.addOperands(window);
  odsState.addTypes(frame);
}

void UnwrapWindow::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value window) {
  odsState.addOperands(window);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(UnwrapWindow::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void UnwrapWindow::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value window) {
  odsState.addOperands(window);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void UnwrapWindow::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void UnwrapWindow::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(UnwrapWindow::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult UnwrapWindow::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI5(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI6(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult UnwrapWindow::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult UnwrapWindow::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand windowRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> windowOperands(windowRawOperands);  ::llvm::SMLoc windowOperandsLoc;
  (void)windowOperandsLoc;
  ::mlir::Type windowRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> windowTypes(windowRawTypes);

  windowOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(windowRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseType(windowRawTypes[0]))
    return ::mlir::failure();
  if (parser.resolveOperands(windowOperands, windowTypes, windowOperandsLoc, result.operands))
    return ::mlir::failure();

  ::llvm::SmallVector<::mlir::Type> inferredReturnTypes;
  if (::mlir::failed(UnwrapWindow::inferReturnTypes(parser.getContext(),
      result.location, result.operands,
      result.attributes.getDictionary(parser.getContext()),
      result.getRawProperties(),
      result.regions, inferredReturnTypes)))
    return ::mlir::failure();
  result.addTypes(inferredReturnTypes);
  return ::mlir::success();
}

void UnwrapWindow::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getWindow();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
   _odsPrinter << getWindow().getType();
}

void UnwrapWindow::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::UnwrapWindow)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::WrapFIFOOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
WrapFIFOOpGenericAdaptorBase::WrapFIFOOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.wrap.fifo", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> WrapFIFOOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr WrapFIFOOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
WrapFIFOOpAdaptor::WrapFIFOOpAdaptor(WrapFIFOOp op) : WrapFIFOOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult WrapFIFOOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

void WrapFIFOOp::getAsmResultNames(::mlir::OpAsmSetValueNameFn setNameFn) {
  auto resultGroup0 = getODSResults(0);
  if (!resultGroup0.empty())
    setNameFn(*resultGroup0.begin(), "chanOutput");
  auto resultGroup1 = getODSResults(1);
  if (!resultGroup1.empty())
    setNameFn(*resultGroup1.begin(), "rden");
}

std::pair<unsigned, unsigned> WrapFIFOOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range WrapFIFOOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value WrapFIFOOp::getData() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> WrapFIFOOp::getEmpty() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::MutableOperandRange WrapFIFOOp::getDataMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange WrapFIFOOp::getEmptyMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> WrapFIFOOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range WrapFIFOOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> WrapFIFOOp::getChanOutput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSResults(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> WrapFIFOOp::getRden() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(1).begin());
}

void WrapFIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type chanOutput, ::mlir::Type rden, ::mlir::Value data, ::mlir::Value empty) {
  odsState.addOperands(data);
  odsState.addOperands(empty);
  odsState.addTypes(chanOutput);
  odsState.addTypes(rden);
}

void WrapFIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value data, ::mlir::Value empty) {
  odsState.addOperands(data);
  odsState.addOperands(empty);
  assert(resultTypes.size() == 2u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void WrapFIFOOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 2u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult WrapFIFOOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSResults(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult WrapFIFOOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

void WrapFIFOOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::ParseResult WrapFIFOOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand dataRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> dataOperands(dataRawOperands);  ::llvm::SMLoc dataOperandsLoc;
  (void)dataOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand emptyRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> emptyOperands(emptyRawOperands);  ::llvm::SMLoc emptyOperandsLoc;
  (void)emptyOperandsLoc;
  ::mlir::Type dataRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> dataTypes(dataRawTypes);
  ::mlir::Type chanOutputRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> chanOutputTypes(chanOutputRawTypes);

  dataOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(dataRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  emptyOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(emptyRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();
  {
    if (parseWrapFIFOType(parser, dataRawTypes[0], chanOutputRawTypes[0]))
      return ::mlir::failure();
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  result.addTypes(chanOutputTypes);
  result.addTypes(odsBuildableType0);
  if (parser.resolveOperands(dataOperands, dataTypes, dataOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(emptyOperands, odsBuildableType0, emptyOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void WrapFIFOOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getData();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getEmpty();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  printWrapFIFOType(_odsPrinter, *this, getData().getType(), getChanOutput().getType());
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::WrapFIFOOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::WrapSVInterfaceOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
WrapSVInterfaceOpGenericAdaptorBase::WrapSVInterfaceOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.wrap.iface", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> WrapSVInterfaceOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr WrapSVInterfaceOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
WrapSVInterfaceOpAdaptor::WrapSVInterfaceOpAdaptor(WrapSVInterfaceOp op) : WrapSVInterfaceOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult WrapSVInterfaceOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> WrapSVInterfaceOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range WrapSVInterfaceOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value WrapSVInterfaceOp::getInterfaceSink() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::MutableOperandRange WrapSVInterfaceOp::getInterfaceSinkMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> WrapSVInterfaceOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range WrapSVInterfaceOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> WrapSVInterfaceOp::getOutput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSResults(0).begin());
}

void WrapSVInterfaceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Value interfaceSink) {
  odsState.addOperands(interfaceSink);
  odsState.addTypes(output);
}

void WrapSVInterfaceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value interfaceSink) {
  odsState.addOperands(interfaceSink);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void WrapSVInterfaceOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult WrapSVInterfaceOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult WrapSVInterfaceOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult WrapSVInterfaceOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand interfaceSinkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> interfaceSinkOperands(interfaceSinkRawOperands);  ::llvm::SMLoc interfaceSinkOperandsLoc;
  (void)interfaceSinkOperandsLoc;
  ::mlir::Type interfaceSinkRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> interfaceSinkTypes(interfaceSinkRawTypes);
  ::mlir::Type outputRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> outputTypes(outputRawTypes);

  interfaceSinkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(interfaceSinkRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseType(interfaceSinkRawTypes[0]))
    return ::mlir::failure();
  if (parser.parseArrow())
    return ::mlir::failure();

  if (parser.parseType(outputRawTypes[0]))
    return ::mlir::failure();
  result.addTypes(outputTypes);
  if (parser.resolveOperands(interfaceSinkOperands, interfaceSinkTypes, interfaceSinkOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void WrapSVInterfaceOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getInterfaceSink();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
   _odsPrinter << getInterfaceSink().getType();
  _odsPrinter << ' ' << "->";
  _odsPrinter << ' ';
   _odsPrinter << getOutput().getType();
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::WrapSVInterfaceOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::WrapValidReadyOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
WrapValidReadyOpGenericAdaptorBase::WrapValidReadyOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.wrap.vr", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> WrapValidReadyOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr WrapValidReadyOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
WrapValidReadyOpAdaptor::WrapValidReadyOpAdaptor(WrapValidReadyOp op) : WrapValidReadyOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult WrapValidReadyOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

void WrapValidReadyOp::getAsmResultNames(::mlir::OpAsmSetValueNameFn setNameFn) {
  auto resultGroup0 = getODSResults(0);
  if (!resultGroup0.empty())
    setNameFn(*resultGroup0.begin(), "chanOutput");
  auto resultGroup1 = getODSResults(1);
  if (!resultGroup1.empty())
    setNameFn(*resultGroup1.begin(), "ready");
}

std::pair<unsigned, unsigned> WrapValidReadyOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range WrapValidReadyOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value WrapValidReadyOp::getRawInput() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> WrapValidReadyOp::getValid() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::MutableOperandRange WrapValidReadyOp::getRawInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange WrapValidReadyOp::getValidMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> WrapValidReadyOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range WrapValidReadyOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::ChannelType> WrapValidReadyOp::getChanOutput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::ChannelType>>(*getODSResults(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> WrapValidReadyOp::getReady() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(1).begin());
}

void WrapValidReadyOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type chanOutput, ::mlir::Type ready, ::mlir::Value rawInput, ::mlir::Value valid) {
  odsState.addOperands(rawInput);
  odsState.addOperands(valid);
  odsState.addTypes(chanOutput);
  odsState.addTypes(ready);
}

void WrapValidReadyOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value rawInput, ::mlir::Value valid) {
  odsState.addOperands(rawInput);
  odsState.addOperands(valid);
  assert(resultTypes.size() == 2u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void WrapValidReadyOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 2u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult WrapValidReadyOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSResults(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult WrapValidReadyOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::WrapValidReadyOp)

namespace circt {
namespace esi {

//===----------------------------------------------------------------------===//
// ::circt::esi::WrapWindow definitions
//===----------------------------------------------------------------------===//

namespace detail {
WrapWindowGenericAdaptorBase::WrapWindowGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("esi.window.wrap", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> WrapWindowGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr WrapWindowGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
WrapWindowAdaptor::WrapWindowAdaptor(WrapWindow op) : WrapWindowAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult WrapWindowAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> WrapWindow::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range WrapWindow::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::hw::TypeAliasOr<hw::UnionType>> WrapWindow::getFrame() {
  return ::llvm::cast<::mlir::TypedValue<::circt::hw::TypeAliasOr<hw::UnionType>>>(*getODSOperands(0).begin());
}

::mlir::MutableOperandRange WrapWindow::getFrameMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> WrapWindow::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range WrapWindow::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::esi::WindowType> WrapWindow::getWindow() {
  return ::llvm::cast<::mlir::TypedValue<::circt::esi::WindowType>>(*getODSResults(0).begin());
}

void WrapWindow::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type window, ::mlir::Value frame) {
  odsState.addOperands(frame);
  odsState.addTypes(window);
}

void WrapWindow::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value frame) {
  odsState.addOperands(frame);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void WrapWindow::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult WrapWindow::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI6(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_ESI5(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult WrapWindow::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult WrapWindow::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand frameRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> frameOperands(frameRawOperands);  ::llvm::SMLoc frameOperandsLoc;
  (void)frameOperandsLoc;
  ::mlir::Type frameRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> frameTypes(frameRawTypes);
  ::mlir::Type windowRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> windowTypes(windowRawTypes);

  frameOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(frameRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();
  {
    if (parseInferWindowRet(parser, frameRawTypes[0], windowRawTypes[0]))
      return ::mlir::failure();
  }
  result.addTypes(windowTypes);
  if (parser.resolveOperands(frameOperands, frameTypes, frameOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void WrapWindow::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getFrame();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  printInferWindowRet(_odsPrinter, *this, getFrame().getType(), getWindow().getType());
}

void WrapWindow::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace esi
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::esi::WrapWindow)


#endif  // GET_OP_CLASSES

