/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Op Definitions                                                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_OP_LIST
#undef GET_OP_LIST

::circt::msft::ChannelOp,
::circt::msft::DeclPhysicalRegionOp,
::circt::msft::DesignPartitionOp,
::circt::msft::DynamicInstanceOp,
::circt::msft::DynamicInstanceVerbatimAttrOp,
::circt::msft::EntityExternOp,
::circt::msft::InstanceHierarchyOp,
::circt::msft::InstanceOp,
::circt::msft::LinearOp,
::circt::msft::MSFTModuleExternOp,
::circt::msft::MSFTModuleOp,
::circt::msft::OutputOp,
::circt::msft::PDPhysLocationOp,
::circt::msft::PDPhysRegionOp,
::circt::msft::PDRegPhysLocationOp,
::circt::msft::PEOutputOp,
::circt::msft::SystolicArrayOp
#endif  // GET_OP_LIST

#ifdef GET_OP_CLASSES
#undef GET_OP_CLASSES


//===----------------------------------------------------------------------===//
// Local Utility Method Definitions
//===----------------------------------------------------------------------===//

namespace circt {
namespace msft {

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_MSFT0(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((true))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be any type, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_MSFT1(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((type.isSignlessInteger(1)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be 1-bit signless integer, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_MSFT2(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::circt::hw::type_isa<circt::hw::ArrayType>(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be an ArrayType, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_MSFT3(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((
      hw::type_isa<hw::ArrayType>(type) &&
      hw::type_isa<hw::ArrayType>(
        hw::type_cast<hw::ArrayType>(type).getElementType())
    ))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be an array of arrays, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT0(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::mlir::StringAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: string attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT0(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT0(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT1(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isUnsignedInteger(64)))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: 64-bit unsigned integer attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT1(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT1(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT2(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::ArrayAttr>(attr))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(attr), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::circt::msft::PhysicalBoundsAttr>(attr))); }))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: array of PhysicalBounds";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT2(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT2(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT3(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::circt::hw::InnerRefAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: Refer to a name inside a module";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT3(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT3(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT4(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: flat symbol reference attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT4(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT4(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT5(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((true)))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: any attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT5(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT5(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT6(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::ArrayAttr>(attr))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(attr), [&](::mlir::Attribute attr) { return attr && ((attr.isa<hw::ParamDeclAttr>())); }))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: parameter array";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT6(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT6(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT7(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::mlir::SymbolRefAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: symbol reference attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT7(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT7(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT8(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::TypeAttr>(attr))) && ((::llvm::isa<::mlir::FunctionType>(::llvm::cast<::mlir::TypeAttr>(attr).getValue()))) && ((::llvm::isa<::mlir::FunctionType>(::llvm::cast<::mlir::TypeAttr>(attr).getValue())))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: type attribute of function type";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT8(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT8(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT9(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::ArrayAttr>(attr))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(attr), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::DictionaryAttr>(attr))); }))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: Array of dictionary attributes";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT9(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT9(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT10(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::ArrayAttr>(attr))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(attr), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: string array attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT10(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT10(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT11(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::ArrayAttr>(attr))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(attr), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::LocationAttr>(attr))); }))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: location array attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT11(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT11(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT12(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::mlir::DictionaryAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: dictionary of named attribute values";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT12(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT12(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT13(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::circt::msft::PhysLocationAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: Descibes a physical location on a device";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT13(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT13(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT14(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::circt::msft::LocationVectorAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: Vector of optional locations corresponding to bits in a type";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_MSFT14(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_MSFT14(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_region_constraint_MSFT0(
    ::mlir::Operation *op, ::mlir::Region &region, ::llvm::StringRef regionName,
    unsigned regionIndex) {
  if (!((::llvm::hasNItems(region, 1)))) {
    return op->emitOpError("region #") << regionIndex
        << (regionName.empty() ? " " : " ('" + regionName + "') ")
        << "failed to verify constraint: region with 1 blocks";
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_region_constraint_MSFT1(
    ::mlir::Operation *op, ::mlir::Region &region, ::llvm::StringRef regionName,
    unsigned regionIndex) {
  if (!((::llvm::hasNItems(region, 0)))) {
    return op->emitOpError("region #") << regionIndex
        << (regionName.empty() ? " " : " ('" + regionName + "') ")
        << "failed to verify constraint: region with 0 blocks";
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_region_constraint_MSFT2(
    ::mlir::Operation *op, ::mlir::Region &region, ::llvm::StringRef regionName,
    unsigned regionIndex) {
  if (!((::llvm::hasNItemsOrLess(region, 1)))) {
    return op->emitOpError("region #") << regionIndex
        << (regionName.empty() ? " " : " ('" + regionName + "') ")
        << "failed to verify constraint: region with at most 1 block";
  }
  return ::mlir::success();
}
} // namespace msft
} // namespace circt
namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::ChannelOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ChannelOpGenericAdaptorBase::ChannelOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.constructs.channel", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ChannelOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ChannelOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr ChannelOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, ChannelOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef ChannelOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::IntegerAttr ChannelOpGenericAdaptorBase::getDefaultStagesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, ChannelOp::getDefaultStagesAttrName(*odsOpName)));
  return attr;
}

uint64_t ChannelOpGenericAdaptorBase::getDefaultStages() {
  auto attr = getDefaultStagesAttr();
  return attr.getValue().getZExtValue();
}

} // namespace detail
ChannelOpAdaptor::ChannelOpAdaptor(ChannelOp op) : ChannelOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ChannelOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_defaultStages;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.constructs.channel' op ""requires attribute 'defaultStages'");
    if (namedAttrIt->getName() == ChannelOp::getDefaultStagesAttrName(*odsOpName)) {
      tblgen_defaultStages = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.constructs.channel' op ""requires attribute 'sym_name'");
    if (namedAttrIt->getName() == ChannelOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'msft.constructs.channel' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");

  if (tblgen_defaultStages && !(((::llvm::isa<::mlir::IntegerAttr>(tblgen_defaultStages))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_defaultStages).getType().isUnsignedInteger(64)))))
    return emitError(loc, "'msft.constructs.channel' op ""attribute 'defaultStages' failed to satisfy constraint: 64-bit unsigned integer attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ChannelOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ChannelOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value ChannelOp::getInput() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> ChannelOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::MutableOperandRange ChannelOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange ChannelOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> ChannelOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ChannelOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value ChannelOp::getOutput() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::StringAttr ChannelOp::getSymNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::llvm::StringRef ChannelOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::IntegerAttr ChannelOp::getDefaultStagesAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getDefaultStagesAttrName()));
}

uint64_t ChannelOp::getDefaultStages() {
  auto attr = getDefaultStagesAttr();
  return attr.getValue().getZExtValue();
}

void ChannelOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void ChannelOp::setSymName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void ChannelOp::setDefaultStagesAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getDefaultStagesAttrName(), attr);
}

void ChannelOp::setDefaultStages(uint64_t attrValue) {
  (*this)->setAttr(getDefaultStagesAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64, /*isSigned=*/false), attrValue));
}

void ChannelOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Value input, ::mlir::Value clk, ::mlir::StringAttr sym_name, ::mlir::IntegerAttr defaultStages) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getDefaultStagesAttrName(odsState.name), defaultStages);
  odsState.addTypes(output);
}

void ChannelOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input, ::mlir::Value clk, ::mlir::StringAttr sym_name, ::mlir::IntegerAttr defaultStages) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getDefaultStagesAttrName(odsState.name), defaultStages);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ChannelOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ChannelOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value clk, ::mlir::StringAttr sym_name, ::mlir::IntegerAttr defaultStages) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getDefaultStagesAttrName(odsState.name), defaultStages);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ChannelOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Value input, ::mlir::Value clk, ::llvm::StringRef sym_name, uint64_t defaultStages) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getDefaultStagesAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64, /*isSigned=*/false), defaultStages));
  odsState.addTypes(output);
}

void ChannelOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input, ::mlir::Value clk, ::llvm::StringRef sym_name, uint64_t defaultStages) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getDefaultStagesAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64, /*isSigned=*/false), defaultStages));

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ChannelOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ChannelOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value clk, ::llvm::StringRef sym_name, uint64_t defaultStages) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getDefaultStagesAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64, /*isSigned=*/false), defaultStages));
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ChannelOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void ChannelOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(ChannelOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult ChannelOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_defaultStages;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'defaultStages'");
    if (namedAttrIt->getName() == getDefaultStagesAttrName()) {
      tblgen_defaultStages = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'sym_name'");
    if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT1(*this, tblgen_defaultStages, "defaultStages")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((((*this->getODSOperands(0).begin()).getType()) == ((*this->getODSResults(0).begin()).getType()) && ((*this->getODSResults(0).begin()).getType()) == ((*this->getODSOperands(0).begin()).getType()))))
    return emitOpError("failed to verify that all of {input, output} have same type");
  return ::mlir::success();
}

::mlir::LogicalResult ChannelOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::LogicalResult ChannelOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = operands[0].getType();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult ChannelOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand inputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> inputOperands(inputRawOperands);  ::llvm::SMLoc inputOperandsLoc;
  (void)inputOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::mlir::StringAttr sym_nameAttr;
  ::mlir::IntegerAttr defaultStagesAttr;
  ::mlir::Type inputRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> inputTypes(inputRawTypes);

  inputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(inputRawOperands[0]))
    return ::mlir::failure();

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(sym_nameAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);
  if (parser.parseLParen())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(defaultStagesAttr, parser.getBuilder().getIntegerType(64, /*isSigned=*/false))) {
    return ::mlir::failure();
  }
  if (defaultStagesAttr) result.attributes.append("defaultStages", defaultStagesAttr);
  if (parser.parseRParen())
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::mlir::Type type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    inputRawTypes[0] = type;
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  result.addTypes(inputTypes[0]);
  if (parser.resolveOperands(inputOperands, inputTypes, inputOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ChannelOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getInput();
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getSymNameAttr());
  _odsPrinter << "(";
  _odsPrinter.printAttributeWithoutType(getDefaultStagesAttr());
  _odsPrinter << ")";
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  elidedAttrs.push_back("defaultStages");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getInput().getType();
    if (auto validType = ::llvm::dyn_cast<::mlir::Type>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

void ChannelOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::ChannelOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::DeclPhysicalRegionOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
DeclPhysicalRegionOpGenericAdaptorBase::DeclPhysicalRegionOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.physical_region", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> DeclPhysicalRegionOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr DeclPhysicalRegionOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr DeclPhysicalRegionOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, DeclPhysicalRegionOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef DeclPhysicalRegionOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::ArrayAttr DeclPhysicalRegionOpGenericAdaptorBase::getBoundsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, DeclPhysicalRegionOp::getBoundsAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr DeclPhysicalRegionOpGenericAdaptorBase::getBounds() {
  auto attr = getBoundsAttr();
  return attr;
}

} // namespace detail
DeclPhysicalRegionOpAdaptor::DeclPhysicalRegionOpAdaptor(DeclPhysicalRegionOp op) : DeclPhysicalRegionOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult DeclPhysicalRegionOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_bounds;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.physical_region' op ""requires attribute 'bounds'");
    if (namedAttrIt->getName() == DeclPhysicalRegionOp::getBoundsAttrName(*odsOpName)) {
      tblgen_bounds = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.physical_region' op ""requires attribute 'sym_name'");
    if (namedAttrIt->getName() == DeclPhysicalRegionOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'msft.physical_region' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");

  if (tblgen_bounds && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_bounds))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_bounds), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::circt::msft::PhysicalBoundsAttr>(attr))); }))))
    return emitError(loc, "'msft.physical_region' op ""attribute 'bounds' failed to satisfy constraint: array of PhysicalBounds");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> DeclPhysicalRegionOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range DeclPhysicalRegionOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> DeclPhysicalRegionOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range DeclPhysicalRegionOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr DeclPhysicalRegionOp::getSymNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::llvm::StringRef DeclPhysicalRegionOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::ArrayAttr DeclPhysicalRegionOp::getBoundsAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getBoundsAttrName()));
}

::mlir::ArrayAttr DeclPhysicalRegionOp::getBounds() {
  auto attr = getBoundsAttr();
  return attr;
}

void DeclPhysicalRegionOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void DeclPhysicalRegionOp::setSymName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void DeclPhysicalRegionOp::setBoundsAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getBoundsAttrName(), attr);
}

void DeclPhysicalRegionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr sym_name, ::mlir::ArrayAttr bounds) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getBoundsAttrName(odsState.name), bounds);
}

void DeclPhysicalRegionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr sym_name, ::mlir::ArrayAttr bounds) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getBoundsAttrName(odsState.name), bounds);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void DeclPhysicalRegionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef sym_name, ::mlir::ArrayAttr bounds) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getBoundsAttrName(odsState.name), bounds);
}

void DeclPhysicalRegionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef sym_name, ::mlir::ArrayAttr bounds) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getBoundsAttrName(odsState.name), bounds);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void DeclPhysicalRegionOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult DeclPhysicalRegionOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_bounds;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'bounds'");
    if (namedAttrIt->getName() == getBoundsAttrName()) {
      tblgen_bounds = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'sym_name'");
    if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT2(*this, tblgen_bounds, "bounds")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult DeclPhysicalRegionOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult DeclPhysicalRegionOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  ::mlir::ArrayAttr boundsAttr;

  if (parser.parseSymbolName(sym_nameAttr))
    return ::mlir::failure();
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);
  if (parser.parseComma())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(boundsAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (boundsAttr) result.attributes.append("bounds", boundsAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void DeclPhysicalRegionOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getBoundsAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  elidedAttrs.push_back("bounds");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::DeclPhysicalRegionOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::DesignPartitionOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
DesignPartitionOpGenericAdaptorBase::DesignPartitionOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.partition", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> DesignPartitionOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr DesignPartitionOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr DesignPartitionOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, DesignPartitionOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef DesignPartitionOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::StringAttr DesignPartitionOpGenericAdaptorBase::getVerilogNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, DesignPartitionOp::getVerilogNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef DesignPartitionOpGenericAdaptorBase::getVerilogName() {
  auto attr = getVerilogNameAttr();
  return attr.getValue();
}

} // namespace detail
DesignPartitionOpAdaptor::DesignPartitionOpAdaptor(DesignPartitionOp op) : DesignPartitionOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult DesignPartitionOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.partition' op ""requires attribute 'sym_name'");
    if (namedAttrIt->getName() == DesignPartitionOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_verilogName;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.partition' op ""requires attribute 'verilogName'");
    if (namedAttrIt->getName() == DesignPartitionOp::getVerilogNameAttrName(*odsOpName)) {
      tblgen_verilogName = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'msft.partition' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");

  if (tblgen_verilogName && !((::llvm::isa<::mlir::StringAttr>(tblgen_verilogName))))
    return emitError(loc, "'msft.partition' op ""attribute 'verilogName' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> DesignPartitionOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range DesignPartitionOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> DesignPartitionOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range DesignPartitionOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr DesignPartitionOp::getSymNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getSymNameAttrName()));
}

::llvm::StringRef DesignPartitionOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::StringAttr DesignPartitionOp::getVerilogNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getVerilogNameAttrName()));
}

::llvm::StringRef DesignPartitionOp::getVerilogName() {
  auto attr = getVerilogNameAttr();
  return attr.getValue();
}

void DesignPartitionOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void DesignPartitionOp::setSymName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void DesignPartitionOp::setVerilogNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getVerilogNameAttrName(), attr);
}

void DesignPartitionOp::setVerilogName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getVerilogNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void DesignPartitionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr sym_name, ::mlir::StringAttr verilogName) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getVerilogNameAttrName(odsState.name), verilogName);
}

void DesignPartitionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr sym_name, ::mlir::StringAttr verilogName) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getVerilogNameAttrName(odsState.name), verilogName);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void DesignPartitionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef sym_name, ::llvm::StringRef verilogName) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getVerilogNameAttrName(odsState.name), odsBuilder.getStringAttr(verilogName));
}

void DesignPartitionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef sym_name, ::llvm::StringRef verilogName) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getVerilogNameAttrName(odsState.name), odsBuilder.getStringAttr(verilogName));
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void DesignPartitionOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult DesignPartitionOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'sym_name'");
    if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_verilogName;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'verilogName'");
    if (namedAttrIt->getName() == getVerilogNameAttrName()) {
      tblgen_verilogName = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_verilogName, "verilogName")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult DesignPartitionOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult DesignPartitionOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  ::mlir::StringAttr verilogNameAttr;

  if (parser.parseSymbolName(sym_nameAttr))
    return ::mlir::failure();
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);
  if (parser.parseComma())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(verilogNameAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (verilogNameAttr) result.attributes.append("verilogName", verilogNameAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void DesignPartitionOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getVerilogNameAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  elidedAttrs.push_back("verilogName");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::DesignPartitionOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::DynamicInstanceOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
DynamicInstanceOpGenericAdaptorBase::DynamicInstanceOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.instance.dynamic", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> DynamicInstanceOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr DynamicInstanceOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::circt::hw::InnerRefAttr DynamicInstanceOpGenericAdaptorBase::getInstanceRefAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::circt::hw::InnerRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, DynamicInstanceOp::getInstanceRefAttrName(*odsOpName)));
  return attr;
}

::circt::hw::InnerRefAttr DynamicInstanceOpGenericAdaptorBase::getInstanceRef() {
  auto attr = getInstanceRefAttr();
  return ::llvm::cast<::circt::hw::InnerRefAttr>(attr);
}

::mlir::Region &DynamicInstanceOpGenericAdaptorBase::getBody() {
  return *odsRegions[0];
}

::mlir::RegionRange DynamicInstanceOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
DynamicInstanceOpAdaptor::DynamicInstanceOpAdaptor(DynamicInstanceOp op) : DynamicInstanceOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult DynamicInstanceOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_instanceRef;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.instance.dynamic' op ""requires attribute 'instanceRef'");
    if (namedAttrIt->getName() == DynamicInstanceOp::getInstanceRefAttrName(*odsOpName)) {
      tblgen_instanceRef = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_instanceRef && !((::llvm::isa<::circt::hw::InnerRefAttr>(tblgen_instanceRef))))
    return emitError(loc, "'msft.instance.dynamic' op ""attribute 'instanceRef' failed to satisfy constraint: Refer to a name inside a module");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> DynamicInstanceOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range DynamicInstanceOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> DynamicInstanceOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range DynamicInstanceOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Region &DynamicInstanceOp::getBody() {
  return (*this)->getRegion(0);
}

::circt::hw::InnerRefAttr DynamicInstanceOp::getInstanceRefAttr() {
  return ::llvm::cast<::circt::hw::InnerRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getInstanceRefAttrName()));
}

::circt::hw::InnerRefAttr DynamicInstanceOp::getInstanceRef() {
  auto attr = getInstanceRefAttr();
  return ::llvm::cast<::circt::hw::InnerRefAttr>(attr);
}

void DynamicInstanceOp::setInstanceRefAttr(::circt::hw::InnerRefAttr attr) {
  (*this)->setAttr(getInstanceRefAttrName(), attr);
}

void DynamicInstanceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::circt::hw::InnerRefAttr instanceRef) {
  odsState.addAttribute(getInstanceRefAttrName(odsState.name), instanceRef);
  (void)odsState.addRegion();
}

void DynamicInstanceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::circt::hw::InnerRefAttr instanceRef) {
  odsState.addAttribute(getInstanceRefAttrName(odsState.name), instanceRef);
  (void)odsState.addRegion();
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void DynamicInstanceOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  for (unsigned i = 0; i != 1; ++i)
    (void)odsState.addRegion();
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult DynamicInstanceOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_instanceRef;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'instanceRef'");
    if (namedAttrIt->getName() == getInstanceRefAttrName()) {
      tblgen_instanceRef = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT3(*this, tblgen_instanceRef, "instanceRef")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_MSFT0(*this, region, "body", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult DynamicInstanceOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult DynamicInstanceOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::circt::hw::InnerRefAttr instanceRefAttr;
  std::unique_ptr<::mlir::Region> bodyRegion = std::make_unique<::mlir::Region>();
  {
    if (parseImplicitInnerRef(parser, instanceRefAttr))
      return ::mlir::failure();
    result.addAttribute("instanceRef", instanceRefAttr);
  }

  if (parser.parseRegion(*bodyRegion))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  result.addRegion(std::move(bodyRegion));
  return ::mlir::success();
}

void DynamicInstanceOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  printImplicitInnerRef(_odsPrinter, *this, getInstanceRefAttr());
  _odsPrinter << ' ';
  _odsPrinter.printRegion(getBody());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("instanceRef");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::DynamicInstanceOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::DynamicInstanceVerbatimAttrOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
DynamicInstanceVerbatimAttrOpGenericAdaptorBase::DynamicInstanceVerbatimAttrOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.instance.verb_attr", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> DynamicInstanceVerbatimAttrOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr DynamicInstanceVerbatimAttrOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr DynamicInstanceVerbatimAttrOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, DynamicInstanceVerbatimAttrOp::getNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef DynamicInstanceVerbatimAttrOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::mlir::StringAttr DynamicInstanceVerbatimAttrOpGenericAdaptorBase::getValueAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, DynamicInstanceVerbatimAttrOp::getValueAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef DynamicInstanceVerbatimAttrOpGenericAdaptorBase::getValue() {
  auto attr = getValueAttr();
  return attr.getValue();
}

::mlir::StringAttr DynamicInstanceVerbatimAttrOpGenericAdaptorBase::getSubPathAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 1, DynamicInstanceVerbatimAttrOp::getSubPathAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > DynamicInstanceVerbatimAttrOpGenericAdaptorBase::getSubPath() {
  auto attr = getSubPathAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::FlatSymbolRefAttr DynamicInstanceVerbatimAttrOpGenericAdaptorBase::getRefAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 1, DynamicInstanceVerbatimAttrOp::getRefAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > DynamicInstanceVerbatimAttrOpGenericAdaptorBase::getRef() {
  auto attr = getRefAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

} // namespace detail
DynamicInstanceVerbatimAttrOpAdaptor::DynamicInstanceVerbatimAttrOpAdaptor(DynamicInstanceVerbatimAttrOp op) : DynamicInstanceVerbatimAttrOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult DynamicInstanceVerbatimAttrOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.instance.verb_attr' op ""requires attribute 'name'");
    if (namedAttrIt->getName() == DynamicInstanceVerbatimAttrOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_value;
  ::mlir::Attribute tblgen_ref;
  ::mlir::Attribute tblgen_subPath;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.instance.verb_attr' op ""requires attribute 'value'");
    if (namedAttrIt->getName() == DynamicInstanceVerbatimAttrOp::getValueAttrName(*odsOpName)) {
      tblgen_value = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == DynamicInstanceVerbatimAttrOp::getRefAttrName(*odsOpName)) {
      tblgen_ref = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == DynamicInstanceVerbatimAttrOp::getSubPathAttrName(*odsOpName)) {
      tblgen_subPath = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'msft.instance.verb_attr' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_value && !((::llvm::isa<::mlir::StringAttr>(tblgen_value))))
    return emitError(loc, "'msft.instance.verb_attr' op ""attribute 'value' failed to satisfy constraint: string attribute");

  if (tblgen_subPath && !((::llvm::isa<::mlir::StringAttr>(tblgen_subPath))))
    return emitError(loc, "'msft.instance.verb_attr' op ""attribute 'subPath' failed to satisfy constraint: string attribute");

  if (tblgen_ref && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(tblgen_ref))))
    return emitError(loc, "'msft.instance.verb_attr' op ""attribute 'ref' failed to satisfy constraint: flat symbol reference attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> DynamicInstanceVerbatimAttrOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range DynamicInstanceVerbatimAttrOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> DynamicInstanceVerbatimAttrOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range DynamicInstanceVerbatimAttrOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr DynamicInstanceVerbatimAttrOp::getNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getNameAttrName()));
}

::llvm::StringRef DynamicInstanceVerbatimAttrOp::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::mlir::StringAttr DynamicInstanceVerbatimAttrOp::getValueAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getValueAttrName()));
}

::llvm::StringRef DynamicInstanceVerbatimAttrOp::getValue() {
  auto attr = getValueAttr();
  return attr.getValue();
}

::mlir::StringAttr DynamicInstanceVerbatimAttrOp::getSubPathAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getSubPathAttrName()));
}

::std::optional< ::llvm::StringRef > DynamicInstanceVerbatimAttrOp::getSubPath() {
  auto attr = getSubPathAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::FlatSymbolRefAttr DynamicInstanceVerbatimAttrOp::getRefAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getRefAttrName()));
}

::std::optional< ::llvm::StringRef > DynamicInstanceVerbatimAttrOp::getRef() {
  auto attr = getRefAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

void DynamicInstanceVerbatimAttrOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void DynamicInstanceVerbatimAttrOp::setName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void DynamicInstanceVerbatimAttrOp::setValueAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getValueAttrName(), attr);
}

void DynamicInstanceVerbatimAttrOp::setValue(::llvm::StringRef attrValue) {
  (*this)->setAttr(getValueAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void DynamicInstanceVerbatimAttrOp::setSubPathAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSubPathAttrName(), attr);
}

void DynamicInstanceVerbatimAttrOp::setSubPath(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getSubPathAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getSubPathAttrName());
}

void DynamicInstanceVerbatimAttrOp::setRefAttr(::mlir::FlatSymbolRefAttr attr) {
  (*this)->setAttr(getRefAttrName(), attr);
}

void DynamicInstanceVerbatimAttrOp::setRef(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getRefAttrName(), ::mlir::SymbolRefAttr::get(::mlir::Builder((*this)->getContext()).getContext(), *attrValue));
    (*this)->removeAttr(getRefAttrName());
}

::mlir::Attribute DynamicInstanceVerbatimAttrOp::removeSubPathAttr() {
return (*this)->removeAttr(getSubPathAttrName());
}

::mlir::Attribute DynamicInstanceVerbatimAttrOp::removeRefAttr() {
return (*this)->removeAttr(getRefAttrName());
}

void DynamicInstanceVerbatimAttrOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr name, ::mlir::StringAttr value, /*optional*/::mlir::StringAttr subPath, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  odsState.addAttribute(getValueAttrName(odsState.name), value);
  if (subPath) {
    odsState.addAttribute(getSubPathAttrName(odsState.name), subPath);
  }
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
}

void DynamicInstanceVerbatimAttrOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr name, ::mlir::StringAttr value, /*optional*/::mlir::StringAttr subPath, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  odsState.addAttribute(getValueAttrName(odsState.name), value);
  if (subPath) {
    odsState.addAttribute(getSubPathAttrName(odsState.name), subPath);
  }
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void DynamicInstanceVerbatimAttrOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef name, ::llvm::StringRef value, /*optional*/::mlir::StringAttr subPath, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  odsState.addAttribute(getValueAttrName(odsState.name), odsBuilder.getStringAttr(value));
  if (subPath) {
    odsState.addAttribute(getSubPathAttrName(odsState.name), subPath);
  }
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
}

void DynamicInstanceVerbatimAttrOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef name, ::llvm::StringRef value, /*optional*/::mlir::StringAttr subPath, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  odsState.addAttribute(getValueAttrName(odsState.name), odsBuilder.getStringAttr(value));
  if (subPath) {
    odsState.addAttribute(getSubPathAttrName(odsState.name), subPath);
  }
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void DynamicInstanceVerbatimAttrOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult DynamicInstanceVerbatimAttrOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'name'");
    if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_value;
  ::mlir::Attribute tblgen_ref;
  ::mlir::Attribute tblgen_subPath;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'value'");
    if (namedAttrIt->getName() == getValueAttrName()) {
      tblgen_value = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getRefAttrName()) {
      tblgen_ref = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getSubPathAttrName()) {
      tblgen_subPath = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_value, "value")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_subPath, "subPath")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT4(*this, tblgen_ref, "ref")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult DynamicInstanceVerbatimAttrOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult DynamicInstanceVerbatimAttrOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::FlatSymbolRefAttr refAttr;
  ::mlir::StringAttr nameAttr;
  ::mlir::StringAttr valueAttr;
  ::mlir::StringAttr subPathAttr;

  ::mlir::OptionalParseResult parseResultrefAttr =
    parser.parseOptionalAttribute(refAttr, parser.getBuilder().getType<::mlir::NoneType>());
  if (parseResultrefAttr.has_value() && failed(*parseResultrefAttr))
    return ::mlir::failure();
  if (parseResultrefAttr.has_value() && succeeded(*parseResultrefAttr))
  if (refAttr) result.attributes.append("ref", refAttr);
  if (refAttr) {
  }
  if (parser.parseKeyword("name"))
    return ::mlir::failure();
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(nameAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (nameAttr) result.attributes.append("name", nameAttr);
  if (parser.parseKeyword("value"))
    return ::mlir::failure();
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(valueAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (valueAttr) result.attributes.append("value", valueAttr);
  if (::mlir::succeeded(parser.parseOptionalKeyword("path"))) {
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(subPathAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (subPathAttr) result.attributes.append("subPath", subPathAttr);
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void DynamicInstanceVerbatimAttrOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getRefAttr()) {
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getRefAttr());
  }
  _odsPrinter << ' ' << "name";
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getNameAttr());
  _odsPrinter << ' ' << "value";
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getValueAttr());
  if (getSubPathAttr()) {
    _odsPrinter << ' ' << "path";
    _odsPrinter << ' ' << ":";
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getSubPathAttr());
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("ref");
  elidedAttrs.push_back("name");
  elidedAttrs.push_back("value");
  elidedAttrs.push_back("subPath");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::DynamicInstanceVerbatimAttrOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::EntityExternOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
EntityExternOpGenericAdaptorBase::EntityExternOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.entity.extern", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> EntityExternOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr EntityExternOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr EntityExternOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, EntityExternOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef EntityExternOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::Attribute EntityExternOpGenericAdaptorBase::getMetadataAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::Attribute>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, EntityExternOp::getMetadataAttrName(*odsOpName)));
  return attr;
}

::mlir::Attribute EntityExternOpGenericAdaptorBase::getMetadata() {
  auto attr = getMetadataAttr();
  return attr;
}

} // namespace detail
EntityExternOpAdaptor::EntityExternOpAdaptor(EntityExternOp op) : EntityExternOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult EntityExternOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_metadata;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.entity.extern' op ""requires attribute 'metadata'");
    if (namedAttrIt->getName() == EntityExternOp::getMetadataAttrName(*odsOpName)) {
      tblgen_metadata = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.entity.extern' op ""requires attribute 'sym_name'");
    if (namedAttrIt->getName() == EntityExternOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'msft.entity.extern' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");

  if (tblgen_metadata && !((true)))
    return emitError(loc, "'msft.entity.extern' op ""attribute 'metadata' failed to satisfy constraint: any attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> EntityExternOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range EntityExternOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> EntityExternOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range EntityExternOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr EntityExternOp::getSymNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::llvm::StringRef EntityExternOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::Attribute EntityExternOp::getMetadataAttr() {
  return ::llvm::cast<::mlir::Attribute>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getMetadataAttrName()));
}

::mlir::Attribute EntityExternOp::getMetadata() {
  auto attr = getMetadataAttr();
  return attr;
}

void EntityExternOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void EntityExternOp::setSymName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void EntityExternOp::setMetadataAttr(::mlir::Attribute attr) {
  (*this)->setAttr(getMetadataAttrName(), attr);
}

void EntityExternOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr sym_name, ::mlir::Attribute metadata) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getMetadataAttrName(odsState.name), metadata);
}

void EntityExternOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr sym_name, ::mlir::Attribute metadata) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getMetadataAttrName(odsState.name), metadata);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void EntityExternOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef sym_name, ::mlir::Attribute metadata) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getMetadataAttrName(odsState.name), metadata);
}

void EntityExternOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef sym_name, ::mlir::Attribute metadata) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getMetadataAttrName(odsState.name), metadata);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void EntityExternOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult EntityExternOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_metadata;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'metadata'");
    if (namedAttrIt->getName() == getMetadataAttrName()) {
      tblgen_metadata = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'sym_name'");
    if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT5(*this, tblgen_metadata, "metadata")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult EntityExternOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult EntityExternOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  ::mlir::Attribute metadataAttr;

  if (parser.parseSymbolName(sym_nameAttr))
    return ::mlir::failure();
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);

  if (parser.parseAttribute(metadataAttr, ::mlir::Type{}))
    return ::mlir::failure();
  if (metadataAttr) result.attributes.append("metadata", metadataAttr);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void EntityExternOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  _odsPrinter << ' ';
  _odsPrinter.printAttribute(getMetadataAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  elidedAttrs.push_back("metadata");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::EntityExternOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::InstanceHierarchyOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
InstanceHierarchyOpGenericAdaptorBase::InstanceHierarchyOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.instance.hierarchy", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> InstanceHierarchyOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr InstanceHierarchyOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::FlatSymbolRefAttr InstanceHierarchyOpGenericAdaptorBase::getTopModuleRefAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, InstanceHierarchyOp::getTopModuleRefAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef InstanceHierarchyOpGenericAdaptorBase::getTopModuleRef() {
  auto attr = getTopModuleRefAttr();
  return attr.getValue();
}

::mlir::StringAttr InstanceHierarchyOpGenericAdaptorBase::getInstNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, InstanceHierarchyOp::getInstNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > InstanceHierarchyOpGenericAdaptorBase::getInstName() {
  auto attr = getInstNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::Region &InstanceHierarchyOpGenericAdaptorBase::getBody() {
  return *odsRegions[0];
}

::mlir::RegionRange InstanceHierarchyOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
InstanceHierarchyOpAdaptor::InstanceHierarchyOpAdaptor(InstanceHierarchyOp op) : InstanceHierarchyOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult InstanceHierarchyOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_topModuleRef;
  ::mlir::Attribute tblgen_instName;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.instance.hierarchy' op ""requires attribute 'topModuleRef'");
    if (namedAttrIt->getName() == InstanceHierarchyOp::getTopModuleRefAttrName(*odsOpName)) {
      tblgen_topModuleRef = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == InstanceHierarchyOp::getInstNameAttrName(*odsOpName)) {
      tblgen_instName = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_topModuleRef && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(tblgen_topModuleRef))))
    return emitError(loc, "'msft.instance.hierarchy' op ""attribute 'topModuleRef' failed to satisfy constraint: flat symbol reference attribute");

  if (tblgen_instName && !((::llvm::isa<::mlir::StringAttr>(tblgen_instName))))
    return emitError(loc, "'msft.instance.hierarchy' op ""attribute 'instName' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> InstanceHierarchyOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range InstanceHierarchyOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> InstanceHierarchyOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range InstanceHierarchyOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Region &InstanceHierarchyOp::getBody() {
  return (*this)->getRegion(0);
}

::mlir::FlatSymbolRefAttr InstanceHierarchyOp::getTopModuleRefAttr() {
  return ::llvm::cast<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getTopModuleRefAttrName()));
}

::llvm::StringRef InstanceHierarchyOp::getTopModuleRef() {
  auto attr = getTopModuleRefAttr();
  return attr.getValue();
}

::mlir::StringAttr InstanceHierarchyOp::getInstNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getInstNameAttrName()));
}

::std::optional< ::llvm::StringRef > InstanceHierarchyOp::getInstName() {
  auto attr = getInstNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

void InstanceHierarchyOp::setTopModuleRefAttr(::mlir::FlatSymbolRefAttr attr) {
  (*this)->setAttr(getTopModuleRefAttrName(), attr);
}

void InstanceHierarchyOp::setTopModuleRef(::llvm::StringRef attrValue) {
  (*this)->setAttr(getTopModuleRefAttrName(), ::mlir::SymbolRefAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

void InstanceHierarchyOp::setInstNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getInstNameAttrName(), attr);
}

void InstanceHierarchyOp::setInstName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getInstNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getInstNameAttrName());
}

::mlir::Attribute InstanceHierarchyOp::removeInstNameAttr() {
return (*this)->removeAttr(getInstNameAttrName());
}

void InstanceHierarchyOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::FlatSymbolRefAttr topModuleRef, /*optional*/::mlir::StringAttr instName) {
  odsState.addAttribute(getTopModuleRefAttrName(odsState.name), topModuleRef);
  if (instName) {
    odsState.addAttribute(getInstNameAttrName(odsState.name), instName);
  }
  (void)odsState.addRegion();
}

void InstanceHierarchyOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::FlatSymbolRefAttr topModuleRef, /*optional*/::mlir::StringAttr instName) {
  odsState.addAttribute(getTopModuleRefAttrName(odsState.name), topModuleRef);
  if (instName) {
    odsState.addAttribute(getInstNameAttrName(odsState.name), instName);
  }
  (void)odsState.addRegion();
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void InstanceHierarchyOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef topModuleRef, /*optional*/::mlir::StringAttr instName) {
  odsState.addAttribute(getTopModuleRefAttrName(odsState.name), ::mlir::SymbolRefAttr::get(odsBuilder.getContext(), topModuleRef));
  if (instName) {
    odsState.addAttribute(getInstNameAttrName(odsState.name), instName);
  }
  (void)odsState.addRegion();
}

void InstanceHierarchyOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef topModuleRef, /*optional*/::mlir::StringAttr instName) {
  odsState.addAttribute(getTopModuleRefAttrName(odsState.name), ::mlir::SymbolRefAttr::get(odsBuilder.getContext(), topModuleRef));
  if (instName) {
    odsState.addAttribute(getInstNameAttrName(odsState.name), instName);
  }
  (void)odsState.addRegion();
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void InstanceHierarchyOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  for (unsigned i = 0; i != 1; ++i)
    (void)odsState.addRegion();
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult InstanceHierarchyOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_topModuleRef;
  ::mlir::Attribute tblgen_instName;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'topModuleRef'");
    if (namedAttrIt->getName() == getTopModuleRefAttrName()) {
      tblgen_topModuleRef = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getInstNameAttrName()) {
      tblgen_instName = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT4(*this, tblgen_topModuleRef, "topModuleRef")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_instName, "instName")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_MSFT0(*this, region, "body", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult InstanceHierarchyOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult InstanceHierarchyOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::FlatSymbolRefAttr topModuleRefAttr;
  ::mlir::StringAttr instNameAttr;
  std::unique_ptr<::mlir::Region> bodyRegion = std::make_unique<::mlir::Region>();

  if (parser.parseCustomAttributeWithFallback(topModuleRefAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (topModuleRefAttr) result.attributes.append("topModuleRef", topModuleRefAttr);

  ::mlir::OptionalParseResult parseResultinstNameAttr =
    parser.parseOptionalAttribute(instNameAttr, parser.getBuilder().getType<::mlir::NoneType>());
  if (parseResultinstNameAttr.has_value() && failed(*parseResultinstNameAttr))
    return ::mlir::failure();
  if (parseResultinstNameAttr.has_value() && succeeded(*parseResultinstNameAttr))
  if (instNameAttr) result.attributes.append("instName", instNameAttr);
  if (instNameAttr) {
  }

  if (parser.parseRegion(*bodyRegion))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  result.addRegion(std::move(bodyRegion));
  return ::mlir::success();
}

void InstanceHierarchyOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getTopModuleRefAttr());
  if (getInstNameAttr()) {
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getInstNameAttr());
  }
  _odsPrinter << ' ';
  _odsPrinter.printRegion(getBody());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("topModuleRef");
  elidedAttrs.push_back("instName");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::InstanceHierarchyOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::InstanceOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
InstanceOpGenericAdaptorBase::InstanceOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.instance", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> InstanceOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr InstanceOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr InstanceOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, InstanceOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef InstanceOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::FlatSymbolRefAttr InstanceOpGenericAdaptorBase::getModuleNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, InstanceOp::getModuleNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef InstanceOpGenericAdaptorBase::getModuleName() {
  auto attr = getModuleNameAttr();
  return attr.getValue();
}

::mlir::ArrayAttr InstanceOpGenericAdaptorBase::getParametersAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 1, InstanceOp::getParametersAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > InstanceOpGenericAdaptorBase::getParameters() {
  auto attr = getParametersAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::SymbolRefAttr InstanceOpGenericAdaptorBase::getTargetDesignPartitionAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::SymbolRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 0, InstanceOp::getTargetDesignPartitionAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::SymbolRefAttr > InstanceOpGenericAdaptorBase::getTargetDesignPartition() {
  auto attr = getTargetDesignPartitionAttr();
  return attr ? ::std::optional< ::mlir::SymbolRefAttr >(attr) : (::std::nullopt);
}

} // namespace detail
InstanceOpAdaptor::InstanceOpAdaptor(InstanceOp op) : InstanceOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult InstanceOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_moduleName;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.instance' op ""requires attribute 'moduleName'");
    if (namedAttrIt->getName() == InstanceOp::getModuleNameAttrName(*odsOpName)) {
      tblgen_moduleName = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;
  ::mlir::Attribute tblgen_parameters;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.instance' op ""requires attribute 'sym_name'");
    if (namedAttrIt->getName() == InstanceOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == InstanceOp::getParametersAttrName(*odsOpName)) {
      tblgen_parameters = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_targetDesignPartition;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == InstanceOp::getTargetDesignPartitionAttrName(*odsOpName)) {
      tblgen_targetDesignPartition = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'msft.instance' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");

  if (tblgen_moduleName && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(tblgen_moduleName))))
    return emitError(loc, "'msft.instance' op ""attribute 'moduleName' failed to satisfy constraint: flat symbol reference attribute");

  if (tblgen_parameters && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_parameters))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_parameters), [&](::mlir::Attribute attr) { return attr && ((attr.isa<hw::ParamDeclAttr>())); }))))
    return emitError(loc, "'msft.instance' op ""attribute 'parameters' failed to satisfy constraint: parameter array");

  if (tblgen_targetDesignPartition && !((::llvm::isa<::mlir::SymbolRefAttr>(tblgen_targetDesignPartition))))
    return emitError(loc, "'msft.instance' op ""attribute 'targetDesignPartition' failed to satisfy constraint: symbol reference attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> InstanceOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range InstanceOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range InstanceOp::getInputs() {
  return getODSOperands(0);
}

::mlir::MutableOperandRange InstanceOp::getInputsMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> InstanceOp::getODSResultIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumResults() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::result_range InstanceOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr InstanceOp::getSymNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::llvm::StringRef InstanceOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::FlatSymbolRefAttr InstanceOp::getModuleNameAttr() {
  return ::llvm::cast<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getModuleNameAttrName()));
}

::llvm::StringRef InstanceOp::getModuleName() {
  auto attr = getModuleNameAttr();
  return attr.getValue();
}

::mlir::ArrayAttr InstanceOp::getParametersAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getParametersAttrName()));
}

::std::optional< ::mlir::ArrayAttr > InstanceOp::getParameters() {
  auto attr = getParametersAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::SymbolRefAttr InstanceOp::getTargetDesignPartitionAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::SymbolRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 0, getTargetDesignPartitionAttrName()));
}

::std::optional< ::mlir::SymbolRefAttr > InstanceOp::getTargetDesignPartition() {
  auto attr = getTargetDesignPartitionAttr();
  return attr ? ::std::optional< ::mlir::SymbolRefAttr >(attr) : (::std::nullopt);
}

void InstanceOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void InstanceOp::setSymName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void InstanceOp::setModuleNameAttr(::mlir::FlatSymbolRefAttr attr) {
  (*this)->setAttr(getModuleNameAttrName(), attr);
}

void InstanceOp::setModuleName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getModuleNameAttrName(), ::mlir::SymbolRefAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

void InstanceOp::setParametersAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getParametersAttrName(), attr);
}

void InstanceOp::setTargetDesignPartitionAttr(::mlir::SymbolRefAttr attr) {
  (*this)->setAttr(getTargetDesignPartitionAttrName(), attr);
}

::mlir::Attribute InstanceOp::removeParametersAttr() {
return (*this)->removeAttr(getParametersAttrName());
}

::mlir::Attribute InstanceOp::removeTargetDesignPartitionAttr() {
return (*this)->removeAttr(getTargetDesignPartitionAttrName());
}

void InstanceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultType0, ::mlir::StringAttr sym_name, ::mlir::FlatSymbolRefAttr moduleName, ::mlir::ValueRange inputs, /*optional*/::mlir::ArrayAttr parameters, /*optional*/::mlir::SymbolRefAttr targetDesignPartition) {
  odsState.addOperands(inputs);
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addAttribute(getModuleNameAttrName(odsState.name), moduleName);
  if (parameters) {
    odsState.addAttribute(getParametersAttrName(odsState.name), parameters);
  }
  if (targetDesignPartition) {
    odsState.addAttribute(getTargetDesignPartitionAttrName(odsState.name), targetDesignPartition);
  }
  odsState.addTypes(resultType0);
}

void InstanceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultType0, ::llvm::StringRef sym_name, ::llvm::StringRef moduleName, ::mlir::ValueRange inputs, /*optional*/::mlir::ArrayAttr parameters, /*optional*/::mlir::SymbolRefAttr targetDesignPartition) {
  odsState.addOperands(inputs);
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addAttribute(getModuleNameAttrName(odsState.name), ::mlir::SymbolRefAttr::get(odsBuilder.getContext(), moduleName));
  if (parameters) {
    odsState.addAttribute(getParametersAttrName(odsState.name), parameters);
  }
  if (targetDesignPartition) {
    odsState.addAttribute(getTargetDesignPartitionAttrName(odsState.name), targetDesignPartition);
  }
  odsState.addTypes(resultType0);
}

void InstanceOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult InstanceOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_moduleName;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'moduleName'");
    if (namedAttrIt->getName() == getModuleNameAttrName()) {
      tblgen_moduleName = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;
  ::mlir::Attribute tblgen_parameters;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'sym_name'");
    if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getParametersAttrName()) {
      tblgen_parameters = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_targetDesignPartition;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getTargetDesignPartitionAttrName()) {
      tblgen_targetDesignPartition = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT4(*this, tblgen_moduleName, "moduleName")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT6(*this, tblgen_parameters, "parameters")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT7(*this, tblgen_targetDesignPartition, "targetDesignPartition")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult InstanceOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult InstanceOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  ::mlir::FlatSymbolRefAttr moduleNameAttr;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> inputsOperands;
  ::llvm::SMLoc inputsOperandsLoc;
  (void)inputsOperandsLoc;
  ::mlir::ArrayAttr parametersAttr;
  ::llvm::ArrayRef<::mlir::Type> inputsTypes;
  ::llvm::ArrayRef<::mlir::Type> allResultTypes;

  if (parser.parseSymbolName(sym_nameAttr))
    return ::mlir::failure();
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);

  if (parser.parseCustomAttributeWithFallback(moduleNameAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (moduleNameAttr) result.attributes.append("moduleName", moduleNameAttr);
  if (parser.parseLParen())
    return ::mlir::failure();

  inputsOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperandList(inputsOperands))
    return ::mlir::failure();
  if (parser.parseRParen())
    return ::mlir::failure();
  {
    if (parseParameterList(parser, parametersAttr))
      return ::mlir::failure();
    if (parametersAttr)
      result.addAttribute("parameters", parametersAttr);
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  ::mlir::FunctionType inputs__allResult_functionType;
  if (parser.parseType(inputs__allResult_functionType))
    return ::mlir::failure();
  inputsTypes = inputs__allResult_functionType.getInputs();
  allResultTypes = inputs__allResult_functionType.getResults();
  result.addTypes(allResultTypes);
  if (parser.resolveOperands(inputsOperands, inputsTypes, inputsOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void InstanceOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getModuleNameAttr());
  _odsPrinter << "(";
  _odsPrinter << getInputs();
  _odsPrinter << ")";
  _odsPrinter << ' ';
  printParameterList(_odsPrinter, *this, getParametersAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  elidedAttrs.push_back("moduleName");
  elidedAttrs.push_back("parameters");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  _odsPrinter.printFunctionalType(getInputs().getTypes(), getOperation()->getResultTypes());
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::InstanceOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::LinearOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
LinearOpGenericAdaptorBase::LinearOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.hlc.linear", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> LinearOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr LinearOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::Region &LinearOpGenericAdaptorBase::getDatapath() {
  return *odsRegions[0];
}

::mlir::RegionRange LinearOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
LinearOpAdaptor::LinearOpAdaptor(LinearOp op) : LinearOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult LinearOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> LinearOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range LinearOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> LinearOp::getClock() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(0).begin());
}

::mlir::MutableOperandRange LinearOp::getClockMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> LinearOp::getODSResultIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumResults() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::result_range LinearOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::result_range LinearOp::getOuts() {
  return getODSResults(0);
}

::mlir::Region &LinearOp::getDatapath() {
  return (*this)->getRegion(0);
}

void LinearOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange outs, ::mlir::Value clock) {
  odsState.addOperands(clock);
  (void)odsState.addRegion();
  odsState.addTypes(outs);
}

void LinearOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  for (unsigned i = 0; i != 1; ++i)
    (void)odsState.addRegion();
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult LinearOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_MSFT0(*this, region, "datapath", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult LinearOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult LinearOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand clockRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clockOperands(clockRawOperands);  ::llvm::SMLoc clockOperandsLoc;
  (void)clockOperandsLoc;
  ::llvm::SmallVector<::mlir::Type, 1> outsTypes;
  std::unique_ptr<::mlir::Region> datapathRegion = std::make_unique<::mlir::Region>();
  if (parser.parseKeyword("clock"))
    return ::mlir::failure();

  clockOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clockRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseTypeList(outsTypes))
    return ::mlir::failure();

  if (parser.parseRegion(*datapathRegion))
    return ::mlir::failure();

  ensureTerminator(*datapathRegion, parser.getBuilder(), result.location);
  result.addRegion(std::move(datapathRegion));
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  result.addTypes(outsTypes);
  if (parser.resolveOperands(clockOperands, odsBuildableType0, clockOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void LinearOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ' << "clock";
  _odsPrinter << ' ';
  _odsPrinter << getClock();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  _odsPrinter << getOuts().getTypes();
  _odsPrinter << ' ';

  {
    bool printTerminator = true;
    if (auto *term = getDatapath().empty() ? nullptr : getDatapath().begin()->getTerminator()) {
      printTerminator = !term->getAttrDictionary().empty() ||
                        term->getNumOperands() != 0 ||
                        term->getNumResults() != 0;
    }
    _odsPrinter.printRegion(getDatapath(), /*printEntryBlockArgs=*/true,
      /*printBlockTerminators=*/printTerminator);
  }
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::LinearOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::MSFTModuleExternOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
MSFTModuleExternOpGenericAdaptorBase::MSFTModuleExternOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.module.extern", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> MSFTModuleExternOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr MSFTModuleExternOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::TypeAttr MSFTModuleExternOpGenericAdaptorBase::getFunctionTypeAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 2, MSFTModuleExternOp::getFunctionTypeAttrName(*odsOpName)));
  return attr;
}

::mlir::FunctionType MSFTModuleExternOpGenericAdaptorBase::getFunctionType() {
  auto attr = getFunctionTypeAttr();
  return ::llvm::cast<::mlir::FunctionType>(attr.getValue());
}

::mlir::ArrayAttr MSFTModuleExternOpGenericAdaptorBase::getArgAttrsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 3, MSFTModuleExternOp::getArgAttrsAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > MSFTModuleExternOpGenericAdaptorBase::getArgAttrs() {
  auto attr = getArgAttrsAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr MSFTModuleExternOpGenericAdaptorBase::getResAttrsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 3, odsAttrs.end() - 1, MSFTModuleExternOp::getResAttrsAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > MSFTModuleExternOpGenericAdaptorBase::getResAttrs() {
  auto attr = getResAttrsAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr MSFTModuleExternOpGenericAdaptorBase::getArgNamesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 3, MSFTModuleExternOp::getArgNamesAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr MSFTModuleExternOpGenericAdaptorBase::getArgNames() {
  auto attr = getArgNamesAttr();
  return attr;
}

::mlir::ArrayAttr MSFTModuleExternOpGenericAdaptorBase::getResultNamesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 3, odsAttrs.end() - 0, MSFTModuleExternOp::getResultNamesAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr MSFTModuleExternOpGenericAdaptorBase::getResultNames() {
  auto attr = getResultNamesAttr();
  return attr;
}

::mlir::ArrayAttr MSFTModuleExternOpGenericAdaptorBase::getParametersAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 1, MSFTModuleExternOp::getParametersAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr MSFTModuleExternOpGenericAdaptorBase::getParameters() {
  auto attr = getParametersAttr();
  return attr;
}

::mlir::StringAttr MSFTModuleExternOpGenericAdaptorBase::getVerilogNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 4, odsAttrs.end() - 0, MSFTModuleExternOp::getVerilogNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > MSFTModuleExternOpGenericAdaptorBase::getVerilogName() {
  auto attr = getVerilogNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::Region &MSFTModuleExternOpGenericAdaptorBase::getBody() {
  return *odsRegions[0];
}

::mlir::RegionRange MSFTModuleExternOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
MSFTModuleExternOpAdaptor::MSFTModuleExternOpAdaptor(MSFTModuleExternOp op) : MSFTModuleExternOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult MSFTModuleExternOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_argNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.module.extern' op ""requires attribute 'argNames'");
    if (namedAttrIt->getName() == MSFTModuleExternOp::getArgNamesAttrName(*odsOpName)) {
      tblgen_argNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_function_type;
  ::mlir::Attribute tblgen_arg_attrs;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.module.extern' op ""requires attribute 'function_type'");
    if (namedAttrIt->getName() == MSFTModuleExternOp::getFunctionTypeAttrName(*odsOpName)) {
      tblgen_function_type = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == MSFTModuleExternOp::getArgAttrsAttrName(*odsOpName)) {
      tblgen_arg_attrs = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_parameters;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.module.extern' op ""requires attribute 'parameters'");
    if (namedAttrIt->getName() == MSFTModuleExternOp::getParametersAttrName(*odsOpName)) {
      tblgen_parameters = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_resultNames;
  ::mlir::Attribute tblgen_res_attrs;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.module.extern' op ""requires attribute 'resultNames'");
    if (namedAttrIt->getName() == MSFTModuleExternOp::getResultNamesAttrName(*odsOpName)) {
      tblgen_resultNames = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == MSFTModuleExternOp::getResAttrsAttrName(*odsOpName)) {
      tblgen_res_attrs = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_verilogName;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == MSFTModuleExternOp::getVerilogNameAttrName(*odsOpName)) {
      tblgen_verilogName = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_function_type && !(((::llvm::isa<::mlir::TypeAttr>(tblgen_function_type))) && ((::llvm::isa<::mlir::FunctionType>(::llvm::cast<::mlir::TypeAttr>(tblgen_function_type).getValue()))) && ((::llvm::isa<::mlir::FunctionType>(::llvm::cast<::mlir::TypeAttr>(tblgen_function_type).getValue())))))
    return emitError(loc, "'msft.module.extern' op ""attribute 'function_type' failed to satisfy constraint: type attribute of function type");

  if (tblgen_arg_attrs && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_arg_attrs))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_arg_attrs), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::DictionaryAttr>(attr))); }))))
    return emitError(loc, "'msft.module.extern' op ""attribute 'arg_attrs' failed to satisfy constraint: Array of dictionary attributes");

  if (tblgen_res_attrs && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_res_attrs))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_res_attrs), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::DictionaryAttr>(attr))); }))))
    return emitError(loc, "'msft.module.extern' op ""attribute 'res_attrs' failed to satisfy constraint: Array of dictionary attributes");

  if (tblgen_argNames && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_argNames))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_argNames), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'msft.module.extern' op ""attribute 'argNames' failed to satisfy constraint: string array attribute");

  if (tblgen_resultNames && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_resultNames))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_resultNames), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'msft.module.extern' op ""attribute 'resultNames' failed to satisfy constraint: string array attribute");

  if (tblgen_parameters && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_parameters))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_parameters), [&](::mlir::Attribute attr) { return attr && ((attr.isa<hw::ParamDeclAttr>())); }))))
    return emitError(loc, "'msft.module.extern' op ""attribute 'parameters' failed to satisfy constraint: parameter array");

  if (tblgen_verilogName && !((::llvm::isa<::mlir::StringAttr>(tblgen_verilogName))))
    return emitError(loc, "'msft.module.extern' op ""attribute 'verilogName' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> MSFTModuleExternOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range MSFTModuleExternOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> MSFTModuleExternOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range MSFTModuleExternOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Region &MSFTModuleExternOp::getBody() {
  return (*this)->getRegion(0);
}

::mlir::TypeAttr MSFTModuleExternOp::getFunctionTypeAttr() {
  return ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 2, getFunctionTypeAttrName()));
}

::mlir::FunctionType MSFTModuleExternOp::getFunctionType() {
  auto attr = getFunctionTypeAttr();
  return ::llvm::cast<::mlir::FunctionType>(attr.getValue());
}

::mlir::ArrayAttr MSFTModuleExternOp::getArgAttrsAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 3, getArgAttrsAttrName()));
}

::std::optional< ::mlir::ArrayAttr > MSFTModuleExternOp::getArgAttrs() {
  auto attr = getArgAttrsAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr MSFTModuleExternOp::getResAttrsAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 3, (*this)->getAttrs().end() - 1, getResAttrsAttrName()));
}

::std::optional< ::mlir::ArrayAttr > MSFTModuleExternOp::getResAttrs() {
  auto attr = getResAttrsAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr MSFTModuleExternOp::getArgNamesAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 3, getArgNamesAttrName()));
}

::mlir::ArrayAttr MSFTModuleExternOp::getArgNames() {
  auto attr = getArgNamesAttr();
  return attr;
}

::mlir::ArrayAttr MSFTModuleExternOp::getResultNamesAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 3, (*this)->getAttrs().end() - 0, getResultNamesAttrName()));
}

::mlir::ArrayAttr MSFTModuleExternOp::getResultNames() {
  auto attr = getResultNamesAttr();
  return attr;
}

::mlir::ArrayAttr MSFTModuleExternOp::getParametersAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 1, getParametersAttrName()));
}

::mlir::ArrayAttr MSFTModuleExternOp::getParameters() {
  auto attr = getParametersAttr();
  return attr;
}

::mlir::StringAttr MSFTModuleExternOp::getVerilogNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 4, (*this)->getAttrs().end() - 0, getVerilogNameAttrName()));
}

::std::optional< ::llvm::StringRef > MSFTModuleExternOp::getVerilogName() {
  auto attr = getVerilogNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

void MSFTModuleExternOp::setFunctionTypeAttr(::mlir::TypeAttr attr) {
  (*this)->setAttr(getFunctionTypeAttrName(), attr);
}

void MSFTModuleExternOp::setFunctionType(::mlir::FunctionType attrValue) {
  (*this)->setAttr(getFunctionTypeAttrName(), ::mlir::TypeAttr::get(attrValue));
}

void MSFTModuleExternOp::setArgAttrsAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getArgAttrsAttrName(), attr);
}

void MSFTModuleExternOp::setResAttrsAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getResAttrsAttrName(), attr);
}

void MSFTModuleExternOp::setArgNamesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getArgNamesAttrName(), attr);
}

void MSFTModuleExternOp::setResultNamesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getResultNamesAttrName(), attr);
}

void MSFTModuleExternOp::setParametersAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getParametersAttrName(), attr);
}

void MSFTModuleExternOp::setVerilogNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getVerilogNameAttrName(), attr);
}

void MSFTModuleExternOp::setVerilogName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getVerilogNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getVerilogNameAttrName());
}

::mlir::Attribute MSFTModuleExternOp::removeArgAttrsAttr() {
return (*this)->removeAttr(getArgAttrsAttrName());
}

::mlir::Attribute MSFTModuleExternOp::removeResAttrsAttr() {
return (*this)->removeAttr(getResAttrsAttrName());
}

::mlir::Attribute MSFTModuleExternOp::removeVerilogNameAttr() {
return (*this)->removeAttr(getVerilogNameAttrName());
}

::mlir::LogicalResult MSFTModuleExternOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_argNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'argNames'");
    if (namedAttrIt->getName() == getArgNamesAttrName()) {
      tblgen_argNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_function_type;
  ::mlir::Attribute tblgen_arg_attrs;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'function_type'");
    if (namedAttrIt->getName() == getFunctionTypeAttrName()) {
      tblgen_function_type = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getArgAttrsAttrName()) {
      tblgen_arg_attrs = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_parameters;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'parameters'");
    if (namedAttrIt->getName() == getParametersAttrName()) {
      tblgen_parameters = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_resultNames;
  ::mlir::Attribute tblgen_res_attrs;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'resultNames'");
    if (namedAttrIt->getName() == getResultNamesAttrName()) {
      tblgen_resultNames = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getResAttrsAttrName()) {
      tblgen_res_attrs = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_verilogName;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getVerilogNameAttrName()) {
      tblgen_verilogName = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT8(*this, tblgen_function_type, "function_type")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT9(*this, tblgen_arg_attrs, "arg_attrs")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT9(*this, tblgen_res_attrs, "res_attrs")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT10(*this, tblgen_argNames, "argNames")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT10(*this, tblgen_resultNames, "resultNames")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT6(*this, tblgen_parameters, "parameters")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_verilogName, "verilogName")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_MSFT1(*this, region, "body", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult MSFTModuleExternOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::MSFTModuleExternOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::MSFTModuleOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
MSFTModuleOpGenericAdaptorBase::MSFTModuleOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.module", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> MSFTModuleOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr MSFTModuleOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::TypeAttr MSFTModuleOpGenericAdaptorBase::getFunctionTypeAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 3, MSFTModuleOp::getFunctionTypeAttrName(*odsOpName)));
  return attr;
}

::mlir::FunctionType MSFTModuleOpGenericAdaptorBase::getFunctionType() {
  auto attr = getFunctionTypeAttr();
  return ::llvm::cast<::mlir::FunctionType>(attr.getValue());
}

::mlir::ArrayAttr MSFTModuleOpGenericAdaptorBase::getArgAttrsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 4, MSFTModuleOp::getArgAttrsAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > MSFTModuleOpGenericAdaptorBase::getArgAttrs() {
  auto attr = getArgAttrsAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr MSFTModuleOpGenericAdaptorBase::getResAttrsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 4, odsAttrs.end() - 2, MSFTModuleOp::getResAttrsAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > MSFTModuleOpGenericAdaptorBase::getResAttrs() {
  auto attr = getResAttrsAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr MSFTModuleOpGenericAdaptorBase::getArgNamesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 4, MSFTModuleOp::getArgNamesAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr MSFTModuleOpGenericAdaptorBase::getArgNames() {
  auto attr = getArgNamesAttr();
  return attr;
}

::mlir::ArrayAttr MSFTModuleOpGenericAdaptorBase::getResultNamesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 5, odsAttrs.end() - 0, MSFTModuleOp::getResultNamesAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr MSFTModuleOpGenericAdaptorBase::getResultNames() {
  auto attr = getResultNamesAttr();
  return attr;
}

::mlir::ArrayAttr MSFTModuleOpGenericAdaptorBase::getArgLocsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 5, MSFTModuleOp::getArgLocsAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr MSFTModuleOpGenericAdaptorBase::getArgLocs() {
  auto attr = getArgLocsAttr();
  return attr;
}

::mlir::ArrayAttr MSFTModuleOpGenericAdaptorBase::getResultLocsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 4, odsAttrs.end() - 1, MSFTModuleOp::getResultLocsAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr MSFTModuleOpGenericAdaptorBase::getResultLocs() {
  auto attr = getResultLocsAttr();
  return attr;
}

::mlir::DictionaryAttr MSFTModuleOpGenericAdaptorBase::getParametersAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::DictionaryAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 3, odsAttrs.end() - 2, MSFTModuleOp::getParametersAttrName(*odsOpName)));
  return attr;
}

::mlir::DictionaryAttr MSFTModuleOpGenericAdaptorBase::getParameters() {
  auto attr = getParametersAttr();
  return attr;
}

::mlir::StringAttr MSFTModuleOpGenericAdaptorBase::getFileNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 4, MSFTModuleOp::getFileNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > MSFTModuleOpGenericAdaptorBase::getFileName() {
  auto attr = getFileNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::ArrayAttr MSFTModuleOpGenericAdaptorBase::getChildAppIDBasesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 4, MSFTModuleOp::getChildAppIDBasesAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > MSFTModuleOpGenericAdaptorBase::getChildAppIDBases() {
  auto attr = getChildAppIDBasesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::Region &MSFTModuleOpGenericAdaptorBase::getBody() {
  return *odsRegions[0];
}

::mlir::RegionRange MSFTModuleOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
MSFTModuleOpAdaptor::MSFTModuleOpAdaptor(MSFTModuleOp op) : MSFTModuleOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult MSFTModuleOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_argLocs;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.module' op ""requires attribute 'argLocs'");
    if (namedAttrIt->getName() == MSFTModuleOp::getArgLocsAttrName(*odsOpName)) {
      tblgen_argLocs = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_argNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.module' op ""requires attribute 'argNames'");
    if (namedAttrIt->getName() == MSFTModuleOp::getArgNamesAttrName(*odsOpName)) {
      tblgen_argNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_function_type;
  ::mlir::Attribute tblgen_arg_attrs;
  ::mlir::Attribute tblgen_childAppIDBases;
  ::mlir::Attribute tblgen_fileName;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.module' op ""requires attribute 'function_type'");
    if (namedAttrIt->getName() == MSFTModuleOp::getFunctionTypeAttrName(*odsOpName)) {
      tblgen_function_type = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == MSFTModuleOp::getArgAttrsAttrName(*odsOpName)) {
      tblgen_arg_attrs = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == MSFTModuleOp::getChildAppIDBasesAttrName(*odsOpName)) {
      tblgen_childAppIDBases = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == MSFTModuleOp::getFileNameAttrName(*odsOpName)) {
      tblgen_fileName = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_parameters;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.module' op ""requires attribute 'parameters'");
    if (namedAttrIt->getName() == MSFTModuleOp::getParametersAttrName(*odsOpName)) {
      tblgen_parameters = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_resultLocs;
  ::mlir::Attribute tblgen_res_attrs;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.module' op ""requires attribute 'resultLocs'");
    if (namedAttrIt->getName() == MSFTModuleOp::getResultLocsAttrName(*odsOpName)) {
      tblgen_resultLocs = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == MSFTModuleOp::getResAttrsAttrName(*odsOpName)) {
      tblgen_res_attrs = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_resultNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.module' op ""requires attribute 'resultNames'");
    if (namedAttrIt->getName() == MSFTModuleOp::getResultNamesAttrName(*odsOpName)) {
      tblgen_resultNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_function_type && !(((::llvm::isa<::mlir::TypeAttr>(tblgen_function_type))) && ((::llvm::isa<::mlir::FunctionType>(::llvm::cast<::mlir::TypeAttr>(tblgen_function_type).getValue()))) && ((::llvm::isa<::mlir::FunctionType>(::llvm::cast<::mlir::TypeAttr>(tblgen_function_type).getValue())))))
    return emitError(loc, "'msft.module' op ""attribute 'function_type' failed to satisfy constraint: type attribute of function type");

  if (tblgen_arg_attrs && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_arg_attrs))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_arg_attrs), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::DictionaryAttr>(attr))); }))))
    return emitError(loc, "'msft.module' op ""attribute 'arg_attrs' failed to satisfy constraint: Array of dictionary attributes");

  if (tblgen_res_attrs && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_res_attrs))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_res_attrs), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::DictionaryAttr>(attr))); }))))
    return emitError(loc, "'msft.module' op ""attribute 'res_attrs' failed to satisfy constraint: Array of dictionary attributes");

  if (tblgen_argNames && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_argNames))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_argNames), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'msft.module' op ""attribute 'argNames' failed to satisfy constraint: string array attribute");

  if (tblgen_resultNames && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_resultNames))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_resultNames), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'msft.module' op ""attribute 'resultNames' failed to satisfy constraint: string array attribute");

  if (tblgen_argLocs && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_argLocs))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_argLocs), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::LocationAttr>(attr))); }))))
    return emitError(loc, "'msft.module' op ""attribute 'argLocs' failed to satisfy constraint: location array attribute");

  if (tblgen_resultLocs && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_resultLocs))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_resultLocs), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::LocationAttr>(attr))); }))))
    return emitError(loc, "'msft.module' op ""attribute 'resultLocs' failed to satisfy constraint: location array attribute");

  if (tblgen_parameters && !((::llvm::isa<::mlir::DictionaryAttr>(tblgen_parameters))))
    return emitError(loc, "'msft.module' op ""attribute 'parameters' failed to satisfy constraint: dictionary of named attribute values");

  if (tblgen_fileName && !((::llvm::isa<::mlir::StringAttr>(tblgen_fileName))))
    return emitError(loc, "'msft.module' op ""attribute 'fileName' failed to satisfy constraint: string attribute");

  if (tblgen_childAppIDBases && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_childAppIDBases))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_childAppIDBases), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'msft.module' op ""attribute 'childAppIDBases' failed to satisfy constraint: string array attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> MSFTModuleOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range MSFTModuleOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> MSFTModuleOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range MSFTModuleOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Region &MSFTModuleOp::getBody() {
  return (*this)->getRegion(0);
}

::mlir::TypeAttr MSFTModuleOp::getFunctionTypeAttr() {
  return ::llvm::cast<::mlir::TypeAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 3, getFunctionTypeAttrName()));
}

::mlir::FunctionType MSFTModuleOp::getFunctionType() {
  auto attr = getFunctionTypeAttr();
  return ::llvm::cast<::mlir::FunctionType>(attr.getValue());
}

::mlir::ArrayAttr MSFTModuleOp::getArgAttrsAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 4, getArgAttrsAttrName()));
}

::std::optional< ::mlir::ArrayAttr > MSFTModuleOp::getArgAttrs() {
  auto attr = getArgAttrsAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr MSFTModuleOp::getResAttrsAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 4, (*this)->getAttrs().end() - 2, getResAttrsAttrName()));
}

::std::optional< ::mlir::ArrayAttr > MSFTModuleOp::getResAttrs() {
  auto attr = getResAttrsAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr MSFTModuleOp::getArgNamesAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 4, getArgNamesAttrName()));
}

::mlir::ArrayAttr MSFTModuleOp::getArgNames() {
  auto attr = getArgNamesAttr();
  return attr;
}

::mlir::ArrayAttr MSFTModuleOp::getResultNamesAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 5, (*this)->getAttrs().end() - 0, getResultNamesAttrName()));
}

::mlir::ArrayAttr MSFTModuleOp::getResultNames() {
  auto attr = getResultNamesAttr();
  return attr;
}

::mlir::ArrayAttr MSFTModuleOp::getArgLocsAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 5, getArgLocsAttrName()));
}

::mlir::ArrayAttr MSFTModuleOp::getArgLocs() {
  auto attr = getArgLocsAttr();
  return attr;
}

::mlir::ArrayAttr MSFTModuleOp::getResultLocsAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 4, (*this)->getAttrs().end() - 1, getResultLocsAttrName()));
}

::mlir::ArrayAttr MSFTModuleOp::getResultLocs() {
  auto attr = getResultLocsAttr();
  return attr;
}

::mlir::DictionaryAttr MSFTModuleOp::getParametersAttr() {
  return ::llvm::cast<::mlir::DictionaryAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 3, (*this)->getAttrs().end() - 2, getParametersAttrName()));
}

::mlir::DictionaryAttr MSFTModuleOp::getParameters() {
  auto attr = getParametersAttr();
  return attr;
}

::mlir::StringAttr MSFTModuleOp::getFileNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 4, getFileNameAttrName()));
}

::std::optional< ::llvm::StringRef > MSFTModuleOp::getFileName() {
  auto attr = getFileNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::ArrayAttr MSFTModuleOp::getChildAppIDBasesAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 4, getChildAppIDBasesAttrName()));
}

::std::optional< ::mlir::ArrayAttr > MSFTModuleOp::getChildAppIDBases() {
  auto attr = getChildAppIDBasesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

void MSFTModuleOp::setFunctionTypeAttr(::mlir::TypeAttr attr) {
  (*this)->setAttr(getFunctionTypeAttrName(), attr);
}

void MSFTModuleOp::setFunctionType(::mlir::FunctionType attrValue) {
  (*this)->setAttr(getFunctionTypeAttrName(), ::mlir::TypeAttr::get(attrValue));
}

void MSFTModuleOp::setArgAttrsAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getArgAttrsAttrName(), attr);
}

void MSFTModuleOp::setResAttrsAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getResAttrsAttrName(), attr);
}

void MSFTModuleOp::setArgNamesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getArgNamesAttrName(), attr);
}

void MSFTModuleOp::setResultNamesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getResultNamesAttrName(), attr);
}

void MSFTModuleOp::setArgLocsAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getArgLocsAttrName(), attr);
}

void MSFTModuleOp::setResultLocsAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getResultLocsAttrName(), attr);
}

void MSFTModuleOp::setParametersAttr(::mlir::DictionaryAttr attr) {
  (*this)->setAttr(getParametersAttrName(), attr);
}

void MSFTModuleOp::setFileNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getFileNameAttrName(), attr);
}

void MSFTModuleOp::setFileName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getFileNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getFileNameAttrName());
}

void MSFTModuleOp::setChildAppIDBasesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getChildAppIDBasesAttrName(), attr);
}

::mlir::Attribute MSFTModuleOp::removeArgAttrsAttr() {
return (*this)->removeAttr(getArgAttrsAttrName());
}

::mlir::Attribute MSFTModuleOp::removeResAttrsAttr() {
return (*this)->removeAttr(getResAttrsAttrName());
}

::mlir::Attribute MSFTModuleOp::removeFileNameAttr() {
return (*this)->removeAttr(getFileNameAttrName());
}

::mlir::Attribute MSFTModuleOp::removeChildAppIDBasesAttr() {
return (*this)->removeAttr(getChildAppIDBasesAttrName());
}

::mlir::LogicalResult MSFTModuleOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_argLocs;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'argLocs'");
    if (namedAttrIt->getName() == getArgLocsAttrName()) {
      tblgen_argLocs = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_argNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'argNames'");
    if (namedAttrIt->getName() == getArgNamesAttrName()) {
      tblgen_argNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_function_type;
  ::mlir::Attribute tblgen_arg_attrs;
  ::mlir::Attribute tblgen_childAppIDBases;
  ::mlir::Attribute tblgen_fileName;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'function_type'");
    if (namedAttrIt->getName() == getFunctionTypeAttrName()) {
      tblgen_function_type = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getArgAttrsAttrName()) {
      tblgen_arg_attrs = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getChildAppIDBasesAttrName()) {
      tblgen_childAppIDBases = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getFileNameAttrName()) {
      tblgen_fileName = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_parameters;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'parameters'");
    if (namedAttrIt->getName() == getParametersAttrName()) {
      tblgen_parameters = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_resultLocs;
  ::mlir::Attribute tblgen_res_attrs;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'resultLocs'");
    if (namedAttrIt->getName() == getResultLocsAttrName()) {
      tblgen_resultLocs = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getResAttrsAttrName()) {
      tblgen_res_attrs = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_resultNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'resultNames'");
    if (namedAttrIt->getName() == getResultNamesAttrName()) {
      tblgen_resultNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT8(*this, tblgen_function_type, "function_type")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT9(*this, tblgen_arg_attrs, "arg_attrs")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT9(*this, tblgen_res_attrs, "res_attrs")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT10(*this, tblgen_argNames, "argNames")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT10(*this, tblgen_resultNames, "resultNames")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT11(*this, tblgen_argLocs, "argLocs")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT11(*this, tblgen_resultLocs, "resultLocs")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT12(*this, tblgen_parameters, "parameters")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_fileName, "fileName")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT10(*this, tblgen_childAppIDBases, "childAppIDBases")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_MSFT2(*this, region, "body", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult MSFTModuleOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

size_t MSFTModuleOp::getNumPorts() {
  // This is excessively expensive
  auto ports = getPorts();
  return ports.size();
}

circt::hw::InnerSymAttr MSFTModuleOp::getPortSymbolAttr(size_t portIndex) {
  for (NamedAttribute argAttr :
       mlir::function_interface_impl::getArgAttrs(*this, portIndex))
    if (auto sym = argAttr.getValue().dyn_cast<circt::hw::InnerSymAttr>())
      return sym;
  return circt::hw::InnerSymAttr();
}
} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::MSFTModuleOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::OutputOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
OutputOpGenericAdaptorBase::OutputOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.output", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> OutputOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr OutputOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
OutputOpAdaptor::OutputOpAdaptor(OutputOp op) : OutputOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult OutputOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> OutputOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range OutputOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range OutputOp::getOperands() {
  return getODSOperands(0);
}

::mlir::MutableOperandRange OutputOp::getOperandsMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> OutputOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range OutputOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

void OutputOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands) {
  odsState.addOperands(operands);
}

void OutputOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult OutputOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult OutputOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult OutputOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> operandsOperands;
  ::llvm::SMLoc operandsOperandsLoc;
  (void)operandsOperandsLoc;
  ::llvm::SmallVector<::mlir::Type, 1> operandsTypes;
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }

  operandsOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperandList(operandsOperands))
    return ::mlir::failure();
  if (!operandsOperands.empty()) {
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseTypeList(operandsTypes))
    return ::mlir::failure();
  }
  if (parser.resolveOperands(operandsOperands, operandsTypes, operandsOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void OutputOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  if (!getOperands().empty()) {
    _odsPrinter << ' ';
    _odsPrinter << getOperands();
    _odsPrinter << ' ' << ":";
    _odsPrinter << ' ';
    _odsPrinter << getOperands().getTypes();
  }
}

void OutputOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::OutputOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::PDPhysLocationOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
PDPhysLocationOpGenericAdaptorBase::PDPhysLocationOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.pd.location", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> PDPhysLocationOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr PDPhysLocationOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::circt::msft::PhysLocationAttr PDPhysLocationOpGenericAdaptorBase::getLocAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::circt::msft::PhysLocationAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, PDPhysLocationOp::getLocAttrName(*odsOpName)));
  return attr;
}

::circt::msft::PhysLocationAttr PDPhysLocationOpGenericAdaptorBase::getLoc() {
  auto attr = getLocAttr();
  return ::llvm::cast<::circt::msft::PhysLocationAttr>(attr);
}

::mlir::StringAttr PDPhysLocationOpGenericAdaptorBase::getSubPathAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, PDPhysLocationOp::getSubPathAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > PDPhysLocationOpGenericAdaptorBase::getSubPath() {
  auto attr = getSubPathAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::FlatSymbolRefAttr PDPhysLocationOpGenericAdaptorBase::getRefAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, PDPhysLocationOp::getRefAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > PDPhysLocationOpGenericAdaptorBase::getRef() {
  auto attr = getRefAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

} // namespace detail
PDPhysLocationOpAdaptor::PDPhysLocationOpAdaptor(PDPhysLocationOp op) : PDPhysLocationOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult PDPhysLocationOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_loc;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.pd.location' op ""requires attribute 'loc'");
    if (namedAttrIt->getName() == PDPhysLocationOp::getLocAttrName(*odsOpName)) {
      tblgen_loc = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_ref;
  ::mlir::Attribute tblgen_subPath;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == PDPhysLocationOp::getRefAttrName(*odsOpName)) {
      tblgen_ref = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == PDPhysLocationOp::getSubPathAttrName(*odsOpName)) {
      tblgen_subPath = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_loc && !((::llvm::isa<::circt::msft::PhysLocationAttr>(tblgen_loc))))
    return emitError(loc, "'msft.pd.location' op ""attribute 'loc' failed to satisfy constraint: Descibes a physical location on a device");

  if (tblgen_subPath && !((::llvm::isa<::mlir::StringAttr>(tblgen_subPath))))
    return emitError(loc, "'msft.pd.location' op ""attribute 'subPath' failed to satisfy constraint: string attribute");

  if (tblgen_ref && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(tblgen_ref))))
    return emitError(loc, "'msft.pd.location' op ""attribute 'ref' failed to satisfy constraint: flat symbol reference attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> PDPhysLocationOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range PDPhysLocationOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> PDPhysLocationOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range PDPhysLocationOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::circt::msft::PhysLocationAttr PDPhysLocationOp::getLocAttr() {
  return ::llvm::cast<::circt::msft::PhysLocationAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getLocAttrName()));
}

::circt::msft::PhysLocationAttr PDPhysLocationOp::getLoc() {
  auto attr = getLocAttr();
  return ::llvm::cast<::circt::msft::PhysLocationAttr>(attr);
}

::mlir::StringAttr PDPhysLocationOp::getSubPathAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getSubPathAttrName()));
}

::std::optional< ::llvm::StringRef > PDPhysLocationOp::getSubPath() {
  auto attr = getSubPathAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::FlatSymbolRefAttr PDPhysLocationOp::getRefAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getRefAttrName()));
}

::std::optional< ::llvm::StringRef > PDPhysLocationOp::getRef() {
  auto attr = getRefAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

void PDPhysLocationOp::setLocAttr(::circt::msft::PhysLocationAttr attr) {
  (*this)->setAttr(getLocAttrName(), attr);
}

void PDPhysLocationOp::setSubPathAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSubPathAttrName(), attr);
}

void PDPhysLocationOp::setSubPath(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getSubPathAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getSubPathAttrName());
}

void PDPhysLocationOp::setRefAttr(::mlir::FlatSymbolRefAttr attr) {
  (*this)->setAttr(getRefAttrName(), attr);
}

void PDPhysLocationOp::setRef(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getRefAttrName(), ::mlir::SymbolRefAttr::get(::mlir::Builder((*this)->getContext()).getContext(), *attrValue));
    (*this)->removeAttr(getRefAttrName());
}

::mlir::Attribute PDPhysLocationOp::removeSubPathAttr() {
return (*this)->removeAttr(getSubPathAttrName());
}

::mlir::Attribute PDPhysLocationOp::removeRefAttr() {
return (*this)->removeAttr(getRefAttrName());
}

void PDPhysLocationOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::circt::msft::PhysLocationAttr loc, /*optional*/::mlir::StringAttr subPath, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getLocAttrName(odsState.name), loc);
  if (subPath) {
    odsState.addAttribute(getSubPathAttrName(odsState.name), subPath);
  }
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
}

void PDPhysLocationOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::circt::msft::PhysLocationAttr loc, /*optional*/::mlir::StringAttr subPath, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getLocAttrName(odsState.name), loc);
  if (subPath) {
    odsState.addAttribute(getSubPathAttrName(odsState.name), subPath);
  }
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void PDPhysLocationOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult PDPhysLocationOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_loc;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'loc'");
    if (namedAttrIt->getName() == getLocAttrName()) {
      tblgen_loc = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_ref;
  ::mlir::Attribute tblgen_subPath;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getRefAttrName()) {
      tblgen_ref = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getSubPathAttrName()) {
      tblgen_subPath = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT13(*this, tblgen_loc, "loc")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_subPath, "subPath")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT4(*this, tblgen_ref, "ref")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult PDPhysLocationOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult PDPhysLocationOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::FlatSymbolRefAttr refAttr;
  ::circt::msft::PhysLocationAttr locAttr;
  ::mlir::StringAttr subPathAttr;

  ::mlir::OptionalParseResult parseResultrefAttr =
    parser.parseOptionalAttribute(refAttr, parser.getBuilder().getType<::mlir::NoneType>());
  if (parseResultrefAttr.has_value() && failed(*parseResultrefAttr))
    return ::mlir::failure();
  if (parseResultrefAttr.has_value() && succeeded(*parseResultrefAttr))
  if (refAttr) result.attributes.append("ref", refAttr);
  if (refAttr) {
  }
  {
    if (parsePhysLoc(parser, locAttr))
      return ::mlir::failure();
    result.addAttribute("loc", locAttr);
  }
  if (::mlir::succeeded(parser.parseOptionalKeyword("path"))) {
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(subPathAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (subPathAttr) result.attributes.append("subPath", subPathAttr);
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void PDPhysLocationOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getRefAttr()) {
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getRefAttr());
  }
  _odsPrinter << ' ';
  printPhysLoc(_odsPrinter, *this, getLocAttr());
  if (getSubPathAttr()) {
    _odsPrinter << ' ' << "path";
    _odsPrinter << ' ' << ":";
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getSubPathAttr());
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("ref");
  elidedAttrs.push_back("loc");
  elidedAttrs.push_back("subPath");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::PDPhysLocationOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::PDPhysRegionOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
PDPhysRegionOpGenericAdaptorBase::PDPhysRegionOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.pd.physregion", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> PDPhysRegionOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr PDPhysRegionOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::FlatSymbolRefAttr PDPhysRegionOpGenericAdaptorBase::getPhysRegionRefAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, PDPhysRegionOp::getPhysRegionRefAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef PDPhysRegionOpGenericAdaptorBase::getPhysRegionRef() {
  auto attr = getPhysRegionRefAttr();
  return attr.getValue();
}

::mlir::StringAttr PDPhysRegionOpGenericAdaptorBase::getSubPathAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, PDPhysRegionOp::getSubPathAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > PDPhysRegionOpGenericAdaptorBase::getSubPath() {
  auto attr = getSubPathAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::FlatSymbolRefAttr PDPhysRegionOpGenericAdaptorBase::getRefAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, PDPhysRegionOp::getRefAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > PDPhysRegionOpGenericAdaptorBase::getRef() {
  auto attr = getRefAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

} // namespace detail
PDPhysRegionOpAdaptor::PDPhysRegionOpAdaptor(PDPhysRegionOp op) : PDPhysRegionOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult PDPhysRegionOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_physRegionRef;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.pd.physregion' op ""requires attribute 'physRegionRef'");
    if (namedAttrIt->getName() == PDPhysRegionOp::getPhysRegionRefAttrName(*odsOpName)) {
      tblgen_physRegionRef = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_ref;
  ::mlir::Attribute tblgen_subPath;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == PDPhysRegionOp::getRefAttrName(*odsOpName)) {
      tblgen_ref = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == PDPhysRegionOp::getSubPathAttrName(*odsOpName)) {
      tblgen_subPath = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_physRegionRef && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(tblgen_physRegionRef))))
    return emitError(loc, "'msft.pd.physregion' op ""attribute 'physRegionRef' failed to satisfy constraint: flat symbol reference attribute");

  if (tblgen_subPath && !((::llvm::isa<::mlir::StringAttr>(tblgen_subPath))))
    return emitError(loc, "'msft.pd.physregion' op ""attribute 'subPath' failed to satisfy constraint: string attribute");

  if (tblgen_ref && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(tblgen_ref))))
    return emitError(loc, "'msft.pd.physregion' op ""attribute 'ref' failed to satisfy constraint: flat symbol reference attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> PDPhysRegionOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range PDPhysRegionOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> PDPhysRegionOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range PDPhysRegionOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::FlatSymbolRefAttr PDPhysRegionOp::getPhysRegionRefAttr() {
  return ::llvm::cast<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getPhysRegionRefAttrName()));
}

::llvm::StringRef PDPhysRegionOp::getPhysRegionRef() {
  auto attr = getPhysRegionRefAttr();
  return attr.getValue();
}

::mlir::StringAttr PDPhysRegionOp::getSubPathAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getSubPathAttrName()));
}

::std::optional< ::llvm::StringRef > PDPhysRegionOp::getSubPath() {
  auto attr = getSubPathAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::FlatSymbolRefAttr PDPhysRegionOp::getRefAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getRefAttrName()));
}

::std::optional< ::llvm::StringRef > PDPhysRegionOp::getRef() {
  auto attr = getRefAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

void PDPhysRegionOp::setPhysRegionRefAttr(::mlir::FlatSymbolRefAttr attr) {
  (*this)->setAttr(getPhysRegionRefAttrName(), attr);
}

void PDPhysRegionOp::setPhysRegionRef(::llvm::StringRef attrValue) {
  (*this)->setAttr(getPhysRegionRefAttrName(), ::mlir::SymbolRefAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

void PDPhysRegionOp::setSubPathAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSubPathAttrName(), attr);
}

void PDPhysRegionOp::setSubPath(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getSubPathAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getSubPathAttrName());
}

void PDPhysRegionOp::setRefAttr(::mlir::FlatSymbolRefAttr attr) {
  (*this)->setAttr(getRefAttrName(), attr);
}

void PDPhysRegionOp::setRef(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getRefAttrName(), ::mlir::SymbolRefAttr::get(::mlir::Builder((*this)->getContext()).getContext(), *attrValue));
    (*this)->removeAttr(getRefAttrName());
}

::mlir::Attribute PDPhysRegionOp::removeSubPathAttr() {
return (*this)->removeAttr(getSubPathAttrName());
}

::mlir::Attribute PDPhysRegionOp::removeRefAttr() {
return (*this)->removeAttr(getRefAttrName());
}

void PDPhysRegionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::FlatSymbolRefAttr physRegionRef, /*optional*/::mlir::StringAttr subPath, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getPhysRegionRefAttrName(odsState.name), physRegionRef);
  if (subPath) {
    odsState.addAttribute(getSubPathAttrName(odsState.name), subPath);
  }
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
}

void PDPhysRegionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::FlatSymbolRefAttr physRegionRef, /*optional*/::mlir::StringAttr subPath, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getPhysRegionRefAttrName(odsState.name), physRegionRef);
  if (subPath) {
    odsState.addAttribute(getSubPathAttrName(odsState.name), subPath);
  }
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void PDPhysRegionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef physRegionRef, /*optional*/::mlir::StringAttr subPath, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getPhysRegionRefAttrName(odsState.name), ::mlir::SymbolRefAttr::get(odsBuilder.getContext(), physRegionRef));
  if (subPath) {
    odsState.addAttribute(getSubPathAttrName(odsState.name), subPath);
  }
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
}

void PDPhysRegionOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef physRegionRef, /*optional*/::mlir::StringAttr subPath, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getPhysRegionRefAttrName(odsState.name), ::mlir::SymbolRefAttr::get(odsBuilder.getContext(), physRegionRef));
  if (subPath) {
    odsState.addAttribute(getSubPathAttrName(odsState.name), subPath);
  }
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void PDPhysRegionOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult PDPhysRegionOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_physRegionRef;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'physRegionRef'");
    if (namedAttrIt->getName() == getPhysRegionRefAttrName()) {
      tblgen_physRegionRef = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_ref;
  ::mlir::Attribute tblgen_subPath;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getRefAttrName()) {
      tblgen_ref = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getSubPathAttrName()) {
      tblgen_subPath = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT4(*this, tblgen_physRegionRef, "physRegionRef")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT0(*this, tblgen_subPath, "subPath")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT4(*this, tblgen_ref, "ref")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult PDPhysRegionOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult PDPhysRegionOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::FlatSymbolRefAttr refAttr;
  ::mlir::FlatSymbolRefAttr physRegionRefAttr;
  ::mlir::StringAttr subPathAttr;

  ::mlir::OptionalParseResult parseResultrefAttr =
    parser.parseOptionalAttribute(refAttr, parser.getBuilder().getType<::mlir::NoneType>());
  if (parseResultrefAttr.has_value() && failed(*parseResultrefAttr))
    return ::mlir::failure();
  if (parseResultrefAttr.has_value() && succeeded(*parseResultrefAttr))
  if (refAttr) result.attributes.append("ref", refAttr);
  if (refAttr) {
  }

  if (parser.parseCustomAttributeWithFallback(physRegionRefAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (physRegionRefAttr) result.attributes.append("physRegionRef", physRegionRefAttr);
  if (::mlir::succeeded(parser.parseOptionalKeyword("path"))) {
  if (parser.parseColon())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(subPathAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (subPathAttr) result.attributes.append("subPath", subPathAttr);
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void PDPhysRegionOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getRefAttr()) {
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getRefAttr());
  }
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getPhysRegionRefAttr());
  if (getSubPathAttr()) {
    _odsPrinter << ' ' << "path";
    _odsPrinter << ' ' << ":";
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getSubPathAttr());
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("ref");
  elidedAttrs.push_back("physRegionRef");
  elidedAttrs.push_back("subPath");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::PDPhysRegionOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::PDRegPhysLocationOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
PDRegPhysLocationOpGenericAdaptorBase::PDRegPhysLocationOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.pd.reg_location", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> PDRegPhysLocationOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr PDRegPhysLocationOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::circt::msft::LocationVectorAttr PDRegPhysLocationOpGenericAdaptorBase::getLocsAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::circt::msft::LocationVectorAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, PDRegPhysLocationOp::getLocsAttrName(*odsOpName)));
  return attr;
}

::circt::msft::LocationVectorAttr PDRegPhysLocationOpGenericAdaptorBase::getLocs() {
  auto attr = getLocsAttr();
  return ::llvm::cast<::circt::msft::LocationVectorAttr>(attr);
}

::mlir::FlatSymbolRefAttr PDRegPhysLocationOpGenericAdaptorBase::getRefAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, PDRegPhysLocationOp::getRefAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > PDRegPhysLocationOpGenericAdaptorBase::getRef() {
  auto attr = getRefAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

} // namespace detail
PDRegPhysLocationOpAdaptor::PDRegPhysLocationOpAdaptor(PDRegPhysLocationOp op) : PDRegPhysLocationOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult PDRegPhysLocationOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_locs;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'msft.pd.reg_location' op ""requires attribute 'locs'");
    if (namedAttrIt->getName() == PDRegPhysLocationOp::getLocsAttrName(*odsOpName)) {
      tblgen_locs = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_ref;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == PDRegPhysLocationOp::getRefAttrName(*odsOpName)) {
      tblgen_ref = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_locs && !((::llvm::isa<::circt::msft::LocationVectorAttr>(tblgen_locs))))
    return emitError(loc, "'msft.pd.reg_location' op ""attribute 'locs' failed to satisfy constraint: Vector of optional locations corresponding to bits in a type");

  if (tblgen_ref && !((::llvm::isa<::mlir::FlatSymbolRefAttr>(tblgen_ref))))
    return emitError(loc, "'msft.pd.reg_location' op ""attribute 'ref' failed to satisfy constraint: flat symbol reference attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> PDRegPhysLocationOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range PDRegPhysLocationOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> PDRegPhysLocationOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range PDRegPhysLocationOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::circt::msft::LocationVectorAttr PDRegPhysLocationOp::getLocsAttr() {
  return ::llvm::cast<::circt::msft::LocationVectorAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getLocsAttrName()));
}

::circt::msft::LocationVectorAttr PDRegPhysLocationOp::getLocs() {
  auto attr = getLocsAttr();
  return ::llvm::cast<::circt::msft::LocationVectorAttr>(attr);
}

::mlir::FlatSymbolRefAttr PDRegPhysLocationOp::getRefAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::FlatSymbolRefAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getRefAttrName()));
}

::std::optional< ::llvm::StringRef > PDRegPhysLocationOp::getRef() {
  auto attr = getRefAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

void PDRegPhysLocationOp::setLocsAttr(::circt::msft::LocationVectorAttr attr) {
  (*this)->setAttr(getLocsAttrName(), attr);
}

void PDRegPhysLocationOp::setRefAttr(::mlir::FlatSymbolRefAttr attr) {
  (*this)->setAttr(getRefAttrName(), attr);
}

void PDRegPhysLocationOp::setRef(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getRefAttrName(), ::mlir::SymbolRefAttr::get(::mlir::Builder((*this)->getContext()).getContext(), *attrValue));
    (*this)->removeAttr(getRefAttrName());
}

::mlir::Attribute PDRegPhysLocationOp::removeRefAttr() {
return (*this)->removeAttr(getRefAttrName());
}

void PDRegPhysLocationOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::circt::msft::LocationVectorAttr locs, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getLocsAttrName(odsState.name), locs);
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
}

void PDRegPhysLocationOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::circt::msft::LocationVectorAttr locs, /*optional*/::mlir::FlatSymbolRefAttr ref) {
  odsState.addAttribute(getLocsAttrName(odsState.name), locs);
  if (ref) {
    odsState.addAttribute(getRefAttrName(odsState.name), ref);
  }
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void PDRegPhysLocationOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult PDRegPhysLocationOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_locs;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'locs'");
    if (namedAttrIt->getName() == getLocsAttrName()) {
      tblgen_locs = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_ref;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getRefAttrName()) {
      tblgen_ref = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT14(*this, tblgen_locs, "locs")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_MSFT4(*this, tblgen_ref, "ref")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult PDRegPhysLocationOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult PDRegPhysLocationOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::FlatSymbolRefAttr refAttr;
  ::circt::msft::LocationVectorAttr locsAttr;
  if (::mlir::succeeded(parser.parseOptionalKeyword("ref"))) {

  if (parser.parseCustomAttributeWithFallback(refAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (refAttr) result.attributes.append("ref", refAttr);
  }
  {
    if (parseListOptionalRegLocList(parser, locsAttr))
      return ::mlir::failure();
    result.addAttribute("locs", locsAttr);
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void PDRegPhysLocationOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getRefAttr()) {
    _odsPrinter << ' ' << "ref";
    _odsPrinter << ' ';
    _odsPrinter.printAttributeWithoutType(getRefAttr());
  }
  _odsPrinter << ' ';
  printListOptionalRegLocList(_odsPrinter, *this, getLocsAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("ref");
  elidedAttrs.push_back("locs");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::PDRegPhysLocationOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::PEOutputOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
PEOutputOpGenericAdaptorBase::PEOutputOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.pe.output", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> PEOutputOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr PEOutputOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
PEOutputOpAdaptor::PEOutputOpAdaptor(PEOutputOp op) : PEOutputOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult PEOutputOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> PEOutputOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range PEOutputOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value PEOutputOp::getOutput() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::MutableOperandRange PEOutputOp::getOutputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> PEOutputOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range PEOutputOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

void PEOutputOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value output) {
  odsState.addOperands(output);
}

void PEOutputOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value output) {
  odsState.addOperands(output);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void PEOutputOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult PEOutputOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult PEOutputOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult PEOutputOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand outputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> outputOperands(outputRawOperands);  ::llvm::SMLoc outputOperandsLoc;
  (void)outputOperandsLoc;
  ::mlir::Type outputRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> outputTypes(outputRawTypes);

  outputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(outputRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::mlir::Type type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    outputRawTypes[0] = type;
  }
  if (parser.resolveOperands(outputOperands, outputTypes, outputOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void PEOutputOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getOutput();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getOutput().getType();
    if (auto validType = ::llvm::dyn_cast<::mlir::Type>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::PEOutputOp)

namespace circt {
namespace msft {

//===----------------------------------------------------------------------===//
// ::circt::msft::SystolicArrayOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
SystolicArrayOpGenericAdaptorBase::SystolicArrayOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("msft.systolic.array", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> SystolicArrayOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr SystolicArrayOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::Region &SystolicArrayOpGenericAdaptorBase::getPe() {
  return *odsRegions[0];
}

::mlir::RegionRange SystolicArrayOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
SystolicArrayOpAdaptor::SystolicArrayOpAdaptor(SystolicArrayOp op) : SystolicArrayOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult SystolicArrayOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> SystolicArrayOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range SystolicArrayOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::hw::TypeAliasOr<circt::hw::ArrayType>> SystolicArrayOp::getRowInputs() {
  return ::llvm::cast<::mlir::TypedValue<::circt::hw::TypeAliasOr<circt::hw::ArrayType>>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::circt::hw::TypeAliasOr<circt::hw::ArrayType>> SystolicArrayOp::getColInputs() {
  return ::llvm::cast<::mlir::TypedValue<::circt::hw::TypeAliasOr<circt::hw::ArrayType>>>(*getODSOperands(1).begin());
}

::mlir::MutableOperandRange SystolicArrayOp::getRowInputsMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange SystolicArrayOp::getColInputsMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> SystolicArrayOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range SystolicArrayOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value SystolicArrayOp::getPeOutputs() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::Region &SystolicArrayOp::getPe() {
  return (*this)->getRegion(0);
}

void SystolicArrayOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type peOutputs, ::mlir::Value rowInputs, ::mlir::Value colInputs) {
  odsState.addOperands(rowInputs);
  odsState.addOperands(colInputs);
  (void)odsState.addRegion();
  odsState.addTypes(peOutputs);
}

void SystolicArrayOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value rowInputs, ::mlir::Value colInputs) {
  odsState.addOperands(rowInputs);
  odsState.addOperands(colInputs);
  (void)odsState.addRegion();
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void SystolicArrayOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  for (unsigned i = 0; i != 1; ++i)
    (void)odsState.addRegion();
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult SystolicArrayOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_MSFT3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_MSFT0(*this, region, "pe", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult SystolicArrayOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

} // namespace msft
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::msft::SystolicArrayOp)


#endif  // GET_OP_CLASSES

