/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Op Definitions                                                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_OP_LIST
#undef GET_OP_LIST

::circt::seq::ClockGateOp,
::circt::seq::CompRegClockEnabledOp,
::circt::seq::CompRegOp,
::circt::seq::FIFOOp,
::circt::seq::FirMemOp,
::circt::seq::FirMemReadOp,
::circt::seq::FirMemReadWriteOp,
::circt::seq::FirMemWriteOp,
::circt::seq::FirRegOp,
::circt::seq::HLMemOp,
::circt::seq::ReadPortOp,
::circt::seq::WritePortOp
#endif  // GET_OP_LIST

#ifdef GET_OP_CLASSES
#undef GET_OP_CLASSES


//===----------------------------------------------------------------------===//
// Local Utility Method Definitions
//===----------------------------------------------------------------------===//

namespace circt {
namespace seq {

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq0(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((type.isSignlessInteger(1)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be 1-bit signless integer, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq1(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((true))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be any type, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq2(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::circt::hw::isHWIntegerType(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be a signless integer bitvector, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq3(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::llvm::isa<::circt::seq::FirMemType>(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be A FIRRTL-flavored memory, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq4(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((type.isSignlessInteger()))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be signless integer, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq5(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::llvm::isa<::circt::seq::HLMemType>(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be Multi-dimensional memory type, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq0(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::mlir::StringAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: string attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq0(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq0(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq1(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() >= 1))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 1";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq1(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq1(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq2(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() >= 0))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 0";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq2(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq2(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq3(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(32)))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: 32-bit signless integer attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq3(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq3(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq4(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<circt::seq::RUWAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: Read-Under-Write Behavior";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq4(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq4(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq5(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<circt::seq::WUWAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: Write-Under-Write Behavior";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq5(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq5(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq6(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::circt::seq::FirMemInitAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: Memory initialization information";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq6(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq6(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq7(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((true)))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: any attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq7(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq7(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq8(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::mlir::IntegerAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: arbitrary integer attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq8(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq8(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq9(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !((::llvm::isa<::mlir::UnitAttr>(attr))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: unit attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq9(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq9(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq10(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> getDiag) {
  if (attr && !(((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(64)))))
    return getDiag() << "attribute '" << attrName
        << "' failed to satisfy constraint: 64-bit signless integer attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq10(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq10(attr, attrName, [op]() {
    return op->emitOpError();
  });
}
} // namespace seq
} // namespace circt
namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::ClockGateOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ClockGateOpGenericAdaptorBase::ClockGateOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.clock_gate", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ClockGateOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {false, false, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 2) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr ClockGateOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
ClockGateOpAdaptor::ClockGateOpAdaptor(ClockGateOp op) : ClockGateOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ClockGateOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ClockGateOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {false, false, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 2) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range ClockGateOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> ClockGateOp::getInput() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> ClockGateOp::getEnable() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> ClockGateOp::getTestEnable() {
  auto operands = getODSOperands(2);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::MutableOperandRange ClockGateOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange ClockGateOp::getEnableMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange ClockGateOp::getTestEnableMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> ClockGateOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ClockGateOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> ClockGateOp::getOutput() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(0).begin());
}

void ClockGateOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Value input, ::mlir::Value enable, /*optional*/::mlir::Value test_enable) {
  odsState.addOperands(input);
  odsState.addOperands(enable);
  if (test_enable)
    odsState.addOperands(test_enable);
  odsState.addTypes(output);
}

void ClockGateOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input, ::mlir::Value enable, /*optional*/::mlir::Value test_enable) {
  odsState.addOperands(input);
  odsState.addOperands(enable);
  if (test_enable)
    odsState.addOperands(test_enable);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ClockGateOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ClockGateOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value enable, /*optional*/::mlir::Value test_enable) {
  odsState.addOperands(input);
  odsState.addOperands(enable);
  if (test_enable)
    odsState.addOperands(test_enable);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ClockGateOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void ClockGateOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(ClockGateOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult ClockGateOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    if (valueGroup2.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup2.size();
    }

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ClockGateOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

void ClockGateOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::LogicalResult ClockGateOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = odsBuilder.getIntegerType(1);
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult ClockGateOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand inputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> inputOperands(inputRawOperands);  ::llvm::SMLoc inputOperandsLoc;
  (void)inputOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand enableRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> enableOperands(enableRawOperands);  ::llvm::SMLoc enableOperandsLoc;
  (void)enableOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> test_enableOperands;
  ::llvm::SMLoc test_enableOperandsLoc;
  (void)test_enableOperandsLoc;

  inputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(inputRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  enableOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(enableRawOperands[0]))
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalComma())) {

  {
    test_enableOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      test_enableOperands.push_back(operand);
    }
  }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  result.addTypes(odsBuildableType0);
  if (parser.resolveOperands(inputOperands, odsBuildableType0, inputOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(enableOperands, odsBuildableType0, enableOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(test_enableOperands, odsBuildableType0, test_enableOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ClockGateOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getInput();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getEnable();
  if (getTestEnable()) {
    _odsPrinter << ",";
    _odsPrinter << ' ';
    if (::mlir::Value value = getTestEnable())
      _odsPrinter << value;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

void ClockGateOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::ClockGateOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::CompRegClockEnabledOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
CompRegClockEnabledOpGenericAdaptorBase::CompRegClockEnabledOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.compreg.ce", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> CompRegClockEnabledOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {false, false, false, true, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 3) / 2;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr CompRegClockEnabledOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr CompRegClockEnabledOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, CompRegClockEnabledOp::getNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef CompRegClockEnabledOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::mlir::StringAttr CompRegClockEnabledOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, CompRegClockEnabledOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > CompRegClockEnabledOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

} // namespace detail
CompRegClockEnabledOpAdaptor::CompRegClockEnabledOpAdaptor(CompRegClockEnabledOp op) : CompRegClockEnabledOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult CompRegClockEnabledOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.compreg.ce' op ""requires attribute 'name'");
    if (namedAttrIt->getName() == CompRegClockEnabledOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == CompRegClockEnabledOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'seq.compreg.ce' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'seq.compreg.ce' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> CompRegClockEnabledOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {false, false, false, true, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 3) / 2;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range CompRegClockEnabledOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value CompRegClockEnabledOp::getInput() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> CompRegClockEnabledOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> CompRegClockEnabledOp::getClockEnable() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> CompRegClockEnabledOp::getReset() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::Value CompRegClockEnabledOp::getResetValue() {
  auto operands = getODSOperands(4);
  return operands.empty() ? ::mlir::Value{} : ::llvm::cast<::mlir::Value>(*operands.begin());
}

::mlir::MutableOperandRange CompRegClockEnabledOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CompRegClockEnabledOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CompRegClockEnabledOp::getClockEnableMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CompRegClockEnabledOp::getResetMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CompRegClockEnabledOp::getResetValueMutable() {
  auto range = getODSOperandIndexAndLength(4);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> CompRegClockEnabledOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range CompRegClockEnabledOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value CompRegClockEnabledOp::getData() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::StringAttr CompRegClockEnabledOp::getNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getNameAttrName()));
}

::llvm::StringRef CompRegClockEnabledOp::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::mlir::StringAttr CompRegClockEnabledOp::getSymNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::std::optional< ::llvm::StringRef > CompRegClockEnabledOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

void CompRegClockEnabledOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void CompRegClockEnabledOp::setName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void CompRegClockEnabledOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void CompRegClockEnabledOp::setSymName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getSymNameAttrName());
}

::mlir::Attribute CompRegClockEnabledOp::removeSymNameAttr() {
return (*this)->removeAttr(getSymNameAttrName());
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, Value input, Value clk, Value ce, StringRef sym_name) {
      return build(odsBuilder, odsState, input.getType(),
                   input, clk, ce, sym_name, Value(), Value(),
                   StringAttr::get(odsBuilder.getContext(), sym_name));
    
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, Value input, Value clk, Value ce, Value reset, Value rstValue, StringRef sym_name) {
      return build(odsBuilder, odsState, input.getType(),
                   input, clk, ce, sym_name, reset, rstValue,
                   StringAttr::get(odsBuilder.getContext(), sym_name));
    
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, ::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }
  odsState.addTypes(data);
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, ::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(CompRegClockEnabledOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, ::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, ::llvm::StringRef name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }
  odsState.addTypes(data);
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, ::llvm::StringRef name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(CompRegClockEnabledOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, ::llvm::StringRef name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(CompRegClockEnabledOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult CompRegClockEnabledOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'name'");
    if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    if (valueGroup4.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup4.size();
    }

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((((*this->getODSOperands(0).begin()).getType()) == ((*this->getODSResults(0).begin()).getType()) && ((*this->getODSResults(0).begin()).getType()) == ((*this->getODSOperands(0).begin()).getType()))))
    return emitOpError("failed to verify that all of {input, data} have same type");
  return ::mlir::success();
}

::mlir::LogicalResult CompRegClockEnabledOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::LogicalResult CompRegClockEnabledOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = operands[0].getType();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

void CompRegClockEnabledOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::CompRegClockEnabledOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::CompRegOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
CompRegOpGenericAdaptorBase::CompRegOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.compreg", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> CompRegOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {false, false, true, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 2) / 2;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr CompRegOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr CompRegOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, CompRegOp::getNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef CompRegOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::mlir::StringAttr CompRegOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, CompRegOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > CompRegOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

} // namespace detail
CompRegOpAdaptor::CompRegOpAdaptor(CompRegOp op) : CompRegOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult CompRegOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.compreg' op ""requires attribute 'name'");
    if (namedAttrIt->getName() == CompRegOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == CompRegOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'seq.compreg' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'seq.compreg' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> CompRegOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {false, false, true, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 2) / 2;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range CompRegOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value CompRegOp::getInput() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> CompRegOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> CompRegOp::getReset() {
  auto operands = getODSOperands(2);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::Value CompRegOp::getResetValue() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::Value{} : ::llvm::cast<::mlir::Value>(*operands.begin());
}

::mlir::MutableOperandRange CompRegOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CompRegOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CompRegOp::getResetMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange CompRegOp::getResetValueMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> CompRegOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range CompRegOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value CompRegOp::getData() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::StringAttr CompRegOp::getNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getNameAttrName()));
}

::llvm::StringRef CompRegOp::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::mlir::StringAttr CompRegOp::getSymNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::std::optional< ::llvm::StringRef > CompRegOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

void CompRegOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void CompRegOp::setName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void CompRegOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void CompRegOp::setSymName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getSymNameAttrName());
}

::mlir::Attribute CompRegOp::removeSymNameAttr() {
return (*this)->removeAttr(getSymNameAttrName());
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, Value input, Value clk, StringRef sym_name) {
      return build(odsBuilder, odsState, input.getType(),
                   input, clk, sym_name, Value(), Value(),
                   StringAttr::get(odsBuilder.getContext(), sym_name));
    
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, Value input, Value clk, Value reset, Value rstValue, StringRef sym_name) {
      return build(odsBuilder, odsState, input.getType(),
                   input, clk, sym_name, reset, rstValue,
                   StringAttr::get(odsBuilder.getContext(), sym_name));
    
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Value input, ::mlir::Value clk, ::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }
  odsState.addTypes(data);
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input, ::mlir::Value clk, ::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(CompRegOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value clk, ::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), name);
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Value input, ::mlir::Value clk, ::llvm::StringRef name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }
  odsState.addTypes(data);
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input, ::mlir::Value clk, ::llvm::StringRef name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(CompRegOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value clk, ::llvm::StringRef name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::StringAttr sym_name) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  odsState.addAttribute(getNameAttrName(odsState.name), odsBuilder.getStringAttr(name));
  if (sym_name) {
    odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CompRegOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(CompRegOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult CompRegOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'name'");
    if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sym_name;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    if (valueGroup2.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup2.size();
    }

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((((*this->getODSOperands(0).begin()).getType()) == ((*this->getODSResults(0).begin()).getType()) && ((*this->getODSResults(0).begin()).getType()) == ((*this->getODSOperands(0).begin()).getType()))))
    return emitOpError("failed to verify that all of {input, data} have same type");
  return ::mlir::success();
}

::mlir::LogicalResult CompRegOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::LogicalResult CompRegOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = operands[0].getType();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

void CompRegOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::CompRegOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FIFOOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FIFOOpGenericAdaptorBase::FIFOOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.fifo", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> FIFOOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr FIFOOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr FIFOOpGenericAdaptorBase::getDepthAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, FIFOOp::getDepthAttrName(*odsOpName)));
  return attr;
}

uint64_t FIFOOpGenericAdaptorBase::getDepth() {
  auto attr = getDepthAttr();
  return attr.getValue().getZExtValue();
}

::mlir::IntegerAttr FIFOOpGenericAdaptorBase::getAlmostFullThresholdAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 2, FIFOOp::getAlmostFullThresholdAttrName(*odsOpName)));
  return attr;
}

::std::optional<uint64_t> FIFOOpGenericAdaptorBase::getAlmostFullThreshold() {
  auto attr = getAlmostFullThresholdAttr();
  return attr ? ::std::optional<uint64_t>(attr.getValue().getZExtValue()) : (::std::nullopt);
}

::mlir::IntegerAttr FIFOOpGenericAdaptorBase::getAlmostEmptyThresholdAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 2, FIFOOp::getAlmostEmptyThresholdAttrName(*odsOpName)));
  return attr;
}

::std::optional<uint64_t> FIFOOpGenericAdaptorBase::getAlmostEmptyThreshold() {
  auto attr = getAlmostEmptyThresholdAttr();
  return attr ? ::std::optional<uint64_t>(attr.getValue().getZExtValue()) : (::std::nullopt);
}

} // namespace detail
FIFOOpAdaptor::FIFOOpAdaptor(FIFOOp op) : FIFOOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult FIFOOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_depth;
  ::mlir::Attribute tblgen_almostEmptyThreshold;
  ::mlir::Attribute tblgen_almostFullThreshold;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.fifo' op ""requires attribute 'depth'");
    if (namedAttrIt->getName() == FIFOOp::getDepthAttrName(*odsOpName)) {
      tblgen_depth = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == FIFOOp::getAlmostEmptyThresholdAttrName(*odsOpName)) {
      tblgen_almostEmptyThreshold = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == FIFOOp::getAlmostFullThresholdAttrName(*odsOpName)) {
      tblgen_almostFullThreshold = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_result_segment_sizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.fifo' op ""requires attribute 'result_segment_sizes'");
    if (namedAttrIt->getName() == FIFOOp::getResultSegmentSizesAttrName(*odsOpName)) {
      tblgen_result_segment_sizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_result_segment_sizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 5)
      return emitError(loc, "'seq.fifo' op ""'result_segment_sizes' attribute for specifying result segments must have 5 "
                "elements, but got ") << numElements;
  }

  if (tblgen_depth && !((((::llvm::isa<::mlir::IntegerAttr>(tblgen_depth))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_depth).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_depth).getInt() >= 1))))
    return emitError(loc, "'seq.fifo' op ""attribute 'depth' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 1");

  if (tblgen_almostFullThreshold && !((((::llvm::isa<::mlir::IntegerAttr>(tblgen_almostFullThreshold))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_almostFullThreshold).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_almostFullThreshold).getInt() >= 0))))
    return emitError(loc, "'seq.fifo' op ""attribute 'almostFullThreshold' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 0");

  if (tblgen_almostEmptyThreshold && !((((::llvm::isa<::mlir::IntegerAttr>(tblgen_almostEmptyThreshold))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_almostEmptyThreshold).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_almostEmptyThreshold).getInt() >= 0))))
    return emitError(loc, "'seq.fifo' op ""attribute 'almostEmptyThreshold' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 0");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> FIFOOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range FIFOOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType>> FIFOOp::getInput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType>>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getRdEn() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getWrEn() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(3).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getRst() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(4).begin());
}

::mlir::MutableOperandRange FIFOOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange FIFOOp::getRdEnMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange FIFOOp::getWrEnMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange FIFOOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange FIFOOp::getRstMutable() {
  auto range = getODSOperandIndexAndLength(4);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> FIFOOp::getODSResultIndexAndLength(unsigned index) {
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getResultSegmentSizesAttrName()));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::result_range FIFOOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType>> FIFOOp::getOutput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType>>>(*getODSResults(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getFull() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getEmpty() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getAlmostFull() {
  auto results = getODSResults(3);
  return results.empty() ? ::mlir::TypedValue<::mlir::IntegerType>() : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*results.begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getAlmostEmpty() {
  auto results = getODSResults(4);
  return results.empty() ? ::mlir::TypedValue<::mlir::IntegerType>() : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*results.begin());
}

::mlir::IntegerAttr FIFOOp::getDepthAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getDepthAttrName()));
}

uint64_t FIFOOp::getDepth() {
  auto attr = getDepthAttr();
  return attr.getValue().getZExtValue();
}

::mlir::IntegerAttr FIFOOp::getAlmostFullThresholdAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 2, getAlmostFullThresholdAttrName()));
}

::std::optional<uint64_t> FIFOOp::getAlmostFullThreshold() {
  auto attr = getAlmostFullThresholdAttr();
  return attr ? ::std::optional<uint64_t>(attr.getValue().getZExtValue()) : (::std::nullopt);
}

::mlir::IntegerAttr FIFOOp::getAlmostEmptyThresholdAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 2, getAlmostEmptyThresholdAttrName()));
}

::std::optional<uint64_t> FIFOOp::getAlmostEmptyThreshold() {
  auto attr = getAlmostEmptyThresholdAttr();
  return attr ? ::std::optional<uint64_t>(attr.getValue().getZExtValue()) : (::std::nullopt);
}

void FIFOOp::setDepthAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getDepthAttrName(), attr);
}

void FIFOOp::setDepth(uint64_t attrValue) {
  (*this)->setAttr(getDepthAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), attrValue));
}

void FIFOOp::setAlmostFullThresholdAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getAlmostFullThresholdAttrName(), attr);
}

void FIFOOp::setAlmostFullThreshold(::std::optional<uint64_t> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getAlmostFullThresholdAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), *attrValue));
    (*this)->removeAttr(getAlmostFullThresholdAttrName());
}

void FIFOOp::setAlmostEmptyThresholdAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getAlmostEmptyThresholdAttrName(), attr);
}

void FIFOOp::setAlmostEmptyThreshold(::std::optional<uint64_t> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getAlmostEmptyThresholdAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), *attrValue));
    (*this)->removeAttr(getAlmostEmptyThresholdAttrName());
}

::mlir::Attribute FIFOOp::removeAlmostFullThresholdAttr() {
return (*this)->removeAttr(getAlmostFullThresholdAttrName());
}

::mlir::Attribute FIFOOp::removeAlmostEmptyThresholdAttr() {
return (*this)->removeAttr(getAlmostEmptyThresholdAttrName());
}

void FIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Type full, ::mlir::Type empty, /*optional*/::mlir::Type almostFull, /*optional*/::mlir::Type almostEmpty, ::mlir::Value input, ::mlir::Value rdEn, ::mlir::Value wrEn, ::mlir::Value clk, ::mlir::Value rst, ::mlir::IntegerAttr depth, /*optional*/::mlir::IntegerAttr almostFullThreshold, /*optional*/::mlir::IntegerAttr almostEmptyThreshold) {
  odsState.addOperands(input);
  odsState.addOperands(rdEn);
  odsState.addOperands(wrEn);
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addAttribute(getDepthAttrName(odsState.name), depth);
  if (almostFullThreshold) {
    odsState.addAttribute(getAlmostFullThresholdAttrName(odsState.name), almostFullThreshold);
  }
  if (almostEmptyThreshold) {
    odsState.addAttribute(getAlmostEmptyThresholdAttrName(odsState.name), almostEmptyThreshold);
  }
  odsState.addTypes(output);
  odsState.addTypes(full);
  odsState.addTypes(empty);
  if (almostFull)
    odsState.addTypes(almostFull);
  if (almostEmpty)
    odsState.addTypes(almostEmpty);
 odsState.addAttribute(getResultSegmentSizesAttrName(odsState.name), odsBuilder.getDenseI32ArrayAttr({1, 1, 1, (almostFull ? 1 : 0), (almostEmpty ? 1 : 0)}));
}

void FIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value rdEn, ::mlir::Value wrEn, ::mlir::Value clk, ::mlir::Value rst, ::mlir::IntegerAttr depth, /*optional*/::mlir::IntegerAttr almostFullThreshold, /*optional*/::mlir::IntegerAttr almostEmptyThreshold) {
  odsState.addOperands(input);
  odsState.addOperands(rdEn);
  odsState.addOperands(wrEn);
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addAttribute(getDepthAttrName(odsState.name), depth);
  if (almostFullThreshold) {
    odsState.addAttribute(getAlmostFullThresholdAttrName(odsState.name), almostFullThreshold);
  }
  if (almostEmptyThreshold) {
    odsState.addAttribute(getAlmostEmptyThresholdAttrName(odsState.name), almostEmptyThreshold);
  }
  assert(resultTypes.size() >= 3u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Type full, ::mlir::Type empty, /*optional*/::mlir::Type almostFull, /*optional*/::mlir::Type almostEmpty, ::mlir::Value input, ::mlir::Value rdEn, ::mlir::Value wrEn, ::mlir::Value clk, ::mlir::Value rst, uint64_t depth, /*optional*/::mlir::IntegerAttr almostFullThreshold, /*optional*/::mlir::IntegerAttr almostEmptyThreshold) {
  odsState.addOperands(input);
  odsState.addOperands(rdEn);
  odsState.addOperands(wrEn);
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addAttribute(getDepthAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), depth));
  if (almostFullThreshold) {
    odsState.addAttribute(getAlmostFullThresholdAttrName(odsState.name), almostFullThreshold);
  }
  if (almostEmptyThreshold) {
    odsState.addAttribute(getAlmostEmptyThresholdAttrName(odsState.name), almostEmptyThreshold);
  }
  odsState.addTypes(output);
  odsState.addTypes(full);
  odsState.addTypes(empty);
  if (almostFull)
    odsState.addTypes(almostFull);
  if (almostEmpty)
    odsState.addTypes(almostEmpty);
 odsState.addAttribute(getResultSegmentSizesAttrName(odsState.name), odsBuilder.getDenseI32ArrayAttr({1, 1, 1, (almostFull ? 1 : 0), (almostEmpty ? 1 : 0)}));
}

void FIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value rdEn, ::mlir::Value wrEn, ::mlir::Value clk, ::mlir::Value rst, uint64_t depth, /*optional*/::mlir::IntegerAttr almostFullThreshold, /*optional*/::mlir::IntegerAttr almostEmptyThreshold) {
  odsState.addOperands(input);
  odsState.addOperands(rdEn);
  odsState.addOperands(wrEn);
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addAttribute(getDepthAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), depth));
  if (almostFullThreshold) {
    odsState.addAttribute(getAlmostFullThresholdAttrName(odsState.name), almostFullThreshold);
  }
  if (almostEmptyThreshold) {
    odsState.addAttribute(getAlmostEmptyThresholdAttrName(odsState.name), almostEmptyThreshold);
  }
  assert(resultTypes.size() >= 3u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FIFOOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 5u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() >= 3u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult FIFOOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_depth;
  ::mlir::Attribute tblgen_almostEmptyThreshold;
  ::mlir::Attribute tblgen_almostFullThreshold;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'depth'");
    if (namedAttrIt->getName() == getDepthAttrName()) {
      tblgen_depth = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getAlmostEmptyThresholdAttrName()) {
      tblgen_almostEmptyThreshold = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getAlmostFullThresholdAttrName()) {
      tblgen_almostFullThreshold = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_result_segment_sizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'result_segment_sizes'");
    if (namedAttrIt->getName() == getResultSegmentSizesAttrName()) {
      tblgen_result_segment_sizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_result_segment_sizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 5)
      return emitOpError("'result_segment_sizes' attribute for specifying result segments must have 5 "
                "elements, but got ") << numElements;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(*this, tblgen_depth, "depth")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(*this, tblgen_almostFullThreshold, "almostFullThreshold")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(*this, tblgen_almostEmptyThreshold, "almostEmptyThreshold")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSResults(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSResults(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSResults(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("result group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSResults(4);

    if (valueGroup4.size() > 1) {
      return emitOpError("result group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup4.size();
    }

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((std::equal_to<>()( (*this->getODSOperands(0).begin()).getType() , (*this->getODSResults(0).begin()).getType()))))
    return emitOpError("failed to verify that Input type should match output type");
  return ::mlir::success();
}

::mlir::LogicalResult FIFOOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult FIFOOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::IntegerAttr depthAttr;
  ::mlir::IntegerAttr almostFullThresholdAttr;
  ::llvm::SmallVector<::mlir::Type, 1> almostFullTypes;
  ::mlir::IntegerAttr almostEmptyThresholdAttr;
  ::llvm::SmallVector<::mlir::Type, 1> almostEmptyTypes;
  ::mlir::OpAsmParser::UnresolvedOperand inputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> inputOperands(inputRawOperands);  ::llvm::SMLoc inputOperandsLoc;
  (void)inputOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand rdEnRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> rdEnOperands(rdEnRawOperands);  ::llvm::SMLoc rdEnOperandsLoc;
  (void)rdEnOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand wrEnRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> wrEnOperands(wrEnRawOperands);  ::llvm::SMLoc wrEnOperandsLoc;
  (void)wrEnOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand rstRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> rstOperands(rstRawOperands);  ::llvm::SMLoc rstOperandsLoc;
  (void)rstOperandsLoc;
  ::mlir::Type inputRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> inputTypes(inputRawTypes);
  if (parser.parseKeyword("depth"))
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(depthAttr, parser.getBuilder().getIntegerType(64))) {
    return ::mlir::failure();
  }
  if (depthAttr) result.attributes.append("depth", depthAttr);
  {
    ::mlir::Type almostFullType;
    if (parseFIFOAFThreshold(parser, almostFullThresholdAttr, almostFullType))
      return ::mlir::failure();
    if (almostFullThresholdAttr)
      result.addAttribute("almostFullThreshold", almostFullThresholdAttr);
    if (almostFullType)
      almostFullTypes.push_back(almostFullType);
  }
  {
    ::mlir::Type almostEmptyType;
    if (parseFIFOAEThreshold(parser, almostEmptyThresholdAttr, almostEmptyType))
      return ::mlir::failure();
    if (almostEmptyThresholdAttr)
      result.addAttribute("almostEmptyThreshold", almostEmptyThresholdAttr);
    if (almostEmptyType)
      almostEmptyTypes.push_back(almostEmptyType);
  }
  if (parser.parseKeyword("in"))
    return ::mlir::failure();

  inputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(inputRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("rdEn"))
    return ::mlir::failure();

  rdEnOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(rdEnRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("wrEn"))
    return ::mlir::failure();

  wrEnOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(wrEnRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("clk"))
    return ::mlir::failure();

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("rst"))
    return ::mlir::failure();

  rstOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(rstRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType> type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    inputRawTypes[0] = type;
  }
  result.addAttribute("result_segment_sizes", parser.getBuilder().getDenseI32ArrayAttr({1, 1, 1, static_cast<int32_t>(almostFullTypes.size()), static_cast<int32_t>(almostEmptyTypes.size())}));
  for (::mlir::Type type : inputTypes) {
    (void)type;
    if (!((::circt::hw::isHWIntegerType(type)))) {
      return parser.emitError(parser.getNameLoc()) << "'input' must be a signless integer bitvector, but got " << type;
    }
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  result.addTypes( inputTypes[0] );
  result.addTypes(odsBuildableType0);
  result.addTypes(odsBuildableType0);
  result.addTypes(almostFullTypes);
  result.addTypes(almostEmptyTypes);
  if (parser.resolveOperands(inputOperands, inputTypes, inputOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(rdEnOperands, odsBuildableType0, rdEnOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(wrEnOperands, odsBuildableType0, wrEnOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(rstOperands, odsBuildableType0, rstOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void FIFOOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ' << "depth";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getDepthAttr());
  _odsPrinter << ' ';
  printFIFOAFThreshold(_odsPrinter, *this, getAlmostFullThresholdAttr(), (getAlmostFull() ? getAlmostFull().getType() : ::mlir::Type()));
  _odsPrinter << ' ';
  printFIFOAEThreshold(_odsPrinter, *this, getAlmostEmptyThresholdAttr(), (getAlmostEmpty() ? getAlmostEmpty().getType() : ::mlir::Type()));
  _odsPrinter << ' ' << "in";
  _odsPrinter << ' ';
  _odsPrinter << getInput();
  _odsPrinter << ' ' << "rdEn";
  _odsPrinter << ' ';
  _odsPrinter << getRdEn();
  _odsPrinter << ' ' << "wrEn";
  _odsPrinter << ' ';
  _odsPrinter << getWrEn();
  _odsPrinter << ' ' << "clk";
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  _odsPrinter << ' ' << "rst";
  _odsPrinter << ' ';
  _odsPrinter << getRst();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("result_segment_sizes");
  elidedAttrs.push_back("depth");
  elidedAttrs.push_back("almostFullThreshold");
  elidedAttrs.push_back("almostEmptyThreshold");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getInput().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType>>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FIFOOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FirMemOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FirMemOpGenericAdaptorBase::FirMemOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.firmem", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> FirMemOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr FirMemOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr FirMemOpGenericAdaptorBase::getReadLatencyAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 3, FirMemOp::getReadLatencyAttrName(*odsOpName)));
  return attr;
}

uint32_t FirMemOpGenericAdaptorBase::getReadLatency() {
  auto attr = getReadLatencyAttr();
  return attr.getValue().getZExtValue();
}

::mlir::IntegerAttr FirMemOpGenericAdaptorBase::getWriteLatencyAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 1, FirMemOp::getWriteLatencyAttrName(*odsOpName)));
  return attr;
}

uint32_t FirMemOpGenericAdaptorBase::getWriteLatency() {
  auto attr = getWriteLatencyAttr();
  return attr.getValue().getZExtValue();
}

circt::seq::RUWAttr FirMemOpGenericAdaptorBase::getRuwAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<circt::seq::RUWAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 2, FirMemOp::getRuwAttrName(*odsOpName)));
  return attr;
}

circt::seq::RUW FirMemOpGenericAdaptorBase::getRuw() {
  auto attr = getRuwAttr();
  return attr.getValue();
}

circt::seq::WUWAttr FirMemOpGenericAdaptorBase::getWuwAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<circt::seq::WUWAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 3, odsAttrs.end() - 0, FirMemOp::getWuwAttrName(*odsOpName)));
  return attr;
}

circt::seq::WUW FirMemOpGenericAdaptorBase::getWuw() {
  auto attr = getWuwAttr();
  return attr.getValue();
}

::mlir::StringAttr FirMemOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 4, FirMemOp::getNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > FirMemOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::StringAttr FirMemOpGenericAdaptorBase::getInnerSymAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 4, FirMemOp::getInnerSymAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > FirMemOpGenericAdaptorBase::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::circt::seq::FirMemInitAttr FirMemOpGenericAdaptorBase::getInitAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::circt::seq::FirMemInitAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 4, FirMemOp::getInitAttrName(*odsOpName)));
  return attr;
}

::std::optional<::circt::seq::FirMemInitAttr> FirMemOpGenericAdaptorBase::getInit() {
  auto attr = getInitAttr();
  return attr ? ::std::optional<::circt::seq::FirMemInitAttr>(::llvm::cast<::circt::seq::FirMemInitAttr>(attr)) : (::std::nullopt);
}

::mlir::StringAttr FirMemOpGenericAdaptorBase::getPrefixAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 4, FirMemOp::getPrefixAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > FirMemOpGenericAdaptorBase::getPrefix() {
  auto attr = getPrefixAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::Attribute FirMemOpGenericAdaptorBase::getOutputFileAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::Attribute>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 4, FirMemOp::getOutputFileAttrName(*odsOpName)));
  return attr;
}

::std::optional<::mlir::Attribute> FirMemOpGenericAdaptorBase::getOutputFile() {
  auto attr = getOutputFileAttr();
  return attr ? ::std::optional<::mlir::Attribute>(attr) : (::std::nullopt);
}

} // namespace detail
FirMemOpAdaptor::FirMemOpAdaptor(FirMemOp op) : FirMemOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult FirMemOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_readLatency;
  ::mlir::Attribute tblgen_init;
  ::mlir::Attribute tblgen_inner_sym;
  ::mlir::Attribute tblgen_name;
  ::mlir::Attribute tblgen_output_file;
  ::mlir::Attribute tblgen_prefix;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.firmem' op ""requires attribute 'readLatency'");
    if (namedAttrIt->getName() == FirMemOp::getReadLatencyAttrName(*odsOpName)) {
      tblgen_readLatency = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == FirMemOp::getInitAttrName(*odsOpName)) {
      tblgen_init = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == FirMemOp::getInnerSymAttrName(*odsOpName)) {
      tblgen_inner_sym = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == FirMemOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == FirMemOp::getOutputFileAttrName(*odsOpName)) {
      tblgen_output_file = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == FirMemOp::getPrefixAttrName(*odsOpName)) {
      tblgen_prefix = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_ruw;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.firmem' op ""requires attribute 'ruw'");
    if (namedAttrIt->getName() == FirMemOp::getRuwAttrName(*odsOpName)) {
      tblgen_ruw = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_writeLatency;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.firmem' op ""requires attribute 'writeLatency'");
    if (namedAttrIt->getName() == FirMemOp::getWriteLatencyAttrName(*odsOpName)) {
      tblgen_writeLatency = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_wuw;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.firmem' op ""requires attribute 'wuw'");
    if (namedAttrIt->getName() == FirMemOp::getWuwAttrName(*odsOpName)) {
      tblgen_wuw = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_readLatency && !(((::llvm::isa<::mlir::IntegerAttr>(tblgen_readLatency))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_readLatency).getType().isSignlessInteger(32)))))
    return emitError(loc, "'seq.firmem' op ""attribute 'readLatency' failed to satisfy constraint: 32-bit signless integer attribute");

  if (tblgen_writeLatency && !(((::llvm::isa<::mlir::IntegerAttr>(tblgen_writeLatency))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_writeLatency).getType().isSignlessInteger(32)))))
    return emitError(loc, "'seq.firmem' op ""attribute 'writeLatency' failed to satisfy constraint: 32-bit signless integer attribute");

  if (tblgen_ruw && !((::llvm::isa<circt::seq::RUWAttr>(tblgen_ruw))))
    return emitError(loc, "'seq.firmem' op ""attribute 'ruw' failed to satisfy constraint: Read-Under-Write Behavior");

  if (tblgen_wuw && !((::llvm::isa<circt::seq::WUWAttr>(tblgen_wuw))))
    return emitError(loc, "'seq.firmem' op ""attribute 'wuw' failed to satisfy constraint: Write-Under-Write Behavior");

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'seq.firmem' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_inner_sym && !((::llvm::isa<::mlir::StringAttr>(tblgen_inner_sym))))
    return emitError(loc, "'seq.firmem' op ""attribute 'inner_sym' failed to satisfy constraint: string attribute");

  if (tblgen_init && !((::llvm::isa<::circt::seq::FirMemInitAttr>(tblgen_init))))
    return emitError(loc, "'seq.firmem' op ""attribute 'init' failed to satisfy constraint: Memory initialization information");

  if (tblgen_prefix && !((::llvm::isa<::mlir::StringAttr>(tblgen_prefix))))
    return emitError(loc, "'seq.firmem' op ""attribute 'prefix' failed to satisfy constraint: string attribute");

  if (tblgen_output_file && !((true)))
    return emitError(loc, "'seq.firmem' op ""attribute 'output_file' failed to satisfy constraint: any attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> FirMemOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range FirMemOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> FirMemOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range FirMemOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::FirMemType> FirMemOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::FirMemType>>(*getODSResults(0).begin());
}

::mlir::IntegerAttr FirMemOp::getReadLatencyAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 3, getReadLatencyAttrName()));
}

uint32_t FirMemOp::getReadLatency() {
  auto attr = getReadLatencyAttr();
  return attr.getValue().getZExtValue();
}

::mlir::IntegerAttr FirMemOp::getWriteLatencyAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 1, getWriteLatencyAttrName()));
}

uint32_t FirMemOp::getWriteLatency() {
  auto attr = getWriteLatencyAttr();
  return attr.getValue().getZExtValue();
}

circt::seq::RUWAttr FirMemOp::getRuwAttr() {
  return ::llvm::cast<circt::seq::RUWAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 2, getRuwAttrName()));
}

circt::seq::RUW FirMemOp::getRuw() {
  auto attr = getRuwAttr();
  return attr.getValue();
}

circt::seq::WUWAttr FirMemOp::getWuwAttr() {
  return ::llvm::cast<circt::seq::WUWAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 3, (*this)->getAttrs().end() - 0, getWuwAttrName()));
}

circt::seq::WUW FirMemOp::getWuw() {
  auto attr = getWuwAttr();
  return attr.getValue();
}

::mlir::StringAttr FirMemOp::getNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 4, getNameAttrName()));
}

::std::optional< ::llvm::StringRef > FirMemOp::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::StringAttr FirMemOp::getInnerSymAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 4, getInnerSymAttrName()));
}

::std::optional< ::llvm::StringRef > FirMemOp::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::circt::seq::FirMemInitAttr FirMemOp::getInitAttr() {
  return ::llvm::dyn_cast_or_null<::circt::seq::FirMemInitAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 4, getInitAttrName()));
}

::std::optional<::circt::seq::FirMemInitAttr> FirMemOp::getInit() {
  auto attr = getInitAttr();
  return attr ? ::std::optional<::circt::seq::FirMemInitAttr>(::llvm::cast<::circt::seq::FirMemInitAttr>(attr)) : (::std::nullopt);
}

::mlir::StringAttr FirMemOp::getPrefixAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 4, getPrefixAttrName()));
}

::std::optional< ::llvm::StringRef > FirMemOp::getPrefix() {
  auto attr = getPrefixAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::Attribute FirMemOp::getOutputFileAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::Attribute>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 4, getOutputFileAttrName()));
}

::std::optional<::mlir::Attribute> FirMemOp::getOutputFile() {
  auto attr = getOutputFileAttr();
  return attr ? ::std::optional<::mlir::Attribute>(attr) : (::std::nullopt);
}

void FirMemOp::setReadLatencyAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getReadLatencyAttrName(), attr);
}

void FirMemOp::setReadLatency(uint32_t attrValue) {
  (*this)->setAttr(getReadLatencyAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(32), attrValue));
}

void FirMemOp::setWriteLatencyAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getWriteLatencyAttrName(), attr);
}

void FirMemOp::setWriteLatency(uint32_t attrValue) {
  (*this)->setAttr(getWriteLatencyAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(32), attrValue));
}

void FirMemOp::setRuwAttr(circt::seq::RUWAttr attr) {
  (*this)->setAttr(getRuwAttrName(), attr);
}

void FirMemOp::setRuw(circt::seq::RUW attrValue) {
  (*this)->setAttr(getRuwAttrName(), circt::seq::RUWAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

void FirMemOp::setWuwAttr(circt::seq::WUWAttr attr) {
  (*this)->setAttr(getWuwAttrName(), attr);
}

void FirMemOp::setWuw(circt::seq::WUW attrValue) {
  (*this)->setAttr(getWuwAttrName(), circt::seq::WUWAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

void FirMemOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void FirMemOp::setName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getNameAttrName());
}

void FirMemOp::setInnerSymAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getInnerSymAttrName(), attr);
}

void FirMemOp::setInnerSym(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getInnerSymAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getInnerSymAttrName());
}

void FirMemOp::setInitAttr(::circt::seq::FirMemInitAttr attr) {
  (*this)->setAttr(getInitAttrName(), attr);
}

void FirMemOp::setPrefixAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getPrefixAttrName(), attr);
}

void FirMemOp::setPrefix(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getPrefixAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getPrefixAttrName());
}

void FirMemOp::setOutputFileAttr(::mlir::Attribute attr) {
  (*this)->setAttr(getOutputFileAttrName(), attr);
}

::mlir::Attribute FirMemOp::removeNameAttr() {
return (*this)->removeAttr(getNameAttrName());
}

::mlir::Attribute FirMemOp::removeInnerSymAttr() {
return (*this)->removeAttr(getInnerSymAttrName());
}

::mlir::Attribute FirMemOp::removeInitAttr() {
return (*this)->removeAttr(getInitAttrName());
}

::mlir::Attribute FirMemOp::removePrefixAttr() {
return (*this)->removeAttr(getPrefixAttrName());
}

::mlir::Attribute FirMemOp::removeOutputFileAttr() {
return (*this)->removeAttr(getOutputFileAttrName());
}

void FirMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type memory, ::mlir::IntegerAttr readLatency, ::mlir::IntegerAttr writeLatency, circt::seq::RUWAttr ruw, circt::seq::WUWAttr wuw, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::StringAttr inner_sym, /*optional*/::circt::seq::FirMemInitAttr init, /*optional*/::mlir::StringAttr prefix, /*optional*/::mlir::Attribute output_file) {
  odsState.addAttribute(getReadLatencyAttrName(odsState.name), readLatency);
  odsState.addAttribute(getWriteLatencyAttrName(odsState.name), writeLatency);
  odsState.addAttribute(getRuwAttrName(odsState.name), ruw);
  odsState.addAttribute(getWuwAttrName(odsState.name), wuw);
  if (name) {
    odsState.addAttribute(getNameAttrName(odsState.name), name);
  }
  if (inner_sym) {
    odsState.addAttribute(getInnerSymAttrName(odsState.name), inner_sym);
  }
  if (init) {
    odsState.addAttribute(getInitAttrName(odsState.name), init);
  }
  if (prefix) {
    odsState.addAttribute(getPrefixAttrName(odsState.name), prefix);
  }
  if (output_file) {
    odsState.addAttribute(getOutputFileAttrName(odsState.name), output_file);
  }
  odsState.addTypes(memory);
}

void FirMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::IntegerAttr readLatency, ::mlir::IntegerAttr writeLatency, circt::seq::RUWAttr ruw, circt::seq::WUWAttr wuw, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::StringAttr inner_sym, /*optional*/::circt::seq::FirMemInitAttr init, /*optional*/::mlir::StringAttr prefix, /*optional*/::mlir::Attribute output_file) {
  odsState.addAttribute(getReadLatencyAttrName(odsState.name), readLatency);
  odsState.addAttribute(getWriteLatencyAttrName(odsState.name), writeLatency);
  odsState.addAttribute(getRuwAttrName(odsState.name), ruw);
  odsState.addAttribute(getWuwAttrName(odsState.name), wuw);
  if (name) {
    odsState.addAttribute(getNameAttrName(odsState.name), name);
  }
  if (inner_sym) {
    odsState.addAttribute(getInnerSymAttrName(odsState.name), inner_sym);
  }
  if (init) {
    odsState.addAttribute(getInitAttrName(odsState.name), init);
  }
  if (prefix) {
    odsState.addAttribute(getPrefixAttrName(odsState.name), prefix);
  }
  if (output_file) {
    odsState.addAttribute(getOutputFileAttrName(odsState.name), output_file);
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FirMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type memory, uint32_t readLatency, uint32_t writeLatency, circt::seq::RUW ruw, circt::seq::WUW wuw, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::StringAttr inner_sym, /*optional*/::circt::seq::FirMemInitAttr init, /*optional*/::mlir::StringAttr prefix, /*optional*/::mlir::Attribute output_file) {
  odsState.addAttribute(getReadLatencyAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(32), readLatency));
  odsState.addAttribute(getWriteLatencyAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(32), writeLatency));
  odsState.addAttribute(getRuwAttrName(odsState.name), circt::seq::RUWAttr::get(odsBuilder.getContext(), ruw));
  odsState.addAttribute(getWuwAttrName(odsState.name), circt::seq::WUWAttr::get(odsBuilder.getContext(), wuw));
  if (name) {
    odsState.addAttribute(getNameAttrName(odsState.name), name);
  }
  if (inner_sym) {
    odsState.addAttribute(getInnerSymAttrName(odsState.name), inner_sym);
  }
  if (init) {
    odsState.addAttribute(getInitAttrName(odsState.name), init);
  }
  if (prefix) {
    odsState.addAttribute(getPrefixAttrName(odsState.name), prefix);
  }
  if (output_file) {
    odsState.addAttribute(getOutputFileAttrName(odsState.name), output_file);
  }
  odsState.addTypes(memory);
}

void FirMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, uint32_t readLatency, uint32_t writeLatency, circt::seq::RUW ruw, circt::seq::WUW wuw, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::StringAttr inner_sym, /*optional*/::circt::seq::FirMemInitAttr init, /*optional*/::mlir::StringAttr prefix, /*optional*/::mlir::Attribute output_file) {
  odsState.addAttribute(getReadLatencyAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(32), readLatency));
  odsState.addAttribute(getWriteLatencyAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(32), writeLatency));
  odsState.addAttribute(getRuwAttrName(odsState.name), circt::seq::RUWAttr::get(odsBuilder.getContext(), ruw));
  odsState.addAttribute(getWuwAttrName(odsState.name), circt::seq::WUWAttr::get(odsBuilder.getContext(), wuw));
  if (name) {
    odsState.addAttribute(getNameAttrName(odsState.name), name);
  }
  if (inner_sym) {
    odsState.addAttribute(getInnerSymAttrName(odsState.name), inner_sym);
  }
  if (init) {
    odsState.addAttribute(getInitAttrName(odsState.name), init);
  }
  if (prefix) {
    odsState.addAttribute(getPrefixAttrName(odsState.name), prefix);
  }
  if (output_file) {
    odsState.addAttribute(getOutputFileAttrName(odsState.name), output_file);
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FirMemOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult FirMemOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_readLatency;
  ::mlir::Attribute tblgen_init;
  ::mlir::Attribute tblgen_inner_sym;
  ::mlir::Attribute tblgen_name;
  ::mlir::Attribute tblgen_output_file;
  ::mlir::Attribute tblgen_prefix;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'readLatency'");
    if (namedAttrIt->getName() == getReadLatencyAttrName()) {
      tblgen_readLatency = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getInitAttrName()) {
      tblgen_init = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getInnerSymAttrName()) {
      tblgen_inner_sym = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getOutputFileAttrName()) {
      tblgen_output_file = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getPrefixAttrName()) {
      tblgen_prefix = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_ruw;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'ruw'");
    if (namedAttrIt->getName() == getRuwAttrName()) {
      tblgen_ruw = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_writeLatency;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'writeLatency'");
    if (namedAttrIt->getName() == getWriteLatencyAttrName()) {
      tblgen_writeLatency = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_wuw;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'wuw'");
    if (namedAttrIt->getName() == getWuwAttrName()) {
      tblgen_wuw = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq3(*this, tblgen_readLatency, "readLatency")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq3(*this, tblgen_writeLatency, "writeLatency")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq4(*this, tblgen_ruw, "ruw")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq5(*this, tblgen_wuw, "wuw")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(*this, tblgen_inner_sym, "inner_sym")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq6(*this, tblgen_init, "init")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(*this, tblgen_prefix, "prefix")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq7(*this, tblgen_output_file, "output_file")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult FirMemOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult FirMemOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr inner_symAttr;
  ::mlir::StringAttr nameAttr;
  ::mlir::IntegerAttr readLatencyAttr;
  ::mlir::IntegerAttr writeLatencyAttr;
  circt::seq::RUWAttr ruwAttr;
  circt::seq::WUWAttr wuwAttr;
  ::mlir::Type memoryRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> memoryTypes(memoryRawTypes);
  if (::mlir::succeeded(parser.parseOptionalKeyword("sym"))) {

  if (parser.parseSymbolName(inner_symAttr))
    return ::mlir::failure();
  if (inner_symAttr) result.attributes.append("inner_sym", inner_symAttr);
  }
  {
    if (parseImplicitSSAName(parser, nameAttr))
      return ::mlir::failure();
    if (nameAttr)
      result.addAttribute("name", nameAttr);
  }

  if (parser.parseCustomAttributeWithFallback(readLatencyAttr, parser.getBuilder().getIntegerType(32))) {
    return ::mlir::failure();
  }
  if (readLatencyAttr) result.attributes.append("readLatency", readLatencyAttr);
  if (parser.parseComma())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(writeLatencyAttr, parser.getBuilder().getIntegerType(32))) {
    return ::mlir::failure();
  }
  if (writeLatencyAttr) result.attributes.append("writeLatency", writeLatencyAttr);
  if (parser.parseComma())
    return ::mlir::failure();

  {
    ::llvm::StringRef attrStr;
    ::mlir::NamedAttrList attrStorage;
    auto loc = parser.getCurrentLocation();
    if (parser.parseOptionalKeyword(&attrStr, {"undefined","old","new"})) {
      ::mlir::StringAttr attrVal;
      ::mlir::OptionalParseResult parseResult =
        parser.parseOptionalAttribute(attrVal,
                                      parser.getBuilder().getNoneType(),
                                      "ruw", attrStorage);
      if (parseResult.has_value()) {
        if (failed(*parseResult))
          return ::mlir::failure();
        attrStr = attrVal.getValue();
      } else {
        return parser.emitError(loc, "expected string or keyword containing one of the following enum values for attribute 'ruw' [undefined, old, new]");
      }
    }
    if (!attrStr.empty()) {
      auto attrOptional = circt::seq::symbolizeRUW(attrStr);
      if (!attrOptional)
        return parser.emitError(loc, "invalid ")
               << "ruw attribute specification: \"" << attrStr << '"';;

      ruwAttr = circt::seq::RUWAttr::get(parser.getBuilder().getContext(), *attrOptional);
      result.addAttribute("ruw", ruwAttr);
    }
  }
  if (parser.parseComma())
    return ::mlir::failure();

  {
    ::llvm::StringRef attrStr;
    ::mlir::NamedAttrList attrStorage;
    auto loc = parser.getCurrentLocation();
    if (parser.parseOptionalKeyword(&attrStr, {"undefined","port_order"})) {
      ::mlir::StringAttr attrVal;
      ::mlir::OptionalParseResult parseResult =
        parser.parseOptionalAttribute(attrVal,
                                      parser.getBuilder().getNoneType(),
                                      "wuw", attrStorage);
      if (parseResult.has_value()) {
        if (failed(*parseResult))
          return ::mlir::failure();
        attrStr = attrVal.getValue();
      } else {
        return parser.emitError(loc, "expected string or keyword containing one of the following enum values for attribute 'wuw' [undefined, port_order]");
      }
    }
    if (!attrStr.empty()) {
      auto attrOptional = circt::seq::symbolizeWUW(attrStr);
      if (!attrOptional)
        return parser.emitError(loc, "invalid ")
               << "wuw attribute specification: \"" << attrStr << '"';;

      wuwAttr = circt::seq::WUWAttr::get(parser.getBuilder().getContext(), *attrOptional);
      result.addAttribute("wuw", wuwAttr);
    }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::seq::FirMemType type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    memoryRawTypes[0] = type;
  }
  result.addTypes(memoryTypes);
  return ::mlir::success();
}

void FirMemOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getInnerSymAttr()) {
    _odsPrinter << ' ' << "sym";
    _odsPrinter << ' ';
    _odsPrinter.printSymbolName(getInnerSymAttr().getValue());
  }
  printImplicitSSAName(_odsPrinter, *this, getNameAttr());
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getReadLatencyAttr());
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getWriteLatencyAttr());
  _odsPrinter << ",";
  _odsPrinter << ' ';

  {
    auto caseValue = getRuw();
    auto caseValueStr = stringifyRUW(caseValue);
    _odsPrinter << caseValueStr;
  }
  _odsPrinter << ",";
  _odsPrinter << ' ';

  {
    auto caseValue = getWuw();
    auto caseValueStr = stringifyWUW(caseValue);
    _odsPrinter << caseValueStr;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("inner_sym");
  elidedAttrs.push_back("name");
  elidedAttrs.push_back("readLatency");
  elidedAttrs.push_back("writeLatency");
  elidedAttrs.push_back("ruw");
  elidedAttrs.push_back("wuw");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getMemory().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::seq::FirMemType>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

void FirMemOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
  effects.emplace_back(::mlir::MemoryEffects::Allocate::get(), ::mlir::SideEffects::DefaultResource::get());
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FirMemOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FirMemReadOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FirMemReadOpGenericAdaptorBase::FirMemReadOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.firmem.read_port", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> FirMemReadOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {false, false, false, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 3) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr FirMemReadOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
FirMemReadOpAdaptor::FirMemReadOpAdaptor(FirMemReadOp op) : FirMemReadOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult FirMemReadOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> FirMemReadOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {false, false, false, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 3) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range FirMemReadOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::FirMemType> FirMemReadOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::FirMemType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadOp::getAddress() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadOp::getClock() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadOp::getEnable() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::MutableOperandRange FirMemReadOp::getMemoryMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange FirMemReadOp::getAddressMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange FirMemReadOp::getClockMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange FirMemReadOp::getEnableMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> FirMemReadOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range FirMemReadOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadOp::getData() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(0).begin());
}

void FirMemReadOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clock, /*optional*/::mlir::Value enable) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clock);
  if (enable)
    odsState.addOperands(enable);
  odsState.addTypes(data);
}

void FirMemReadOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clock, /*optional*/::mlir::Value enable) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clock);
  if (enable)
    odsState.addOperands(enable);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(FirMemReadOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void FirMemReadOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clock, /*optional*/::mlir::Value enable) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clock);
  if (enable)
    odsState.addOperands(enable);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FirMemReadOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void FirMemReadOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(FirMemReadOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult FirMemReadOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getDepth())))
    , (*this->getODSOperands(1).begin()).getType()))))
    return emitOpError("failed to verify that address type should match clog2 of memory depth");
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getWidth()))
    , (*this->getODSResults(0).begin()).getType()))))
    return emitOpError("failed to verify that data type should match memory width");
  return ::mlir::success();
}

::mlir::LogicalResult FirMemReadOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

void FirMemReadOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::LogicalResult FirMemReadOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = 
      IntegerType::get(
        operands[0].getType().getContext(),
        std::max(1U, cast<FirMemType>(operands[0].getType()).getWidth()))
    ;
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult FirMemReadOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand memoryRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> memoryOperands(memoryRawOperands);  ::llvm::SMLoc memoryOperandsLoc;
  (void)memoryOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand addressRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> addressOperands(addressRawOperands);  ::llvm::SMLoc addressOperandsLoc;
  (void)addressOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clockRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clockOperands(clockRawOperands);  ::llvm::SMLoc clockOperandsLoc;
  (void)clockOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> enableOperands;
  ::llvm::SMLoc enableOperandsLoc;
  (void)enableOperandsLoc;
  ::mlir::Type memoryRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> memoryTypes(memoryRawTypes);

  memoryOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(memoryRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseLSquare())
    return ::mlir::failure();

  addressOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(addressRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseRSquare())
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();
  if (parser.parseKeyword("clock"))
    return ::mlir::failure();

  clockOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clockRawOperands[0]))
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalKeyword("enable"))) {

  {
    enableOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      enableOperands.push_back(operand);
    }
  }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::seq::FirMemType type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    memoryRawTypes[0] = type;
  }
  for (::mlir::Type type : memoryTypes) {
    (void)type;
    if (!((::llvm::isa<::circt::seq::FirMemType>(type)))) {
      return parser.emitError(parser.getNameLoc()) << "'memory' must be A FIRRTL-flavored memory, but got " << type;
    }
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  result.addTypes(
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, cast<FirMemType>(memoryTypes[0]).getWidth()))
    );
  if (parser.resolveOperands(memoryOperands, memoryTypes, memoryOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(addressOperands, 
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>(memoryTypes[0]).getDepth())))
    , addressOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clockOperands, odsBuildableType0, clockOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(enableOperands, odsBuildableType0, enableOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void FirMemReadOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getMemory();
  _odsPrinter << "[";
  _odsPrinter << getAddress();
  _odsPrinter << "]";
  _odsPrinter << ",";
  _odsPrinter << ' ' << "clock";
  _odsPrinter << ' ';
  _odsPrinter << getClock();
  if (getEnable()) {
    _odsPrinter << ' ' << "enable";
    _odsPrinter << ' ';
    if (::mlir::Value value = getEnable())
      _odsPrinter << value;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getMemory().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::seq::FirMemType>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

void FirMemReadOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
  effects.emplace_back(::mlir::MemoryEffects::Read::get(), ::mlir::SideEffects::DefaultResource::get());
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FirMemReadOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FirMemReadWriteOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FirMemReadWriteOpGenericAdaptorBase::FirMemReadWriteOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.firmem.read_write_port", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> FirMemReadWriteOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  assert(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, FirMemReadWriteOp::getOperandSegmentSizesAttrName(*odsOpName)) && "missing segment size attribute for op");
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, FirMemReadWriteOp::getOperandSegmentSizesAttrName(*odsOpName)));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr FirMemReadWriteOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
FirMemReadWriteOpAdaptor::FirMemReadWriteOpAdaptor(FirMemReadWriteOp op) : FirMemReadWriteOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult FirMemReadWriteOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_operand_segment_sizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.firmem.read_write_port' op ""requires attribute 'operand_segment_sizes'");
    if (namedAttrIt->getName() == FirMemReadWriteOp::getOperandSegmentSizesAttrName(*odsOpName)) {
      tblgen_operand_segment_sizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operand_segment_sizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 7)
      return emitError(loc, "'seq.firmem.read_write_port' op ""'operand_segment_sizes' attribute for specifying operand segments must have 7 "
                "elements, but got ") << numElements;
  }
    return ::mlir::success();
}

std::pair<unsigned, unsigned> FirMemReadWriteOp::getODSOperandIndexAndLength(unsigned index) {
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName()));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range FirMemReadWriteOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::FirMemType> FirMemReadWriteOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::FirMemType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getAddress() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getClock() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getEnable() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getWriteData() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(4).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getMode() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(5).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getMask() {
  auto operands = getODSOperands(6);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::MutableOperandRange FirMemReadWriteOp::getMemoryMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(0u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange FirMemReadWriteOp::getAddressMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(1u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange FirMemReadWriteOp::getClockMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(2u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange FirMemReadWriteOp::getEnableMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(3u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange FirMemReadWriteOp::getWriteDataMutable() {
  auto range = getODSOperandIndexAndLength(4);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(4u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange FirMemReadWriteOp::getModeMutable() {
  auto range = getODSOperandIndexAndLength(5);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(5u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange FirMemReadWriteOp::getMaskMutable() {
  auto range = getODSOperandIndexAndLength(6);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(6u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

std::pair<unsigned, unsigned> FirMemReadWriteOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range FirMemReadWriteOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getReadData() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(0).begin());
}

void FirMemReadWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type readData, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clock, /*optional*/::mlir::Value enable, ::mlir::Value writeData, ::mlir::Value mode, /*optional*/::mlir::Value mask) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clock);
  if (enable)
    odsState.addOperands(enable);
  odsState.addOperands(writeData);
  odsState.addOperands(mode);
  if (mask)
    odsState.addOperands(mask);
  odsState.addAttribute(getOperandSegmentSizesAttrName(odsState.name), odsBuilder.getDenseI32ArrayAttr({1, 1, 1, (enable ? 1 : 0), 1, 1, (mask ? 1 : 0)}));
  odsState.addTypes(readData);
}

void FirMemReadWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clock, /*optional*/::mlir::Value enable, ::mlir::Value writeData, ::mlir::Value mode, /*optional*/::mlir::Value mask) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clock);
  if (enable)
    odsState.addOperands(enable);
  odsState.addOperands(writeData);
  odsState.addOperands(mode);
  if (mask)
    odsState.addOperands(mask);
  odsState.addAttribute(getOperandSegmentSizesAttrName(odsState.name), odsBuilder.getDenseI32ArrayAttr({1, 1, 1, (enable ? 1 : 0), 1, 1, (mask ? 1 : 0)}));

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(FirMemReadWriteOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void FirMemReadWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clock, /*optional*/::mlir::Value enable, ::mlir::Value writeData, ::mlir::Value mode, /*optional*/::mlir::Value mask) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clock);
  if (enable)
    odsState.addOperands(enable);
  odsState.addOperands(writeData);
  odsState.addOperands(mode);
  if (mask)
    odsState.addOperands(mask);
  odsState.addAttribute(getOperandSegmentSizesAttrName(odsState.name), odsBuilder.getDenseI32ArrayAttr({1, 1, 1, (enable ? 1 : 0), 1, 1, (mask ? 1 : 0)}));
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FirMemReadWriteOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 5u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void FirMemReadWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 5u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(FirMemReadWriteOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult FirMemReadWriteOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_operand_segment_sizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'operand_segment_sizes'");
    if (namedAttrIt->getName() == getOperandSegmentSizesAttrName()) {
      tblgen_operand_segment_sizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operand_segment_sizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 7)
      return emitOpError("'operand_segment_sizes' attribute for specifying operand segments must have 7 "
                "elements, but got ") << numElements;
  }
    {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup5 = getODSOperands(5);

    for (auto v : valueGroup5) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup6 = getODSOperands(6);

    if (valueGroup6.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup6.size();
    }

    for (auto v : valueGroup6) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getDepth())))
    , (*this->getODSOperands(1).begin()).getType()))))
    return emitOpError("failed to verify that address type should match clog2 of memory depth");
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getWidth()))
    , (*this->getODSOperands(4).begin()).getType()))))
    return emitOpError("failed to verify that data type should match memory width");
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getWidth()))
    , (*this->getODSResults(0).begin()).getType()))))
    return emitOpError("failed to verify that data type should match memory width");
  return ::mlir::success();
}

::mlir::LogicalResult FirMemReadWriteOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

void FirMemReadWriteOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::LogicalResult FirMemReadWriteOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = 
      IntegerType::get(
        operands[0].getType().getContext(),
        std::max(1U, cast<FirMemType>(operands[0].getType()).getWidth()))
    ;
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult FirMemReadWriteOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand memoryRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> memoryOperands(memoryRawOperands);  ::llvm::SMLoc memoryOperandsLoc;
  (void)memoryOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand addressRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> addressOperands(addressRawOperands);  ::llvm::SMLoc addressOperandsLoc;
  (void)addressOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand writeDataRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> writeDataOperands(writeDataRawOperands);  ::llvm::SMLoc writeDataOperandsLoc;
  (void)writeDataOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand modeRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> modeOperands(modeRawOperands);  ::llvm::SMLoc modeOperandsLoc;
  (void)modeOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clockRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clockOperands(clockRawOperands);  ::llvm::SMLoc clockOperandsLoc;
  (void)clockOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> enableOperands;
  ::llvm::SMLoc enableOperandsLoc;
  (void)enableOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> maskOperands;
  ::llvm::SMLoc maskOperandsLoc;
  (void)maskOperandsLoc;
  ::mlir::Type memoryRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> memoryTypes(memoryRawTypes);
  ::llvm::SmallVector<::mlir::Type, 1> maskTypes;

  memoryOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(memoryRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseLSquare())
    return ::mlir::failure();

  addressOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(addressRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseRSquare())
    return ::mlir::failure();
  if (parser.parseEqual())
    return ::mlir::failure();

  writeDataOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(writeDataRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("if"))
    return ::mlir::failure();

  modeOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(modeRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();
  if (parser.parseKeyword("clock"))
    return ::mlir::failure();

  clockOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clockRawOperands[0]))
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalKeyword("enable"))) {

  {
    enableOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      enableOperands.push_back(operand);
    }
  }
  }
  if (::mlir::succeeded(parser.parseOptionalKeyword("mask"))) {

  {
    maskOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      maskOperands.push_back(operand);
    }
  }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::seq::FirMemType type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    memoryRawTypes[0] = type;
  }
  if (::mlir::succeeded(parser.parseOptionalComma())) {

  {
    ::mlir::Type optionalType;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalType(optionalType);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      maskTypes.push_back(optionalType);
    }
  }
  }
  result.addAttribute("operand_segment_sizes", parser.getBuilder().getDenseI32ArrayAttr({1, 1, 1, static_cast<int32_t>(enableOperands.size()), 1, 1, static_cast<int32_t>(maskOperands.size())}));
  for (::mlir::Type type : memoryTypes) {
    (void)type;
    if (!((::llvm::isa<::circt::seq::FirMemType>(type)))) {
      return parser.emitError(parser.getNameLoc()) << "'memory' must be A FIRRTL-flavored memory, but got " << type;
    }
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  result.addTypes(
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, cast<FirMemType>(memoryTypes[0]).getWidth()))
    );
  if (parser.resolveOperands(memoryOperands, memoryTypes, memoryOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(addressOperands, 
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>(memoryTypes[0]).getDepth())))
    , addressOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clockOperands, odsBuildableType0, clockOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(enableOperands, odsBuildableType0, enableOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(writeDataOperands, 
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, cast<FirMemType>(memoryTypes[0]).getWidth()))
    , writeDataOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(modeOperands, odsBuildableType0, modeOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(maskOperands, maskTypes, maskOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void FirMemReadWriteOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getMemory();
  _odsPrinter << "[";
  _odsPrinter << getAddress();
  _odsPrinter << "]";
  _odsPrinter << ' ' << "=";
  _odsPrinter << ' ';
  _odsPrinter << getWriteData();
  _odsPrinter << ' ' << "if";
  _odsPrinter << ' ';
  _odsPrinter << getMode();
  _odsPrinter << ",";
  _odsPrinter << ' ' << "clock";
  _odsPrinter << ' ';
  _odsPrinter << getClock();
  if (getEnable()) {
    _odsPrinter << ' ' << "enable";
    _odsPrinter << ' ';
    if (::mlir::Value value = getEnable())
      _odsPrinter << value;
  }
  if (getMask()) {
    _odsPrinter << ' ' << "mask";
    _odsPrinter << ' ';
    if (::mlir::Value value = getMask())
      _odsPrinter << value;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("operand_segment_sizes");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getMemory().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::seq::FirMemType>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
  if (getMask()) {
    _odsPrinter << ",";
    _odsPrinter << ' ';
    _odsPrinter << (getMask() ? ::llvm::ArrayRef<::mlir::Type>(getMask().getType()) : ::llvm::ArrayRef<::mlir::Type>());
  }
}

void FirMemReadWriteOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
  effects.emplace_back(::mlir::MemoryEffects::Read::get(), ::mlir::SideEffects::DefaultResource::get());
  effects.emplace_back(::mlir::MemoryEffects::Write::get(), ::mlir::SideEffects::DefaultResource::get());
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FirMemReadWriteOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FirMemWriteOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FirMemWriteOpGenericAdaptorBase::FirMemWriteOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.firmem.write_port", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> FirMemWriteOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  assert(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, FirMemWriteOp::getOperandSegmentSizesAttrName(*odsOpName)) && "missing segment size attribute for op");
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, FirMemWriteOp::getOperandSegmentSizesAttrName(*odsOpName)));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr FirMemWriteOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
FirMemWriteOpAdaptor::FirMemWriteOpAdaptor(FirMemWriteOp op) : FirMemWriteOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult FirMemWriteOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_operand_segment_sizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.firmem.write_port' op ""requires attribute 'operand_segment_sizes'");
    if (namedAttrIt->getName() == FirMemWriteOp::getOperandSegmentSizesAttrName(*odsOpName)) {
      tblgen_operand_segment_sizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operand_segment_sizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 6)
      return emitError(loc, "'seq.firmem.write_port' op ""'operand_segment_sizes' attribute for specifying operand segments must have 6 "
                "elements, but got ") << numElements;
  }
    return ::mlir::success();
}

std::pair<unsigned, unsigned> FirMemWriteOp::getODSOperandIndexAndLength(unsigned index) {
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName()));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range FirMemWriteOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::FirMemType> FirMemWriteOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::FirMemType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemWriteOp::getAddress() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemWriteOp::getClock() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemWriteOp::getEnable() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemWriteOp::getData() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(4).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemWriteOp::getMask() {
  auto operands = getODSOperands(5);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::MutableOperandRange FirMemWriteOp::getMemoryMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(0u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange FirMemWriteOp::getAddressMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(1u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange FirMemWriteOp::getClockMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(2u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange FirMemWriteOp::getEnableMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(3u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange FirMemWriteOp::getDataMutable() {
  auto range = getODSOperandIndexAndLength(4);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(4u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange FirMemWriteOp::getMaskMutable() {
  auto range = getODSOperandIndexAndLength(5);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(5u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

std::pair<unsigned, unsigned> FirMemWriteOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range FirMemWriteOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

void FirMemWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clock, /*optional*/::mlir::Value enable, ::mlir::Value data, /*optional*/::mlir::Value mask) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clock);
  if (enable)
    odsState.addOperands(enable);
  odsState.addOperands(data);
  if (mask)
    odsState.addOperands(mask);
  odsState.addAttribute(getOperandSegmentSizesAttrName(odsState.name), odsBuilder.getDenseI32ArrayAttr({1, 1, 1, (enable ? 1 : 0), 1, (mask ? 1 : 0)}));
}

void FirMemWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clock, /*optional*/::mlir::Value enable, ::mlir::Value data, /*optional*/::mlir::Value mask) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clock);
  if (enable)
    odsState.addOperands(enable);
  odsState.addOperands(data);
  if (mask)
    odsState.addOperands(mask);
  odsState.addAttribute(getOperandSegmentSizesAttrName(odsState.name), odsBuilder.getDenseI32ArrayAttr({1, 1, 1, (enable ? 1 : 0), 1, (mask ? 1 : 0)}));
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FirMemWriteOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 4u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult FirMemWriteOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_operand_segment_sizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'operand_segment_sizes'");
    if (namedAttrIt->getName() == getOperandSegmentSizesAttrName()) {
      tblgen_operand_segment_sizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operand_segment_sizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 6)
      return emitOpError("'operand_segment_sizes' attribute for specifying operand segments must have 6 "
                "elements, but got ") << numElements;
  }
    {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup5 = getODSOperands(5);

    if (valueGroup5.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup5.size();
    }

    for (auto v : valueGroup5) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getDepth())))
    , (*this->getODSOperands(1).begin()).getType()))))
    return emitOpError("failed to verify that address type should match clog2 of memory depth");
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getWidth()))
    , (*this->getODSOperands(4).begin()).getType()))))
    return emitOpError("failed to verify that data type should match memory width");
  return ::mlir::success();
}

::mlir::LogicalResult FirMemWriteOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

void FirMemWriteOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::ParseResult FirMemWriteOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand memoryRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> memoryOperands(memoryRawOperands);  ::llvm::SMLoc memoryOperandsLoc;
  (void)memoryOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand addressRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> addressOperands(addressRawOperands);  ::llvm::SMLoc addressOperandsLoc;
  (void)addressOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand dataRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> dataOperands(dataRawOperands);  ::llvm::SMLoc dataOperandsLoc;
  (void)dataOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clockRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clockOperands(clockRawOperands);  ::llvm::SMLoc clockOperandsLoc;
  (void)clockOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> enableOperands;
  ::llvm::SMLoc enableOperandsLoc;
  (void)enableOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> maskOperands;
  ::llvm::SMLoc maskOperandsLoc;
  (void)maskOperandsLoc;
  ::mlir::Type memoryRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> memoryTypes(memoryRawTypes);
  ::llvm::SmallVector<::mlir::Type, 1> maskTypes;

  memoryOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(memoryRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseLSquare())
    return ::mlir::failure();

  addressOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(addressRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseRSquare())
    return ::mlir::failure();
  if (parser.parseEqual())
    return ::mlir::failure();

  dataOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(dataRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();
  if (parser.parseKeyword("clock"))
    return ::mlir::failure();

  clockOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clockRawOperands[0]))
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalKeyword("enable"))) {

  {
    enableOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      enableOperands.push_back(operand);
    }
  }
  }
  if (::mlir::succeeded(parser.parseOptionalKeyword("mask"))) {

  {
    maskOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      maskOperands.push_back(operand);
    }
  }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::seq::FirMemType type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    memoryRawTypes[0] = type;
  }
  if (::mlir::succeeded(parser.parseOptionalComma())) {

  {
    ::mlir::Type optionalType;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalType(optionalType);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      maskTypes.push_back(optionalType);
    }
  }
  }
  result.addAttribute("operand_segment_sizes", parser.getBuilder().getDenseI32ArrayAttr({1, 1, 1, static_cast<int32_t>(enableOperands.size()), 1, static_cast<int32_t>(maskOperands.size())}));
  for (::mlir::Type type : memoryTypes) {
    (void)type;
    if (!((::llvm::isa<::circt::seq::FirMemType>(type)))) {
      return parser.emitError(parser.getNameLoc()) << "'memory' must be A FIRRTL-flavored memory, but got " << type;
    }
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  if (parser.resolveOperands(memoryOperands, memoryTypes, memoryOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(addressOperands, 
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>(memoryTypes[0]).getDepth())))
    , addressOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clockOperands, odsBuildableType0, clockOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(enableOperands, odsBuildableType0, enableOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(dataOperands, 
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, cast<FirMemType>(memoryTypes[0]).getWidth()))
    , dataOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(maskOperands, maskTypes, maskOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void FirMemWriteOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getMemory();
  _odsPrinter << "[";
  _odsPrinter << getAddress();
  _odsPrinter << "]";
  _odsPrinter << ' ' << "=";
  _odsPrinter << ' ';
  _odsPrinter << getData();
  _odsPrinter << ",";
  _odsPrinter << ' ' << "clock";
  _odsPrinter << ' ';
  _odsPrinter << getClock();
  if (getEnable()) {
    _odsPrinter << ' ' << "enable";
    _odsPrinter << ' ';
    if (::mlir::Value value = getEnable())
      _odsPrinter << value;
  }
  if (getMask()) {
    _odsPrinter << ' ' << "mask";
    _odsPrinter << ' ';
    if (::mlir::Value value = getMask())
      _odsPrinter << value;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("operand_segment_sizes");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getMemory().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::seq::FirMemType>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
  if (getMask()) {
    _odsPrinter << ",";
    _odsPrinter << ' ';
    _odsPrinter << (getMask() ? ::llvm::ArrayRef<::mlir::Type>(getMask().getType()) : ::llvm::ArrayRef<::mlir::Type>());
  }
}

void FirMemWriteOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
  effects.emplace_back(::mlir::MemoryEffects::Write::get(), ::mlir::SideEffects::DefaultResource::get());
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FirMemWriteOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FirRegOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FirRegOpGenericAdaptorBase::FirRegOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.firreg", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> FirRegOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {false, false, true, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 2) / 2;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr FirRegOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr FirRegOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, FirRegOp::getNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef FirRegOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::mlir::StringAttr FirRegOpGenericAdaptorBase::getInnerSymAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, FirRegOp::getInnerSymAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > FirRegOpGenericAdaptorBase::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::IntegerAttr FirRegOpGenericAdaptorBase::getPresetAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, FirRegOp::getPresetAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::APInt > FirRegOpGenericAdaptorBase::getPreset() {
  auto attr = getPresetAttr();
  return attr ? ::std::optional< ::mlir::APInt >(attr.getValue()) : (::std::nullopt);
}

::mlir::UnitAttr FirRegOpGenericAdaptorBase::getIsAsyncAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::UnitAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, FirRegOp::getIsAsyncAttrName(*odsOpName)));
  if (!attr)
    attr = ((false) ? ::mlir::Builder(odsAttrs.getContext()).getUnitAttr() : nullptr);
  return attr;
}

bool FirRegOpGenericAdaptorBase::getIsAsync() {
  auto attr = getIsAsyncAttr();
    if (!attr)
      return ((false) ? ::mlir::Builder(odsAttrs.getContext()).getUnitAttr() : nullptr) != nullptr;
  return attr != nullptr;
}

} // namespace detail
FirRegOpAdaptor::FirRegOpAdaptor(FirRegOp op) : FirRegOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult FirRegOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;
  ::mlir::Attribute tblgen_inner_sym;
  ::mlir::Attribute tblgen_isAsync;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.firreg' op ""requires attribute 'name'");
    if (namedAttrIt->getName() == FirRegOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == FirRegOp::getInnerSymAttrName(*odsOpName)) {
      tblgen_inner_sym = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == FirRegOp::getIsAsyncAttrName(*odsOpName)) {
      tblgen_isAsync = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_preset;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == FirRegOp::getPresetAttrName(*odsOpName)) {
      tblgen_preset = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'seq.firreg' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_inner_sym && !((::llvm::isa<::mlir::StringAttr>(tblgen_inner_sym))))
    return emitError(loc, "'seq.firreg' op ""attribute 'inner_sym' failed to satisfy constraint: string attribute");

  if (tblgen_preset && !((::llvm::isa<::mlir::IntegerAttr>(tblgen_preset))))
    return emitError(loc, "'seq.firreg' op ""attribute 'preset' failed to satisfy constraint: arbitrary integer attribute");

  if (tblgen_isAsync && !((::llvm::isa<::mlir::UnitAttr>(tblgen_isAsync))))
    return emitError(loc, "'seq.firreg' op ""attribute 'isAsync' failed to satisfy constraint: unit attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> FirRegOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {false, false, true, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 2) / 2;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range FirRegOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value FirRegOp::getNext() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirRegOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirRegOp::getReset() {
  auto operands = getODSOperands(2);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::Value FirRegOp::getResetValue() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::Value{} : ::llvm::cast<::mlir::Value>(*operands.begin());
}

::mlir::MutableOperandRange FirRegOp::getNextMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange FirRegOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange FirRegOp::getResetMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange FirRegOp::getResetValueMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> FirRegOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range FirRegOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value FirRegOp::getData() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::StringAttr FirRegOp::getNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getNameAttrName()));
}

::llvm::StringRef FirRegOp::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::mlir::StringAttr FirRegOp::getInnerSymAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getInnerSymAttrName()));
}

::std::optional< ::llvm::StringRef > FirRegOp::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::IntegerAttr FirRegOp::getPresetAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getPresetAttrName()));
}

::std::optional< ::mlir::APInt > FirRegOp::getPreset() {
  auto attr = getPresetAttr();
  return attr ? ::std::optional< ::mlir::APInt >(attr.getValue()) : (::std::nullopt);
}

::mlir::UnitAttr FirRegOp::getIsAsyncAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::UnitAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getIsAsyncAttrName()));
}

bool FirRegOp::getIsAsync() {
  auto attr = getIsAsyncAttr();
    if (!attr)
      return ((false) ? ::mlir::Builder((*this)->getContext()).getUnitAttr() : nullptr) != nullptr;
  return attr != nullptr;
}

void FirRegOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void FirRegOp::setName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void FirRegOp::setInnerSymAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getInnerSymAttrName(), attr);
}

void FirRegOp::setInnerSym(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getInnerSymAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getInnerSymAttrName());
}

void FirRegOp::setPresetAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getPresetAttrName(), attr);
}

void FirRegOp::setIsAsyncAttr(::mlir::UnitAttr attr) {
  (*this)->setAttr(getIsAsyncAttrName(), attr);
}

void FirRegOp::setIsAsync(bool attrValue) {
    if (attrValue)
      return (*this)->setAttr(getIsAsyncAttrName(), ((attrValue) ? ::mlir::Builder((*this)->getContext()).getUnitAttr() : nullptr));
    (*this)->removeAttr(getIsAsyncAttrName());
}

::mlir::Attribute FirRegOp::removeInnerSymAttr() {
return (*this)->removeAttr(getInnerSymAttrName());
}

::mlir::Attribute FirRegOp::removePresetAttr() {
return (*this)->removeAttr(getPresetAttrName());
}

::mlir::Attribute FirRegOp::removeIsAsyncAttr() {
return (*this)->removeAttr(getIsAsyncAttrName());
}

::mlir::LogicalResult FirRegOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_name;
  ::mlir::Attribute tblgen_inner_sym;
  ::mlir::Attribute tblgen_isAsync;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'name'");
    if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getInnerSymAttrName()) {
      tblgen_inner_sym = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getIsAsyncAttrName()) {
      tblgen_isAsync = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_preset;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getPresetAttrName()) {
      tblgen_preset = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(*this, tblgen_inner_sym, "inner_sym")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq8(*this, tblgen_preset, "preset")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq9(*this, tblgen_isAsync, "isAsync")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    if (valueGroup2.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup2.size();
    }

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((((*this->getODSOperands(0).begin()).getType()) == ((*this->getODSResults(0).begin()).getType()) && ((*this->getODSResults(0).begin()).getType()) == ((*this->getODSOperands(0).begin()).getType()))))
    return emitOpError("failed to verify that all of {next, data} have same type");
  return ::mlir::success();
}

::mlir::LogicalResult FirRegOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

void FirRegOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::LogicalResult FirRegOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = operands[0].getType();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

void FirRegOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
  effects.emplace_back(::mlir::MemoryEffects::Write::get(), ::mlir::SideEffects::DefaultResource::get());
  effects.emplace_back(::mlir::MemoryEffects::Read::get(), ::mlir::SideEffects::DefaultResource::get());
  effects.emplace_back(::mlir::MemoryEffects::Allocate::get(), ::mlir::SideEffects::DefaultResource::get());
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FirRegOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::HLMemOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
HLMemOpGenericAdaptorBase::HLMemOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.hlmem", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> HLMemOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr HLMemOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr HLMemOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, HLMemOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef HLMemOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

} // namespace detail
HLMemOpAdaptor::HLMemOpAdaptor(HLMemOp op) : HLMemOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult HLMemOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.hlmem' op ""requires attribute 'sym_name'");
    if (namedAttrIt->getName() == HLMemOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'seq.hlmem' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> HLMemOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range HLMemOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> HLMemOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> HLMemOp::getRst() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::MutableOperandRange HLMemOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange HLMemOp::getRstMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> HLMemOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range HLMemOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::HLMemType> HLMemOp::getHandle() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::HLMemType>>(*getODSResults(0).begin());
}

::mlir::StringAttr HLMemOp::getSymNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::llvm::StringRef HLMemOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

void HLMemOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void HLMemOp::setSymName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void HLMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type handle, ::mlir::Value clk, ::mlir::Value rst, ::mlir::StringAttr sym_name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  odsState.addTypes(handle);
}

void HLMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clk, ::mlir::Value rst, ::mlir::StringAttr sym_name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void HLMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type handle, ::mlir::Value clk, ::mlir::Value rst, ::llvm::StringRef sym_name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  odsState.addTypes(handle);
}

void HLMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clk, ::mlir::Value rst, ::llvm::StringRef sym_name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void HLMemOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult HLMemOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'sym_name'");
    if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult HLMemOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult HLMemOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand rstRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> rstOperands(rstRawOperands);  ::llvm::SMLoc rstOperandsLoc;
  (void)rstOperandsLoc;
  ::mlir::Type handleRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> handleTypes(handleRawTypes);

  if (parser.parseSymbolName(sym_nameAttr))
    return ::mlir::failure();
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  rstOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(rstRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::seq::HLMemType type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    handleRawTypes[0] = type;
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  result.addTypes(handleTypes);
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(rstOperands, odsBuildableType0, rstOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void HLMemOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getRst();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getHandle().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::seq::HLMemType>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::HLMemOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::ReadPortOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ReadPortOpGenericAdaptorBase::ReadPortOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.read", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> ReadPortOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  assert(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, ReadPortOp::getOperandSegmentSizesAttrName(*odsOpName)) && "missing segment size attribute for op");
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, ReadPortOp::getOperandSegmentSizesAttrName(*odsOpName)));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr ReadPortOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr ReadPortOpGenericAdaptorBase::getLatencyAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, ReadPortOp::getLatencyAttrName(*odsOpName)));
  return attr;
}

uint64_t ReadPortOpGenericAdaptorBase::getLatency() {
  auto attr = getLatencyAttr();
  return attr.getValue().getZExtValue();
}

} // namespace detail
ReadPortOpAdaptor::ReadPortOpAdaptor(ReadPortOp op) : ReadPortOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult ReadPortOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_latency;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.read' op ""requires attribute 'latency'");
    if (namedAttrIt->getName() == ReadPortOp::getLatencyAttrName(*odsOpName)) {
      tblgen_latency = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_operand_segment_sizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.read' op ""requires attribute 'operand_segment_sizes'");
    if (namedAttrIt->getName() == ReadPortOp::getOperandSegmentSizesAttrName(*odsOpName)) {
      tblgen_operand_segment_sizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operand_segment_sizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 3)
      return emitError(loc, "'seq.read' op ""'operand_segment_sizes' attribute for specifying operand segments must have 3 "
                "elements, but got ") << numElements;
  }

  if (tblgen_latency && !(((::llvm::isa<::mlir::IntegerAttr>(tblgen_latency))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_latency).getType().isSignlessInteger(64)))))
    return emitError(loc, "'seq.read' op ""attribute 'latency' failed to satisfy constraint: 64-bit signless integer attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ReadPortOp::getODSOperandIndexAndLength(unsigned index) {
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName()));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range ReadPortOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::HLMemType> ReadPortOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::HLMemType>>(*getODSOperands(0).begin());
}

::mlir::Operation::operand_range ReadPortOp::getAddresses() {
  return getODSOperands(1);
}

::mlir::TypedValue<::mlir::IntegerType> ReadPortOp::getRdEn() {
  auto operands = getODSOperands(2);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::MutableOperandRange ReadPortOp::getMemoryMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(0u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange ReadPortOp::getAddressesMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(1u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange ReadPortOp::getRdEnMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(2u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

std::pair<unsigned, unsigned> ReadPortOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ReadPortOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value ReadPortOp::getReadData() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::IntegerAttr ReadPortOp::getLatencyAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getLatencyAttrName()));
}

uint64_t ReadPortOp::getLatency() {
  auto attr = getLatencyAttr();
  return attr.getValue().getZExtValue();
}

void ReadPortOp::setLatencyAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getLatencyAttrName(), attr);
}

void ReadPortOp::setLatency(uint64_t attrValue) {
  (*this)->setAttr(getLatencyAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), attrValue));
}

void ReadPortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type readData, ::mlir::Value memory, ::mlir::ValueRange addresses, /*optional*/::mlir::Value rdEn, ::mlir::IntegerAttr latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  if (rdEn)
    odsState.addOperands(rdEn);
  odsState.addAttribute(getOperandSegmentSizesAttrName(odsState.name), odsBuilder.getDenseI32ArrayAttr({1, static_cast<int32_t>(addresses.size()), (rdEn ? 1 : 0)}));
  odsState.addAttribute(getLatencyAttrName(odsState.name), latency);
  odsState.addTypes(readData);
}

void ReadPortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::ValueRange addresses, /*optional*/::mlir::Value rdEn, ::mlir::IntegerAttr latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  if (rdEn)
    odsState.addOperands(rdEn);
  odsState.addAttribute(getOperandSegmentSizesAttrName(odsState.name), odsBuilder.getDenseI32ArrayAttr({1, static_cast<int32_t>(addresses.size()), (rdEn ? 1 : 0)}));
  odsState.addAttribute(getLatencyAttrName(odsState.name), latency);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ReadPortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type readData, ::mlir::Value memory, ::mlir::ValueRange addresses, /*optional*/::mlir::Value rdEn, uint64_t latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  if (rdEn)
    odsState.addOperands(rdEn);
  odsState.addAttribute(getOperandSegmentSizesAttrName(odsState.name), odsBuilder.getDenseI32ArrayAttr({1, static_cast<int32_t>(addresses.size()), (rdEn ? 1 : 0)}));
  odsState.addAttribute(getLatencyAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), latency));
  odsState.addTypes(readData);
}

void ReadPortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::ValueRange addresses, /*optional*/::mlir::Value rdEn, uint64_t latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  if (rdEn)
    odsState.addOperands(rdEn);
  odsState.addAttribute(getOperandSegmentSizesAttrName(odsState.name), odsBuilder.getDenseI32ArrayAttr({1, static_cast<int32_t>(addresses.size()), (rdEn ? 1 : 0)}));
  odsState.addAttribute(getLatencyAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), latency));
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ReadPortOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ReadPortOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_latency;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'latency'");
    if (namedAttrIt->getName() == getLatencyAttrName()) {
      tblgen_latency = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_operand_segment_sizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'operand_segment_sizes'");
    if (namedAttrIt->getName() == getOperandSegmentSizesAttrName()) {
      tblgen_operand_segment_sizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operand_segment_sizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 3)
      return emitOpError("'operand_segment_sizes' attribute for specifying operand segments must have 3 "
                "elements, but got ") << numElements;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq10(*this, tblgen_latency, "latency")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    if (valueGroup2.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup2.size();
    }

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((isValidIndexValues((*this->getODSOperands(0).begin()), this->getODSOperands(1)))))
    return emitOpError("failed to verify that address bit widths should be identical to the clog2 of the shape of the HLMemType");
  return ::mlir::success();
}

::mlir::LogicalResult ReadPortOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::ReadPortOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::WritePortOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
WritePortOpGenericAdaptorBase::WritePortOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.write", odsAttrs.getContext());
}

std::pair<unsigned, unsigned> WritePortOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {false, true, false, false};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 3) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr WritePortOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr WritePortOpGenericAdaptorBase::getLatencyAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, WritePortOp::getLatencyAttrName(*odsOpName)));
  return attr;
}

uint64_t WritePortOpGenericAdaptorBase::getLatency() {
  auto attr = getLatencyAttr();
  return attr.getValue().getZExtValue();
}

} // namespace detail
WritePortOpAdaptor::WritePortOpAdaptor(WritePortOp op) : WritePortOpAdaptor(op->getOperands(), op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

::mlir::LogicalResult WritePortOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_latency;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'seq.write' op ""requires attribute 'latency'");
    if (namedAttrIt->getName() == WritePortOp::getLatencyAttrName(*odsOpName)) {
      tblgen_latency = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_latency && !(((::llvm::isa<::mlir::IntegerAttr>(tblgen_latency))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_latency).getType().isSignlessInteger(64)))))
    return emitError(loc, "'seq.write' op ""attribute 'latency' failed to satisfy constraint: 64-bit signless integer attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> WritePortOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {false, true, false, false};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 3) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range WritePortOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::HLMemType> WritePortOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::HLMemType>>(*getODSOperands(0).begin());
}

::mlir::Operation::operand_range WritePortOp::getAddresses() {
  return getODSOperands(1);
}

::mlir::Value WritePortOp::getInData() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> WritePortOp::getWrEn() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(3).begin());
}

::mlir::MutableOperandRange WritePortOp::getMemoryMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange WritePortOp::getAddressesMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange WritePortOp::getInDataMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange WritePortOp::getWrEnMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> WritePortOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range WritePortOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::IntegerAttr WritePortOp::getLatencyAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getLatencyAttrName()));
}

uint64_t WritePortOp::getLatency() {
  auto attr = getLatencyAttr();
  return attr.getValue().getZExtValue();
}

void WritePortOp::setLatencyAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getLatencyAttrName(), attr);
}

void WritePortOp::setLatency(uint64_t attrValue) {
  (*this)->setAttr(getLatencyAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), attrValue));
}

void WritePortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::mlir::ValueRange addresses, ::mlir::Value inData, ::mlir::Value wrEn, ::mlir::IntegerAttr latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  odsState.addOperands(inData);
  odsState.addOperands(wrEn);
  odsState.addAttribute(getLatencyAttrName(odsState.name), latency);
}

void WritePortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::ValueRange addresses, ::mlir::Value inData, ::mlir::Value wrEn, ::mlir::IntegerAttr latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  odsState.addOperands(inData);
  odsState.addOperands(wrEn);
  odsState.addAttribute(getLatencyAttrName(odsState.name), latency);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void WritePortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::mlir::ValueRange addresses, ::mlir::Value inData, ::mlir::Value wrEn, uint64_t latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  odsState.addOperands(inData);
  odsState.addOperands(wrEn);
  odsState.addAttribute(getLatencyAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), latency));
}

void WritePortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::ValueRange addresses, ::mlir::Value inData, ::mlir::Value wrEn, uint64_t latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  odsState.addOperands(inData);
  odsState.addOperands(wrEn);
  odsState.addAttribute(getLatencyAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), latency));
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void WritePortOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult WritePortOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_latency;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'latency'");
    if (namedAttrIt->getName() == getLatencyAttrName()) {
      tblgen_latency = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq10(*this, tblgen_latency, "latency")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  if (!((std::equal_to<>()((*this->getODSOperands(0).begin()).getType().cast<HLMemType>().getElementType(), (*this->getODSOperands(2).begin()).getType()))))
    return emitOpError("failed to verify that type of 'value' matches element type of 'hlmemvalue'");
  if (!((isValidIndexValues((*this->getODSOperands(0).begin()), this->getODSOperands(1)))))
    return emitOpError("failed to verify that address bit widths should be identical to the clog2 of the shape of the HLMemType");
  return ::mlir::success();
}

::mlir::LogicalResult WritePortOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::WritePortOp)


#endif  // GET_OP_CLASSES

